Getting Started

XYplorer

File Manager

for Windows 8.1, 8, Server 2012, 7, Server 2008, Vista, XP, Server 2003, 2000, NT, Me, 98; 32-bit and 64-bit versions.

Help for XYplorer 13.80 onwards

Copyright © 1997-2014 Donald Lessau. All rights reserved.

Introduction

XYplorer is a tabbed file manager for Windows. It features a powerful file search, a versatile preview, a highly customizable interface, optional dual pane, and a large array of unique ways to efficiently automate frequently recurring tasks. It's fast and light, it's innovative, and it's portable.

This Help File

will guide you through the interface, features, usage, and customizations offered by XYplorer.

If you need further assistance, or want to share an experience or a suggestion, you are always welcome to the XYplorer User Forum, where you will find friendly and competent support.

Enjoy XYplorer!

Donald Lessau, Cologne 2014


Installing XYplorer

System Requirements

Operating Systems: Windows 8, Windows 7, Windows Server 2008, Windows Vista, Windows XP, Windows Server 2003, Windows 2000, Windows NT, Windows Me, Windows 98; x64/x32.

Minimal Hardware: 100 MHz Pentium, 32MB RAM

Monitor: A monitor resolution of at least 800x600 pixels is recommended.

Installation

XYplorer is portable. It doesn't require any "installation" in the proper sense, and using it does not change your system or registry. You can run it directly from your USB drive, and you can have as many parallel "installations" as you wish.

Choose one of the following packages:

(1) Installer Package
(2) No-Install Package

Note: No matter which package you use, Install or No-Install, running XYplorer does not change your system or registry at any time.

Installation using the Installer Package

Use this package to use an installer to install XYplorer, with icons in the start menu and an uninstaller.

Extract xyplorer_full.zip to some temporary directory and run XYplorer_x.xx_Install.exe. The following files will be copied to the directory you selected/created during the install procedure:

XYplorer.exe Application
XYcopy.exe Copy Handler
XYplorer.chm Help
Startup.ini Sets the Application Data Path (see below)
XYplorer Homepage.url Link to www.xyplorer.com
LicenseXY.txt XYplorer License Agreement
ReadmeXY.txt Readme file
CatalogDefault.dat Sample Catalog File
Uninstall.exe Uninstaller

A program group "XYplorer" will be created under "Programs" in your Start menu, containing four icons.

The Application Data Path

The file Startup.ini contains information about the Application Data Path. By default this path is set to %appdata%\XYplorer which on a typical system (with English locale) is resolved to C:\Documents and Settings\<user>\Application Data\XYplorer.

Note that Startup.ini can be manually edited and will not be overwritten on a subsequent installation.

No further files are added anywhere to your system, and nothing will be put into the registry but uninstall information.

Installation using the No-Install Package

Use this package to install XYplorer on a removable drive (e.g. USB), or in any folder on any drive you like. All application data will be stored under the application path.

Simply extract xyplorer_full_noinstall.zip (respectively *.rar) anywhere.

Dependencies

VB6 runtime files

xyplorer_full.zip does not contain the VB6 runtime files needed to run XYplorer. This is to keep download times short, and because they are present on almost every computer. If you're not sure whether you got those files, it's easy to find out: if you can start XYplorer.exe you got them, if not you gotta get them.

ONLY IF THE PROGRAM DOES NOT START: The VB6 runtime files needed can be found at this URL: http://www.microsoft.com/downloads/en/details.aspx?FamilyId=7B9BA261-7A9C-43E7-9117-F673077FFB3C&displaylang=en

Digital Signatures

From v11.40.0100 onwards: To ensure origin and integrity of the download all executable files (.EXE files) are digitally signed by Donald Lessau. Make sure to check the digital signatures. Do not install or use a copy of XYplorer where the digital signatures are missing or not valid.


Configuration Dialog

Configuration Dialog

Open the Configuration dialog by menu Tools | Configuration (F9). The dialog is organized into various sections:

Tree and List, Sort and Rename, Refresh, Icons, History, Menus, Mouse, Safety, Controls and More, Startup & Exit, Colors, Styles, Color Filters, Tags, Fonts, Templates, Find Files & Branch View, File Operations, Report, Preview, Previewed Formats, File Info Tips, Thumbnails, Dual Pane, Tabs, Undo & Action Log, Shell Integration, Features

Buttons

At the bottom left of the dialog you find two buttons:

Help (F1)

Opens the Help file at the currently opened section of the dialog.

Jump to Setting... (F3)

Shows an alphabetically ordered list of all settings available in the Configuration dialog, along with a live filter box. From there you can jump directly to a setting to check or modify it. The jump targets are highlighted (where possible -- buttons cannot be highlighted) and focused. If the list shows only one item OK will trigger it even if it is not selected.

Tree and List

Items in Tree and List

Show Desktop folder

Show/Hide the Desktop folder right under the Computer node in the Tree.

Show Documents folder

Show/Hide the Documents folder right under the Computer node in the Tree.

Show User folder

Show/Hide the User folder right under the Computer node in the Tree.

This special folder points to the current user's profile folder (CSIDL_PROFILE).

Show Network folder

Show/Hide the Network folder right under the Computer node in the Tree.

Show Recycle Bin folder

Show/Hide the Recycle Bin folder right under the Computer node in the Tree.

Notes on the above special folders

If e.g. the Desktop node is hidden then special paths like "Desktop" will not work anymore in the special way but will be auto-resolved to their real file system path.

The Mini Tree does not really care about these settings but shows and hides what you tell him to show and hide.

Show floppy drives

Uncheck this box if you want to reduce hardware access to rarely used Floppy drives (A: and B:).

Show hidden drives

Check to show drives that Explorer and other file managers do not show because they are marked as hidden.

Show hidden files and folders

Uncheck if you don't want to see hidden system folders like "System Volume Information" and "Recycler" or files like "C:\boot.ini" or "desktop.ini". Operations on these items are often disallowed by the system or dangerous.

If hidden, those items won't also be found by a search. They will, however, be contained in folder reports and backups.

Show system files and folders

Unchecking this checkbox will hide all items with the SYSTEM attribute set (regardless of the HIDDEN attribute and the setting of the "Show hidden..." checkbox).

If hidden, those items won't also be found by a search. They will, however, be contained in folder reports and backups.

Show junctions

Uncheck to hide junctions (items with the REPARSE_POINT attribute set). The factory default is unchecked. This command has mainly been added to get rid of the plethora of junctions in Win7.

Note that in the folder tree, on hovering a junction the tooltip displays the Junction Target.

Tree

Expand destination node in tree

When you goto a folder by any means apart from using the Tree, this setting controls whether it auto-expands in the Tree. The effect is suppressed though in MiniTree (to keep it mini!).

Expand tree nodes on single click

When enabled any non-expanded tree node with child nodes will expand on a single click.

Auto-optimize tree

Check to automatically collapse non-current nodes in Tree. Rule: Auto-optimize sets in when you expand the current tree node.

Check existence of subfolders in tree

If turned ON then all freshly displayed tree folders are checked for any contained subfolders (and depending on the result a "+" is display in front of them, or not). If OFF then it is simply assumed that subfolders exist, and the "+" icon is set unconditionally. Turning it OFF will speed up browsing the tree considerably.

In network locations as well

Turn it OFF to have the speed booster only where it is really needed: on slow drives (high-latency networks).

Remember state of tree

Tick it to remember which nodes are expanded in the Maxi Tree (the Mini Tree state is remembered anyway ever since).

The tree state is retained across sessions and also when switching between Maxi and Mini Tree. It also works with a Locked Tree. Also the scroll position is remembered. So now you have a pretty good chance that you find your tree exactly as you left it last time (unless another application changed the folder structure). Of course, recreating the tree does involve additional browsing, so the startup time will be slightly longer depending on the complexity of the tree.

Show localized folder names

Tick it to show special display names (that differ from the real path name) for certain tree folders in non-English Windows installations.

Some examples from German Windows 7:

Real Path Component Localized Folder Name

-------------------------------------------

Program Files Programme

Users Benutzer

Public Öffentlich

Program Files (x86) Programme (x86)

The real name is shown in the tree name hover tooltip.

When you inline rename a folder with a localized name, the real name is used instead.

These localized folder names are currently only provided for the tree.

Select parent of moved folder

If ticked then the focus jumps to the parent of the moved folder when the moved folder was the focused folder. If unticked the focus stays with the moved folder.

Select parent of deleted folder

Check it to always select the parent of a deleted folder. If unchecked the next sibling is selected (if there is any, otherwise the parent is selected).

List

Show folder sizes

Folder sizes can also be shown directly in the file list. Of course, with large and deeply nested folders, this slows down the file browsing considerably, especially on a first browse of that folder. So: use with care... or press ESC to abort the endless counting of bytes.

In network locations as well

Tick this to also show folder sizes for network locations. This can take a long time on slow drives (high-latency networks).

Tip: There is always menu View | Calculate Folder Sizes (Shift+F5) if you need the folder sizes in the current listing now. There is also a toolbar button to do this one-time job.

Show item count with folder sizes

Check it to also show the number of items in each folder in the list's Size column (if folder sizes are shown).

Show folder size on Properties tab

Show Size (total contents bytes sum), Space used and Contents for folders on the Properties tab. This feature has to be explicitly activated in configuration since for large deeply nested folders it takes some time to gather this info.

Select last used subfolder

Tick it to have the last used subfolder within the current folder auto-selected. Only takes effect when browsing by the list or by history, or when going up or down.

Usage: Makes it very convenient to browse downwards by keyboard within the list.

Select next item after delete and move

Tick it to auto-select the next item in the file list after the current item has been deleted or moved away. If the current item is the last item, then of course not the next but the previous item is auto-selected.

Add new items at the end of the list

Tick it to have new items added at the end of the list. Untick it to have new items added where they belong according to the current sort order.

Sort and Rename

Sort

Sort folders apart

Check this to make XYplorer behave like Explorer in sorting folders apart from files. Uncheck it if you want everything in one alphabet.

Keep folders on top

Check it to keep the folders at the top of the list always (independently of the sort order and column).

Sort folders always ascending

Tick it to have the folders always sorted by name in ascending order. Especially useful if also "Keep folders on top" is ticked.

Note that "Mixed sort on date columns" will overwrite this setting for the Date columns.

Mixed sort on date columns

Check to use a mixed sort (mix folders and files when sorting) always on the Date columns.

Mixed sort on tag columns

Check to use a mixed sort (mix folders and files when sorting) always on the columns Label, Tags, and Comment.

Mixed sort on path columns

Check to use a mixed sort (mix folders and files when sorting) always on the columns Path (Search Results) and Original Location (Recycle Bin).

Natural numeric sort order

Enable natural numeric sort order (aka "intuitive filename sorting") for files and folders in tree and list. For example:

File3.ext

File20.ext

File100.ext

With normal alphabetical sort you get:

File100.ext

File20.ext

File3.ext

Sort filenames by base

Check it to sort filenames primarily by base, secondarily by extension. Note that Explorer in Windows XP sorts by full name (base + extension) whereas Explorer in Vista/Win7 sorts by base. For example:

Natural numeric sort order ON

--------------------------------------

Sort by base ON Sort by base OFF

----------------- -----------------

a.txt a2.txt

a2.txt a10.txt

a10.txt a.txt

Natural numeric sort order OFF

--------------------------------------

Sort by base ON Sort by base OFF

----------------- -----------------

a.txt a.txt

a10.txt a10.txt

a2.txt a2.txt

Sort size (date) columns descending by default

Allows you to control the default sort order for certain column types in List.

Keep focused item in view after resorting

If checked then the focused item stays in view (if possible) after the list is resorted. And not only in view, but -- again: if possible -- exactly in the same place in the view port. So your eyes don't have to go on a trip looking for it.

This setting is ignored if there are no selections in the list. In that case what happens after sorting is controlled by Scroll to top after resorting following here below.

Tip If the setting is unticked you still can enforce it by holding CTRL while clicking the column header. This will even keep the focused item in view when it is not selected, so CTRL gives you even a little more power than the config setting.

Scroll to top after resorting

If checked the list is auto-scrolled to top when you change the sort order. Additionally, if there are no selections in the list, the focus is auto-shifted to the top item. Note that the option is honored only when no current item is kept in view due to an enabled Keep focused item in view after resorting (in other words, the latter setting takes precedence).

Show sort headers in all views

Tick it to have sort headers (column headers) also in non-Details views, e.g. in Thumbnails.

Note that in views "Small Icons" and "List" you can modify the column width by resizing the Name column header.

Rename

Exclude extension on rename

Check to exclude extension from the rename pre-selection.

Resort list immediately after rename

Resorts list after single and batch renames, and scrolls focused item into view.

Note that on Serial Rename (using the Tab key) the list will not be auto-resorted after each rename operation even if you checked "Resort list immediately after rename" in Configuration | Tree and List. It would be extremely confusing if the list resorted between each rename.

Also when a single rename is triggered by focus loss (e.g. when you click outside the rename box) the list does not auto-resort because, again, it might lead to confusion.

So, a single rename (aka inline rename) should be completed by pressing [Enter] in order to invoke an immediate resort.

Serial rename by Up and Down keys

Check it to use the cursor keys UP and DOWN to go to the next and previous file while renaming them. Additionally, the current caret position (e.g., your caret is at the 8th letter) is kept if possible (if the filename is long enough), so renaming files in a list now is almost like moving and typing around in a multi-line text block. Very intuitive and convenient!
Note that serial rename by (Shift+)Tab key is always enabled by design, independently of the above.

Allow move on rename

A cute little time saver that enables you to move-and-rename files or folders in one go right from the file list. Simply enter a relative (to the current path of the file!) or absolute path\[name] into the inline rename box (F2) in the file list, and Move On Rename will happen. If the target folder doesn't exist yet it is created on the fly.

For example, select a file in the file list and enter this into the rename box:

C:\new.png = Move file to C:\ renaming it to new.png.

C:\1\2\3\new.png = Move file to C:\1\2\3 renaming it to new.png. If "C:\1\2\3\" does not exist it is created.

..\new.png = Move file one up renaming it to new.png.

stuff\new.png = Move file one down to subfolder "stuff" renaming it to new.png. If "stuff" does not exist it is created.

You can also move a file or folder without renaming it. Simply select the rename box, and enter a path with a trailing slash:

C:\stuff\ = Move file to C:\stuff\.

stuff\ = Move file one down to subfolder "stuff".

..\ = Move file one up.

Or create a new folder and paste Parent\Child into the fresh rename box: The relative path "Parent\Child" is created in the current path.

Note that Move On Rename works only for one item at a time (no Batch Move On Rename).

Use dialog to rename single items

Tick it to use a dialog instead of the usual inline rename in Tree and List.

Note that the setting only affects the F2 rename; the slow double-click will always open the inline rename.

Auto-replace invalid characters

If ticked then invalid characters in pasted or typed input are replaced by the character defined at Character to replace invalid characters in dropped messages (in Templates). If no character is defined then "." (dot) is used.

Applies to inline rename in Tree and List as well as to dialog based rename (see above Use dialog to rename single items).

Renaming Items in Tree and List (General Remark)

The above rename dialog as well as inline rename in Tree and List support the following

Multiline Paste: You can paste multiline clipboard contents into the edit box. The linefeeds are replaced by a space before pasting, so all lines go into the edit box.

Refresh, Icons, History

Auto-Refresh

Auto-refresh

Automatic refresh (of tree and list) on file system changes. You don't need to press F5 (Refresh) anymore to get a fresh impression of reality.

In network locations as well

Auto-refresh network locations as well, including mapped network drives. Unchecking this option will speed up network access on some systems.

Include removable drives

Auto-refresh removable drives as well. Applies to USB sticks, thumb drives, flash card readers, and the like, but NOT to floppies (which are excluded from all auto-refresh).

Refresh during file operations

Check to auto-refresh the Tree and current List while file operations triggered within XYplorer are in progress.

Tip: File operations will generally run faster if you do not enable this setting because the permanent refreshing takes time.

Icons

Draw selected list icons dimmed

Tick to draw the icons of selected list items in a dimmed way. Factory default is ON for XP and earlier, OFF for Vista/Win7 and later.

Cache specific icons

Enable it to obtain specific icons (e.g. for ICO files) from the shell icon cache. It's faster than accessing the files each time.

Use generic icons for super-fast browsing

Generic icons are determined by the extension (respectively type) of a file only, and not by its specific contents and hence need no file access to be determined, which makes retrieving them much faster, especially in network locations.

Note that only the following file types can have specific icons (which typically but not necessarily are embedded icons), so only files of these types will show different icons when you enable the use of generic icons: folders and *.exe *.lnk *.ico *.icl *.cur *.ani *.htm(l) *.url.

But only in network locations: Since the effects will be most notable in network locations, there is a second option that allows you to confine the use of generic icons to network locations.

Apply to all controls: Tick it to have super-fast generic icons everywhere (Catalog, Status Bar, Properties, various other lists), not just in the file list. Note that the Toolbar is an exception and will always show specific icons for Droppable User Buttons (DUB).

Show icon overlays

Show icon overlays (as for example used by TortoiseSVN, a Subversion client, implemented as a Windows shell extension).

Note for TortoiseSVN users on x64: You can install both the 32 and 64-bit version side by side. This will enable the TortoiseSVN features also for 32-bit applications like XYplorer.

Note that icon overlays are not retrieved for (UNC or mapped) network locations. Reason: Retrieving icons slows down network browsing even if there are no overlays to be found, and the latter is quite likely the case.

In network locations as well

Tick to show icon overlays also in network locations. Note that this can slow down network browsing considerably.

Show embedded icons on Properties tab

If enabled then any embedded icons are extracted from the following file types:

.exe .dll .cpl .ocx .scr .icl

Note that this operation updates the last accessed date of a file.

Enable custom file icons

Tick to display any defined Custom File Icons. No restart required.

History

History without duplicates

This option makes the history work very similarly to an MRU (most recently used) list. Differences to the normal history:

Automatically avoids duplicates in the history.

Note that the History holds up to 256 items.

History per Tab

History per Tab means that Back and Forward move within each tab's individual history, as opposed to the global history over all tabs.

If History per Tab is enabled then:

(1) Back and Forward (Toolbar buttons and Keyboard Shortcuts) are confined to each tab's individual history.
(2) The Back and Forward buttons's "arrow drop-downs" are confined to each tab's individual history.
(3) In the all-history popup menu (triggered via right-click "Back"/"Forward" Toolbar buttons, or via KS) those history items belonging to the current tab are shown bold.
(4) If History without duplicates (see above) is enabled then duplicates on different tabs are tolerated.
(5) The Toolbar back/forward buttons are blue instead of green.

The per-tab-data are saved between sessions. They are even maintained and saved if you untick History per Tab. So you can enable it at any time and get the desired functionality right away.

History retains selections

If checked the selected items are stored with the History. If you return-by-history to a location you have visited during the current session, the location's previous selections are restored. The selections are NOT remembered between sessions. Factory default is OFF because it can take quite some memory.

Scripting

Remember permanent variables

Tick it to remember Permanent Variables across sessions.

Menus, Mouse, Safety

Menus

Custom items in shell context menu

Check to show a couple of custom items at the top of the shell context menu of List items.

The buttons "Folder Tree..." and "File List..." allow you to further refine which custom context menu items you want to see in the Tree respectively List.

See here for descriptions of the individual commands.

Hide shell extensions from shell context menu

Check to have a clean context menu without all those funky shell extensions. For purists only.

Custom drag and drop context menu

Check this option if you prefer to see XYplorer's custom drag and drop context menu instead of the shell's original one. The custom menu has an entry called "Shell Context Menu..." (press access key "H") which allows you to show the shell menu from the custom menu.

Navigation commands in List context menu

Check to have the items Up, Back, and Forward in the List's context menu.

Find Files commands in List context menu

Check to have the Find Files section from menu Edit in the List's context menu.

Mouse

Single click on icon opens list items

Tick it to open list items by a left button single click on their icon. It will trigger the same action as if you double-clicked the item. The action is triggered on MouseUp.

Note: In Thumbnails view Single Click Open works only if Mouse Down Blow Up (On left mouse down) is OFF, else both features would conflict.

Line number selection

Tick it to enable Line Number Selection: In Details View, a click on a line number toggles list item selection. Functionally, Line Number Selection is like checkbox selection without the checkboxes.

Tip: It's triggered only if no function key is pressed (Ctrl, Shift, Alt). So you can e.g. lasso select additional files (without removing any previous selections) right from the line numbers column by holding CTRL before you press the mouse button.

Dbl-click on empty space goes up

If checked you can use the dbl-click to go up. If unchecked dbl-click will move the focused item to the top of the view port (which is XY's traditional function for this action).

Tip: Hold shift while dbl-clicking to go down one level.

Tip: Holding CTRL while dbl-clicking will move the focused item to the top of the view port, independent of the setting of "Dbl-click on empty space goes up".

Middle-click opens folder in new tab

Check it to open folders in a new tab by middle-clicking them in Tree, Catalog, and List.

Middle-click goes to file in new tab

Applies to files in List. Especially useful in search results, where it works identically to the right-click menu command "Go to Focused Item in New Tab".

Click on status bar toggles info panel

Check to allow toggling the info panel via clicking the status bar. Note that this setting controls both left click (show/hide panel) and right click (last size/minimize panel) on the status bar.

Safety Belts

Disallow left-dragging from tree and list

If you feel shaky with the mouse this is your safety belt. Note that the right button is always available for dragging.

Confirm drag and drop

Check it to pop a confirmation prompt for every left-mouse drag and drop operation. A reliable protection from accidental drops.

Note: If "Disallow left-dragging from tree and list" is ticked then "Confirm drag and drop" is not applicable, of course.

Confirm copy and move operations

Tick it to get a confirmation prompt before any move, copy, or backup operation, be it from clipboard, drag and drop, or other means.

This setting includes and supersedes "Confirm drag and drop" whose setting is ignored when "Confirm copy and move operations" is ticked.

Delete on key up

If ticked then all commands that delete files are triggered on KeyUp instead of on KeyDown if you use the keyboard to trigger them. All delete commands including Wipe are affected.

Directional formatting codes protection

Tick this to protect yourself from the so-called "Unitrix Exploit" where certain Unicode characters (Directional Formatting Codes, DFC) are used maliciously to disguise executables.

For example, U+202E (Right-to-Left Override): If you insert U+202E at the 2nd position of the file "Htxt.exe" it will be shown as "Hexe.txt" (in *every* Unicode-compliant software), an apparently harmless TXT file which in reality is a potentially dangerous executable. When you double-click this "TXT" file the executable will be run.

If you tick "Directional formatting codes protection" then "Hexe.txt" will be shown as "H*!*txt.exe", i.e. the U+202E character has not been resolved but replaced by "*!*", and the file is clearly recognizable as executable.

DFC protection is implemented in the following places:

· In the File List: each DFC in all filenames is replaced by "*!*".
· In the Status Bar: each DFC in the current filename is replaced by "*!*".
NOTE: Because DFCs can make the Status Bar unreadable you get this replacement independently of the setting of "Directional formatting codes protection".
· When opening a file containing any DFC, you are warned.

Here is the list of the 7 DFCs handled by this safety belt:

U+200E = "Left-to-Right Mark"

U+200F = "Right-to-Left Mark"

U+202A = "Left-to-Right Embedding"

U+202B = "Right-to-Left Embedding"

U+202C = "Pop Directional Formatting"

U+202D = "Left-to-Right Override"

U+202E = "Right-to-Left Override"

Further Remarks:

· XYplorer allows you to search for files with such characters in the name. You can paste them into the Name field (you won't see them but they are there).
· The "Convert to ASCII" command in Rename Special is a quick way to remove such characters from a filename (but, of course, it will remove ALL Unicode characters).

Further information:

· http://www.unicode.org/reports/tr9/

Type Ahead Find

Enable type ahead find

Check to enable Type Ahead Find (aka "Find as you type") in Tree and List. This also includes Paste and Find.

Matching

"Match at beginning" of filenames is the factory default (and the only thing Windows Explorer can do), but XYplorer gives you four different matching options, selectable in Configuration | Menus, Mouse, Safety | Type Ahead Find.

· Match at beginning: Check to count matches just at the beginning of the file names.
· Match anywhere: Check to count matches anywhere, not just at the beginning of the file names.
· Prefer matches at beginning: Only if there are no matches at the beginning, XYplorer starts looking for matches anywhere.
· Prefer matches at beginning (but only for single-characters): Only if there are no matches at the beginning OR if the pattern is longer than one character, XYplorer starts looking for matches anywhere. Sounds complicated but is the most popular matching mode.

Ignore diacritics

Tick it to ignore diacritics in Type Ahead Find in Tree and List. Typing "ö" will match "o" and vice versa.

Note: This setting also affects Spot and Jump matching.

Use sorted column

Uncheck to let Type Ahead Find in the file list always use the Name column; check to use the columns Name, Ext, Type, Path, Label, Tags, or Comment if they are the sorted columns.

Highlight matches

Tick it to highlight the current Type Ahead Find matches in the List (it's not implemented in the Tree). The color is hard-coded to black on yellow.

Controls and More

Drop-down Lists

(The factory default for all five options is ON.)

Auto-complete recently used items

When you start typing into the field, it shows you a list of items (sorted alphabetically) you've used before that match what you've typed so far.

Move last used item to top

Check to have the last used item always at the top position in the drop-down list.

Select list items on mouse hover

When the list is dropped the mouse selects list items by mere hovering (no buttons pressed).

Select all on focus by key

When the control gets focused by Tab key the current contents are auto-selected.

Select all on focus by mouse

When the control gets focused by clicking into the edit box the current contents are auto-selected.

Select all on item change

When you select a new item from the dropdown list by clicking or pressing [Enter], or you reset the current temporary item by pressing [ESC], the new edit box contents are auto-selected.

Select match on drop down

Tick it to auto-select the item in the dropdown list that matches the current item in the edit box (if any) and scroll it into view (if necessary).

Auto-Complete Path Names

Enable auto-complete paths for Address Bar (also affects the, Go to... dialog) and Find Files Location. See here for details.

Filter: Here you can choose whether the Auto-Complete match list should contain "Folders only", "Files only", or "Files and Folders".

Miscellaneous

Assume that servers are available

If you are browsing the network then if this option is enabled then the check for existence of servers is skipped, with two possible effects:

(1) It might speed up browsing and start up.
(2) In some rare configurations the checks are not reliable (servers that do exist are not seen), so if YOU know the servers do exist, you don't need the check and can turn it off.

Note: When skipping the check, password protected servers won't pop up a logon dialog!

The factory default is OFF (no check).

Support overlong filenames

Tick it to support filenames with more than 260 characters.

Background: In NTFS, the total length can be up to 32,765 characters with each component limited to 254 characters. The Windows Shell, however, doesn't allow overlong filenames (> 260 characters, including the terminating null character) and Shell functions (e.g. Copying, Moving, Deleting) will fail with items having overlong filenames. However, since it is possible to create items with overlong filenames under NTFS, with Explorer you are stuck when meeting such item: You cannot delete, rename, or move it! Consequently, also XYplorer will fail wherever it uses Shell functions. When Support overlong filenames is enabled, however, XYplorer will resort to Kernel functions that can deal with overlong filenames and thus work around the Shell limitations.

Note: XYplorer reports the filename length without the invisible terminating null character, but the maximum filename length for the windows shell is defined as 260 *including* the terminating null character. Therefore a filename reported as 260 characters by XYplorer is actually 261 characters for the shell and hence too long.

Here is a list of features with support for overlong filenames in XYplorer:

· Browse and search folders.
· Auto-refresh.
· Calculating the folder size.
· Create new files and folders within folders with overlong names.
· Inline Rename (Tree and List).
· Drag and drop overlong files, and cut/copy/paste them via clipboard. Note that the move/copy/delete support for overlong filenames is limited to operations on single items. Note also that the clipboard (tested on XP) will not handle items > 1027 characters.
· Image preview and thumbnails.
· Properties (Info Panel).
· Raw View (Info Panel).
· readfile, writefile (Scripting commands).
· Quick File View, Preview, Floating Preview, Full Screen Preview.
· Rename Special (menu File).
· Swap Names (menu File).
· Delete: If at least one of the items selected for deletion has an overlong filename you are automatically prompted to perform a special delete operation for such overlong items. Note that these deletions are permanent, they don't go to the Recycle Bin (it doesn't support overlong filenames).
Note that the automatic detection only scans the selected items, not any contained items (in selected folders). If only contained items are overlong, the automatic detection will not see them and the deletion will fail (shell error message). In that case use the command Delete Long from menu File to successfully delete the items in question.
· All "Copy Here..." commands (menu File), but only for files, not for folders.
· All Backup operations: Note that Backup Operations are not affected by the setting of Support overlong filenames! They always support overlong filenames.

Support volume labels in paths

Tick it to support Volume Labels in path specifications, e.g. TheSystem:\Windows. See Named Drives.

Address Bar relative to application path

Check to have the Address Bar resolve paths relative to the application path. The factory default is unchecked: The Address Bar works relative to the current path.

Open files from Address Bar

Tick it to have "Address Bar Go" open a file right away instead of browsing to its location. The "Address Bar Go" (internal name) event is triggered by:

· Pressing Enter in the Address Bar.
· Selecting an item in the Address Bar dropdown.
· Clicking the "Address Bar Go" toolbar button.

If unticked then "Address Bar Go" will browse to the location of the file and select it. Applies to files only, not to folders. Files are opened as if they were dbl-clicked, i.e. Portable File Associations are honored.

If ticked and the Address Bar shows a file, the icon in the Address Bar shows a little overlay to signal that <Enter> will open that file.

This setting can be temporarily inverted by holding CTRL: On Ctrl+Enter in the Address Bar, a file is handled as if the setting of "Open files from Address Bar" would be inverted: It is opened if "Open files from Address Bar" is OFF, and it is gone to if the setting is ON.

Resolve junctions

Tick it to automatically resolve junctions when entered through the Address Bar or similar ports (Catalog, Favorites, Go to ...).

E.g., it will silently convert "C:\Documents and Settings\<user>\AppData\" to "C:\Users\<user>\AppData\Roaming\" in Win7.

Open favorite files directly

Tick it to directly open files by selecting them from the Favorite Files menu. Portable File Associations are honored.

Tip: The toolbar button's tooltip reflects the current setting.

Show message when list is empty

Tick it to get a message ("This view is empty.") displayed right in the list when it is empty. There is some additional information if items are present in the folder but currently not shown.

Paste to selected list folder

When ticked and a folder is selected in the list then pasting from clipboard (Ctrl+V) goes into this folder. Also works in Branch View and Search Results. Of course, the list needs to have the focus.

Allow zombies in the Mini Tree

Tick it to keep currently unavailable folders in the Mini Tree, given they are located on currently unavailable drives. Factory default is OFF, i.e. on loading a Mini Tree any unavailable folders are silently removed from the tree.

Show version information in the Status Bar

Tick it to show the embedded version information of executables, DLLs, DRVs, etc. (if they have any) right in the Status Bar on selecting such a file.

Sunday is the first day of the week

If unticked (factory default and ISO standard) then Monday is the first day of the week.

This setting affects e.g. find files by week and color filters by week.

Startup & Exit

Permanent startup path

Here you can set a path that will always be the startup path, even if you closed the app on another path and saved this other path to the INI file. If "Permanent startup path" is empty then everything is as it has always been: XYplorer starts where it was closed last time (if "Save settings on exit" is enabled).

Tip: Environment variables are supported. E.g. %userprofile%\Desktop.

Note: If XY was closed in Find mode, then the "Permanent startup path" will auto-set the mode to browse on next startup.

Expand in tree

If checked then the Permanent Startup Path (if any) will be guaranteed to be expanded on next startup. If unchecked it will only be expanded if on last exit it was the last path and expanded.

Startup pane

Always start on a certain pane, or on the last pane (factory default).

Startup window state

Always start with a certain window state, or with the last window state (factory default).

Open command line start path in new tab

If checked then a start path given by command line (e.g. "xyplorer.exe e:\") will not overwrite the current tab (when XY was unloaded last time) but open in a new foreground tab. If the start path happens to be identical to the current tab's location then, of course, no new tab is opened.

Allow multiple instances

If unchecked, then XYplorer will always re-use any previous instance (and restore it if minimized), even if no path is passed as command line parameter.

Note that if you use the /ini switch in the command line then you will ALWAYS get a new instance even if "Allow multiple instances" is unchecked.

Open new instance always

Uncheck to re-use an already running previous instance if the new instance is called with a startpath in the commandline.

Minimize to tray

When you minimize XYplorer's main window it will be removed from the task bar and its icon will appear in the system tray.

The tray icon's tooltip is identical to the main window's title bar (and hence also configurable).

Minimize to tray on X close

Check it to minimize the app to the system tray when using the X close windows button.

No network browsing on startup

Check it to block any network location browsing on startup similar to the (hard-coded) blocking of searches at startup. This will prevent any delays when starting up on an unavailable network location.

If it is enabled and the last path was on a network location then the next startup will be auto-redirected to "Computer" (unless you are in Mini Tree mode, which is more tolerant about unavailable locations).

Cache network servers

Check if you want your servers to be stored between sessions; the My Network Places node will be populated much faster then.

You can edit the cached list in List Management | Servers in Network Folder….

Check for updates on startup

Check it to perform a quick online check whether your current version is still up-to-date. If there is a newer version available you get a message. The check is only performed if you are online already.

Note that if Admin Settings are set to eAPHide_Help_XYOnTheWeb (64), this option is hidden and the functionality disabled.

Note that unfortunately the check can take a couple of seconds.

Save settings on exit

Automatically save the all settings when closing the application. This includes saving the current configuration to the current INI file, and all data settings to the various *.dat files located in the application data path.

Include most-recently-used lists on save

Check to save the most recently used data of History, Tabs, Address Bar, Visual Filter, Selection Filter, Rename Special, Open, and Find Files Name and Location. Pick your choices under the Apply To... button. Note that, of course, those lists are only remembered when you actually save the settings, either manually or automatically on exit (tick Save settings on exit).

Remarks on some of the choices:

· History: Uncheck to clear history on exit.
Also the Mini Tree is not saved. On next startup, the Mini Tree defaults to the Favorite MiniTree (if there is defined any).
· Tabs: Uncheck to clear all tabs on exit, so that only the current tab will be there on the next restart.
With this setting enabled also the last paths of each pane are forgotten and on next start will be initialized to Computer. If you want to forget the tabs but keep the last paths of each pane use this tweak: KeepLastPaths=1
· Tabsets: This concerns only the MRU lists of tabsets, not the tabsets data themselves, which will stay on disk, of course, even when the MRU lists are forgotten.
· Last Tags: Controls whether the last applied Label, Find Label, and Tags are remembered across sessions.

Backup settings on save

If ticked then -- when the settings are saved -- the current INI file (typically XYplorer.ini), the Tags database (tag.dat), and the Catalog (catalog.dat) are backed up to the folder <xydata>\AutoBackup before it is modified if the last auto-backup is older than 24h. A smart little safety precaution to protect you from mishap. These are probably the data files you would be most sad about losing.

Keep pane data private

Check it if you don't want share history and tab data with other configurations. If unchecked then history and tab data are read from and written to <xydata>\Panes\1 and <xydata>\Panes\2.

Changing this option will have an effect only after a restart.

Colors

Setting Colors

Here you can set foreground and background colors for various interface elements. Click the labels to set colors via the Windows color selection dialog, or simply paste hex values into the text fields. Right-click the labels to reset to default colors.

The Selected Rows Color is also used for the background of selected thumbnails. This way selected thumbnails can be recognized even when "Show Caption" is off.

Reset Colors

The button pops up a little menu that offers two options:

· Reset Colors to Currently Active Values
· Reset Colors to Factory Defaults

Styles

Styles

Apply list styles globally

When checked, the list styles are applied globally to all tabs in all panes. Otherwise they are only applied to the current tab of the active pane.

Remember list settings per tab

Here you can control which list settings are remembered tabwise, and which are applied (inherited) cross-tab. The button "Apply To..." allows you to further refine which list properties you want to retain per tab.

The factory default is to remember them all.

For example, if you would like to have the same sort order in all tabs, but keep the view mode (Details, Thumbnails, ...) persistent in each tab, then you would check Remember list settings per tab, and then in the list under the "Apply To..." button you would check "View Mode" and uncheck "Sort Order".

Mirror tree box color in list

When checked, the list background color will adapt to the current tree boxed branch color.

Underline selected rows

Allows you to further specify the "Highlight Selected Rows" list style: If enabled, all selected rows are underlined with the color defined in "Selected Row", else all selected rows are fully backlighted with that color.

This is a global setting (not per Tab).

Translucent selection box

Available only for Windows 2000 Professional or later. If unchecked the old-school dotted focus rectangle is used instead of the translucent selection box.

Focus rectangle

Tick it to draw a dotted focus rectangle on the focused item in the main controls (Tree, List, Catalog).

Note: With Visual Themes enabled (Vista and later) this setting is totally ignored and the focused-but-not-selected item is drawn in the current themes style (which usually is not a dotted line but some other sort of line).

Grid style

Here you can choose between grid styles:

· Grid Lines: Thin 1-pixel lines between the rows.
· Zebra Stripes: Alternate Rows (1): Every 2nd row is highlighted.
· Zebra Stripes: Alternate Rows (2): Every 2nd 2 rows are highlighted.
· Zebra Stripes: Alternate Rows (3): Every 2nd 3 rows are highlighted.
· Zebra Stripes: Alternate Rows (4): Every 2nd 4 rows are highlighted.
· Zebra Stripes: Alternate Rows (5): Every 2nd 5 rows are highlighted.
· Alternate Groups: Every 2nd group is highlighted. Groups of items are striped depending on the contents of the sorted column. This gives you immediate visual clues about groups of same file types, sizes, dates, etc.
· Alternate Groups (Smart Names): See below under Highlighted Groups (Smart Names).
· Highlighted Groups: Every group is highlighted. This style lets you spot groups (as opposed to single, non-group items) even easier than style Alternate Groups.
· Highlighted Groups (Smart Names): Extra-smartness for Names. For the Name column a smart algorithm is applied to bring some grouping into this column which otherwise would be without groups.

Notes:

· Grids require "Show Grid" enabled in the file list (menu Tools | Customize List). There is a Toolbar button for this as well.
· Grids are shown only in views "Details" and "Details with Thumbnails".
· File Dates (Modified, Created, Accessed, Deleted) are grouped by day (the time part is ignored).
· If the list is not sorted by any column no grid is shown on Alternate Groups.
· The grid color can be customized using the "Grid" item under "List" in Configuration | Colors.
· Grid Style is a global setting (not per Tab).

Borders

Here you can choose between various border styles for the main controls (Tree, List, Catalog).

Selections

Here you can choose how the selected items are drawn in Tree, List, Catalog, and the small lists all over the interface.

(1) Windows Themes: This choice is only meaningful in Vista and later because in earlier systems Windows Themes don't affect selections. Furthermore it is only effective when Themes are enabled, of course.
If this option is selected and valid, then the color settings of Tree / Current Folder and Other / Sel. Items Back are ignored.
(2) XYplorer Classic: The selections are drawn as in XP and earlier Windows systems.

Use Use (Current Tree Folder) and Use (Selected List Items): Here you can define two colors concerning selected items in non-focused controls. Both can be individually ticked. If ticked they overwrite the active selection style, be it Themes or Classic.

Tree Path Tracing

Here you can define the color used by Tree Path Tracing.

Wide: You can as well choose between a slim and a wide style of the highlighting.

Note: To turn on Tree Path Tracing tick menu Tools | Customize Tree | Tree Path Tracing.

Line Spacing

Here you can customize the general line spacing in Tree, Catalog, and all lists and dropdowns.

Note that Tree, Catalog, and List support individual line spacing customization on top of this general one, adjustable by Ctrl+Wheel over the respective control.

Color Filters

See also the main article on Color Filters.

Enable color filters

Enable color filters in Tree and List. This is the master control for all settings below.

Apply color filters to the List

Check this box to color code items in the List. If you're not in the mood for color you can easily switch back to black & white, without deleting all your color settings.

Apply color filters to the Tree

Color filters based on name or attributes can also be applied to the Tree.

Ignore diacritics

Tick it to match Koln with Köln, and vice versa. Applies to name: and dir: filters in Tree and List.

Draw background colors in distinctive shapes

Tick it to give a distinctive shape to each type of filter (name, size, date...), given it has a background color defined.

The Color Filters List:

Setting Color Filters

In the color filters list you may add as many filters as you like, and define a Text Color and/or a Back Color for each filter. For details on color filter syntax see the main article on Color Filters.

The checkboxes in the list allow you to in/exclude the filters individually.

The filters are processed from top to bottom: the first match makes it. However, in Details mode, the first matching filter with backcolor (if any) is displayed combined with the first matching filter without backcolor (if any).

If a Back Color is defined, it is only drawn behind the item name (not any other columns). The color block is drawn with a distinctive shape at the right end to immediately hint at the applied Filter Type (name, attributes, size, date, age...) .

Note: When you completely leave out the color definitions (Text/Back), black on pink will be shown as default color combination. This is also true for SC colorfilter, e.g.: colorfilter("+lent:>12");

Handy keyboard shortcuts

Rename a pattern: F2

Recolor a pattern: Dbl-click the list

Delete a pattern: DEL

Tip: To reset text color or back color to the default value, simply hold CTRL when you click the Text Color respectively Back Color button.

Tip: Hold CTRL when clicking New to duplicate current item.

Editing Color Filters via List Management

Alternatively to the interface in the Configuration window you can edit your Color Filters menu Tools | List Management | Color Filters...

For your interest, the following filters are provided as factory defaults. They are listed here as copied from menu Tools | List Management | Color Filters... (Editor Mode) (the leading + means the filter is activated; the hex numbers are the color codes):

+len:>260 //overlong filenames>FFFFFF,FB4F04

+attr:junction>D500D5,

+attr:system>FF0000,FFFF80

+attr:encrypted>008000,

+attr:compressed>0000FF,

+ageM: d //modified today>FFFFFF,74C622

attr:d>5E738C,

+size:0>4199E0,E0E2ED

+*.exe;*.bat>D24257,

+*.htm;*.html;*.php>4287D2,

+*.txt;*.ini>38A050,

+*.png;*.jpg;*.gif;*.bmp>933968,

+*.zip;*.rar>CC6600,

+*.dll;*.ocx>7800F0,

+*.mp3;*.wav>FF8000,

Tags

Show tags in file list

Uncheck it to stop showing tags (Labels, Tags, Comments) in the file list. Useful to speed up browsing when you have tagged a large number of items but do not need the tags at the moment. Note that reading and writing the tag database (tag.dat) is not affected by this setting.

Toggle Labels by Label column click

Check to allow Column-Click Labeling, i.e. quick one-click labeling of items by left-clicking directly into the Label column (toggles Last Label / No Label). Right-clicking into the Label column will popup the Label selection context menu.

Popup by tag columns right-click

If checked then right-clicking into the Label, Tags, or Comment column will popup a little context menu with some useful options relating to the respective tags of the clicked item.

Sticky Selection Deluxe. There's a command Select All "[Label Name]" in the context menu of toolbar button Labels and in the Label column right-click menu. This gives you a comfortable way to select a group of files based on their Labels and the Label of the currently focused item (respectively the clicked item in case of the column context menu).

The context menu command Select All "[Label Name]" can be modified by modifier keys:

- Hold None: Select all [Label Name] items, unselect all other items.

- Hold CTRL: Select all [Label Name] items, keep other selections.

- Hold SHIFT: Unselect all [Label Name] items, keep other selections.

Apply tagging to all selected items

Check to apply the commands in the right-click popup menu to all selected items instead of to the right-clicked item. If nothing is selected this setting is ignored and the tagging applies to the right-clicked item.

On sorting keep tagged items on top

If ticked then the tagged files are kept on top and the empty items are sorted to the bottom. Pretty useful when most of your items are not tagged so that your tagged items would vanish below the view port instead of showing up when sorting by tags. Note that "tag columns" include Label, Tags, and Comment.

Copy tags on copy operations

If enabled then tags are copied from the source to the target items of copy operations.

Copy tags on backup operations

If enabled then tags are copied from the source to the target items of backup operations.

Confirm copying tags

If ticked then you are prompted before any tags are copied from the source items to the target items.

The prompt is popped not more than once per copy or backup operation.

Notes on Copying Tags

· The tag.dat database will grow for each new target item.
· If the target is on a removable drives be aware that the tags do not actually end up on that drive but are just added to the local tag.dat where they merely point to that drive.

Customize Label names and colors

Here you can edit the labels and how labeled items are displayed in the file list. You can add up to 15 label schemes to the list.

Note that the menu icons for labels in the main window will adjust to the back colors you have chosen. Also note the following extra functions of the buttons (also in the buttons' tooltips):

- Edit: Hold CTRL to reset all to factory defaults.

- Text Color: Hold CTRL to reset to default color.

- Back Color: Hold CTRL to reset to default color. Hold SHIFT to remove any back color.

Tips

- DblClick an item to edit its Back Color.

- You can move the items by dragging them.

Note: You cannot move the list positions of the label schemes. Also deletion works only on the last item of the list. This way the index order of the existing labels is always maintained.

Coloring style

Select if and how the labeled items shall be colored in the list.

Options

The Options button pops a menu with several advanced options:

Remove All Tags...

Removes all Labels, Tags, Comments.

Note: This action cannot be undone by cancelling the Configuration dialog! However, in case you made a mistake, if you exit XYplorer without saving (Ctrl+Alt+F4) then tag.dat will not be changed.

Database Check...

If other processes move or rename files or folders, the tag database (the file tag.dat) may contain items that don't exist anymore, the so-called "orphaned tags". This does not affect the functionality of the database at all, but it might slightly decrease performance if the number of orphans is huge.

Click this button to check whether there are any orphaned tags (and how many), with the option to remove them from the database. Along with the orphan removal a number of other things are performed as well:

· Sorting is checked and corrected if necessary.
· Any double entries are removed.
· Any wrong capitalization is corrected.
· Any orphaned entries (entries pointing to non-existing items) are removed.

You can choose (checkbox at the bottom) whether to check all drives or just fixed drives. Choose the latter if you want to clean your database but leave tags from removable drives untouched.

Note: This action cannot be undone by cancelling the Configuration dialog. But, of course, you can undo it by exiting XYplorer without saving (Ctrl+Alt+F4) so that the tag.dat on disk is not touched.

Edit Tagged Items...

Offers backdoor access to the tags database in its current state in memory. You can edit the records (of course you should know what you do, there is no error checking concerning the syntax), remove records, add records. Using Editor Mode you can outsource the work to a text editor of your choice. This feature also comes in handy at checking out orphans and manually reviving them by updating the paths.

FYI, here is the record syntax: filename|label|tags|reserved1|reserved2|reserved3|comment

Edit Orphans (All Drives)...

Pops a list of all current orphans (entries pointing to non-existing items) (if any) which can be manually edited. Note that in this interface, you cannot add or remove items.

Edit Orphans (Fixed Drives Only)...

Same as above, but only checking tagged items on fixed drives.

Enable portable tags

Tick it to store tags in a portable manner. See here for the details.

Fonts

Main Contents: Configure the font (face, size, weight etc.) for Address Bar, Tabs, Tree, Catalog, and List. Tip: If you have a wheel you can easily zoom the font by Ctrl+MouseWheel. The "Apply to..." button opens a checkbox list where you can tick the controls that shall adjust to the font size.

Buttons and Labels: Choose the font (name and size only) used for buttons and labels in the main window, i.e. all elements apart from Address Bar, Tabs, Tree, Catalog, and List. Use font size with care since larger sizes will surely mess up the layout.

Tip: You can control the size of this font using Ctrl+Wheel over the Status Bar. This is not only very practical but also gives you some intermediate fractional sizes that the standard font dialog does not offer.

Dialogs: Choose the font (name only) used in the popup dialogs. Usually you would choose the same font as in General but some users like the chance to make a difference.

Regular Expressions: Choose the font (name and size) to be used when entering a Regular Expression. A fixed space font like Courier makes things more easy here.The size is limited to a maximum of 12 points, else the application's layout would break. Defaults to "Courier New, 8.25".

Tip: This special setting is implemented for the Name field of Find Files, RegExp Rename (under Rename Special), Visual Filter dialog, Selection Filter dialog, Go To dialog (for RegExp Name Searches and Visual Filters), Catalog Item's Destination (same). In most of these fields Regular Expressions mode is turned on by prefixing the entered term with ">".

Edit Text: Choose the font (name and size) used in text boxes (e.g. in List Management's Editor Mode, or in Quick File View, or in the Preview tab for previewed text files). Defaults to "Courier New, 8.25".

Note

Tooltips in the main window follow the font settings of their parent controls, i.e. you can have them as big or as small as the rest of the text.

Templates

Filename affixes

Here you can configure various templates that may be used by XYplorer in "Copy Here with Increment" etc. operations, and/or when new files are created and need to be named, and/or generally when name collisions are to be avoided.

Incremental affix

Used e.g. by "Copy Here with Increment". Set the start value in the template and use "a" as the placeholder for letters and "0" for numbers. The factory default is "-01". Use e.g. "_000" to start with "_000", or "-a" to start with "-a". The suffix is always appended to the file base (i.e. before the extension).

Examples:

Templates

-01 -ab

---------------

Numbers 1: -01 -ab

2: -02 -ac

25: -25 -az

26: -26 -ba

100: -100 -dw

675: -675 -zz

1000: -1000 -bmm

You see, the hexavigesimal system saves space and is fun. :)

If you mix numbers and letters, the increment template will be interpreted as numerical, and the letters will be used unchanged. For example, a template -copy01 will render increments *-copy01, *-copy02, *-copy03, etc.

Using the asterisk: While the default is to suffix the increment you can also define increments that are prefixed to the filename, or that have fixed parts (additionally to the increment part) that are prefixed or suffixed to the filename. The syntax is identical to that of the Date Affix (see below): The asterisk (*) stands for the base (= name without extension) of the original filename. This way you can e.g. mimic the Windows standard "Copy (#) of..." in Custom Copy. Here are some examples:

Copy (1) of * (similar to Windows standard increment)

Copy of *-01

01-*

01-* (Copy)

aa-*

Notes:

· If Custom Copy is turned off and you paste (Ctrl+V) a file into its own location, or you use File | Duplicate | Copy Here, then Windows controls the format of the increment and the incremental affix template is ignored. If on the other hand you use Custom Copy or File | Duplicate | Copy Here with Increment (Ctrl+D), then the incremental affix template is applied.
· If no asterisk (*) is present the increment is suffixed to the base of the original filename.
· You CANNOT combine the asterisk with fixed parts AND non-numeric increments because such a pattern is ambiguous and cannot be parsed without making too many assumptions:
Copy of *-aa NO GOOD!
· The fixed parts may contain numbers, but be aware that always the right-most numbers in the pattern will be incremented.
Copy 2012 of *-01 Will work as expected
Copy (1) of * (2012) Will NOT work as expected!

Date affix

Used e.g. by "Copy Here with Current/Last Modified Date".

The factory default is "*-<date yyyymmdd>". The date is always affixed (prefixed, circumfixed, suffixed) to the file base. The file base is represented by an asterisk in the pattern. If the asterisk is missing the pattern is by default suffixed to the file base.

Examples for copying a file called "Test.txt" using various affix templates:

*-<date yyyymmdd> = Test-20100803.txt

<date yyyymmdd> * = 20100803 Test.txt

Copy of * = Copy of Test.txt

Copy of * from <date yyyymmdd> = Copy of Test from 20100803.txt

The template also supports the variable <folder> that is resolved to the moved/copied file's parent folder (only the folder, not the whole path). Example for a template:

*-<date yyyymmdd> (<folder>)

Note that the presence of this variable in the template is not reflected in the related commands' menu captions, so this variable is rather a very special option that you have to make a mental note about when you use it.

Dropped messages

When drag-dropping messages from Outlook or Outlook Express, this template controls the makeup of the new filenames. The following fields are available for the template which you can define in Configuration | Templates:

- <from> e-mail address or, if given, name of the sender
- <to> e-mail address or, if given, name of the receiver
- <subject> subject line of the message
- <date> local (at yours) date/time when message was sent

A template may, for example, look like this:

<from>_<to>_<subject>_<date yyyy-mm-dd_hh-nn-ss>

You can freely change the order of the fields and pack any text strings before, after or between them. Do not add the extension to the template -- it is done automatically, and mind the space after "<date". If you just put <date> without specifiying the format, the format will default to yyyy-mm-dd_hh-nn-ss.

Note that it's your responsibility to ensure that your templates contain only characters that are legal for filenames. It is not validated inside the configuration window.

Character to replace invalid characters in dropped messages

Here you can state a character that will be used to replace characters that are invalid in filenames (e.g. :?\/*).

For example if you set it to ~ then the email subject

Re: Verifying whether a CD/DVD is a true copy?

will be renamed to

Re~ Verifying whether a CD~DVD is a true copy~

to function within a filename.

Titlebar

Here you can define the layout of the main window's titlebar. The factory default is:

<path> - <app> <ver>

You may add or remove what you like, in any order. There's only one rule: The <app> variable (resolved to the EXE base name, normally XYplorer; if XYplorer is not part of that name it is added to the titlebar anyway) is mandatory.

Variables supported in the Titlebar Template:

- <path> current path
- <app> this EXE base name
- <ini> current INI file (without path)
- <ver> this EXE version
- <folder> current folder (without path)
- <title> the title of the current session (the title can be set by command line switch /title).
- <tabset> name of the tabset of the active pane
- <tabset1> name of the tabset of pane 1
- <tabset2> name of the tabset of pane 2

- And most other XYplorer native variables, e.g. <date>, <xydrive>, <get pane>, <get userrole> etc., but not e.g. <curfolder> (which in this context will always show the previous folder).

- Environment variables.

Command Line Interpreter

Here you can define a custom command line interpreter (CLI) and the arguments it should use. This CLI is used when you use the DOS command syntax in location ports like the Address Bar, e.g. !dir. It is also used by the command Open Command Prompt Here (Tree folder context menu).

Use custom command line interpreter: Check it to actually use the custom CLI. If unchecked the factory default CLI cmd.exe (usually in C:\WINDOWS\system32\) is used.

Executable: State a full or portable path to executable file.

Arguments: Define any arguments for the custom CLI. If your definition contains the placeholder <command> (case-sensitive!), it is replaced with the input from the Address Bar, if not, the input is appended to the end of the arguments definition.

Find Files & Branch View

Find Files

Show relative path in Path column

Show only the relative path in the find results path column (relative to the search path). This is very useful when you do recursive file finds starting somewhere deep down the folder hierarchy when otherwise the path column would be stuffed with redundant information.

Synchronize tree with search location

Check it to always keep the tree in synch with the find results list.

Cache Search Results

Check to store and retrieve the results of searches tabwise and across sessions.

Where and when does it happen. Cached data are not held in memory but written to tab_*.ini files down in the Panes subfolder. They are written whenever a non-cached search tab is backgrounded, and read whenever a search tab is foregrounded (selected). In other words, caching only happens on tab selection, i.e. when you re-open a cached tab. Whereas pressing F3 or any other way to run a search will always trigger a live search.

What is cached. Only the item names are cached. All other data (size, file dates, attributes, etc.) are freshly polled and always up-to-date even in a cached search. Naturally, this polling takes time, and the efficiency of the cache highly depends on the nature of the search:

· The worst case is a search without any filters (e.g. find all items in all subfolders), where reading the cache and processing the data is likely to be even slower than a fresh live search.
· The best case is a search over a large area with relatively few results -- this is where the cache really shines.

Maximum number of items cached (0 = cache always)

Here you can set an absolute limit to the number of items cached. The factory default is set to 1000 and a much higher number is not recommened. There are several reasons for such a limit:

· The bigger the cache the slower it is compared to a live search. So caching is simply inefficient, at least if it is done for speed.
· Reading a cache may (depending on the sort order of the cached items) trigger lots of wild-jumping head movements.
· A cache takes space on the disk.
· A huge cache is more likely to be stale (out-of-date).

Note that this limit does not apply to Search Templates that are explicitly saved together with the search results (which internally is identical to caching).

Follow junctions

Tick it to allow following junctions on a search including subfolders.

Show search results in

Choose among three possibilities:

· Current tab: Show search results right in the current tab.
· New tab: Show search results in a newly created tab.
· "Search results" tab (locked): Show search results in a locked tab named "Search results" (this default name can be changed by renaming the tab). If no locked tab named "Search results" exists it is automatically created. All following search results will be sent to this tab.
· "Search results" tab (unlocked): It's the same as above but -- you guessed it -- the tab is not auto-locked.

Show name search results in current tab

Tick it to show the Quick Name Search results always in the current tab (unless it is locked), irrespective of the setting of the above "Show search results in".

Show name search information in list

If checked then name search information "Name Search: <pattern>" is shown in a name searched list. There is a small right-click menu where you can edit or remove the name search (Edit Search... , Repeat Search, and Remove Search).

Branch View

For a detailed description of Branch View see here. All of the following settings are global to all tabs in Branch View mode.

Persist across folders

Keep Branch View mode active when changing folders within the same tab.

Toggle on same query

Applying the same query again, e.g. "? /:flat" from the Catalog, turns the Branch View off.

Auto-refresh

Allow a list in Branch View mode to be auto-refreshed.

Level-indent

Indent the items in Branch View to show their hierarchical tree position. Hard-coded to 8 pixels per level.

Note 1: The level-indented Branch View is most useful when you sort the file list by Path which will give you a tree-like picture. To automatically invoke such a sort order there is the following option...

Note 2: Branch Views of type "Files Only" are not level-indented. Reason: It's confusing to see files indented below other files.

Level-indent width in pixels (1 to 64)

Customize the level-indent width in pixels. Allowed values are from 1 to 64. Factory default is 12.

Default to tree-like sort order

When invoking a level-indented Branch View sort the items like in a tree: All items sorted alphabetically under their direct parent folders. This is usually the best way to show a level-indented view so it's recommended to tick this option.

Let folders pass all filters

If ticked then on a mixed Branch View (showing files and folders), any Visual Filters or Name Search patterns only apply to files, not to folders. So the folders always stay visible while their contents are filtered. A concept that's further discussed under the name Filtered Branch here.

Multi branch view lists top folders

Tick it to list the containing/top level folders in a Multi Branch View as well, not just the items contained in those folders.

Default branch view type

There are three types of Branch View:

· Files and folders
· Files only
· Folders only

Here you can choose which type shall be used when Branch View is toggled via menu or toolbar.

Tip: You can as well select a Branch View of a certain type right from the right-click menu of the Branch View toolbar button. The Default Branch View Type is not affected by this choice.

Visual Filters

Persist Visual Filters Across Folders

By factory default, Visual Filters will not persist across folders within the same tab; in other words, a Visual Filter is automatically cancelled when you change the location within the same tab. Tick this toggle to change this behavior.

Toggle On Same Filter

If checked then applying the same filter to a filtered list again will remove the filter.

Ignore Diacritics

If checked then the filter matching ignores diacritics and a filter "Koln" will match a file "Köln.txt", and vice versa: a filter "Köln" will match a file "Koln.txt".

Show filter information in list

If checked then the filter information "Visual Filter: <pattern>" is shown in a filtered list. There is a small right-click menu where you can edit or remove the filter (Edit Filter..., Repeat Filter, and Remove Filter).

Show filter information in tab headers

If checked then the Visual Filter pattern is shown right in the tab header in blue color (color "Marked Text 1"), separated from the caption by a "|" character.

File Operations

Background Processing

Backup Operations

Custom Copy Operations

Custom Copy Blacklist

Configure Custom Copy

External Copy Handlers

Miscellaneous

Background Processing

Enable background processing

Check to launch file operations in a separate process.

The advantage of background processing: You can continue working in XYplorer while heavy copy jobs are processed in the background.

Technically this is achieved by passing the file operations to the copy handler XYcopy (XYcopy.exe) which is contained in the distribution package and must be located in the same folder as XYplorer.exe.

Apply To...

Click the button "Apply to..." to configure which types of file operations are backgrounded. The factory default is:

[x] Backup

[x] Copy

[x] Move cross-volume

[ ] Move intra-volume (runs at once in parallel process)

[ ] Delete (runs at once in parallel process)

Notes

· Background processing is by default applied to Backup, Copy and Move (cross-volume) operations. Rename and Delete operations are not backgrounded. Use Apply To (see above) to change these default settings.
· Note on Move operations: Only moves across volume boundaries (= within the same drive) involve copying of bytes and hence take time, whereas moves within volume boundaries just update the MFT (master file table), so they are very fast and do not really need to be backgrounded. However, for the sake of consistency both types of moves are backgrounded.
· When you terminate XYplorer while XYcopy is still working, the job in progress will be finished, but any jobs still waiting in queue will not be triggered. You are prompted whether you really want to lose the jobs.
· Any file operations triggered by Undo/Redo are not spawned to XYcopy.
· Any file operations triggered by drag and drop to XYplorer from another application are not spawned to XYcopy.
· Of course, any file operations triggered by drag and drop from XYplorer to another application are not spawned to XYcopy because those operations are handled by the drop target.
· Any file operations triggered by drag and drop using the Shell context menu are not spawned to XYcopy.
· Background processing is not supported under Windows Me and Windows 98.
· In scripting background processing may lead to undesired results when the script flow overtakes a backgrounded file operation before it is completed. To avoid this you can temporarily disable background processing by inserting this line to the beginning of such a script:
setting "BackgroundFileOps", 0;
Background processing will be automatically re-enabled when the script is finished.

Queue file operations

Check to process background file operations sequentially, in a queue, where successive operations are lined up in sequence and completed one after the other. If unchecked then background file operations are processed in parallel.

E.g. if you initiate a job, say a Copy operation, while another one is still in progress, the new one will be delayed until the other one is finished. One job is triggered after the next, until all pending jobs are completed. A copy queue, also known as asynchronous copy, avoids inefficient pseudo-parallel processing and undue stress on your HD head.

Notes

· This option is applied on a per-job basis in the moment the jobs are initiated by the user, so while one or more jobs are running in the background you can change the setting of "Queue file operations" to control how the next job is handled; running or pending jobs are not affected.
· There's no explicit limit applied to the number of parallel processes.
· Move operations within volume boundaries (see above Note on Move operations) are always processed in parallel (= not queued) regardless of the setting of Queue file operations, because they are usually fast and you rather expect immediate action.
· There is also a toolbar button for this setting.

Status of background jobs

See Background Jobs Dialog.

Backup Operations

See Backup for some general remarks on the nature of XYplorer's Backup.

Configure (button): Click to open the Configuration Dialog (see below) for Backup operations.

Custom Copy Operations

Custom Copy is a widely configurable alternative copy method based on Kernel API. It exceeds shell copy in lots of ways as you will immediately notice when you open its configuration dialog. Note that Custom Copy optionally also includes all sorts of move operations, so the term "Custom Copy" comprises "Custom Move"; see For all move operations below.

Configure (button): Click to open the Configuration Dialog (see below) for Custom Copy operations.

Use Custom Copy: Check to use Custom Copy in place of the standard Windows shell copy. This includes operations like Copy To, Paste (copy) from clipboard and drag and drop. If Copy operations are configured as backgrounded, then Custom Copy operations are backgrounded as well.

For all copy operations: Use Custom Copy for all copy operations.

No progress dialog on duplications: Tick it to prevent the progress dialog when copying files in place (source and target path are the same).

Note: If ticked then the copy operation is forced to run in the foreground even if Backgrounding is enabled.

For all move operations: Use Custom Copy for all move operations.

For cross-volume moves only: Tick it to use Custom Move only for cross-volume moves (between different logical drives) and not for intra-volume moves (where no bytes are copied at all, and which technically are a rename rather than a move).

No progress dialog on intra-volume moves: These moves are extremely fast since no bytes are copied (see also Remarks below), so a progress is not really necessary. Instead you get a summary feedback in the status bar (at least on foreground jobs; on background jobs another status bar message will overwrite it -- but usually you will exclude intra-volume moves from background processing anyway because they are so fast). Note that this setting overwrites the setting of "Show progress dialog" in the general Custom Copy configuration. (However, if "Show progress dialog" is off, then unticking "No progress dialog on intra-volume moves" will not make it show, of course.)

Note: If ticked then the move operation is forced to run in the foreground even if Backgrounding is enabled.

Remarks on Intra-Volume Moves vs Cross-Volume Moves

Custom Move comprises intra-volume and cross-volume moves. Since intra-volume moves are just changes in the volume's Master File Table (MFT) and do not involve any copying of bytes, they are very fast and notably will ignore some of the configuration options, namely:

· Verification (not applicable/necessary: no bytes are copied)
· Safe overwrite (not applicable/necessary: no bytes are copied)
· Remove read-only attribute (unlikely to be useful with moves)
· Preserve all item dates (not necessary: they are preserved anyway)

Note, however, that both intra-volume and cross-volume custom moves optionally provide automatic rename-on-collision.

On cross-volume moves, each file is first copied and then (after optional verification of the copy's correctness) the source file is deleted. When all files are moved, the source folders are deleted (unless they are not completely empty for whatever reason).

Tip: You can configure Custom Copy directly from the right-click menu of the toolbar button "Queue File Operations".

Note: Custom Copy supports Undo/Redo.

Custom Copy Blacklist

Advanced Tip: To exclude certain target folders from Custom Copy (and automatically use normal Shell Copy instead) you can list those folders in a manually created text file placed in the Application Data Folder and named "CustomCopyBlacklist.dat". The paths should be listed one per line in any order. All sorts of variables and portable syntax are supported. Append an * (asterisk) to a path to include subfolders. Here's an example for the contents of the file on 64-bit Windows (on 32-bit Windows you would drop the line "%ProgramFiles(x86)%*"):

%HOMEDRIVE%

%ALLUSERSPROFILE%*

%ProgramFiles%*

%ProgramFiles(x86)%*

%WinDir%*

The typical reason for blacklisting folders is that Custom Copy will fail where UAC disallows writing to them, whereas Shell Copy will prompt for elevation.

The Configuration Dialog for Backup and Custom Copy operations

On name collisions: Here you can configure what happens on a name collision. You have the choice between the following options:

· Ask: [factory default for Custom Copy] Pops an overwrite prompt on each name collision, allowing you to decide case by case. The overwrite prompt tells you a bit about the conflicting files and offers you not to be asked again during the current job.
· Overwrite if newer: [factory default for Backup] Copies only files that are younger/newer than same named files in the destination, otherwise does nothing.
· Overwrite: Copies always, whether a file of the same name exists or not.
· Skip: Copies only files that don't exist in the destination, otherwise does nothing.
· Suffix increment to copy: Suffixes an increment (formatted as defined by the template in Configuration | Templates) to the files being copied.
· Affix current date to copy: Affixes the current date (formatted as defined by the template in Configuration | Templates) to the files being copied.
· Affix last modified date to copy: Affixes the file's last modified date (formatted as defined by the template in Configuration | Templates) to the files being copied.
· Suffix increment to existing: Suffixes an increment to the existing files.
· Affix current date to existing: Affixes the current date to the existing files.
· Affix last modified date to existing: Affixes the file's last modified date to the existing files.

The "existing file" is the one that would otherwise be overwritten. If the existing file cannot be renamed for some reason, the copy will not happen.

Note: Files that are copied in-place (copied onto themselves) are unconditionally auto-renamed (incremental affix) if the setting for "On name collisions" is "Ask" or "Overwrite if newer" or "Overwrite".

On failures: Here you can configure what happens on a failure.

· Ask: Pops a prompt on each failure.
· Continue: Just continues processing.
· Cancel: Cancels the whole job.

On "Ask" you get a prompt with three buttons:

· Continue All: Continues on all such failures (no more asking).
· Continue: Continues (ask again next time).
· Cancel: Cancels the whole job now.

The following failures are recognized:

· Verification failed: May happen if verification is enabled (see below).
· Decryption failed: May happen when copying an encrypted file to a medium that does not support encryption.
· Something else failed: Well, something bad happened that cannot be further specified.

Verification: Verify the correctness of each copy operation on the fly (file by file). If a verification fails you are prompted to continue or abort the operation. You additionally get the option to continue without further such messages. You can choose among several verification methods:

· None (no verification).
· Byte-to-byte: Most secure, but slower on huge files.
· MD5: Fastest of the hashing algorithms offered here.
· SHA-1: More secure than MD5 but slightly slower. Faster than Byte-to-byte on huge files.
· SHA-256: More secure than SHA-1 but slightly slower.
· SHA-512: More secure than SHA-256 but slightly slower.

Notes:

· The verification is only done when bytes are copied, i.e. when a new file is created in the target or when an existing file is overwritten. No verification is done when there is no copying, e.g. when overwriting an existing target file is skipped because the user configured name collision behavior like this.
· Verification ensures that the target file is read from disk, not from the Windows write cache. This makes it slower, but much more useful.
· The reports (available from the Progress dialog) show the hash value of each successfully verified file.
· Verifying a file copy is not necessary under normal conditions. Windows copying is reliable. However, when copying over a network or on USB drives, things can get interesting. Especially if you are backing up files over a shaky network you might want to use Verification for ultimate reliability.

Rename folders on collision: If checked then all copies of folders in your selection are auto-renamed (incremental affix) on collision, else they are overwritten. Note that this concerns only the top folders, not any subfolders, of the items selected for the copy. Subfolders are never renamed on a Backup or Custom Copy.

Note: Folders that are copied in-place (copied onto themselves) are unconditionally auto-renamed (incremental affix) even if this option is not ticked.

Ask before overwriting read-only files: Tick it to get prompted before a READONLY or SYSTEM file is overwritten. (SYSTEM is not mentioned in the caption because it would be too long.)

Remove read-only attribute: Tick it to remove the read-only attribute on target files if present on the source files AND if the source medium is optical (CD-ROM, DVD).

Preserve all item dates: Here you can decide whether all three item dates (created, modified, accessed) are preserved with the copy. Note: Also when the setting is not ticked then at least the Modified date of files (but not of folders) is preserved; this is Windows standard behavior.

Skip junctions: Tick it to exclude folder junctions and their contents from the copying. Note that if this option is OFF (which is the factory default) then folder junctions are not backed up as junctions but as if they were real folders with contents. In other words, the junctions are resolved before the copying.

Symbolic links (Vista/Win7 and later): If Skip junctions is off, then symbolic links are copied as symbolic links. If the source file is a symbolic link, the destination file is also a symbolic link pointing to the same file that the source symbolic link is pointing to. If Skip junctions is on, symbolic links are skipped.

Safe overwrite: Check it to minimize the risk of data loss due to failures while overwriting. See how it works compared to normal overwrite:

Normal Overwrite:

· Source overwrites target. If there is a failure (e.g. power out) while copying the bytes the target is lost and nothing will bring it back. So if the target was your only backup you are without any backup now.

Safe Overwrite:

· Copy: Source is copied to a new temporary target file in the target folder.
· Optional Verification (you set this under "Verification"): The temporary target is compared with the source.
· Rename: If the copy (and optional verification) succeeds then the target to be overwritten and the temporary target swap names.
· Delete: If the name swap succeeds then the target to be overwritten (which now has the temporary name) is deleted.

Note that due to its logic Safe Overwrite needs enough space on the target device to hold the target file to be overwritten and the temporary target file (same size as the source file) at the same time. Nevertheless: Applying Safe Overwrite is HIGHLY RECOMMENDED!

Skip verification on hard disks: Check it to skip verification on hard disks, i.e. when both sources and targets are located on hard disk drives (aka fixed drives). Ticking it is recommended because copying between hard disks is extremely error-safe nowadays, so the verification is not really necessary and just increases wear.

Note that portable external hard drives sometimes show up as fixed instead of removable, i.e. as hard disks. They would be excluded from verification as well if you tick this option.

Show progress dialog: Check it to show a progress dialog (see "The Progress Dialog" below) while the copying is in progress. If unchecked the progress is shown in the status bar if the operation runs in the foreground (else it is totally silent).

Keep progress dialog open: If checked the dialog stays open after the operation is completed. If unchecked the dialog is auto-closed. In the latter case, if Show summary report is checked the dialog is auto-closed only after 5 seconds, otherwise it is auto-closed immediately.

Show summary report: Check to pop up a summary message about what was copied / overwritten / not overwritten. Such a message is only shown when no progress dialog is shown, otherwise the setting has an effect described in the paragraph here above.

Create log file: If checked then all copy operations are logged to file. See details.

Log to default location: If checked (and Create log file is enabled) then the factory default locations are used for the log file location and name. If unchecked you are prompted for a name when triggering the copy operation. The factory defaults are:

· Backup: <xydata>\Log\Backup_<date yyyy-mm-dd_hh-nn-ss>.txt
· Custom Copy: <xydata>\Log\CustomCopy_<date yyyy-mm-dd_hh-nn-ss>.txt

Tip: The defaults can be changed by tweaking the INI file. See Tweaks.

The Progress Dialog

Backup and Custom Copy operations optionally come with a detailed progress dialog. The dialog contains information about the elapsed and remaining time, the average transfer rate, number of done and remaining files and bytes, etc. ... the usual progress dialog stuff. But there is also something interesting:

· There is a Pause button which allows you to Pause and Resume an operation.
Tip: Now you are prompted before the process is paused. This prompt alone might often be already all the pause you need, so you need not "really" pause the processing (with the possible disadvantage that processing resumes with processing the current again from start).
· For files larger 10MB you get a per-file progress (numeric percentage only, no separate progress bar, to keep the interface as plain as possible).
· For files being verified you get a per-file verification progress (numeric percentage).
· Pressing ESC while the operation is in progress will Pause, pressing ESC while the operation is not in progress (paused or cancelled or completed) will close the dialog.
· After Pause/Resume the process will resume with the file that was being processed when Pause was clicked. So it will be copied/verified again. (But see also next point.)
· Without Safe Overwrite, pausing or cancelling processing while a target file was being overwritten would effectively lead to the deletion of the target. Assuming that this can hardly be a desired outcome of pressing Pause or Cancel, an ongoing overwrite operation is allowed to finish before processing is paused or cancelled. Note that this is not necessary (and therefore not done) when Safe Overwrite is enabled.
· When the operation is paused or completed you can view the details (button Report / All Files). Note that this works also when Create log file is off.
· You also can view the log file from this dialog (button Report / View Log File) if you enabled Create log file. The contents are identical to the Report / All Files contents, but here they are shown in a file opened in the system default editor.
· In the unlikely case of failures (e.g. verification failed) you get a detailed list of all failed files (also under button Report / Failed Files).
· When the operation is completed, the dialog (optionally, see Show progress dialog above) stays up so that you can check the results.
· Showing the progress dialog is optional, see Show progress dialog above.
· The progress dialog remembers its position. The same position is also used for the Backup progress dialog.
· The progress dialogs are cascading, i.e. any non-first dialog is positioned in an offsetting (cascaded) position from the last dialog popped up.

Further Remarks on Backup and Custom Copy

· The available free space on the target drive is checked before each copy operation (per job or per file, depending on the circumstances). The operation is only initiated if enough space is available. This will save you frustration when copying very large files to already packed drives.
· Care is taken to prevent the system from entering sleep/standby during long copy or backup jobs. Windows now is kept awake until the copy process is completed. Note: This function does not stop the screen saver from executing. This service needs Windows XP or later.

External Copy Handlers

You can let External Copy Handlers handle the Custom Copy and Custom Move operations. Currently the following products are supported:

· FastCopy
· TeraCopy

To use an External Copy Handler the following has to be ensured:

· Of course, the External Copy Handler has to be installed on your system.
· The setting Configuration | File Operations | Custom Copy Operations | Use Custom Copy has to be ticked.

Configure (button): The button opens a multiline edit box where you can specify any number of external copy handler definitions, one per line. Each line has to follow the same syntax which should agree to this general format:

Caption|[Executable]|[Switches]

· The Caption has to begin with either "TeraCopy" or "FastCopy".
· The Executable has to be the full path to the executable. The path supports full portability, and you can use all kinds of XYplorer native and environment variables. The path can be omitted in which case it will default to the standard path (e.g. "%ProgramFiles%\FastCopy\FastCopy.exe").
· The optional Switches can be used to modify the behavior of the copy handler (rename on collision, verify, overwrite only older, etc.). Form and function here totally depend on the respective copy handler. Look them up in the documentation of the copy handler.
Optionally you can define separate switches for Copy and Move operations. For this use the following alternate syntax:
Caption|[Executable]|[Copy Switches]|[Move Switches]

For instance, the contents of the edit box could look like this:

FastCopy (AutoClose)|%ProgramFiles%\FastCopy\FastCopy.exe|/auto_close

FastCopy (Verify)|%ProgramFiles%\FastCopy\FastCopy.exe|/verify /auto_close

TeraCopy (Rename All)|%ProgramFiles%\TeraCopy\TeraCopy.exe|/RenameAll

TeraCopy (Overwrite Older)|%ProgramFiles%\TeraCopy\TeraCopy.exe|/OverwriteOlder

Select copy handler: Here you can select the current copy handler. This contents of this dropdown are defined by the contents of edit box that is opened by the Configure button. "XYplorer" is automatically added as first item in the list; select it to use XYplorer's native Custom Copy instead of any external copy handler.

The same can also be done via the toolbar. See next paragraph.

Toolbar Integration: All copy handlers listed here are also listed in the right-click menu of the "Use Custom Copy" toolbar button, where you can now select your preferred copy handler by a single click. Also listed here is "XYplorer" which stands for XYplorer's native Custom Copy.

The icon of that toolbar button turns green when and external copy handler is selected, and the tooltip displays the name of the current copy handler.

Auto-Elevation: The copy handlers are auto-elevated if necessary when copying to UAC-protected locations. You don't need to define any Custom Copy Blacklist for this. Actually, you should remove any Custom Copy Blacklist if you plan to use copiers because locations listed in this file will be handled by shell copy and thus never reach the copiers.

Differences to Custom Copy: Integration is very good (whenever anything is copied or moved the External Copy Handler will be used for it), but there are a few differences to using XYplorer's native Custom Copy:

· No Rich Copy. In a Rich Copy situation Custom Copy will be automatically used instead of the External Copy Handler. Reason: You cannot state multiple destinations (one individual destination for each source file) in the External Copy Handler.
· No undo/redo.
· No background processing via XYcopy ( the External Copy Handler is another process anyway), and hence no queueing.

Special Remarks on particular copy handlers

FastCopy: When copying with FastCopy the mode "diff" (copy only if size or date are different) is used which is the default for FastCopy (see FastCopy documentation).

Miscellaneous

Suppress delete confirmation dialog

Check it to skip the confirmation prompt that usually precedes a deletion. Also controls the behavior when you empty the Recycle Bin.

Note that unticking this option does NOT ensure the confirmation prompt! If the delete confirmation prompt is turned off in the Windows system configuration then nothing will bring it back.

Preserve permissions on move operation

When checked then the security attributes of files are preserved when they are moved in the same volume. Uncheck it to have the moved files inherit the security attributes of their new folder.

File operation progress modeless

If checked the file operation progress window is shown modeless. Which effectively means that you can go on working while files are being moved or copied in the literal background: the progress dialog is not "always on top" of the main window. Note however that a modeless progress window can easily get lost behind larger windows.

Note also that when file operations were triggered by drag and drop the source window is usually blocked until the operation is finished.

Note: This setting is ignored if Enable background processing is ON.

Report

Info Panel / Report

Output File Options

When you want to send your report to file you find some options here regarding the default filename (the name preset in the Save As dialog).

Default name to "[Current folder].txt": automatically generates a default filename from the currently browsed folder, quite useful to automate archiving find results.

Date/time as filename suffix: save the current report to a file whose name will carry the exact time when the report was created, eg Report_2009-12-23_21-09-33.txt.

Append to existing file: appends the current report to the file you select in the Save As dialog. If the file does not exist it will be created.

Classic directory dump table width: set the table width in measured characters (64-256).

Line feed on oversized filenames: wrap long lines.

Preview

Audio/Video preview:

Loop

Auto-restart medium when through.

Autoplay

If checked Audio/Video files will start playing immediately. Else you have to click on the progress bar or press the space key.

Play only the first seconds

You can optionally play only the beginning of a sound or video file, and then stop, loop, and jump to the next file (depending on the Loop settings). The number of seconds to be played can be defined in the edit box right of "Play only the first seconds". Untick the checkbox or enter value 0 to play the whole file. The factory default is 3 seconds.

Note that for technical reasons the stop time cannot be exact to the millisecond but will usually be plus-minus 30 milliseconds off.

Keep playing when info panel is hidden

Tick it to keep a running audio/video preview busy when you close the Info Panel.

Audio preview:

Play also when info panel is hidden

Check to preview (listen to) your audio files while the info panel is down and/or the preview panel is not selected.

Video preview:

Preview static frame, skip n seconds

Check it to preview a single static frame of a video (only applied if Autoplay is OFF, of course). You can further define the offset of that frame (skip intro) in milliseconds, which allows you skip any black/blank frames at the very beginning.

Image/Video preview:

Zoom smaller originals to fit preview area

Images that are smaller than the preview area (under standard display settings 320x160 pixel), for example icons and cursors, are zoomed to fill up the space available.

Border style options: No Border, 2D Border, 3D Border

Choose border style for image and Audio/Video preview. Just a look & feel thing.

Image preview:

High quality image resampling

Here you can control the quality of the image resampling used in the Preview Tab, the Floating Preview, the Full Screen Preview, and in Mouse Down Blow Up (on Preview and on thumbnails).

The setting does not affect the thumbnails quality.

Transparency grid

Enable this option to have a checkered grid shining through the transparent parts of the previewed image (PNG, GIF, and other formats supporting transparency). The size of the grid adjusts to the size of the image (larger images get larger fields).

Note that this feature is supported in the Info Panel as well as with Thumbnails (independent setting), Mouse Down Blow Up, and Full Screen Preview.

Auto-rotate preview

Tick to enable Auto-Rotate for the Image Preview, its Mouse Down Blow Up, the Floating Preview, and the Full Screen Preview.

Digital cameras with orientation sensors allow auto-rotation of portrait images by reflecting the positioning of the camera with respect to the ground in the picture's EXIF data. So, the Auto-Rotate feature works only with picture files that contain EXIF data, usually JPEGs and TIFFs (extensions: jpg, jpeg, tif, tiff).

Mouse down blow up:

Shrink to fit

Check to avoid scrolling around larger images.

Affects Mouse Down Blow Up on Image Preview and on thumbnails.

Use whole screen

If checked then the blow up will use the whole screen (if necessary), not only XYplorer's main window. The option "Shrink to fit" (above) will then apply to the screen, of course, i.e. it will work as "Shrink to fit screen".

Affects Mouse Down Blow Up on Image Preview and on thumbnails.

With border

Tick it to show a 1-pixel border around the blow up. Affects Mouse Down Blow Up on Info Panel Preview, Floating Preview, and on thumbnails.

Movement

Lets you control the Mouse Down Blow Up behavior on mouse move. There are two options:

Loupe: The mouse pointer, the blow up, and the preview are always exactly aligned "over" the blown-up spot.

Touch Screen: Like with a touch screen the blow up is dragged around along with the mouse.

Affects Mouse Down Blow Up on Info Panel Preview, Floating Preview, and on thumbnails.

Floating and full screen preview:

Show filename and dimensions

The filename and dimensions (width x height) of the previewed image is shown in a status bar at the bottom of the preview window.

The status bar also shows the approximated aspect ratio of the image (3:2, 16:9, 3:4, etc.).

Zoom to fit

Images that are smaller than the screen area are zoomed to fill up the space available.

Top-align if vertically cropped

Tick to initially top-align a vertically cropped preview. Useful for documents where you want to see the title first. If not ticked the preview is vertically centered.

Mouse Down Blow Up

Tick to enable Mouse Down Blow Up. Untick to enable left mouse panning of cropped images.

Background

Select the background color for the preview. Note that in the preview itself the shortcut B will cycle the background colors.

Quick file view:

Modeless dialog

Tick it to have the Quick File View (and also the Metadata view) modeless similar to the Floating Preview: You can leave it open and select files in the file list to have them quick-viewed.

Web preview:

Enable server mappings

See HTML preview.

Rename preview:

Preview all Rename Special operations

Check to show a preview for each of the Rename Special operations, including detection of possible conflicts.

Text preview:

Display Tabs as spaces

Here you can define how Tab characters are displayed in ASCII Raw View and Quick File View. Select 0 (factory default) to expand TABs by the system default tab stop value (usually 8). Select any other number to display TABs by this number of spaces (the files are not changed by this, of course).

UTF-8 auto-detection

Tick it to attempt to auto-detect BOM-less UTF-8 files. This setting also controls UTF-8 detection in Find Files Contents search.

For your interest, the UTF-8 BOM (or signature) is "ï»¿" (EF BB BF), but often UTF-8 files come without the BOM.

Previewed Formats

XYplorer attempts to preview all checked file types you see in the lists. What formats actually work depends on the configuration of your local system (what Windows version, what version of Media Player is installed, what version of Internet Explorer is installed). If you experience problems with a certain format, uncheck it in the list and it will not be previewed.

In the groups list (upper list) you can enable/disable the preview for a whole group of file types, e.g. for all Image files.

In the extensions list (lower list) you can enable/disable or add certain file types (identified by extension) to the file groups.

Add extension...: Use this button to add new extensions. User-added extensions are colored green (respectively color "Marked Text 2"). They can be excluded from preview by unticking them, or completely removed from the list using the Remove button.

For example, to add *.zig files to the text preview you first select the Text Files group in the upper list, and then add "zig" (without the quotes) as extension to the lower list.

You can as well add files without any extension as a separate file type to any of the file type groups. To do this state "<none>" (without the quotes) as the extension.

Tip: DEL and INS keys work on the extensions list.

File Info Tips

File Info Tips: extensive file information (depending on file type and individual file up to 35 fields!) pops up when you move the mouse over a filename's icon in the List. This feature is restricted to Win2K, WinXP, and higher. You can configure what information you want to see. Contrary to Microsoft Explorer, longer entries (eg the user-editable "Comments" field; you can edit these fields in each file's properties dialog) are not cut off (up to 259 chars per field are shown). Plus, as always, XYplorer is much faster and smoother than Explorer.

In network locations as well: Unless you check this option File Info Tips are not shown for items in network locations (mapped and UNC). This is for performance reasons: depending on the connection they can be somewhat slow because the file has to be physically accessed to retrieve this information.

Show MP3 info tips: These tooltips also work for Win98, ME, and NT. A very powerful feature for MP3 fanatics: scan through your ID3v1.1 tags at the speed of light on mouseover, i.e. without moving one finger! Another unique XYplorer feature.

Show tip only when hovering file icon: if checked, File Info Tips will pop up only when you move the mouse over a file's icon (not the filename).

Initial delay in milliseconds: Time in milliseconds between mouseover and popup. Valid values are from 0 thru 9999.

Visible time in milliseconds: Here you can customize the time a file info tip is visible before it auto-destroys. The factory default is 10,000 (= 10 seconds). The maximum value is 32767, so the tooltips cannot be shown longer than about 32 seconds.

Show tips for clipped tree and list items (aka "in-place tooltips"): Will display a tooltip with the full item name when hovering an item with a partly clipped name. In case of the file list, these tips will only appear when the other sorts of tips (file info tips, mp3 info tips) do not. The tips are hard-coded to an initial delay of 200 ms and vanish after 3 seconds.

Show custom file info tips: Tick the checkbox to customize the file info tips using the list of all available properties (the list varies with your Windows version). Untick it to show the tips as they are shown in Explorer.

The latter has advantages:

· You can see specific 3rd party extensions of the file info tips (e.g. by MediaInfo) which are not shown in XYplorer when you turn "Show custom file info tips" ON.
· Using the default tip (and with "Show MP3 info tips" OFF), you can see the ID3v2 (XY internally only supports ID3v1) info of mp3 files in the file info tip if your shell/OS supports it.

Add the following extra fields if applicable: These XYplorer-only extra fields are appended to the standard file info tips.

Len (Full Path): Shows the hovered filename's length (including the full path).

Path: Shows the item's full path (search results only).

Version Information: Shows the following six fields (if they exist) from the so-called "String Version Info", for example for XYplorer.exe:

FileDescription: XYplorer
CompanyName: www.xyplorer.com
FileVersion: 9.90.0000
OriginalFilename: XYplorer.exe
LegalCopyright: Copyright © 1997-10 by Donald Lessau
Comments: A portable multi-tabbed dual pane file manager... (etc.)

Target (Shortcuts only): Shows the target of shortcuts (LNK files).

Junction Target: Shows the target of NTFS junctions.

Label: Shows the item's label (if any).

Tags: Shows the item's tags (if any).

Comment: Shows the item's comment (if any).

Hard Links: Shows the number of Hard Links of a file. Every file has at least one.

Thumbnails

Width/Height

Thumbnail width and height is mildly configurable. You can choose between various pixel sizes for each dimension.

Tip: When you work a lot with digital photos, which usually have a 4:3 proportion, a setting of width=96 and height=72 or width=240 and height=180 is perfect for you (if you do mostly landscape orientation): more visible rows in the file list, and about 25% smaller cache files.

Note, that the cache files for each of the possible thumbnail sizes are kept independently of each other: thus you can switch between thumbnail sizes in a blink, whereas with Explorer, you have to reboot Windows to do that!

Super-fast thumbnails

Check this box to have thumbnail creation run up to 50 (!) times faster. The price you pay is that the quality of the thumbnails is only as good as Explorer's. You choose...

Note: This feature needs GDI+ installed.

Note: Images >= 6 MegaPixels are super-fast thumbnailed by force (if GDI+ is installed).

Zoom to fill

Tick it to fill all the available space with the thumbnail. Left/right parts or top/bottom parts may be cropped. Using this option makes better use of the available space at the expense of the cropped areas.

Remarks:

· This setting affects how thumbnails are created and stored in the cache, so you cannot apply it to already cached thumbnails without recreating the thumbnails from scratch.
· Images are never stretched to fill the space, just cropped.
· The cropped image is centered, i.e. the cropping is done equally at both of the cropped sides.
· The quality costs of "Super-fast thumbnails" will be more visible with "Zoom to fill" so it is recommendable to turn "Super-fast thumbnails" OFF when "Zoom to fill" is ON.
· Mouse Down Blow Up on cropped thumbnails works fine just as expected.

Enable shell thumbnails

Tick this option to use your Shell's capabilities, and you will get thumbnails for PDF, HTML, MHT, URL, various Office and video formats, and, of course, all sorts of image formats (many of which are already done by XY's internal thumbnails/preview). With the appropriate CODECs installed ticking this option enables XYplorer to show thumbnails of RAW image formats (e.g. CRW, DNG, NEF).

Background: The Shell provides a way to obtain preview images (aka thumbnails) for any file which has a Shell extension that supports this: typically images, videos, web and Office documents, and folders. Windows Explorer's thumbnails are created using this way.

Note: It depends on your operating system and the installed software which file types are actually supported. In the web you can find numerous "Windows Thumbnail Plugins" that will add more thumbnail formats to the Shell and hence to XYplorer.

Cache thumbnails on disk

While the processing on the fly is pretty fast (BTW, it can be aborted at any time by ESC), you can achieve speed of light if you enable the thumbnail caching. Contrary to Explorer, no hidden "thumbs.db" files will be scattered all around your hard disk, but XYplorer stores all cache data in one central folder whose name and location you can choose yourself (button Browse...) (default is a folder "Thumbnails" located right under the application's data folder).

Note that the Thumbnails Cache Folder is fully portable, i.e. you can define it in XY's portable path syntax, e.g.:

Thumbs : relative to application data path

Thumbs\ : same as above (backslash is optional)

..\..\Thumbs : relative to application data path

?:\Thumbs : relative to this XYplorer's drive

DriveName:\Thumbs : relative to the drive named "DriveName" (see Named Drives)

F:\Thumbs : absolute

Tip: The tooltip of the Thumbnails Cache Folder edit box now shows the resolved absolute path.

Button "Clear...": Allows you to delete all *.dat2 and *.dbits files from the thumbnails cache folder. Note that the thumbnails cache folder is the one that is defined in the "Cache folder" edit field on Configuration | Thumbnails in the moment you press "Clear...". But there's a prompt anyway, before the actual deletion takes place.

Cache thumbnails of search results, too: cache as well thumbs of Find Files results.

To refresh the thumbnails cache click menu View | Caches | Refresh Thumbnails. However, it won't be necessary too often: while XYplorer expects and supports user smartness, the cache isn't dumb either and whenever an image file is updated the cached thumbnail is immediately updated too.

Also whenever you rename or move a folder within XYplorer, any affected thumbs cache is automatically adjusted to the change in the background. This is accomplished with and index file called XYThumbs.txt which is created and maintained in the thumbs cache folder. The format of the index file is simple and self-explaining, so that you can even edit it manually or programmatically if needed (if you try to do this note that the folder list is expected to be sorted).

Create all thumbnails at once

Check it to have all thumbnails in the current list created at once (not just the ones that are currently visible in the viewport). Enabling this option is only advisable if also "Cache thumbnails on disk" is enabled because then the work will have to be done only once. Otherwise browsing large image folders will become slow again and again.

Note that even with "Cache thumbnails on disk" enabled this new setting makes browsing a bit slower on fully cached folders. So, if all or most of your folders are already fully cached, you can (very) slightly increase speed by disabling "Create all thumbnails at once".

Note that this setting is ignored in Find mode (Search Results and Branch View) for performance reasons.

Tip 1: The context menu of the Toolbar buttons related to list views features a command Create All Thumbnails Now. Here you can have all thumbnails in the current list created for this list, without having the global Create all thumbnails at once enabled in Configuration | Thumbnails.

Tip 2: The same context menu also features two command Refresh Selected Thumbnails (Faster) and Refresh Selected Thumbnails (Better), as opposed to Refresh Thumbnails which refreshes them all. Note that "faster" is equivalent to the global setting "Super-fast thumbnails". When using these Refresh commands the global setting is temporarily ignored.

Show folder thumbnails

Check it to show thumbnails for folders if possible.

Folder Thumbnails. The file list supports Folder Thumbnails. In Thumbnails view, folders display a thumbnail of any file in the folder named "folder.*" where * is any of the following image extensions: jpg, png, gif (looked for in that order).

If no "folder.*" is found, the alphabetically first *.jpg image in the folder is taken (if any).

Auto-rotate thumbnails

Tick to enable Auto-Rotate for the Thumbnails and their Mouse Down Blow Up.

Digital cameras with orientation sensors allow auto-rotation of portrait images by reflecting the positioning of the camera with respect to the ground in the picture's EXIF data. So, the Auto-Rotate feature works only with picture files that contain EXIF data, usually JPEGs and TIFFs (extensions: jpg, jpeg, tif, tiff).

Transparency grid

Enable this option to have a checkered grid shining through the transparent parts of the thumbnail image (PNG, GIF, and other formats supporting transparency).

Here you can (and have to) control the grid in thumbnails independently from the grid on the Preview Panel.

Show file icon on thumbnail

Check to show the small file icon in the top-left corner of the thumbnail.

Show caption

Tick it to show captions (= filenames) below the thumbnails.

Note: When "Show caption" is disabled then no inline rename is possible in the file list.

Show dimensions of original image on thumbnail

Check to display the size of the original image at the bottom of each thumbnail.

Style

Choose between various display styles.

Padding

Here you can customize the distance between thumbnails. Note that depending on the thumbnails Style some minimal padding is internally hard-coded and silently ensured. Only style "Plain" allows effectively zero padding.

Caption lines

Here you can customize the number of caption lines shown. This setting affects Thumbnails and Large Icons views.

Use (Thumbnails View Backcolor)

Here you can customize the background color just for thumbnails views. Notes:

· The color is only applied to the active pane.
· The color overwrites Configuration | Styles | Mirror tree box color in list.

Pop up image in original size on mouse down (Mouse Down Blow Up)

Turn it on to do enable Mouse Down Blow Up: Pop up image in original size on mouse down. If it's off, you can drag and drop thumbnails easier because you can use the whole thumbnail area for grabbing, not just the caption.

Note that Mouse Down Blow Up is also available for the thumbnails Animated GIFs. The blow up will be animated.

On left mouse down (popup stays up until button is released): Turn it on for left mouse down.

On right mouse down: Turn it on for right mouse down.

· Stay up: Tick to have the blow up stay up until clicked again or any button is pressed.
· Fit image to screen: Tick to show the whole image using the whole screen. If unticked then the MDBU settings at Configuration | Preview | Mouse down blow up are used.

Dual Pane

Shade inactive pane

Check to shade the background of the inactive pane. The color is configurable in Configuration | Colors.

If ticked then the inactive pane will not color the sorted column anymore.

Tab key

Select the functionality of the Tab key.

Resizing the window

Select the automatic resizing of the panes when the window size is changed.

Always keep 1st pane visible

Check it to ensure that the first pane is always visible. E.g., when you are in single pane mode / 1st pane, and do "Toggle Active Pane", then dual pane mode is auto-enabled before activating the 2nd pane so that the first pane is still visible. In other words, tick this option to never see only the 2nd pane.

Sync select honors relative paths

If ticked (= factory default) then in search results, Sync Select automatically honors the relative paths of the items (relative to the root path of the search, respectively of the Branch View).

Note that the settings also takes effect if only one of the panes is in Find mode.

Tabs

Open new tab next to current

Check to open a new tab next to the current one.

Activate left tab on closing current

If checked then the tab to the left (else to the right) of the current tab is activated (selected) when the current tab is closed.

Cycle tabs in recently used order

Check to cycle the tabs based on the usage sequence (aka MRU) instead of the left-to-right position.

The cycle functions are these (as listed in Customize Keyboard Shortcuts):

Miscellaneous / Tab Functions /

Cycle Tabs Backward: Ctrl+Shift+Tab; MouseWheel Up

Cycle Tabs Forward: Ctrl+Tab; MouseWheel Down

Cycle Tabs Backward, Delay Browsing: Ctrl+PageUp

Cycle Tabs Forward, Delay Browsing: Ctrl+PageDown

Note that going by MRU has the usual "history" logic: If you go backward from A to B, then to return to A you have to go *forward* (not backward again).

Note that when you are on the most recent tab, Ctrl+Tab will not wrap around but go backward. This allows you to jump back and forth between the 2 most recent tabs with one key combination.

Note that with "Activate left tab on closing current" and "Cycle tabs in recently used order" both enabled, the *previously used tab* is auto-selected on closing the current tab.

Maximum number of tabs (0 = unlimited)

If the limit is reached, and no Default Tab is defined, and a new tab is to be created by you or by some implied process, then the last (right-most) tab will be used for it.

Maximum tab width in pixels (0 = use all space)

Here you can define a maximum tab width. Default is 250 pixels. Set to 0 to have tabs use all space available.

Flexible width

If enabled tabs will only be as wide as necessary to show the full caption.

Special benefits for named tabs (Menu View | Tab | Rename Tab):

(1) You can save valuable screen space if you choose short names for your tabs.
(2) Named tabs' captions are never cropped if space gets scarce.

Always keep right end of tab bar empty

Ensures, independently of the setting of maximum tab width, an empty space of 16 pixels at the right end of the tab bar. This space can be dbl-clicked to create a new tab, or right-clicked to pop a list of all tabs.

Show 'New Tab' button

Tick it to show the 'New Tab' button. It is positioned right of all tabs on each pane and provides a mousy way to open a new tab.

Prompt on closing a locked tab

Tick it to prompt on closing a locked tab, a tab with a home, or a default tab.

Delay before a dragged-over tab is auto-selected (in milliseconds)

The delay before a dragged over tab is automatically selected. Allowed values are from 0 to 9999.

Tip: When you enter 0 (zero) the tabs are never auto-selected on drag-over.

Also auto-select tabs in the inactive pane

Untick it to keep the inactive pane's tabs passive on being dragged-over. This can be quite practical.

Tab captions

Here you can customize the tab captions. Choose among three options:

Full path: Show the whole path.

Folder only: Show only the last child folder name.

Custom: Use a template that can be defined using the Custom button. The default pattern is
<drive>: <folder> but you can do anything that crosses your mind, e.g. <folder> (<drive>) or <folder> on <drive>: etc.

Tip: Variables like <folder> or <drive> can also be specified per-tab using menu View | Tab | Rename Tab.

Show X close buttons on tabs

Choose whether/how X close buttons are displayed on the tabs.

On dbl-click

Choose what happens when dbl-clicking a tab header.

On middle-click

Choose what happens when middle-clicking a tab header.

Visual style

Choose the style of the tab headers.

(1) Windows Themes: Only effective when Themes are enabled (XP and higher).
(2) XYplorer Classic

Yellow highlight marks selected tab in classic style

Check it to have a thin yellow stripe on top of the selected tab. This setting controls the tabs on the Info Panel, and the main browsing tabs if they are in classic style.

Auto-save tabsets on switch

Check it to automatically save the current tabset when switching to a new one. If unchecked the closed tabset will be opened in its last saved state next time it is opened.

Going home also restores the list layout

Tick it to restore the full list layout (view mode, sort order, column layout, list style) when selecting the "Go Home" command. Otherwise going home only changes the location.

Undo & Action Log

Log actions and enable undo/redo

Turn the whole thing on/off.

Remember the logged actions between sessions

If checked then the file action.dat is written on exit and read on startup. Note that it is even written when "Save settings on exit" is off because it must stay in synch with reality as much as possible.

Allowed number of entries in the action log (maximum is 100)

The more entries you log the larger is action.dat, the more memory is used, the slower is startup. But don't worry: It's virtually not notable.

Date format in action labels

Some options for date display.

Prompt before undo/redo

Pops a short description of what will happen when you click OK. Note: With cumulative undo you get only one prompt, but you get it always (independent of this setting) because cumulative undo can be a pretty terrifying experience...

There are three levels of safety:

* Always
The safest.
* If action is older than 10 minutes
You'll lose at most 10 minutes of work without being warned.
* Never
You are tough.

Prompt before delete

If checked then you are prompted before undoing Copy or New, which both involve deletions. This prompting in accordance with Explorer behavior and the factory default is ON.

Delete to recycle bin

When undoing a Copy or a New operation, items will be deleted. If this option is checked they will be moved to the recycle bin instead of being permanently deleted. This is a safety net in case you pressed Undo without thinking. The price is that you don't get back the disk space. Note that redoing such an operation will not get the items back from the recycle bin but create them anew!

Show last actions in toolbar button menu

If checked then (after a restart) the Undo/Redo buttons have a small arrow that pops the previous/next actions (relative to the current position in the action log) in a menu.

The dropdown has further options:

* Allow only single step undo/redo
The safe way. You can see your action history in the menu but you are not allowed to trigger any non-sequential operations. An easy protection from potential disaster.
* Allow cumulative undo/redo
If selected then undoing a non-next action will not trigger (non-sequential) undo of this action alone but trigger undo for all actions from here to the selected one.

As this can mean a tremendous (and devastating) operation by a single click, you'll get a safety prompt before it happens.

* Allow non-sequential undo/redo
If selected then the toolbar menu allows for non-sequential undo/redo.
When you trigger a non-sequential operation (one that is not next to the current position in the action log) from this menu the current position in the action log will NOT change. This makes it easier to do non-sequential undo/redo operations.
If checked then inverse operations are tolerated, i.e. you can trigger a Redo by clicking the Undo button and vice versa! This is a necessary consequence of the ability to do non-sequential undo. So Undo/Redo are then Back/Forward in action log.
Repeated warning: Non-sequential undo can mess up the action log (and hence the possibility of further undo) if you are not careful enough. It's safer to do it from the Action Log Window than via the toolbar menu because the former has more information for you.

Show options in menu

If checked then the above settings are also available in the Undo button's arrow menu. Gives you an idea about what will happen when you click a menu item.

Shell Integration

Here you can integrate XYplorer with the Windows shell.

Scope

Here you control the scope of the shell integration. You have two options:

· Only for the current user
· For all users of this computer (you need admin rights to alter the following settings!)

Note that changes in the following checkboxes will take immediate effect and modify the registry of the host system.

XYplorer in shell context menu

Tick this box to add the item "XYplorer" to the shell context menu for drives and directories. By selecting "XYplorer", XYplorer will open this drive or directory.

To remove XYplorer from the shell context menu simply untick the checkbox.

XYplorer is default file manager

Tick this box to have drives and directories opened in XYplorer by system wide default and thus replace Windows Explorer as default file manager. Untick the box to go back to Explorer at any time.

Note that this option is logically and technically subordinated to the one here above: You cannot have this without the other, but you can have the other without this.

64-bit Windows

The following is only visible in 64-bit Windows and Vista or later.

Show the real System32 directory

Tick it to access the real System32 directory instead of being redirected by Windows to SysWOW64.

If unticked then a warning message is shown in a list that is redirected by Windows to SysWOW64.

See here for details on the Windows file system redirection.

Show 64-bit context menu

Tick it to show the 64-bit shell context menu instead of the 32-bit shell context menu.

· The shell context menu is the menu you see when you right-click files or folders. Here so-called shell extensions can place custom commands that extend the Windows native commands. But there is a drawback: On 64-bit Windows, 32-bit applications only show 32-bit shell extensions, and 64-bit applications only show 64-bit shell extensions. XYplorer now offers you the best of both worlds: You can pop the 32-bit context menu AND the 64-bit context menu, whatever you prefer!
· The option is only offered under 64-bit Windows (it would be meaningless under 32-bit Windows).
· The functionality is provided by the helper file ContextMenu64.exe which has to be located in the path of XYplorer.exe.
· The 64-bit context menu will not contain any of XYplorer's custom items in the shell context menu.

Tip: If you leave the option unticked then the 32-bit context menu (in Tree and List) will offer an extra command "Show 64-bit Context Menu" by which you can open the 64-bit context menu on the fly. That way you can have XYplorer's custom items in the context AND quick access to the 64-bit context menu.

Last not least, credits and a big thanks for designing and writing ContextMenu64.exe go to "Mesh" (from XYplorer Beta Club)!

Features

Here you can control some of the advanced functionality of XYplorer and disable features which you do not use or wish to see. Disabling a feature will remove the related elements from the GUI and may improve overall resource usage.


Multilingual Support

Multilingual Support

XYplorer supports interface languages other than English. A list of all available interface translations can be found on this web page:
http://www.xyplorer.com/languages.php

How to Select a Language

Use the command Select Language... in menu Help to download the language file of your choice from the server and load it into the interface in one go. No restart required.

The downloaded language files are saved in the application data path. Once a file is downloaded you can hold CTRL while you click Select Language... from the Help menu to load the language (e.g. "French.lng") into the running application. If you have downloaded different language files you can switch languages on the fly. No restart required.

To quickly go back to English simply tick Back to English in the same menu (this command will always stay in English). Untick Back to English to go back to the loaded language. Again, no restart required.

Tip: You may need to change the system locale

Loading a language works seamlessly when the language matches the language of the operating system, or more exactly: when the character sets match. So, there is no problem to run XYplorer in e.g. French under a German Windows. However, on a German Windows you won't be able to see, for example, Korean characters in the main menu but just question marks. In that case you should set the system locale to Korean.

Here is how to change the system locale in Windows 7: Open the Control Panel and click the Clock, Language, and Region link. In the Clock, Language, and Region panel, click on Region and Language. This opens the Region and Language. There, go to the Administrative tab. In the Language for non-Unicode programs section, you can see the currently set language. To change it, first click on Change system locale. This opens the Region and Language Settings window. Click on the Current system locale drop-down list and select the language you need to be used. When done selecting the language, click OK. You are now informed that you need to restart your computer, so that the change gets applied. Close all your open applications and documents and click on Restart now. When you log back in, the new language is applied for non-Unicode programs. IMPORTANT WARNING: The change of the language used for non-Unicode programs gets applied to ALL non-Unicode programs. Therefore, if you need to run another non-Unicode program which uses a completely different character set, you need to change the non-Unicode program language yet again.

How to Edit the Interface Language

You can easily edit a translation or create a new one yourself using the Interface Translation Tool. If you want to contribute to XYplorer and translate it into your language please see this:

http://www.xyplorer.com/languages.php#Translators

Interface Translation Tool (ITT)

The command Interface Translation Tool in the Help menu is only enabled when a language is loaded. It opens a dialog where you can edit every single text bit in the interface.

Here is a short overview over the main features. A more detailed description of the Interface Translation Tool (online!) is found in the XYplorer User Forum.

· At the top of the list you can edit some of the header data. Then the translation begins with the "OK" button.
· Original and translation are WYSIWYG-previewed where applicable. Variables are resolved using "Dummy" values, number variables are resolved using a set of test numbers (0, 1, 2, 5, 21).
· Apply & Next: Pressing <enter> in the Edit box (Ctrl+Enter in a multi-line box) will apply the changes in the current item, set it to "translated" state internally, make it green in the text items list, and move on to the next item.
· The right-click menu of the main items list offers a traffic light system for tagging the items:
Translated Green
Mostly Translated Yellow
Partially Translated Red
Not Yet Translated White
· Suggestions are given if similar items have already been translated. Click on a suggestion to place its value into the Edit field.
· Assign Missing Accelerators: This command in the Tools menu automatically adds accelerators to all items meeting a set of conditions.
· A progress bar at the bottom colorfully reflects the overall translation state (red, yellow, green).
· If you save the changes they will be immediately applied to the application interface after closing the ITT.
· Upgrade Language File (Download): Downloads the latest reference file from the XYplorer server, stores it locally and upgrades the currently loaded language file to the latest state. You do this when the MultiLingualSupportVersion is not up-to-date (the ITT will tell you in red letters).
· Apart from translation you can use this tool to modify the original English, e.g. add helpful remarks to captions or tooltips. In other words, you now have a revolutionary way to personalize the application.
· Of course, you can as well work directly in the LNG file using any editor. The ITT is just a GUI for this job.


Keyboard Shortcuts and Mouse Tricks

Menu Command Default Shortcuts

Shortcut keys allow you to quickly invoke menu commands without first displaying the menu and then selecting an item from it. The most commonly used commands can be invoked using the following shortcut keys. Note that all shortcuts can be altered using the Customize Keyboard Shortcuts dialog in menu Tools.

File Menu

Enter Open Selected Item(s)
Ctrl+Alt+Enter Open with...
Ctrl+Enter Open Focused Item
Ctrl+O Open...
Ctrl+D Copy Here with Increment
Ctrl+Shift+Alt+D Copy Here with Current Date
Ctrl+Shift+D Copy Here with Last Modified Date
Ctrl+S Copy Here As…
Ctrl+Shift+C Copy Here to New Subfolder...
Ctrl+Shift+X Move Here to New Subfolder...
Del Delete
Shift+Del Delete (No Recycle Bin)
Ctrl+Del Delete (Skip Locked)
F2 Rename
Shift+F2 Batch Rename
Alt+Enter Properties
Ctrl+Q Preview
Ctrl+Alt+F4 Exit without Saving
Alt+F4 Exit

Ctrl+P Copy Item Path/Name: copy name(s) with path to clipboard (of all selected items in List)
Ctrl+Shift+P Copy Item Name: copy name(s) (w/o path) to clipboard (of all selected items in List)

Edit Menu

Ctrl+Z Undo
Ctrl+Shift+Z Redo
Ctrl+Alt+Z Action Log
Ctrl+X Cut
Ctrl+C Copy
Ctrl+V Paste
Ctrl+Shift+V Paste Here to New Subfolder...
Shift+F7 Move To...
Ctrl+F7 Copy To...
Ctrl+Shift+F7 Backup To...
Ctrl+Alt+N New Path…
Ctrl+A Select All: select all items currently listed
Ctrl+Shift+A Deselect All: deselect all items currently listed
Ctrl+Shift+I Invert Selection
Ctrl+M Selection Filter...
Ctrl+Alt+M Select By Selected Type(s)
Ctrl+Shift+M Select Items...
Ctrl+Shift+Alt+M Select All Files
Ctrl+F Find Files: open find files tab if not visible anyway
Ctrl+Alt+F Find Now
F3 Quick Name Search
Ctrl+Shift+F3 Toggle Quick Name Search
Shift+F3 Repeat Last Quick Name Search
Ctrl+F3 Show All Items In Branch

Ctrl+N Create New Folder
Ctrl+Shift+N Create new Text File

View Menu

F5 Refresh
Ctrl+Shift+R Auto-Refresh
Ctrl+R Suspend Auto-Refresh
F4 Refresh Tree
Shift+F4 Refresh Current Folder
Ctrl+Shift+F4 Reset Tree: rebuilds the whole folder tree and then carries you back to the location where you were before, while closing all other open branches
Ctrl+F5 Refresh List: update the current list data, but keep any selections and scroll position.
Ctrl+Shift+F5 Reset List: update the data, scroll back to top, set focus to the first item (if any), unselect any selections.
Shift+F5 Calculate Folder Sizes: refresh current file list with folder sizes shown.
Ctrl+Shift+H Show/Hide hidden files and folders

Ctrl+T New Tab
Ctrl+Shift+T Tab List...
Alt+Home Go Home
Ctrl+L Lock Location
Ctrl+W, Ctrl+F4 Close Tab
Ctrl+Shift+W Close All Other Unlocked Tabs
Ctrl+J Set Visual Filter...
Shift+Alt+J Filter by Selected Extension(s)
Ctrl+Shift+J Toggle Visual Filter
Ctrl+Alt+J Filter by Selected Extension(s)

Ctrl+Numpad Add Autosize Columns Now
Ctrl+Shift+Numpad Add Grow Name Column
Ctrl+Shift+Numpad Subtract Shrink Name Column

Ctrl+Alt+R Sort by Random Order
Ctrl+Shift+E Toggle Age (date display format)

Go Menu

F7 Previous Location: jump to the previous tab/mode/location (useful to zap back and fore between two locations)
Shift+Alt+F7 Go to Previous Item in List: jump to the previously focused and selected item in the current file list.
Ctrl+Alt+F7 Go to Last Target
Backspace Up
Shift+Backspace Down
Ctrl+Backspace Breadcrumb...
Alt+Left Back
Alt+Right Forward
Ctrl+H Hotlist...
Ctrl+G Go to...: enter/paste a location to jump to
Ctrl+Shift+G Go to from Here...: enter/paste a location to jump to (preset to current path)
Ctrl+Shift+L Go to Line...: enter/paste a line number to jump to
Ctrl+Shift+Alt+G Go to Application Folder

Favorites Menu

Ctrl+B Toggle Favorite Folder: toggle favorite status of current folder
Ctrl+Shift+B Toggle Highlighted Folder: toggle highlighted status of current folder
Ctrl+Alt+B Toggle Boxed Branch: toggle boxed branch status of current folder

Tools Menu

F9 Configuration: show configuration window
Shift+F9 Customize Keyboard Shortcuts
Ctrl+Shift+F9 Customize Toolbar
Ctrl+I Customize File Icons

Panes Menu

F10 Dual Pane

Ctrl+F10 Horizontal Panes

Ctrl+Alt+F10 Toggle Active Pane

Shift+F6 Move to Other Pane

Ctrl+F6 Copy to Other Pane

Ctrl+Shift+F6 Backup to Other Pane

Window Menu

Ctrl+Shift+F12 Show Address Bar
Ctrl+F12 Show Toolbar
F8 Show Navigation Panel
Shift+F8 Show Tree
Ctrl+F8 Show Catalog
F12 Show Info Panel: toggle the Info Panel's visibility
Alt+F12 Last Size/Minimize Info Panel
Shift+F12 Maximize/Minimize Info Panel

Help Menu

F1 Contents and Index: display this help file

Other Shortcuts

Tree

[alphanum. key] Select the next visible folder whose name starts with that letter or number
Numpad - (subtract) Collapse selected node
Numpad + (add) Expand selected node
Numpad / (divide) Fully collapse selected node
Numpad * (multiply) Fully expand selected node
Ctrl+Numpad / (divide) Fully collapse drive
Shift+Numpad / (divide) Optimize tree
Return Toggle collapse/expand
Backspace key Browse to parent folder
[arrow keys etc.] All common navigation keys just like Explorer
Alt+Return Show Properties dialog of the focused item (AltGr+Return to avoid beep sound)
Ctrl+Home Jump to the top folder (Drive, \\Server, Desktop, MyDocuments) of the current folder
Shift+Alt+F6 Move the focused item into view
Ctrl+Alt+P Open Command Prompt Here

List

[alphanum. key] Select the next file whose name starts with that letter or number
Backspace key Browse to parent folder
Del Delete all currently selected files (Recycle Bin)
Shift+Del Delete all currently selected files (NO Recycle Bin)
Ctrl+Left Arrow (find results only) jump to currently focused file in its folder
Alt+Return Show Properties dialog of the focused item (AltGr+Return to avoid beep sound)
Ctrl+Numpad Add Adjust all column widths
Esc Abort calculating folder sizes or a running search
Shift+Alt+F6 Move the focused item into view

Catalog

Del Remove selected item from Catalog ("sure?"-prompt)

Ins Add New Item Here...

Shift+Del Remove selected item from Catalog (no prompt)

Shift+Alt+F6 Move the focused item into view
Ctrl+Shift+Enter Open Selected List Item(s), using the clicked application
Ctrl+Shift+Alt+Enter Show a Catalog item's location in the Tree, without selecting the tree folder nor displaying its contents in the file list.

Tabs

Ctrl+T New tab
Alt+Home Go Home
Ctrl+W, Ctrl+F4 Close current tab
Ctrl+Tab Cycle thru tabs (forward)
Ctrl+Shift+Tab Cycle thru tabs (backward)
Ctrl+Shift+Left Shift current tab to left
Ctrl+Shift+Right Shift current tab to right
Shift+Click Close that tab

Tabbed Info Panel

Ctrl+1 - Ctrl+6 Jump to Panel tabs by number

File Find

Return Start File Find when any control on the find files tab is focused (except the textbox on the Contents tab, where this key just creates a new paragraph).
Esc Abort a running File Find or Folder Report process

Audio/Video Preview

Space bar Start/Pause playing.
Shift+Space bar Go to beginning and stop.

Floating Preview and Full Screen Preview

F11 Open current image file in Floating Preview
F11, Esc Close Floating Preview
Shift+F11 Open current image file in Full Screen Preview
Shift+F11, Esc Close Full Screen Preview
PageUp/Shift+Space/WheelUp Previous image
PageDown/Space/WheelDown Next image
Up, Down, Left, Right Pan cropped image
Home/End First/Last image
A, Numpad Multiply Fit All
W Fit Width
H Fit Height
I Zoom to Fill
O, 1, Numpad Divide Original Size
D, 2 Double Size
Numpad Add Zoom In
Numpad Subtract Zoom Out
Shift+Numpad Add Fine Zoom In
Shift+Numpad Subtract Fine Zoom Out
K Lock Zoom
G Toggle Zoom
Z Zoom to Fit
V Top-align if Vertically Cropped
B Cycle Background Color
Shift+B Cycle Background Color Backwards
S Show Filename and Dimensions
M Mouse Down Blow Up
L Rotate Left
R Rotate Right
F Flipped
Q High Quality Image Resampling
T Transparency Grid
C Copy Original
Ctrl+C Copy Preview
Del Delete File
F2 Rename File
F5 Refresh

Customize Toolbar

DEL Remove selected item
INS Insert selected item
S Add separator
Backspace Remove the item right before the currently selected item

Edit Boxes

Ctrl+A Select all.
Triple-Click Select all.
F2 Select toggle all/nothing.
Up If selection: caret to start of selection and unselect

else: caret to start of text.

Down If selection: caret to end of selection and unselect

else: caret to end of text.

F5 Convert selected text to Title Case (converts the first letter of every word in string to upper case).
Shift+F5 Convert selected text to UPPER CASE.
Ctrl+F5 Convert selected text to lower case.
Ctrl+Backspace Delete the previous word.

Other

ESC All time-consuming processes (finding files, calculating folder sizes...) can always be stopped by pressing ESC.
F6 Cycle focus in this sequence: Address Bar > Tree > List > Catalog.
Ctrl+F11 Open focused file in default browser. Only for web files.
Ctrl+Up/Down In lists with shiftable positions: shift selected item up/down.
Ctrl+Numpad Div Fully collapse current drive. The drive root will automatically be selected.
Alt+Up Show/Hide the main menu (CKS | Miscellaneous | General Functions).
Hold Shift Open the location you are going to in a new tab.
Hold Ctrl+Shift Open the location you are going to in the inactive pane.

Mouse Tricks

Anywhere

Ctrl+Wheel Over Status Bar: Zoom font size of Buttons and Labels.

Ctrl+Wheel Elsewhere: Zoom font size of main controls.

Tree

Ctrl+Dbl-Click On the white space: scroll focused item into view.
Right Mouse Click On non-folder area: pops up the Favorites context menu.
Ctrl+Click Open in new background tab.
Ctrl+Shift+Click Open in new tab (and focus it).
Shift+Click Open in new tab (and focus it).
Alt+Click Open in inactive pane.
Shift+Alt+Click Open in a new tab in the inactive pane.
Middle-Click Open in new tab (equivalent to Shift+Click).
Ctrl+Shift+Wheel Increase/Decrease row height (line spacing).
Shift+Wheel Increase/Decrease indent.

Catalog

Ctrl+Click Open in new background tab.
Shift+Click Open in new tab (and focus it).
Ctrl+Alt+Click Open in this tab (even if it is locked).
Middle-Click Open in new tab (equivalent to Shift+Click). Needs "Middle-click opens folder in new tab" enabled.
Ctrl+Shift+Click Open Selected List Item(s), using the clicked application.
Ctrl+Shift+Alt+Enter Show a Catalog item's location in the Tree, without selecting the tree folder nor displaying its contents in the file list.
Drag Move dragged item to new position.
Drag holding Ctrl Copy dragged item to new position.
Ctrl+Shift+Wheel Increase/Decrease row height (line spacing).
Click Left-most 8 pixels: select item but do not trigger action.

List

Dbl-Click On the line numbers column header ("#"), or on the area to the right of all column headers: adjust all column widths to their contents.
Ctrl+Dbl-Click On the white space: scroll focused item into view.
Right Mouse Click On the line numbers column header ("#"): pops the Sort By menu.
Right Mouse Click On the column headers: pops the Show Columns context menu.
Hold Shift While selecting a view: Apply the view to all tabs.
Middle-Click Open a folder in a new tab (equivalent to Shift+Dbl-Click). Needs "Middle-click opens folder in new tab" enabled.
Ctrl+Shift+Wheel Increase/Decrease row height (line spacing).
Ctrl+Shift+Dbl-Click On a folder: browse the folder in the inactive pane.
On a file in Search Results: the containing folder is opened in the inactive pane and the file is selected.
On the white space: Scroll to Top.

List showing thumbnails

Left-Click on thumb Mouse Down Blow Up, while mouse button is down. Note: hold the mouse down longer than 150ms. Quick clicks will simply select the item.
Right-Click on thumb Mouse Down Blow Up, stay up until you hit any key or click it again.

Drag & Drop

Hold Ctrl Force copying dragged objects.
Hold Shift Force moving dragged objects.

Tabs

Wheel over Tab heads Scroll through the tabs
Dbl-Click Close tab (background tabs are shortly selected, then closed).
Middle-Click Close tab (background tabs are closed without selecting them first).

Tree/List Splitter and Dual Pane Splitter

Right-Click Open context menu for splitters.
Shift+MouseWheel Change the global splitter width.

Tabbed Info Panel

Dbl-Click on Splitter Toggle Info Panel min/max size.
Ctrl+1, Ctrl+2, etc. Select Tab 1, 2 etc.

Find Files Tab

Ctrl+Click Tab heads Toggle search filter On/Off

Copying Information to Clipboard

As rule of thumb, any text or icon you see anywhere on the info panel or the status bar can be copied to the clipboard by double-clicking it. Some special cases are extensions to this rule:

Dbl-Click on the Objects-section on the status bar (the left-most section) copies summary information on the current folder, eg:

D:\Download\, 145 object(s), Total: 13.29MB (13,935,798 bytes)

Dbl-Click on a Key label on the Properties and Version tabs copies the key and the value. eg:

Created: Wednesday, January 12, 2000 20:57:21

Dbl-Click on a Value label on the Properties and Version tabs copies just the value. eg:

Wednesday, January 12, 2000 20:57:21

Image Preview

Mouse actions directly on the preview image:

Left Mouse Down Mouse Down Blow Up: Popup image in original size (aligned to the bottom-left). If image is larger than the main window move the mouse while holding it down to scroll the image in any direction (or enable "Shrink to fit" in Configuration | Preview).
Ctrl+Mouse Down Toggle zoom/original size.
Right Mouse Click Pops up the image preview context menu.

Audio/Video Preview

Mouse actions directly on the progress bar:

Left Mouse Down Go to mouse position.
Right Mouse Down Start/Pause playing.
Shift+Left Mouse Down Go to beginning.
Shift+Right Mouse Down Go to beginning and stop.
Ctrl+Left Mouse Down Set start of sub loop.
Ctrl+Right Mouse Down Set end of sub loop.
Ctrl+Alt+Mouse Down Reset sub loop.

Floating Preview and Full Screen Preview

Right Mouse Click Show context menu.
Ctrl+Left Mouse Drag Pan a cropped image.
Right Mouse Drag Pan a cropped image.
Middle Click Close preview.
MouseWheel Up Previous Image.
MouseWheel Down Next Image.
Ctrl+MouseWheel Up Zoom In.
Ctrl+MouseWheel Down Zoom Out.
Ctrl+Shift+MouseWheel Up Fine Zoom In.
Ctrl+Shift+MouseWheel Down Fine Zoom Out.


Command Line Switches

Command line switches

This is about the Windows command line, aka command prompt, as used e.g. in the DOS-Box or in the properties of shortcuts (LNK files).

The overall command line format is:

XYplorer.exe[ /win=min|max|normal][ /ini=myini][ mystartpath]

The order of the switches is not relevant. Only the startup path must be last.

/win

You can control the window state on start up:

/win=min -> start minimized

/win=max -> start maximized

/win=normal -> start normal

/win=tray -> start minimized to tray

/win (extended syntax)

The switch /win can also be used to specify the main window position and dimension at startup, overwriting the values in the INI file. Each value is optional and if missing the value found in the INI file is used. General format:

/win=[min|max|normal|tray],[x],[y],[width],[height]

Examples:

/win=normal,40,20,1200,800

/win=,20,20,1200 -> window state and height from INI

/win=,,,1000,800 -> window state and position from INI

/win=min -> start minimized (other values from INI)

/win=max,,,,400 -> start maximized, restore to height 400

/win=tray,40,20,1200,400 -> start minimized to tray

/ini

You can determine which INI-file is loaded by starting the application like this:

/ini=myini -> load [XYplorer app data path] myini.ini

Note that myini can be just a base name (myini) or include the extension .ini (myini.ini). If you pass no path then the file is looked for in the Application Data Path (which is identical to the path of XYplorer.exe unless you state a different path in Startup.ini).

Note: myini must be quoted if the name contains any blanks.

Date variables, e.g. <date yyyy>, are supported in the path. See examples below.

You can pass a non-existing path with the /ini switch, e.g.:

XYplorer.exe /ini=%temp%\XY\ /fresh

Only on saving any settings, the path will be created. Usage: By passing a non-existing path you can ensure that no current settings are overwritten, e.g. like this:

XYplorer.exe /ini="%temp%\XY_<date yyyymmddhhnnss>\"

Or from the Address Bar:

::run quote("<xy>") . ' /ini="%temp%\XY_<date yyyymmddhhnnss>\"';

/new

Open a new instance regardless of any settings that would otherwise force any existing instance to be re-used.

XYplorer.exe /new

/fresh

Run the application without loading any settings apart from the license data. This can be useful for isolating any issues under factory defaults conditions and thus can help the analysis.

XYplorer.exe /fresh

Note that a new instance is opened regardless of any settings or existing instances (like with switch /new).

Tip: Run a 2nd instance with factory defaults via Address Bar:

::run """<xy>"" /fresh";

/title

You can set a session title via the command line switch /title=[session title]. If the title contains any spaces it has to be quoted. Example:

/title="Mars Project"

A session title is useful when you need to distinguish several parallel sessions. See Titlebar Template in Configuration | Templates.

/script

You can run a script on startup directly from the command line. The switch is /script=[script resource], where [script resource] can be:

1) The path to a script file (commonly called *.xys). The file spec is resolved as in the script command load, so you can skip the XYS extension. You can also skip the path if the XYS file is located in the default scripts folder. For example

XYplorer.exe /script=test

would run the file <xyscripts>\test.xys on startup. If the path contains spaces it must be quoted:

XYplorer.exe /script="C:\Zen\test one.xys"

2) A script. It must be preceded by ::, and it must not contain double quotes or other characters that might lead to problems when parsing the command line. For example

XYplorer.exe /script="::msg 'Welcome to XY!';"

Note the double quotes surrounding the whole argument which are needed because of the spaces in the script line.

/flg

You can feed a script into an existing instance of XYplorer without changing the location or tabs of that instance. Simply pass the switch /flg=2 in the command line, for example:

XYplorer.exe /script="::msg 'Hi!';" /flg=2

/hwnd

If feeding a script into XYplorer you can pass the window handle of the target XYplorer instance with this switch if you know it. If you want to feed the script into this XYplorer, you can simply use the variable <hwnd>, for example:

run "<xy> /script=""::msg 'Hi!';"" /flg=2 /hwnd=<hwnd>", , 0, 0;

Setting the Application Data Path (ADP)

You can pass an alternate ADP right via command line! Simply use the /ini switch and pass a full path with it.

For example:

XYplorer.exe /ini=C:\XYdata\XY.ini

Sets the ADP to C:\XYdata\, and loads XY.ini as main configuration file from there, as well as all other data files like cks.dat, udc.dat etc.

Note that portable syntax is supported:

XYplorer.exe /ini=?:\XYdata\XY.ini

? will be set to the drive XY is running from.

XYplorer.exe /ini=XYdata\XY.ini

Sets the ADP to [XY app path]\XYdata\

You can also pass the path alone without stating the INI file. Simply end the argument with a backslash:

XYplorer.exe /ini=C:\XYdata\

Sets the ADP to C:\XYdata\, and loads XYplorer.ini (the default INI file).

This new support for passing the ADP via command lines means that you now can run completely independent configurations simply using Windows shortcuts.

Tip: The currently used INI file and Application Data Path is displayed in the title bar of the Configuration window.

Start Path

The INI contains all settings including the current start path. You can however overwrite this value by stating the start path in the right-most (unnamed) switch, e.g.:

XYplorer.exe /ini=myini mystartpath

You may also pass a start path relative to the application path, e.g. "..\..\". Passing "." will startup at application path.

Notes:

· The start path switch must be the last in the command line.
· Special paths, e.g. "Desktop\Blah\", are supported.
· Real paths that correspond to special paths are auto-converted to special paths. E.g. "C:\Users\<user>\Desktop\Blah\" will open XYplorer pointing to "Desktop\Blah\" if this is a valid special path.

Keeping a Single Instance

If XYplorer is opened with a startpath command line parameter and no /ini switch, this path is opened in a new foreground tab of the previous instance instead of loading the new instance. So, of these command line setups...

XYplorer.exe

XYplorer.exe mystartpath

XYplorer.exe /ini=myini mystartpath

... only the second will trigger the above behavior (open path in new tab). The others will load a second instance.


Address Bar

Address Bar

The Address Bar is the control where you can enter (type, paste) locations directly. You can show/hide it using Show Address Bar (Ctrl+Shift+F12) in menu Window.

Any locations entered via the address bar are stored in the bar's dropdown list (up to 64 items; last on top), and saved between sessions. On top of this XYplorer's Address Bar comes with a number of important usability enhancements:

(1) Keys F4, Up, Down: all open the list; F4 closes again; next Up or Down select list items; selection wraps around ends.
(2) It optionally auto-completes path names (see below: 6 Key Navigation, 4 Key Navigation, Mouse Click Navigation).
(3) It optionally auto-completes recently used items: When you start typing a location into the address bar, it shows you a list of places (sorted alphabetically, colored green) you've gone to before that match what you've typed so far. To see the complete list sorted alphabetically, empty the edit field, hold CTRL, and press the down or up arrow key.
(4) It supports Tabbing through the items.
(5) It supports select-all-by-triple-click.
(6) It is highly configurable (Configuration | Controls and More).
(7) It shows icons for edit box and list items. Icons help you to easily distinguish the various types of items that are supported by the Address Bar: Folders, Files, Drives, Servers, Quick Searches, Visual Filters, URLs, Scripts.
(8) The dropdown list supports the mouse wheel.
(9) The droplist has a minimal width of 400.
(10) The droplist is higher than Windows standard: 12 instead of 8 items.
(11) Right-clicking the dropdown arrow pops a menu featuring the breadcrumb menu for the current path, the virtual folders, and the drives.
(12) The edit box ignores mouse wheel (that's good!).
(13) The edit box supports automatic word breaking (dbl-click selection, moving cursor with CTRL). Recognized word boundaries: .:,; _-~(){}[]<>|/\^°*?!§$%&=+#"'
(14) Enhanced usability through a number useful key combinations and mouse tricks (see below).
(15) Relative paths are resolved relative to the current path.
You can use ".." to go upwards.
You can use "C:\Windows\..\" to go to "C:\".
(16) Shift+Enter will open the location in a new tab.
(17) When you attempt to go to a non-existing location you are prompted to create it on the fly. Will also create whole new paths (as long as the drive exists and is writable). Note that the location must end with a backslash to enable this feature.
(18) When the Address Bar shows an existing file (not a folder), then the icon pops a right-click menu with some useful commands: Go To, Open, Copy Item, Copy Name.
(19) Last not least, it fully supports Unicode.

For power users here's a number if useful Key Combinations and Mouse Tricks:

(1) If dropdown list is not visible:

Enter: Shoot, i.e. trigger the Address Bar's current contents (e.g. go to that location; run that search; apply that filter; run that script...).
Shift+Enter: Open the location in a new tab
Ctrl+Enter: A file in Address Bar is opened right away instead of browsing to its location.
Esc: Reset edit box to last shot item.
If there is nothing to reset: Toggle selection state (all versus nothing) of the edit box.
Ctrl+A: Select All.
F2: If all is selected: unselect all, move caret to end of text. Else: select all.
F4: Open MRU list.
Down/Up: Open MRU list.
Ctrl+Down/Up: Open the auto-complete match list. Any selection in the edit field is removed and the caret is placed at the right end of the contents.
If the edit box is empty the whole MRU list is shown as Match List, i.e. sorted alphabetically.

Right-click the icon:

"Auto-Complete Path Names" is OFF: Pops the shell context menu for the item (folder or file) currently displayed in the Address Bar. This will always be the standard shell context menu, without any XYplorer-only custom items.
"Auto-Complete Path Names" is ON: Pops a breadcrumb menu for the item (folder or file) currently displayed in the Address Bar.

(2) If dropdown list is visible:

Down/Up: Select next/previous item in list.
Tab/Shift+Tab: Select next/previous item in list.
Page Down/Up: Select next/previous item in list page-wise.
Right: When the caret in the Edit field is at the right-most position, then pressing the "Right" arrow key will open the match list. If there is no trailing backslash then it is auto-appended.
Enter: Undrop the list, and shoot.
Ctrl+Enter: Just undrop the list.
F4: Just undrop the list.
Ctrl+Down/Up: Just undrop the list.
Click on list: Set the edit box to clicked item, undrop the list, and shoot.
Ctrl+Click on list: Set the edit box to clicked item, and undrop the list.
Click in edit box: Just undrop the list.
Esc: Undrop the list, reset edit box to last shot item.

Note that Address Bar and the "Go to" dialog share the same item history.

Tip: The special alias "*" (asterisk) can be used for "Computer" as location.

6 Key Navigation

6 Key Navigation (6KN) means you can browse the whole computer by just 6 keys (Ctrl, Left, Right, Up, Down, Enter) in the Address Bar.

Note: Configuration | Controls and More | Auto-Complete Path Names | Address Bar has to be ticked for this, and Filter should be set to "Files and Folders" or "Folders only".

6 Key Navigation in the Address Bar

Always:

Left: Move caret to left.

Right: On right end (if folder): Opens match list (appends backslash if there is none yet).

Else: Move caret to right.

Ctrl+Left: Move caret to parent folder component.

Ctrl+Right: Move caret to child folder component.

Ctrl+Down: Open/Update match list at caret position.

Enter: Go to item or open file (if "Open files from Address Bar" is ticked).

Close match list if it is open.

Ctrl+Enter: Like Enter, but Go to and Open inverted.

On the dropped match list:

Up: Move up in match list (to last item if none selected).

Down: Move down in match list (to first item if none selected).

Ctrl+Up: Close match list (no action).

The crucial part of 6KN is that you can open a match list at the caret position. Move the caret at to some position in the edit field of the Address Bar. Now Ctrl+Down will open the match list for the part left of the caret and trim the part right of the caret. You now can live-filter the match list by pressing letters or select an item from it using the Down and Up keys.

Example 1:

C:\Programs\ XYplorer\

^

Now press Ctrl+Down: The match list will open for C:\Programs\*.

Example 2:

C:\Programs\X Yplorer\

^

Now press Ctrl+Down: The match list will open for C:\Programs\X*.

The next cool part of 6KN is that when the match list is already open, you can renew its contents (= browse another folder/pattern) without first closing it. Simply press Ctrl+Down again and the list will update.

Tips:

· In Configuration | Controls and More | Auto-Complete Path Names | Filter you can control whether the match list should contain "Folders only", "Files only", or "Files and Folders".
· You can open the auto-complete match list (for the whole path, regardless of caret position) by MouseDown on the icon.
· Delete all contents of the Address Bar to pop the drives list (including the Network node).
· Typing a single drive letter into the Address bar will drop the match list for that drive.
· On Ctrl+Enter, a file is handled as if the setting of "Open files from Address Bar" would be inverted: It is opened if "Open files from Address Bar" is OFF, and it is gone to if the setting is ON.

4 Key Navigation

4 Key Navigation (4KN) means you can browse the whole computer by just 4 keys (Ctrl, Shift, Tab, Enter) in the Address Bar.

Note: Configuration | Controls and More | Auto-Complete Path Names | Address Bar has to be ticked for this, and Filter should be set to "Files and Folders" or "Folders only".

4 Key Navigation in the Address Bar

On closed match list:

Ctrl+Tab: Open match list at cursor position.

Ctrl+Shift+Tab: Open match list to parent of current Address Bar item.

On the dropped match list:

Tab: Move down in match list (to first item if none selected).

Shift+Tab: Move up in match list (to last item if none selected).

Ctrl+Tab: Update match list to current list item.

If no list item selected: close match list.

Ctrl+Shift+Tab: Update match list to parent of current list item.

Note: In XP and earlier Ctrl+Alt+Tab works as an alternative to Ctrl+Shift+Tab.

Mouse Click Navigation

Mouse Click Navigation (MCN) means you can browse the whole computer by using just the Left and Right mouse button in the Address Bar.

Mouse Click Navigation in the Address Bar

On closed match list:

Left Click on icon: Opens match list at caret position.

Right Click on icon: Pops a breadcrumb menu for the current Address Bar contents.

On the dropped match list:

Left Click on Address Bar icon: Close match list (no action).

Left Click on file: Performs the default action for that file (open or go to).

Left Click on folder icon: Browse that folder (right in the dropdown!).

Left Click on folder name: Go to that folder.

Right Click on file: Pops a context menu that lets you open or go to the file,

or go up to the parent folder.

Right Click on folder: Pops a context menu that lets you browse (right in the dropdown!)

or go to the folder, or go up to the parent folder.

Tip: Ctrl+Click on the edit box icon will open/update the match list to the parent of the current Address Bar item.

Quick Name Searches via Address Bar

You can enter search patterns directly into the Address Bar. Simply put a ? (question mark) between location and pattern.

There are interesting possibilities, for example:

C:\WINDOWS\?*.log = Find all LOGs in C:\WINDOWS\

Desktop?*.bmp = Find all BMPs in Desktop

Desktop? = Find all items in Desktop

? = Find all items in current folder

?*.txt = Find all TXT files in current folder

It also works with Boolean and RegExp patterns, for example:

Desktop?>.*(\.bmp|\.jpg)$ = Find all BMPs and JPGs in Desktop

Desktop?:*.jpg | *.bmp = Find all BMPs and JPGs in Desktop

?:!# = Find all items with no number in the name in current folder

A Quick Name Search bypasses the settings in the Find Files tab: They are not modified and not applied. Exceptions: Include subfolders and Follow folder links (which can be overwritten by switches). So, the Quick Name Search is a way to quickly perform a search without caring about the current state of all the other Find Files settings, and without having to open the Find Files tab respectively the Info Panel.

Notes:

· Quick Name Search support a couple of search pattern switches.
· In a branch-filtered search, any Visual Filters apply only to files, not to folders. So you can first filter the branches using the search pattern, and then filter the files within the shown branches using the visual filter pattern. This gives you some interesting possibilities, like show all *.jpg in branches not named "*copy*".
· The switch overwrites "Let folders pass all filters" (sets it to False internally).
· There is an extra interface for Quick Name Searches accessible from the Edit menu (F3).

Multiple Locations

Multiple locations have to be separated by ";". E.g., you may paste a lines like these into the Address Bar...

E:\XY\;C:\Temp\;D:\Backup\?*.gif = Show all GIFs in these three folders

E:\a\;E:\b\? /n = Show these two folders in one list, non-recursive.

(1) The ";" may be surrounded by any number of blanks. Built-in smartness will recognize a ";" that's not a separator but part of a folder name.
(2) Multi-Location Name Searches are remembered in tabs and across sessions.
(3) You can save them as Favorites or assign Keyboard Shortcuts to them via User-Defined Commands.
(4) As always with Name Searches, the settings in the Find Tab are not touched.

Quick Visual Filters

You can set a Visual Filter directly through the Address Bar, the Catalog, the Favorites etc. This means you can set a new path and a new filter at the same time! For example:

       Desktop|*.jpg;*.png   = browse to Desktop and show only *.jpg

                               and *.png files

The crucial operator here is the "|"-char (pipe). These are the general syntax options (Path can be slashed or not):

       Path|a*   = set filter "a*" to Path

       Path|     = remove any filters from Path

       |a*       = set filter "a*" to current Path

       |         = remove any filters from current Path

The filter will be added to the top of the Visual Filter MRU (most recently used) list, so it will be available for toggling on/off (Ctrl+Shift+J).

These "Quick Visual Filters" can not be combined with "Quick Name Searches" (using the "?" operator), as generally Searches cannot be visually filtered (it would mean filtering a filter...).

See Visual Filters for syntax.

Executing DOS commands

You can launch DOS commands directly through the XYplorer UI by prefixing "!" to the location term. The default startpath for the DOS commands is the current List folder. The DOS box will stay alive when you use a single "!", and it will auto-vanish when you use a double "!!".

Examples:

! simply open DOS box without any action
!dir directory listing of current list folder; DOS box stays visible
!!dir directory listing of current list folder;
DOS box will vanish immediately (not very useful with dir)

DOS commands support XYplorer native variables and Environment variables. Examples:

!dir "%temp%" /p directory listing of the TEMP folder; DOS box stays visible
!!regsvr32 "<curitem>" register the currently focused and selected file
!!regsvr32 <selitems> register all currently selected files

Aliases

Aliases are user-definable variables where you can freely choose the name of the variable and their value. When you enter such an alias into the Address Bar (or any other location port) it will be resolved to its value before further processing.

Format of aliases: Aliases are marked by a prefixed @ (at-sign). The alias name may contain any character apart from "=", "/", and space. It may even be completely empty, so you can have one minimal alias that's simply @! The alias value may contain any character. Note, however, that line breaks do not count as "characters" here and are not allowed in name or value.

Usage of aliases: Aliases can be added, edited, or removed directly through the Address Bar:

@AliasName=value define AliasName as an alias to value

adds a new alias or overwrites any existing

alias of the same name

@AliasName goto/execute value associated with AliasName

@AliasName= undefine AliasName (i.e. remove it)

For example:

@home=C:\mystuff\blah\yadda\ [ENTER]

Now typing @home into the Address Bar will carry you to

C:\mystuff\blah\yadda\

Another way to edit aliases is through Tools | List Management | Aliases...

Aliases with arguments

Taking it to the next level, aliases support up to 9 arguments. In the alias definition the arguments are referred to by placeholders <@1>, <@2>, <@3> etc. On using the alias the argument values are passed as a comma-separated list, separated from the alias name by at least one space. Any surrounding spaces are trimmed. Then <@1> is replaced with the first argument, <@2> with the second, etc.

A special placeholder <@0> stands for the non-split input, i.e. it will be replaced with everything following the first space.

Example 1: How to use 2 placeholders.

Define alias: @Greet=::echo "Hello, <@1>! It's <@2>!";

Use alias: @Greet Don, Daisy

Resolved alias: ::echo "Hello, Don! It's Daisy!";

Example 2: To use the separator (comma) within an argument or have surrounding spaces you need to quote the argument:

Define alias: @Greet=::echo "Hello, <@1>! It's <@2>!";

Use alias: @Greet Don, "Duck, Daisy Duck"

Resolved alias: ::echo "Hello, Don! It's Duck, Daisy Duck!";

Example 3: How to use the <@0> placeholder:

Define alias: @Greet=::echo "Hello, <@0>!";

Use alias: @Greet Don, Daisy, Huey, Dewey, and Louie

Resolved alias: ::echo "Hello, Don, Daisy, Huey, Dewey, and Louie!";

Defining default values: You can optionally define a default value for each placeholder. The default is used when the respective argument is missing or empty. The default value is optionally stated within the placeholder, separated from the beginning by a space: <@1 DefaultValue>. The default value can have all characters apart from >.

Example for using default values (one definition, several uses):

Define alias: @Greet=::echo "Hello, <@1>! It's <@2 Dewey>!";

Use alias: @Greet Don, Daisy

Resolved alias: ::echo "Hello, Don! It's Daisy!";

Use alias: @Greet Don

Resolved alias: ::echo "Hello, Don! It's Dewey!";

Use alias: @Greet

Resolved alias: ::echo "Hello, ! It's Dewey!";

Further remarks on aliases

· Aliases are resolved very early, before any other special syntaxes are resolved. This means you can have e.g. small scripts, DOS commands, Spot and Jump commands, Visual Filters etc. defined as value of an alias and they will be treated as expected. Of course, they must fit in one line -- line breaks are not allowed.
· If you enter a non-existing alias it is not resolved and treated as relative path (which is probably not existing, but who knows...).
· The Address Bar icon for aliases is a blue heart. It turns red when you add/edit an alias.
· Aliases are case-sensitive: @hi is not the same as @Hi.
· Of course, aliases are retained across sessions.
· The number of possible aliases is not limited by XYplorer.
· Also Quick Searches support aliases. For example, this works in the Address Bar if you have an alias "home": @home?a* It will find all items beginning with "a" in the path that the alias "home" points to.
· You can use aliases also in the Location field on the Find Files tab.
· If you define <@2> but pass only one argument, <@2> is removed (replaced by nothing).
· If you define only <@1> but pass two arguments, the 2nd argument is ignored.
· Quotes inside quoted arguments have to be doubled.

Supported protocols

You can add even more into the Address Bar, not only folders, files, and quick searches. Address Bar (and Catalog!) support the http:// protocol and the file:/// protocol. These files are executed by the Shell, so http[s]:// URLs are opened by your default browser whereas file:/// URLs are opened by the associated application. E.g., enter this into the Address Bar:

file:///C:\Program Files\XYplorer\LicenseXY.txt

if C:\Program Files\XYplorer is your XYplorer location.

Support of common Windows environment variables

You can enter common Windows environment variables, e.g. %appdata%, into the Address Bar (Catalog, Favorites, Go To), to have a soft-coded approach to certain useful system paths. They have to be marked by a leading "%" and a trailing "%".

Obviously, to serve as a location those variables should point to individual paths. So, XYplorer allows only a subset of the Windows environment variables, but adds some proprietary variables to the set. For a list of the supported environment variables see here.

Note that these variables work well in combination with the extended XYplorer location syntax. It's a simple string replacement. For example:

%tmp%?*.tmp

%desktop%;%personal%?*.txt

%desktop%\archive

%desktopreal%\archive


Quick Name Search

Quick Name Search

The Quick Name Search dialog offers a very simple interface to finding files by their name. The command "Quick Name Search..." (F3) is found near to the bottom of menu Edit.

The obvious idea is to offer an ultra-smooth access to the most common find task: the search by filename. No more need to open the Info Panel, select the mighty Find Files tab, reset any previous filters, enter a pattern, and press Find Now. Instead you completely bypass the Find Files tab leaving its current settings unused and unchanged.

Notes:

· Include subfolders (recursive search): Quick Name Searches follow the "Include subfolders" setting for the general File Find found on the Find Files tab. You can force a recursive search by appending the switch "/r", or a non-recursive search by appending the switch "/n".
· Quick Name Searches always search the current location (as shown in the Title Bar, the Address Bar, and in the unlocked Tree).
· There is a handy command Toggle Quick Name Search (Ctrl+Shift+F3) to toggle between no Quick Name Search and the last one (if any) in the current location.
· There is another handy command Repeat Last Quick Name Search (Shift+F3) to repeat the last Quick Name Search (if any) in the current location.
· The last 64 patterns are stored in an MRU (most-recently-used) list. They are remembered across sessions if "Configuration | Startup & Exit | Include most-recently-used lists on save" is ticked and "Find Files Patterns and Locations" is ticked in the Apply list. The MRU list can be edited in List Management.
· Quick Name Searches are displayed in the Address Bar, but not added to the Address Bar MRU (the dropdown list).
· Quick Name Search also supports more complex patterns like Boolean terms, RegExp, and Multi Field Search. Simply everything that's supported in the Address Bar right of the ?, the marker for Quick Name Searches through the Address Bar. See examples here below.
· Alternatively, you can run Quick Name Searches directly through the Address Bar (see Quick Name Searches via Address Bar). These are not added to the Quick Name Search MRU list.
· There is a toolbar button "Quick Name Search".

Search Pattern Switches

There are freely combinable switches to modify a name Search, allowing to overwrite the global search settings:

/r Recurse subfolders.
/n Do not recurse subfolders.
In a Multi Branch View this switch will also suppress listing the top folders of each branch.
/f Find only files, not folders.
/d Find only folders, not files.
/b Branch-filtered (name filters in the search or branch view are only applied to branches (= folders and all of their contents), not to files.

Pattern switches can optionally be appended to the search pattern in the name field and have the general format "blank-slash-letter(s)", e.g. " /r" or " /rf" (the order of letters is irrelevant).

Examples:

?* /n = Find all items (not recurring subfolders).
?* /r = Find all items (recurring subfolders).
?* /nf = Find all files (do not recurse subfolders).
?* /rf = Find all files (recurring subfolders).
?!s* /br = Find all items (recurring subfolders), but exclude any branches starting with s*.
?!s*;p* /b:flat = Run a filtered branch view excluding any branches starting with s* OR with p*.

?* /n:flat = Run an unfiltered non-recursive branch view.

Examples

Wildcards and partial matches are supported, for example:

readme.txt = Find all files called readme.txt

black = Find all items containing 'black' in the name

b* = Find all items beginning with b*

*.png = Find all PNG files

* = Find all items

* /fr = Find all files (no folders) (recurse subfolders)

*.txt /n = Find all TXT files (don't recurse subfolders)

Also tags can be searched for, for example:

lbl:red = Find all items labeled 'red'

cmt:chicago = Find all items with 'chicago' in the comment

tags:cats|dogs = Find all items tagged 'cats' or 'dogs'

tags:"" = Find all items without tags

Also Boolean (:) and RegExp (>) patterns, for example:

:!# = Find all items with no number in the name

:*.jpg | *.png = Find all JPGs and PNGs

:*.jpg or *.png = Find all JPGs and PNGs

:tags:cats AND name:a* = Find all items tagged 'cats' and beginning with a*

>.*(\.jpg|\.png)$ = Find all JPGs and PNGs


Toolbar

Toolbar

To show/hide the toolbar use menu Window | Show Toolbar.

Context menus

Note that almost every toolbar button has a right-click context menu.

Customizing the toolbar

The default toolbar contains a couple of buttons you might find useful. But there's much more in the store...

Right-click any toolbar button to customize the toolbar via the command Customize Toolbar.... Here you can add more useful buttons and as many separators as you like.

Here you can also toggle small and large icons, and you can enable toolbar scrolling (see below).

Scrolling the Toolbar

Enable scrolling in Tools | Customize Toolbar by ticking Toolbar can be scrolled.

To scroll the toolbar drag it with left or right mouse button, or wheel it. Drag fast and you get a bit of animation when you release the mouse button.

When you OK the Customize Toolbar dialog the scroll position is reset to initial. The scroll position is not stored between sessions.

Scrolled toolbar wraps: Check it to have the scrolled toolbar wrap around edges.

Overflow Dropdown

Buttons that do not fit in the toolbar are reachable via a so-called overflow dropdown at the right end of the toolbar. You can freely combine it with the toolbar scrolling feature.

Drive Bars and Drive Buttons

Drive Bars

Under Tools | Customize Toolbar | Available Buttons you find couple of drive-oriented "button groups" which softly and automatically (when you plug in/out a removable drive) react to the current drives setup. The groups represent drive bars with different scopes that partly contain each other, so for your toolbar you would typically choose one of them:

· All Drives (Group) = all drives as listed under the top tree node (Computer)
· Available Drives (Group) = all drives apart from empty CD drives and unconnected mapped network drives
· Hard Drives (Group) = only hard drives
· Removable Drives (Group) = only available removable drives (e.g. a floppy drive, thumb drive, or flash card reader)
· Network Drives (Group) = mapped network drives (connected and unconnected)
· CD-ROM Drives (Group) = CD-ROM drives (empty or not)

Further remarks:

· The soft drive bars are sensitive to the following settings in Configuration | Tree and List: Show floppy drives, Show hidden drives.
· If Show floppy drives is ticked then floppies are displayed even if empty to spare the annoying hardware check.
· You can use the normal drive buttons (see below) parallely to the soft groups without problems.

Drive Buttons

Under Tools | Customize Toolbar | Available Buttons you find buttons for all drives A: to Z: which you can use to build your own custom Drives Bar section within the main toolbar.

Further remarks:

· If the toolbar has large icons the buttons show the specific drive icon plus the drive letter, else just the letter.
· The icons react on adding or removing of removable drives if Auto-Refresh is enabled.
· The buttons' tooltips show the drive display captions.
· Right-clicking the buttons pops a small context menu where you can customize the function of the button. Choose between two options:
- Go to Drive Root [Factory Default]
- Go to Recent Path on Drive
The button tooltips show the location they will go to.
· Last not least, the buttons function as drop targets, i.e. you can drop files on them to copy/move them to the drive's root. Use the right mouse drop menu for further options.

Special Toolbar Buttons

Nuke

The Nuke command is only available as toolbar button. It's an alternative Delete command that is highly configurable.

By factory default Nuke pops a confirmation prompt and on OK deletes the selected items to the Recycle Bin. Via the button's right-click menu you can freely configure its behavior.

· With Confirmation: Enable or disable confirmation prompt.
· To Recycler: Recycle or delete permanently.
· Skipping Locked File: Skip any locked files.
· Wiping Beyond Recovery: Wipe files beyond recovery. See also Wipe under menu File | File Special.

Custom Toolbar Buttons

[This feature is Pro Edition Only, respectively only available if the Scripting feature is enabled.]

You have 32 easily customizable user buttons, where you define how the button looks and what it does when pressed.

To add a new user button to the toolbar you first open the Customize Toolbar dialog (menu Tools) and add a User Button (bottom of the list) to the current buttons. Then you right-click the button in the toolbar and select Edit... In the Edit User Button dialog you set the Name and Icon (both optional) for the button, and the Script (required) that is triggered when clicking the button. That's all. Of course, the buttons are stored between sessions and portable.

User Button Icons: Simply state any existing file or folder, and its icon will be used for the button. Relative and portable paths are supported, as well as environment variables and short forms for registered applications (e.g. "Photoshop" without the quotes). Also generic patterns are allowed, e.g. "*.jpg".

If the toolbar has large icons, stretching or shrinking to 24x24 pixels would be needed, but experience shows that the quality of scaled icons is not satisfying, so it works as follows:

- If you point to an ICO, ICL, EXE, or DLL file then the first contained icon resource will be used on the large toolbar. Optimal results are achieved if this is a 24x24 icon resource (note that in multi-icon resources always the first icon is taken and scaled if necessary!). Other sizes are scaled. For the small toolbar this ICO file's small system icon is used.
- If you point to any other file type or folder, then its small system icon (16x16) is used on the small and the large toolbar without any scaling.

In other words, if you know how to make icons you can create high quality custom icons for the large and the small toolbar.

Tip: You may as well re-use XYplorer's internal Toolbar icons for your own button. Simply state the toolbar icon key preceded by a colon (":") in the Icon field, e.g. :hotlist. You can find the toolbar icon keys in the Customize Toolbar dialog when you call it from the context menu of a user button.

User Button Labels: You can as well define a short text to be displayed in the toolbar instead of the icon. Simply prefix the contents of the Icon field with "label:", for example: label:Fun. Now "Fun" is printed to the button in the toolbar. Optionally you can define text and back colors in format RRGGBB, for example:

label:Fun>FFFFFF,555555 //white on dark grey

label:Fun>FF0000 //red (no background)

Of course, this also works for Droppable User Buttons (which are just a subtype of User Buttons).

User Button Scripts: Multi-line scripts (and hence also multi-scripts) are supported and can be entered directly in the button definition using the Edit... button.

On right-click: Here you can define a separate script for a user button's right-click event. It is merged with the standard right-click menu for user buttons. This means you can have user buttons that do one thing on left click and pop lots of additional options on right click.

There's special support for the load command. Example (in field On right-click):

load "test", "foo" //load script labeled "foo" from "test.xys"

The file "test.xys" will be loaded and parsed, and then the context menu is shown, with the standard items (Click, Edit... etc) appended at the bottom. If the file contains only one script, it is not executed directly (as it would be in a "non-Right-Click" load statement) but shown in the menu.

Tip 1: Using the internal button keys you can create context menus featuring buttons that might be not visible on your toolbar:

"Recent Locations|:mru" button "mru"
"Hotlist|:hotlist" button "hotlist"
-
"CKS|:cks" button "cks"
"UDC|:udc" button "udc"
-
"Exit no save|:exitnosave" button "exitnosave"

Tip 2: You can skip stating the caption when you use an internal icon. The internal caption and keyboard shortcut will be used. For example:

"|:hotlist" button "hotlist"

will show "Hotlist Ctrl+H" in the popup menu.

Tip 3: It might happen that you construct an invalid script that will corrupt the context menu of a user button, in which case you'd not be able to reach the Edit dialog via the button's context menu anymore to correct the bad script. To escape from this deadlock you now can hold CTRL while right-clicking the user button, and you will get the default context menu for user buttons.

Fire click on mousedown: Check it to have the User Button trigger at MouseDown. The button will be displayed with an arrow overlay in the toolbar.

Note that you should typically use this option only if your Click script creates a popup menu, in which case it will save you one click because MouseDown will open the menu and MouseUp will select the desired item.

Clear: Press this button to clear all fields.

Drop on Custom Toolbar Buttons

All scripted buttons are "droppable". You can drop files or text onto a button, and the scripts assigned to the button are triggered. If you drop by left mouse button, the On-click script is triggered. If you drop by right mouse button, the On-right-click script is triggered. The dropped files or text can be referred to in the dropped-on scripts by <get drop> (see Drop on a Script File).

Notes:

· At least the On-click script has to be defined, else the button is interpreted as a Droppable User Button (DUB) of the old (and still working) style where the Name field is used for the location.
· If no right-click script is defined, then a right mouse drop will not do anything.

Smart Dropdown Buttons

It must not be scripts. User Buttons also support passing plain path/file specs as a shorthand for a well-formed goto-scripts, respectively open-scripts. The type of the listed items determines the action: The button will drop a menu that opens documents, runs executables, and goes to folders. Note that at least two items are needed to form a valid Smart Dropdown Button.

Examples:

C:\ = go to C:\

C:\Windows = go to C:\Windows

%winsysdir%\Calc.exe = run %winsysdir%\Calc.exe

%winsysdir%\setup.bmp = open %winsysdir%\setup.bmp with the default application

This little shorthand trick comes extremely handy in the left and right click events of User Buttons. Simply paste a plain list of documents, executables, and folders (in any mix and order), and enjoy the power of type-aware default actions right from the toolbar. Environment variables, XYplorer native variables, and Aliases are supported.

For example (the hyphen stands for a menu separator):

C:\

%windir%

<xypath>

-

%winsysdir%\Calc.exe

%winsysdir%\setup.bmp

<xydata>\XYplorer.ini

<xy>

Note that the menu captions are reduced to the item titles, and the full paths are shown in the Status Bar on hovering the popup menu items. Optionally you may pass a quoted caption in front of the path spec. This can be useful when the item titles don't distinguish the items, for example:

"XY code www" G:\www\xyplorer.com\code\

"XY code" H:\XYplorer.dev\code\

Droppable User Buttons (DUB)

There is a way to turn a normal Custom Toolbar Button into a Droppable User Button which is a toolbar button onto which you can drag-n-drop files: Enter a Location or Executable or File into the "Name" field and leave the "On Click" field empty. The button will now automatically show the matching icon and certain behaviors depending on what you entered:

Location Executable File

------------- ------------- --------------------------

Click: Go to Run EXE Open with Associated (PFA)

Drop: Copy/Move to Open with EXE (Nothing)

This means when dropping files onto a DUB that points to a location the files are copied or moved to that location. When dropping files onto a DUB that points to an executable the files are opened with this executable. Clicking a button that points to a location will bring you to that location, clicking a button that points to an executable will run this executable, clicking a button that points to a file will open that file with the associated application.

Remarks

· All portability feats are fully supported (XYplorer native variables, environment variables, portable paths). Also basenames (e.g. "ACDSee32" can stand for the full path to the Executable) are supported for registered applications.
· Command line parameters work also when dropping onto the buttons. Fictive example for an executable identified by basename and with a command switch, in the "Name" field:
"ACDSee32" /fullscreen
· Right-mouse dropping is supported, offering the full power of the drag-n-drop context menu..
· You can customize the button icon by stating an icon resource (or any file or folder that has a system icon) in the "Icon" field.
· The button tooltip tells you that it's a DUB (in case you wonder).
· You may as well state a single file (full path), for example an executable to launch, in the "On Click" field, and the button will run/open that file.

User Buttons as Open-With Panels

Here is a simple way to make a User Button pop a menu offering a list of items where the opening application AND the opened file is defined. In the "On right-click" field of a User Button pointing to an executable you can pass a path/file spec (all portability feats are fully supported) as a shorthand for a well-formed open-with script. Such a line will be internally auto-converted to a valid open-with statement including the appropriate icon in the generated popup menu, and in all those open-with statements the open-with application will be the one defined in the Name field of the button.

In other words, paste the list of files you want to open with the executable into the "On right-click" field and you are done!

Three examples for the contents of Name field:

"ACDSee32"

"ACDSee32" /fullscreen

C:\Programme\ACDSee32\ACDSee32.exe

One example for the contents of the "On right-click" field:

E:\TestFiles\images\_misc\08-lrg-16bit.tga

E:\TestFiles\images\_misc\aguilera-32bit.tga

Desktop\voice_dailer_256.png

-

"Favorite Folders|:favs" button "favs";

Now right-clicking the button will pop a menu containing three image files, one separator, and one little script that opens the Favorite Folders menu. Selecting any of the image files from the menu will open it using ACDSee (all items not pointing to an existing file are processed as scripts).

Tip: This feature also works in the "On click" (= left-click) event of the button (also with "Fire click on mousedown" enabled, which is quite cool). However, the button will not work as a DUB in this case (DUBs by definition need this field to be empty).


Tabbed Browsing

Tabbed Browsing

On each pane you can have any number tabs, where each tab can point to a different location (a "Browsing Tab") or to a search results listing (a "Finding Tab"). The tabs remember their configuration (list view, sort order, column widths and positions, scroll position, focused item, etc.) individually and across sessions.

The tab-related commands are found in menu View | Tab and in the context menu of the tab headers (right-click any tab header). See Configuration | Tabs for extended options concerning tabs.

Open a New Tab

To open a new tab use the command New Tab at the top of menu View | Tab.

Shortcut: Ctrl+T

Browsing Tabs and Finding Tabs

Each tab remembers the mode it was in when left (browse mode or find mode).

When you re-select a Browsing Tab (a tab in browse mode):

(1) The tree will jump to the tab's location and the list will display the contained items.
(2) Find Files settings do not change.
(3) Multi-selections are retained. To save resources selections are only retained in lists of no more than 32,767 items, and no more than 4,096 individual selections are retained between tab switches.

When you re-select a Finding Tab (a tab in find mode, showing search results) there are some differences:

(1) The last find will run again exactly as before (respectively the cached search results are loaded) and the list will show the results.
(2) Find Files settings change according to the tab's previous settings.
(3) The tree will not change.

Finding Tabs provide a very simple one-click-access to all imaginable search routines. You can for example design yourself a "find suite", a row of tabs with your recurrent find tasks just one click away. Hey, with XYplorer's ability to load specific configurations (INI files) on start-up you can have thousands of find suites!

View Settings are remembered per-tab

All tabs remember the following settings individually:

(1) View mode (details, thumbnails...)
(2) Sort order (column, direction)
(3) Column layout (positions, widths, visibility)
(4) List style (line numbers, auto-size, grid...) (see menu Tools | Customize List)

Tip: To set any of these settings to all open tabs at once simply hold SHIFT while making your choices. This trick does not work with the Column layout (positions, widths, visibility), however.

Multi-selections in tabs

Multi-selections are retained between tab switches.

Note that selections are remembered by filename, so if another process renames a selected file it will not be recognized as selected. Again, this is irrelevant if all files are selected.

Note that multi-selections are not retained between sessions.

Search results to tab

In Configuration | Find Files, you can choose where the search results shall be listed: on the Current tab, a New tab, or a (locked or unlocked) tab called "Search results" (automatically created if not yet existing).

Tabs are drop targets

Note that you can drag and drop files onto the tab headers to copy or move them to the location the hovered tab is pointing to. If you wait for a configurable time (see Configuration | Tabs) the hovered tab will be auto-selected.

Left and right button dragging is supported. The latter pops the usual drag and drop context menu.

Renaming tabs

You can give the tabs any name of your choice. Once a tab is named that name will stay fixed when you change the current directory inside the tab. A tab name can have any characters, even those that are illegal for filenames. To un-name a tab rename it to nothing.

When a tab is locked to a home zone AND is renamed then its icon will always be the one of the tab's home folder. This behavior is very practical when you use iconized tabs because once you have defined a special icon (using common Windows means) for the home folder you always recognize that tab by its icon no matter at what subfolder it is currently pointing to.

Custom tab icons

You can customize the icon of each Tab. Simply append any file spec to the caption of the tab, i.e. to the name you give to a tab by the Rename Tab function (found in the tab headers context menu), separated by a | (pipe). It can be an icon file or any other file or folder with associated system icon. XYplorer native variables, environment variables, and portable paths are supported. Internal toolbar icons (prefixed with ":") are supported as well. Examples:

fav|E:\Test\Kiss.ico

xy|<xy>

co|Computer

|:home Use the "home" toolbar icon. No particular name specified.

Tip: Right-clicking the icon of a tab pops a breadcrumb menu for the tab's path.

Portable Tabs and Portable Paths

You can make your tabs fully portable by relocating them to a portable path, i.e. by pointing them to a term that resolves to a path depending on the environment. Here are some examples:

· Absolute Path: C:\Myfolder (the normal case: not portable)
· Relative Path: appdata (relative to the app folder)
· Portable Path: ?:\ , ?:\Stuff\ (? stands for the application drive, the drive on which the current instance of XYplorer is running)
· Named Drives: TheSystem:\Windows (TheSystem stands for a drive named "TheSystem", see Named Drives).
· Environment Variable: %temp% (depends on environment variables)
· Native Variable: <xydata> (depends on the variable and the context )

These terms are remembered as such (unresolved) between sessions. But how do you define such a location? You relocate them using the command menu View | Tab | Relocate Tab.

Tip: To increase the usability of such a portable tab it is recommended to set its home (Set Home) to the portable path and then apply Lock Home Zone. That way you can browse the whole portable branch without ever losing the portability of that tab.

Named Drives

You can specify paths using their name (Volume Label) instead of the drive letter. So, for example, if your drive C: is called "TheSystem", then these two paths will refer to the same location: C:\Windows and TheSystem:\Windows. This works wherever Portable Paths work. Of course, this way to specify drives is particularly interesting for removable drives where the host system assigns an unpredictable drive letter.

Note: Support for Named Drives needs to be explicitly enabled: Configuration | Controls and More | Miscellaneous | Support volume labels in paths.

Tips for naming drives

· '@', '!', and '%' are valid characters in a volume label. But they create possibilities for parsing mess:
· '@a:\' takes you to the volume named '@a' unless '@a:\' is defined as an alias.
· '!dir:\' runs an invalid DOS command instead of taking you to the volume named '!dir'.
· With environment variable 'MyDrive' set to 'Q', '%MyDrive%:\' takes the user to 'Q:\' instead of the volume named '%MyDrive%' (which is okay if the volume mounted at 'Q:' is named '%MyDrive%').

So: Don't use such crazy Volume Labels when you enable "Support volume labels in paths".

Tabs with a Home

Each tab can have its own "Home", defined by a browse/find location and mode, and optionally the file list layout (turn it on at Configuration | Tabs | Going home also restores the list layout). To set (or update) the current tab's home click "Set Home" (menu View | Tab). To go to the current tab's home click "Go Home" (menu View/Tabs) or simply press Alt+Home. You cannot unset a home because it's not necessary (if you don't want a home, don't go home). Homes are remembered between sessions, and can be set independently of the tab being named or not. A new tab starts homeless. Apart from the possibility to click "Go Home" home tabs behave 100% like homeless tabs.

Portable Homes: Homes also support portable paths like %temp% or ?:\Stuff\, and variables like <xypath>.

See Lock Home Zone for a way to lock tabs to a branch.

Locked tabs

A locked tab will never leave its current location but instead open a new tab automatically. Of course, you can as well lock the Search results tab.

A locked tab is marked by an underlined caption.

Default tab

It's a means to reduce the number of opened tabs: Any passively (implicitly) opened new tab will open in this tab instead. There's a visual indicator (a green icon overlay ) to show which tab is the default tab (if any). There can be only one default tab.

Note: the "Default Tab" will only be used if no other tab pointing to the desired location does already exist in which case this tab will be selected.

Moving the tabs

Need a new order? You can easily drag-shift the tabs using the mouse.

You can as well move any tab to a new position by using the following shortcuts:

Ctrl+Shift+Left Shift current tab to left

Ctrl+Shift+Right Shift current tab to right

Closing the tabs

In Configuration | Tabs you find an option to show X close buttons on each tab, either permanently or only when hovering the tabs.

Note: Tabs smaller 80 pixels won't show the X button to prevent unwanted closings.


Tabsets

Tabsets

You can save and load the tabset of a pane, that's all tabs including their layout (tab settings and tabwise list settings) and contents (cached search data, find settings, homes, history, etc.). This concept is also known as Workspaces or Environments.

While each pane always has exactly one tabset loaded, you can have any number of tabsets available on disk to choose from. The definition of each tabset is held in a folder (also referred to as "pane data path") containing all necessary information within a couple of files. The name of the folder is identical to the name of the tabset. Thus tabsets are perfectly portable and easily maintainable.

Interface

The commands related to tabsets are found in the main menu "Tabsets", in the toolbar button "Tabsets", and can also be accessed via the scripting command tabset().

1. Main Menu Commands

New: Start a virgin tabset. You are prompted for a name.

Open...: Open/Load a stored tabset. A list of all available tabsets in the default tabsets folder (<xydata>\Panes) is popped. The current tabset of each pane is marked as [In Use - Pane #]; if you select one of them nothing happens.

Open As...: Open/Load a tabset as clone. The name for the clone is prompted for (it defaults to "Clone#", where # stands for the number of the current pane). Note that any existing tabset of the same name as the clone will be overwritten without any warning.

Revert to Saved: Reverts the current tabset to its saved state. Afterwards the previous temporary state is irreversibly lost. Note that the temporary state is preserved even across sessions.

Save: Save the current tabset. Only useful if Configuration | Tabs | Auto-save tabsets on switch is off, otherwise tabsets are saved automatically on tabset switch.

Save As...: Save the current tabset under a new name. The new tabset becomes the current one. The old tabset is kept on disk.

Save Copy As...: Save a copy of the current tabset under a new name. The old tabset remains the current one.

Rename...: Rename the current tabset. If a tabset of the same name already exists in the parent folder of the current tabset you are prompted for overwriting.

Go to Tabset Folder: Brings you to the folder of the current tabset.

2. Toolbar Button "Tabsets"

The names of the current tabsets are now shown in the button's tooltip.

MRU list: The button's left-click dropdown contains a list of the most recently used tabsets (MRU list) of the active pane. Click an item to load that tabset. The MRU tabsets lists hold 32 items per pane. The lists are stored between sessions in a portable manner

Tip: Hold CTRL when selecting a tabset from the MRU list to load it as a clone.

The button's right-click menu mirrors the main menu.

3. Scripting Command tabset()

See tabset().

Further Remarks

· On loading a new tabset the previous tabset will only be auto-saved if Configuration | Tabs | Auto-save tabsets on switch is checked. As long as no explicit Save or Auto-save is performed, you can always revert to the stored state of a tabset using the Revert to Saved command.
· You are not allowed to load the same tabset into both panes, i.e. to point both panes to the same pane data path, because this would lead to sure trouble.
· The current pane data paths are shown in Various Information window (menu Help). They are also available in the new variables <xypane1> and <xypane2>.
· The pane data paths are typically located under <xydata>\Panes, and they can be referenced relative to this location. It is recommended that you store all your tabsets here; makes it easier for you to handle.
However, tabsets can be stored anywhere in the system, even in a network path. This means users can share tabsets over the network. Note, however, that currently no measures are implemented to handle concurrent save operations of such a shared tabset.
· The pane data paths are stored in the INI file in a portable way relative to <xydata>\Panes.
· The name of the current tabset can be shown in the titlebar using the variable <tabset>. The variables <tabset1> and <tabset2> can be used to show the tabset names of both panes.


Breadcrumb Bars

Breadcrumb Bars

Both panes can feature a Breadcrumb Bar (toggled via menu Window | Show Breadcrumb Bar). It shows the full path of the current tab and lets you efficiently navigate the whole file system. Its layout is highly configurable.

Usage

Click on any of the components to go there.

Click on any of triangles (separators between the components) to pop a dropdown menu with all subfolders of the component left of the triangle, and select one of them to go there.

· The setting of "Show hidden files and folders" and "Show system files and folders" is honored by the dropdown menus.
· You can right-click items in the dropdown menus to pop a little context menu with copy functions.

Right-click anywhere in the Breadcrumb Bar to pop the right-click menu (see here below).

Right-Click Menu Options

At the top of the right-click menu you find some useful commands:

Copy Path: Copy the right-clicked path to the clipboard. The text to be copied is shown in the Status Bar.

Copy Real Path (only visible when the current path is a special path) and Copy Special Path (only visible when the current path is a real path that has a special path counterpart). These commands can be used to copy the real/special counterpart of the currently shown path.

Copy Folder Name: Copy the right-clicked component to the clipboard. The text to be copied is shown in the Status Bar.

Paste and Go: Goes to the current clipboard contents (can be a folder or file, or folder or file name). When hovering the command, the Status Bar displays the text found in the clipboard.

Paste and Search: Searches the right-clicked component for the current clipboard contents. When hovering the command, the Status Bar displays the text found in the clipboard, prefixed with the right-clicked component and "?".

In the lower part of the right-click menu you find a couple of settings to control the looks of the Breadcrumb Bars.

Triangles: Show triangles as separators between the components. The breadcrumb path will have the format known from Windows Explorer.

Slashes: Show slashes as separators between the components. The breadcrumb path will have the usual path format.

Bold: Tick it to show the text in bold.

Show Navigation Buttons: Show a couple of standard navigation buttons (back, forward, up, down). Each of them has its own right-click menu.

Show Icon: Tick it to show the icon of the current path at the left end of the bar.

Show Drive Labels: Tick it to show the display name for the drive, not just the letter. Triangles mode only.

Show Downward Paths: If ticked then the most recently used downward path is shown in a somewhat lighter color than the current path. This allows you to quickly go up and down a path in the most easy manner.

Check for Subfolders: If ticked then the final triangle/slash is only shown when the last shown node has subfolders. If unticked the final triangle/slash is always shown. Why is this optional? Well, the check can take a while when a folder is very large. Note: In network locations the check is always skipped to avoid trouble with unavailable locations.

The dropdown menu popped on clicking a triangle can have three different formats:

Standard Menu: The menu is a standard Windows menu. It has no scrollbars, so if there are a lot of subfolders the menu will extend to the whole screen height which makes it difficult to handle.

Custom Menu: The menu is a proprietary control featuring a vertical scrollbar if necessary.

Colored Menu: Same as Custom Menu, but inheriting the colors of its Breadcrumb Bar.

Finally the right-click menu lets you control the visual style of the Breadcrumb Bars:

Beveled Bar: Slightly beveled.

Flat Bar: Totally flat.

Other Configuration Options

Adjustable font size: You can modify the font size of the Breadcrumbs on-the-fly by Ctrl+Wheel over any of the Breadcrumb Bars. Alternatively you can customize font and font size via Configuration | Fonts | Main Contents. (To apply the font size tick "Breadcrumb Bars" in the list popped by the Apply To... button).

Colors: All colors of the Breadcrumb Bars are configurable in Configuration | Colors.


Tree

A New Kind of Tree

XYplorer's Tree has some features that might be new to you when you are coming from Windows Explorer.

Showing the Tree

Use menu Window | Show Tree (Shift+F8) or Window | Show Navigation Panel (F8) to show/hide the Tree.

Desktop is located under Computer

Other than in Windows Explorer, the Desktop node is located under Computer instead of vice versa. This seems more logical and spares 16 pixels of horizontal space in the Tree.

Tree nodes unfold on hover

There's extended drag and drop functionality to the Tree: When dragging an object over a folded node, the node will automatically expand after 0.8 seconds. When the object leaves the tree area or Drag&Drop is cancelled by ESC, the previous state of the tree is restored.

By the way, moving folders within Tree, is much more robust in XYplorer than it is in Explorer, which every other time throws the towel and jumps onto Desktop.

Highlighting features

Various highlighting features add more visual grip to the tree. Color Filters, Highlight Folder, Boxed Branch, Favorite Folder Bold, Tree Path Tracing, ... all colors are fully customizable.

Mini Tree

The tree can be turned into a Mini Tree, that's a tree that only shows the paths that you have actually visited.

Bypassed Tree

A Tree bypassed by browsing (i.e. the location shown in the file list is not shown, let alone selected, in the Tree) is displayed with a grey background, respectively with the color you have defined for a Locked Tree. This makes it immediately clear that Tree and List are not synced at the moment and protects you from false assumptions and potentially fatal decisions.

Context menus

A right-mouse-click on Tree will popup one of two context menus depending on the mouse position:

Folder caption Pops the Windows shell context menu for folders, plus some custom commands (if Configuration | Menus, Mouse, Safety | Context Menus | Custom items in shell context menu is ticked).
Customize the context menu in Configuration | Menus, Mouse, Safety | Custom items in shell context menu | Folder Tree...
White space Pops the Favorites context menu.
Plus/minus symbol Tree Node Crumbs: Pops a list of all child folders of that folder. That way you can select any child folder of a visible folder without opening the whole node. This is especially useful in the Mini Tree.
- Child folders that are not yet present in the Mini Tree are colored with "Marked Text 2" color in the popup.
- Right-click the same Plus/minus symbol again to hide the popup.


List

List View

A New Kind of List

Note that XYplorer's List is a hand-coded thing, and as such totally independent of Windows's common controls and has some features that might be new to you.

Columns can be reordered by dragging

List columns can be mouse-dragged to the position you prefer: hold the mouse down on a column header and drag to the new position.

Columns can be hidden

List columns can be individually hidden: menu View | Columns.

Display line numbers

List row numbers are displayed when you check the corresponding entry in Tools | Customize List.

Displaying thumbnails

There are various "views" (i.e. List display styles) featuring thumbnails. See menu View | Views, or the Views button on the Toolbar.

In any of those views the thumbnails have the "Mouse Down Blow Up" functionality you already know and love from the Image Preview:

Long* Left-click on thumb Mouse Down Blow Up, while mouse button is down.

Right-click on thumb Mouse Down Blow Up, stay up until you hit any key or click it again.

* Note: hold the mouse down longer than 150ms. Quick clicks will simply select the item.

Further details see Configuration | Thumbnails.

"desktop.ini" and other invisible files

What you see in XYplorer is the raw files that are actually there. So, in some folders XYplorer shows files that are not visible in the standard Explorer, for example files called desktop.ini: DO NOT DELETE THEM! You could destroy the functionality of a special folder. Remember: not knowing what a file is good for is the worst reason for destroying it.

Shortcut files

Shortcut files are displayed with their extensions (*.lnk, *.pif, *.url), whereas Explorer does not show those extensions.

Drag and Drop within file list

You can easily make a safety copy of a file (or more files) by drag-and-dropping it from the file list into the file list: select the file(s) and then hold down the Ctrl-key and drag. The copy will be automatically renamed, eg.: the copy of Myfile.txt is named Copy of Myfile.txt.

You can as well drag and drop items onto a folder displayed within the same list. XYplorer also supports dropping items on executables or ZIP-archives.

Type Ahead Find

The list supports Type Ahead Find (aka "Find as you type"): When the focus is on the list, you can simply type a letter, say E, and the next file starting with letter "e" will be selected. You can also type a sequence of letters (quickly one after the other as in normal typing), e.g. V-A-C, and the next file starting with "vac" will be selected.

Pressing ESC will reset the internal keystroke store. So quickly typing K-E-Esc-Y will match "Y", not "KEY". Also pressing any arrow keys, or changing the listed folder will reset the internal keystroke store.

Type-ahead find delays the actual find while the list is still loading, and jumps to the matching item once the load is complete. This means you can happily type in your pattern while the desired item is not yet contained in the list and it still will be found.

Matching

"Match at beginning" of filenames is the factory default (and the only thing Windows Explorer can do), but XYplorer gives you four different matching options, selectable in Configuration | Menus, Mouse, Safety | Type Ahead Find.

Advanced Usage

There are two keyboard-only commands to jump to the next/previous match: Tools | Customize Keyboard Shortcuts | Miscellaneous | Focus Functions: "Next Type Ahead Match" and "Previous Type Ahead Match". They repeat the last used Type Ahead Find pattern in forward respectively backward direction. Usage: Serves nicely to quickly repeat a multi-character Type Ahead Find pattern.

The last used Type Ahead Find pattern is now stored between sessions. It's one global last pattern for all panes, tabs, folders, lists, etc. Usage: In connection with the Next/Previous commands mentioned above this can be extremely useful when you need quick jumping to files of a certain name in different locations.

Use Sorted Column

XYplorer also supports Type Ahead Find for other columns than the Name column. Check Configuration | Menus, Mouse, Safety | Type Ahead Find | Use sorted column and Type Ahead Find will use the columns Name, Ext, Type, or Path if they are the sorted columns.

Paste and Find

When you have a bit of text in the clipboard, pasting this text into the List will attempt to find, focus, and highlight the next match, just as if you used Type Ahead Find.

· On multiline clipboard contents only the first line is used.
· Paste and Find always uses "Match anywhere".
· Since under NTFS the maximum length of individual components of a filename (i.e. each subdirectory along the path, and the final filename) is limited to 255 characters, also the string used by Paste and Find is limited to the first 255 characters.

Empty List Message

You get a message when the list is empty. There is some additional information if items are present in the folder but currently not shown.

Display Modes

The List supports 5 different modes: Browse, Find, Drives, Network, and Recycler. Each mode has its own column headers and type of entries. Each mode can be configured individually regarding column size, column position, background color, sort order and sorted column.

Browse

The standard browse mode (as known from Explorer). The List now displays all items contained in the currently selected folder.

Find

Invoked by a File Find and lists the search results of a find. By default the background color of this mode is green to make it easily distinguishable from the other modes.

Once you selected any folders in Tree, the mode is set back to Browse (or Drives, when you select the Computer Icon in Tree).

Drives

When you select the Computer Icon in Tree, the Drives mode is invoked. The List now displays various information about your local and mapped logical hard drives.

Network (My Network Places)

This mode with only 2 columns (Name and Comments) is shown when you selected Network Neighborhood or any Server (network machine).

Network Places On Demand. You can browse to servers outside the local/primary workgroup/domain. Simply enter them (or items located on them) into the Address Bar, or browse to them via Catalog or Favorites. If reachable they will be automatically/on-the-fly added to the Network (My Network Places) node in the tree.

Network servers are remembered between sessions. This means: (a) Network servers load at the speed of light, and (b) Servers outside the primary workgroup that have been entered via Address Bar are now remembered and don't have to be entered again.

To refresh this server cache select My Network Places in the tree and press F4 or F5. This will re-browse the network and list all servers in the primary workgroup that are currently reachable.

Recycler

The Recycle Bin with some special columns like Deleted (Date), Original Location, and Recycled Name.

Columns in the File List

The following columns can be displayed in the list in Browse and Find mode (the last one, Path, only in Find mode because in Browse mode it would be redundant):

#: Line Number

Name: File Name

Ext: File extension (txt, doc, jpg …)

Size: File Size (and Folder Size, if Show Folder Sizes is enabled)

Type: File Type (Application, File Folder, Shortcut …)

Modified: Last Modified Date

Created: Created Date

Accessed: Last Accessed Date

Attr: File Attributes, in the follow order:

R = READONLY

H = HIDDEN

S = SYSTEM

D = DIRECTORY

A = ARCHIVE

N = NORMAL

T = TEMPORARY

J = REPARSE_POINT (=Junction)

C = COMPRESSED

O = OFFLINE

I = NOT_CONTENT_INDEXED

E = ENCRYPTED

Len: Length of the file name, including the full path) in characters. Note that for performance reasons the "Len" column will only be filled with data when visible.

Label: Label of the item (only if item has been tagged).

Tags: Tags of the item (only if item has been tagged).

Comment: Comment of the item (only if item has been tagged).

Path: Path of the file (column shown in Find Mode / Search Results only)

Hint: When the sorted column is "dirty" i.e. the sort order is probably not perfect (e.g. because a new folder has been added to the bottom of the list), the little pyramid symbol changes its color (to color "Marked Text 1") to show the dirtiness.

Secondary Sorting

There's secondary sorting, aka multi-column sort. Simply hold SHIFT while you click on another column header to secondary-sort by this column. Of course, secondary sorting makes only sense where the primary sorting results in groups. This typically is the case with the following columns: Path, Ext, Type, and Attr; less so with Size and Dates. The column that's sorted secondarily is marked by a smaller sorting icon.

Day Groups: When the primary sorting is by date (e.g. Modified), the secondary sorting will ignore the time parts of the file dates when looking for groups of files that should be secondary-sorted. In other words you can sort the files by the day they have been modified, and then sub sort each day by Name, Type, or Size.

Tip: You can remove any secondary sorting and keep the current primary sort order: Hold SHIFT and click the primary sort column.

Context menus

A right-mouse-click on List will popup one of three context menus depending on the mouse position:

On filename File context menu (incl. Explorer's standard context menu for folders)
Customize the context menu in Configuration | Menus, Mouse, Safety | Custom items in shell context menu | File List...
On column headers Show Columns context menu
On Label column (If showing tags is enabled) Label selection context menu
On Tags column (If showing tags is enabled) Tags selection context menu
On Comment column (If showing tags is enabled) Comment context menu
Elsewhere Edit context menu

The context menu of Shortcuts has a special submenu Shortcut Target with these extra commands:

Go to Shortcut Target
Copy Shortcut Target Item
Copy Shortcut Target Name

The context menu of Junctions has a special submenu Junction with these extra commands:

Go to Junction Target
Copy Junction Target Name
Delete Junction

Spot and Jump

Spot and Jump

A highlighting feature inspired by the Google Toolbar and the Firefox Find Bar. It has no separate GUI but can be invoked via the Address Bar (or any of the other location interfaces, e.g. Favorites, Catalog, Goto, etc.). Simply type in a string prefixed with ">" press Enter. The string will be highlighted in the file list wherever it's found (case-insensitive: a=A) and focus will jump to the next matching name.

For example, to highlight all strings "xy" and jump to the next item containing "xy":

>xy [Enter]

To turn it off again, enter ">" without any pattern (or simply go to another folder):

> [Enter]

If you are not interested in jumping and just want the colors, put ">>" at the beginning. If you use more than one pattern at a time (separated by |) no jumping takes place:

>>xy = color all occurrences of "xy"

>>xy|2009 = color all occurrences of "xy" and "2009"

>xy|2009 = (same as above)

To turn it off again, either repeat the same pattern, or enter ">" or ">>" without any pattern:

>>xy [Enter]

>> [Enter]

> [Enter]

Spot supports an unlimited number of strings, separated by | (pipe). Four predefined colors are rotated. For example (the forth item is a space):

>7.|xy|2008| |-|~

For easier typing also spaces work as alternative pattern separators.

>chuck berry = spot all "chuck" and all "berry"

>chuck|berry = (same)

The | separator only has to be used when spaces are part of a pattern:

>chuck berry| = spot all "chuck berry"

The highlighting is not retained across different listings: refreshing the list or browsing to the next location will remove the colors.

Advanced

Wildcards are fully supported, and you can store an unlimited number of jump links in your Catalog or Favorites. Next time you want to listen to your Chuck Berry collection buried in a list of 20,000 mp3s -- just define a jump link once and the rest is a single click that takes you from one Chuck Berry to the next.

Examples:

>chuck = jump to the next List item containing "chuck"
anywhere in the name

>???? = jump to the next List item that's 4 chars long

>*##* = jump to the next List item with at least
2 consecutive numbers in the name

>*.txt = jump to the next item ending with ".txt"

> = remove any coloring now

Tip: Jump links are easily added to the Catalog and thus turned into a one-click affair.

Tip: You can jump upwards by holding Shift.

Tip: Check Configuration | Menus, Mouse, Safety | Type Ahead Find | Ignore diacritics to ignore diacritics (o==ö) when matching the patterns.


Dual Pane

Panes Menu

Panes Menu Commands

Dual Pane

Show/hide the inactive pane. In other words: Toggle between Dual Pane and Single Pane mode.

Shortcut: F10

Horizontal Panes

Toggle Horizontal Panes (Top/Bottom) and Vertical Panes (Left/Right).

Shortcut: Ctrl+F10

Toggle Active Pane

Activate the inactive pane.

Shortcut: Ctrl+Alt+F10

Note that also focusing the inactive pane will activate it: by clicking into it, or by Tab key.

Note that you can also toggle panes in Single Pane mode. Which means you can easily switch back and forth between two completely independent sets of tabs.

Move to Other Pane

Move all selected item(s) of the active pane to the inactive pane.

Shortcut: Shift+F6

Copy to Other Pane

Copy all selected item(s) of the active pane to the inactive pane.

Shortcut: Ctrl+F6

Backup to Other Pane

Backup all selected item(s) of the active pane to the inactive pane.

Note: This command comes pretty close to a nice Two-Way Folder Synch: Do it left-to-right and right-to-left, and you end up with two identical folders, and - depending on your Backup configuration - with all the newest versions from either side.

Shortcut: Ctrl+Shift+F6

Move/Copy Tab to Other Pane

Move/Copy the current tab to the inactive pane. All properties of the tab are taken along, including current selections and scroll position. The newly created tab is auto-selected and the target pane is activated. If there's only one tab left on a pane it will not be removed, of course.

The position of the new tab is the same as if you'd created it within the same pane.

The command also works in single pane mode.

Tip for mouse users: You can move/copy tabs from one pane to the other by dragging them to their new position. The default action is move (the source tab is removed from its pane), but you can force a copy by holding CTRL.

Go to Other Location

Use it to go to the inactive pane's location, in other words to make the active pane's location the same as the inactive pane's.

Go Here in Other Pane

Use it to make the inactive pane's location the same as the active pane's. It's the reverse of the above "Go to Other Location".

Tip: Hold CTRL+SHIFT to open the location you are going to in the inactive pane. This works on all sorts of location menus: History (Back, Forward); Breadcrumb; Favorites; Drives; Recent Locations; Hotlist; and most commands in menu Go (all commands concerned with going to a new location). And it works in the List: Ctrl+Shift+DblClick an item; if the item is a file the containing folder is opened and the file is selected.

Tip: Hold ALT when clicking a node in the Tree to go to it in the inactive pane.

Swap Panes

Swaps the locations of both panes.

Tip: Hold SHIFT to open the locations in a new foreground tab on each pane.

Sync Browse

Here you can toggle synchronous browsing of both panes. When enabled the inactive pane will auto-change its location in sync with the active pane.

Usage

· Enable Dual Pane (F10). Point both panes to locations that you want to sync-browse. Tip: Hold ALT and you can use the Tree to navigate the inactive pane.
· Turn on Sync Browse.
· Now when you change locations in one pane, the other pane will attempt to do the same relative move.
· When Sync Browse is not possible (because it would lead to a non-existing location) the status bar displays "cannot sync browse this location" and the synced pane will not change its location.
· Auto-Sync Select: When in Sync Browse mode selecting "A.txt" in the active pane will optionally auto-select "A.txt" in the inactive pane (if it exists there). Useful when both panes have different sort orders, differing file listings, or different view modes. To enable this feature tick "Auto-Sync Select" in the right-click menu of the "Sync Browse" toolbar button.

Notes

· When you change to another tab in any of the panes, Sync Browse is suspended until both original tabs are active again.
· Sync Browse also works when the inactive pane is invisible.
· There's also a toolbar button "Sync Browse".
· Sync Browse is not stored between sessions.

Sync Browse is a great time saver when performing moves/renames and other reorganizations on mirrored drives. Another usage is to browse one location in two different simultaneous views, e.g. Details and Thumbnails.

Sync Scroll

Here you can toggle synchronous scrolling of both panes. When enabled then the relative top index of the active lists/tabs of both panes is stored. When you then scroll the list in either of these tabs the top index relation is restored (if possible) by auto-scrolling the other list.

Notes

· Sync Scroll includes Sync Sort: If Sync Scroll is enabled, and you then resort any of the lists the other list is automatically sorted the same way.
· When you change to another tab in any of the panes, Sync Scroll is suspended until both original tabs are active again.
· Also horizontal scrolling is synchronized.
· If both panes have different view modes than scrolling is synced as "percentage of window scrolled" instead of absolute line counts. That way you can perfectly sync scroll a Details view with a Thumbnails view of the same location.
· Sync Scroll also works when the inactive pane is invisible.
· There's also a toolbar button "Sync Scroll".
· Sync Scroll is not stored between sessions.

Sync Select...

Here you find various commands to modify the selection in one pane based on items in the other pane. They are best used for comparing two locations which have similar content.

· Select Matches: Select all items that are also listed in the other pane.
· Select Uniques: Select all items that are only listed in this pane.
· Select Newer: Select all matches with a more recent modified date.
Newer is a file or folder where the modified date is at least one full second newer than that of the other item.
If Ignore extensions is ticked then the first match (both lists are compared from top to bottom, with the active pane as the outer loop) is taken to the file time comparison.
· Select Uniques and Newer: Select all items that are unique or newer.
· Select Selected: Select all items that are selected in the other pane.

Additionally there are the following checkboxes to modify the functions:

On both panes: Check to apply the chosen command to both panes, i.e. to have items on both panes selected.

Ignore extensions: Check to ignore the extensions when matching the names.

Further Remarks

· Matching is case-insensitive (A=a).
· You can add to / remove from the current selections:
- Hold CTRL while pressing OK (or ENTER) = Add to the current selections.
- Hold SHIFT whilepressing OK (or ENTER) = Remove from the current selections.
· The last used command and the state of the checkboxes are saved between sessions.
· The dialog remembers its size and position.


Color Filters

Index

Color Filters Overview

The Types of Color Filters

Color-coding based on file or folder names (name:)

Color-coding based on folder names (dir:)

Color-coding based on file attributes (attr:)

Color-coding based on file size (size:)

Color-coding based on file date (date:)

Color-coding based on file age (age:)

Color-coding based on name length (len: and lenT:)

Color-coding based on properties (prop:)

Instant Color Filters

Color Filters Overview

Color filters allow you to color-code the files and folders currently visible in the List pane based on various criteria like name, attributes, size, date, age, name length, and properties. Filters based on name, age and attributes optionally also work in the Tree pane. Color-coding items helps to easily spot and distinguish particular items.

Configuration of Color Filter

See Configuration | Color Filters.

General Color Filter Syntax

Color Filters are defined by a selector and a pattern in the general form selector: pattern. The following selectors (= filter types) are available:

Filter Type Selector 2nd Selector

----------------------------------------------

Name [name:]

Folder Name dir:

Attributes attr:

Size size:

Date Created dateC:

Date Modified dateM:

Date Accessed dateA:

Age Created ageC:

Age Modified ageM:

Age Accessed ageA:

Name Length len:

Title Length lenT:

Property prop: property selector:

Examples:

name: *.txt = named *.txt

dir: *.txt = folder named *.txt

attr: system = SYSTEM attribute set

size: >= 1.5 GB = 1.5 GB or bigger

dateM: 2010.01.01 - = modified 2010 or later

dateC: dw 6-7 = created on a weekend

ageA: < 5 d = accessed less than 5 days ago

len: > 260 = path/name longer than 260 characters

prop:dimensions: 1500 x * = 1500 pixels wide

Notes:

· The Name Selector is optional: if no other selector is found then Name is assumed by default.
· The space between selector and pattern is optional.
· Case does not matter in selectors.
· Property filters are special in that they need an additional property selector to specify the sort of property. This can be a verbal identifier (e.g. prop:dimensions:) or a numeric identifier (e.g. prop:#31:)

Scope Suffix

An optional scope suffix can be used to limit color filters to directories or to files.

Scope suffixes are appended to the primary selector separated by a space. "d" stands for "directories", "f" stands for "files", "df" (or "fd") for both (i.e. unlimited scope). A missing scope suffix defaults to "df" (unlimited scope) but see some obvious exceptions below.

Usage: For example, you want to color folders by age created in Tree and List but don't want to color the files.

Examples:

ageC d:d //folders created today

ageM f:d //files modified today

prop d:#HardLinks: > 1 //folders with more than one hardlink

Exceptions:

· "dir:" is always directory-only by definition
· [no selector] is equivalent to "name f:" (name files-only), for example: *.txt

Boolean Logic

OR: In each line of the Color Filter List you can state an unlimited number of filters separated by ; (semi-colon). These will be logically combined with OR: The colors are applied if any of the filters in the line matches.

AND: Filters in each line can also be connected by logical AND. The operator is AND (surrounded by spaces!); it's not case-sensitive, so and works as well.

NOT: The prefixed unary NOT operator "!" is supported. The operator can also be used for individual operands in a Boolean expression. Note that this works only for non-first operands, since the NOT operator in front of the first operand is interpreted as NOT operator for the whole expression (see examples below).

Notes:

· The semi-colon (which works as Boolean OR) has a lower precedence than AND.
· Color Filters which contain the strings " AND " or ";" can/should be quoted.

Examples:

· TXT files modified in any of the last 5 days at the 11th hour:
ageM: <= 5 d AND dateC: h 11 AND *.txt
· Files named "A AND B*" and larger than 1MB:
"A AND B*" AND size: > 1MB
· Files modified Mondays at 11 OR Tuesdays at 12:
dateM: dw 1 AND dateM: h 11; dateM: dw 2 AND dateM: h 12;
· Items not beginning with a:
!a*
· Items not beginning with a or b (NOT operator refers to whole expression)
!a*;b*
· Items beginning with a or not with b (NOT operator refers only to 2nd operand)
a*;!b*

Captions

Color Filters support captions prefixed in quotes to the filter definition. Currently only Instant Color Filters actually use this caption, where it is displayed as menu item caption in the Instant Color Filters popup menu. For example:

"Created or Modified Today" ageC: d;ageM: d>FFFFFF,70B926

Comments (Advanced Feature only for Geeks)

You can add a free form user comment to the end of each line of the Color Filter List, separated from the rest of the line by "//", e.g.:

ageM: d AND *.txt //text files modified today

Note that the general form of the comments section is (see Switches and Pre-Filters in the following paragraphs):

//[switches]|[filter:pre-filters]|free form user comment

Switches (Advanced Feature only for Geeks)

There are two switches that can be placed in the comments section of a filter right after "//" and followed by a "|" (pipe) , m (merge) and n (no more). If switches are used, the user comments have to be placed after the "|" (see example below).

m-switch: merge

This switch can be used to merge the back color of the first matching filter with the text color of the next matching filter.

In the following example (copied from List Management | Color Filters to show the color codes), any TXT file that was modified today will now be displayed with colors 38A050,6798E0. What the m-switch actually does is: Instead of taking this color filter's text color, look for the next matching color filter that has NO backcolor defined and take its text color.

+ageM: d //m|modified today>FFFFFF,6798E0

+name:*.txt>38A050,

This example will set a light yellow background color to all items with SYSTEM attribute, and use the text color of the next matching color filter that has only a text color defined (note that the "|" after "m" is obligatory!):

+attr:s//m|>,FFFF80

n-switch: no more

In Details mode, the first matching filter *with* backcolor (if any) is displayed combined with the first matching filter *without* backcolor (if any). The filter *with* backcolor must be the first match. The name column will show Text/Back color of the first match, the other columns will show the Text color of the second match.

This behavior can be suppressed using the n-switch. For example:

*.bak //n|Only color the name column

Pre-Filters (Advanced Feature only for Geeks)

There is a way to pre-filter the files that a are checked for matching a particular Color Filter. This is very welcome for slow Color Filters such as the "prop:" filter because it can considerably speed up the processing.

The pre-filter is located in the optional comments section of a filter, i.e. after "//". As the first part of the comments section is reserved for certain switches ("m" and "n", see above), the pre-filter is to be placed in the second part, after the first "|"; it has to be prefixed by "filter:". Any number of filters can be stated, separated by ";" which stands for logical OR. Pre-filters can include whole paths, actually anything that will work in a simple pattern matching against the full path/file name of the item in question. So you can limit the job to certain folders or branches if you like.

For example, these pre-filters limit the items that are checked for the CameraModel property to CRW and JPG files, respectively to the folders E:\photos and F:\photos:

prop:CameraModel:*Canon* //|filter:*.crw;*.jpg

prop:CameraModel:*Canon* //|filter:E:\photos\;F:\photos\

The Types of Color Filters

Color-coding based on file or folder names (name:)

For example to color all TXT files blue, add the pattern name:*.txt to the list and then choose a nice blue. Or give an extraterrestrial ultra-violet to all files containing a space in their name by adding the pattern name:* *.

Note that the selector name: is optional (in other words, this is the default color filter type). Simply *.txt will do as well.

Further you can use the wildcard "#" for any single digit (0-9).

Color Filter pattern matching is not case-sensitive: a=A.

Loose matches: Name and Dir patterns support Loose Match, i.e. wildcards (*) are internally auto-added left and right of a pattern if no wildcards (* or ?) are contained in the pattern. So "cat" will match "wildcat.txt".

Advanced filename patterns

You can as well color certain List items in specific directories by stating a pattern that will be matched against the full path of each item.

Rules:

If the pattern contains the character "\" then

it's treated against the full path (relative/portable syntax supported)

Else

it's treated against the file name (without path)

Examples:

?:\*.png -> matches only those PNG files that are located on XY's home drive.

C:\Windows\*.dll -> matches only those DLL files that are located in C:\Windows\.

C:\Windows\* -> matches all items that are located in C:\Windows\.

Color-coding based on folder names (dir:)

Works identical to the name: filter above, but is confined to folders. If "Apply all checked "dir:" and "attr:" patterns to the Tree" is ticked the coloring is also applied to the Tree.

For example to color all folders named "*_work" brown, add the pattern dir:*_work to the list and then choose a nice brown.

Color-coding based on file attributes (attr:)

You add an attribute pattern by simply adding the name of the attribute, preceded by attr:, to the color filters list (tip: stating the first letter is enough; case is ignored).

These are the available file attributes:

attr:readonly (or attr:r) -> matches all items with READONLY set

attr:hidden (or attr:h) -> matches all items with HIDDEN set

attr:system (or attr:s) -> matches all items with SYSTEM set

attr:directory (or attr:d) -> matches all items with DIRECTORY set

attr:archive (or attr:a) -> matches all items with ARCHIVE set

attr:normal (or attr:n) -> matches all items with NORMAL set

attr:temporary (or attr:t) -> matches all items with TEMPORARY set

attr:junction (or attr:j) -> matches all items with REPARSE POINT set

attr:compressed (or attr:c) -> matches all items with COMPRESSED set

attr:offline (or attr:o) -> matches all items with OFFLINE set

attr:encrypted (or attr:e) -> matches all items with ENCRYPTED set

attr:indexednot (or attr:i) -> matches all items with NOT CONTENT INDEXED set

Attribute patterns can be freely OR-combined with each other and with name patterns into one filter definition, e.g.:

attr:c; attr:r -> matches all items that are compressed or readonly

attr:d; *.txt -> matches all directories and all TXT files

Color-coding based on file size (size:)

Using size-based color filters you can, for example, color all empty files in a certain way, or all files bigger than a certain size.

You add an size pattern according to the following syntax:

size: n = exact size

size: == n = exact (identical to the above)

size: < n = smaller than n

size: > n = bigger than n

size: <= n = n or smaller

size: >= n = n or bigger

size: min - max = from min to max (both inclusive)

size: min -< max = from min to max (max exclusive)

size: min >- max = from min to max (min exclusive)

size: min >< max = from min to max (both exclusive)

size: min- = min or bigger (same as >=n)

size: -max = max or smaller (same as <=n)

Here are some examples:

size: 0 = size 0 bytes (empty file)

size: 1000 = size 1000 bytes

size: < 10 = smaller than 10 bytes

size: > 1 MB = bigger than 1 MB

size: >= 1.5 GB = 1.5 GB or bigger

size: 1KB - 20KB = from 1 KB to 20 KB (both incl.)

As you see, size-based filters support human-friendly size formats, recognized units are KB, MB, GB, TB, PB, and B (B is optional for bytes). Fractional values are okay, case does not matter, and you can throw in spaces as you like.

Color-coding based on file date (date:) - Part 1: Absolute Dates

All three file dates (Created, Modified, Accessed) are supported. So you can, for example, color all files that were modified on a certain day, or that were created before the year 2008.

General syntax:

dateC: = Date Created

dateM: = Date Modified

dateA: = Date Accessed

dateM: [date] = exact date (down to the second)

dateM: == [date] = exact date (down to the second)

dateM: < [date] = earlier than

dateM: > [date] = later than

dateM: <= [date] = same or earlier

dateM: >= [date] = same or later

dateM: [date] - [date] = from earliest to latest (both inclusive)

dateM: [date] -< [date] = from earliest to latest (latest exclusive)

dateM: [date] >- [date] = from earliest to latest (earliest exclusive)

dateM: [date] >< [date] = from earliest to latest (both exclusive)

dateM: [date] - = same or later (same as >= )

dateM: - [date] = same or earlier (same as <= )

Examples with time part:

dateM: == 2010.11.16 10:30:12 (all items modified then)

dateA: >= 11.11.2010 11:11:11 (all items accessed in this Carnival and later)

Examples without time part:

dateC: < 2008.01.01 (all items created before 2008)

dateM: 2010.01.01 - (all items modified 2010 and later)

dateM: 2010.11.14 - 2010.11.15 (all items modified 2010.11.14 or 2010.11.15)

dateC: 05/22/2011 (all items created 05/22/2011)

Notes:

· The date has to be given in a form that is recognized as a valid date format on your locale.
· The time part can be skipped. In this case, when operators are used in the term, the time it is internally set to 00:00:00 or 23:59:59, depending on the semantics of the term. When no operators are used (you just give a date without the time part) the term is interpreted as a time range covering that whole day (see examples above).
· The selector is not case-sensitive: DaTem: would work as well. date: = defaults to "Date Modified".
· A trailing ";" is optional. Like with all color filters, ";" can also be used to concatenate patterns assigned to the same colors.
· These filters work for files and folders but only in the List (not in the Tree).

Color-coding based on file date (date:) - Part 2: Subranges

You also can color items if their file times match certain subranges, e.g. created from 8:00-10:00 in the morning, last modified on a weekend, last accessed in an April (of any year). To achieve this a unit selector is prefixed to a number or range (using the usual set of operators).

Unit selectors:

y = year (1601 - 32767)

q = quarter of year (1 - 4)

m = month (1 - 12)

dw = day of week (Monday = 1 ... Sunday = 7)

dy = day of year (1st January = 1)

d = day (of month)

h = hour (0 - 23)

n = minute (0 - 59)

s = second (0 - 59)

ms = millisecond (0 - 999)

Examples:

dateC: h 8-10 = created from 8:00-10:00 (of any day)

dateM: m 4 = last modified in an April (of any year)

dateM: dw 6-7 = last modified on a weekend

dateM: dw 7-2 = last modified from sunday to tuesday

dateC: dy 1-100 = created in the first 100 days (of any year)

dateC: q 3 = created in the 3rd quarter (of any year)

Notes:

· The Unit selectors must be separated from the unit number or range by at least one space.

Color-coding based on file age (age:)

All three file dates (Created, Modified, Accessed) are supported. You can, for example, color all files that were modified today or last week, or that were created more than 10 years ago. This filter also supports folders in the folder Tree.

General syntax:

ageC: = Date Created

ageM: = Date Modified

ageA: = Date Accessed

The usual operators apply; [n] is a number and [u] a unit selector; for example:

ageM: [n] [u] = specific unit

ageM: == [n] [u] = specific unit

ageM: < [n] [u] = less than so many units

ageM: > [n] [u] = more than so many units

ageM: <= [n] [u] = so many units or less

ageM: >= [n] [u] = so many units or more

ageM: [min] - [max] [u] = from min to max units (both included)

Unit selectors:

y = year

q = quarter of year

m = month

w = week (Monday - Sunday)

d = day [default unit!]

h = hour

n = minute

s = second

Examples:

ageM: < 5 n = modified less than 5 minutes ago

ageM: >= 3 h = modified 3 or more hours ago

ageM: 1 w = modified last week (previous Monday - Sunday)

ageM: 0 d = modified today (from 00:00:00 till 23:59:59)

age: = modified today (same as above, all defaults used)

ageM: 1 d = modified yesterday

ageM: < 0 d = modified in the future (tomorrow or later)

Notes:

· The Unit selectors must be separated from the unit number or range by at least one space.
· The Age selector is not case-sensitive: AgEm: would work as well.
· age: defaults to "Date Modified".

Color-coding based on name length (len: and lenT:)

Name length here refers filename length (with full path) (len:) and file title length (name without path) (lenT:). The syntax is identical to the one of the "size:" selector, so you can use all sorts of numerical comparison operators to define limits and ranges.

Examples:

len: > 260 = color all files with a path/name longer than 260 characters

lent: <= 12 = color all files with a name with 12 or fewer characters

Color-coding based on properties (prop:)

Properties here refers to shell properties, that's the properties you see in the File Info Tips when hovering a file. The Properties filter is an extremely powerful color filter with a vast number of options. Win7 and later offer over 250 shell properties (of course, not all are used by each file type).

There is a drawback though: Property filters are quite slow! This is because retrieving shell properties has to rely on a slow shell mechanism. Each active "prop:" color filter will notably slow down listing and scrolling a list and selecting items in the list, and the more items are displayed simultaneously in the visible part of the list the slower it will be. Nevertheless, the "prop:" color filter can be of significant value. There is also a way to reduce the loss of speed (see Pre-Filters above).

Property filters are special in that they need an additional property selector to specify the sort of property. This can be a verbal identifier (e.g. prop:dimensions:) or a numeric identifier (e.g. prop:#31:).

Examples:

prop:dimensions:1500 x * = color all files 1500 pixels wide

prop:#26:1500 x * = (same as above on WinXP)

Note that #26 is identical to "dimensions" on WinXP but not on Win7 where "dimensions" is #31. You can find the correct indices in the list under Configuration | File Info Tips | Show custom file info tips.

More examples:

prop:fileversion:8.60 = color all files versioned 8.60

prop:#26:1024 x 768 = color all files sized 1024 x 768

prop:CameraModel:*Canon* = color all files snapped with a Canon

Also XYplorer-specific named arguments are supported, e.g.:

prop:#tags:dogs = color all files tagged "dogs" exactly

prop:#tags:*dogs* = color all files tagged "dogs" (and other tags)

prop:#ShortcutTarget:*.jpg = color all files linking to JPGs

prop:#JunctionTarget:*blah* = color all junctions to "*blah*"

prop:#HardLinks: > 1 = color all files with more than one hard link

prop:#AspectRatio: 16:9 = color all image files with a 16:9 aspect ratio

Also the #Hash property is supported, but it is not recommended because it would extremely slow down browsing. For example (don't do this at home), this color filter will color all files with a certain MD5 value:

prop:#Hash.MD5:58172fd15526e1249ac8bfd690ced076

Note that "prop:" filters have their own distinctive background color shapes (in case you enabled Configuration | Color Filters | Draw background colors in distinctive shapes).

Numeric Properties

The "prop:" filter also supports numeric comparisons. For example to color all JPG and PNG images with a width of at least 1024 pixels use any of these (two ways to express the same):

prop:#162:1024 - //|filter:*.jpg;*.png

prop:#162:>=1024 //|filter:*.jpg;*.png

Note that #162 is the numeric property identifier for "Width" on one Win7 system. It might be different on your system. You can find the correct indices in the list under Configuration | File Info Tips | Show custom file info tips.

Date Properties

The "prop:" filters also support dates. For example, to color all files with a specific shooting time (valid date/time syntax varies with your locale):

prop:#25:02.08.2011 13:52 //|filter:*.jpg

You can omit the time part to only search for JPG images shot on a certain day:

prop:#25:02.08.2011 //|filter:*.jpg

You can as well specify ranges using the complete operator syntax that's already supported by the Date Color Filters ("dateM:" etc.). For example, to color all JPG images shot between 01.01.2011 and 31.12.2011 (both dates inclusive):

prop:#25:01.01.2011 - 31.12.2011 //|filter:*.jpg

Note that the numeric property identifier "#25" is preferred to the verbal "WhenTaken" because the latter returns the time in UTC (Coordinated Universal Time) instead of local time -- a mysterious shell anomaly. Note further that #25 is only valid for Windows XP, whereas Win7 needs #11 here.

Instant Color Filters

XYplorer comes with a predefined set of so-called Instant Color Filters that can be applied individually and independently of the normal Color Filters.

Usage

Instant Color Filters are applied via the toolbar button "Toggle Instant Color Filter". The button has an arrow-dropdown where the filters can be individually applied. The button itself toggles the last applied filter.

· If you activate a new filter, the old filter is replaced by it. So you cannot have two at the same time.
· If you activate the same filter again it is deactivated (toggle).
· The filters activated by this command are completely independent of the Color Filters (which are defined and enabled via Configuration | Color Filters). They even work if the normal Color Filters are disabled.

Tip: The button has a right-click menu with some useful options.

Advantages

Instant Color Filters have a couple of advantages over the normal color filters:

· You can quickly and individually turn them on/off without going through Configuration.
· This means you can spotlight the files you are interested in now, just in time. With normal Color Filters your are often bothered with colors all over that are rather distracting than helpful.
· They are always processed on top of all other color filters, so you always see all matches. Whereas in normal color filters it's common that the first match covers any possible other matches because usually only one color can be shown at the time for each item (exception: Details view allows two colors simultaneously per item under certain conditions).
· Because lists of filters are supported you can use this function to toggle whole color schemes which would be very cumbersome to do using the normal color filters.
· It's also easy to share color schemes between users via user button snippets or included catalogs.
· Just like normal Color Filters, Instant color filters are retained across sessions

Tip: You can assign a keyboard shortcut to toggle the last applied filter via Customize Keyboard Shortcuts | Miscellaneous | Various | Toggle Instant Color Filter.

Customization

The predefined filters can be freely customized via List Management | Instant Color Filters. Of course, the customizations are retained between sessions.

The color filter syntax is identical to that of normal Color Filters. The color filter definition uses the full Color Filter syntax including colors in RRGGBB and leading "+" (the "+" is optional here, the filters will also be applied without the "+"). You can see this syntax in List Management | Color Filters, in Editor Mode (F6).

Multi-Filter Definitions: There is one thing where ICFs go beyond normal CFs. You can append several filter definitions in one line separated by "||". Example:

"Files Shaded By Size" size: >= 1 GB>000000,8A939F||size: >= 100 MB>003080,8EA4C4||size: >= 10 MB>004080,A9BAD3||size: >= 1 MB>0053A6,BCCCDE||size: >= 1 KB>0E80DC,D1DAE9||size: > 0>4F91D2,E2E3EB||size: 0>96ABB8,ECEDF2

Note that the coloring displayed in List Management only takes the left-most filter into account if there are many filters in a line.

Factory Defaults

For reference, the following Instant Color Filters are supplied by factory default.

"Created or Modified Today" ageC: d;ageM: d>FFFFFF,70B926

"Created or Modified This Week" ageC: w;ageM: w>FFFFFF,B97026

"Folders Created Recently" ageC d: <= 3 h //folders created last 3 hours>FFFF00,0073E6||ageC d: d //folders created today>FFFF80,379BFF||ageC d: w //folders created this week>FFFFFF,71B8FF

"Files Modified Recently" ageM f: <= 5 n //files modified last 5 min>FFFF00,4F831B||ageM f: <= 1 h //files modified last hour>FFFF00,63A521||ageM f: <= 24 h //files modified last 24 hours>FFFFFF,70B926

-

"Empty Files" size: 0>96ABB8,ECEDF2

"Files Shaded By Size" size: >= 1 GB>000000,8A939F||size: >= 100 MB>003080,8EA4C4||size: >= 10 MB>004080,A9BAD3||size: >= 1 MB>0053A6,BCCCDE||size: >= 1 KB>0E80DC,D1DAE9||size: > 0>4F91D2,E2E3EB||size: 0>96ABB8,ECEDF2

-

"Overlong Filenames" len: > 260>FFFF80,FB4F04

-

"Read Only Files" attr f:readonly>47A905,FFFF80

"System Files" attr f:system>FF0080,FFFF00

-

"Executables" *.exe;*.bat;*.cmd;*.com;*.scr>804000,FFFFAA

"Common Image Files" *.gif;*.jpg;*.png;*.tif>36530F,E6F786

-

"Image Aspect Ratio 16:9" prop:#AspectRatio: 16:9>5A4F36,F7E686

-

"Black Out" name: *>222222,222222

Tip: You can easily reset your filter collection to factory defaults by deleting all filters in List Management | Instant Color Filters.

Scripting support

The scripting function colorfilter() can also be used to apply Instant Color Filters. Details see colorfilter().


Floating Preview

Floating Preview

Note: All features and settings of the Floating Preview are shared by the Full Screen Preview. Below, "Floating Preview" stands for both.

The Floating Preview previews the current file in a non-modal preview window whose size and absolute screen position is stored between sessions. The window supports many media types (i.e. images, including Animated GIFs, and shell thumbnail previews for HTML, PDF, MPEG, DWG, etc., everything your system can generate thumbnails for), including the transparency grid for transparent images. A right-click menu, and a set of keyboard shortcuts shown in that menu, lets you control various display options. Here is an overview over the related keyboard shortcuts and mouse tricks.

The Floating Preview optionally (see below) supports Mouse Down Blow Up, for images as well as for PDF files and other shell generated previews.

Here are some of the right-click menu options:

Next (PageDown) and Previous (PageUp): Browse previewed files. Note that changing the current file in the main form will update the preview, and vice versa: Wheeling through the preview (or key PageUp/PageDown) will change the current file in the main form browsing only previewable files.

Fit All (A) shrinks larger originals to fit the width and height of the preview window. Resizing the window resizes the preview in real time. Toggles with Original Size.

Fit Width (W) shrinks larger originals to fit the width of the preview window. This serves to see the images that have a portrait orientation in more detail. Use Mouse Down Blow Up to view any cropped top and bottom parts. Fit Width is only supported in the Floating Preview, not in any other preview. Toggles with Fit All.

Fit Height (H) does for height what Fit Width does for width. Toggles with Fit All.

Zoom to Fill (I) fills all the available space with the preview. Left/right parts or top/bottom parts may be cropped. Using this option makes better use of the available space at the expense of the cropped areas. Note that the cropped preview is centered, i.e. the cropping is done equally at both of the cropped sides.

Original Size (O, 1, Numpad Divide) shows the image in original size (100%), cropped if there is not enough space. You can pan the preview by holding down the right mouse (or CTRL+left mouse) button and moving the mouse, or by the arrow keys (Up, Down, Left, Right). Toggles with Fit All.

Double Size (D, 2, Numpad Multiply) shows the image in original size (200%). See Original Size for panning. Toggles with Fit All.

Zoom In (Numpad Add, +, CTRL+Wheel Up) zooms into the image.

Zoom Out (Numpad Subtract, -, CTRL+Wheel Down) zooms out of the image.

· Zooming uses a logarithmic scale (based on the 4th root of 2, which means you need 4 steps to get to the half or double size), and it starts flexibly at the current zoom whatever it is. The possible range is from 0.5% to 6400% of the original size.
· To ensure that zooming passes the 100% point it initially snaps to a normalized scale that contains the 100% point, so the first zooming step might not be exactly by 4th root of 2.
· There is an even finer zooming by the 12th root of 2, which matches the chromatic scale of Western music and e.g. echoes the fret pattern on a guitar neck. Hold SHIFT to zoom by the 12th root of 2 (1.0594630943593).
· On zoom 400% and higher you will see the pixels. This is intended because "High Quality" resampling just looks bad with such high zoom factors.
· The zooming is auto-reset when the next image is previewed, unless Lock Zoom (see below) is enabled.

Lock Zoom (K): If ticked then the current zoom level is kept when switching images as long as the preview window is open.

Toggle Zoom (G): Use this command to toggle between the last zoom level and the default size of the image (Fit All, Original Size, etc.). The last zoom level is remembered across openings of the preview window (but not across application sessions).

Mouse Down Blow Up (M): If ticked then the preview supports Mouse Down Blow Up (MDBU). Note that here MDBU always uses the whole screen (ignoring the setting of Configuration | Preview | Mouse Down Blow Up | Use whole screen).

· If MDBU is OFF you can pan a cropped image using the Left Mouse Button (additionally to CTRL+Left Mouse Button and Right Mouse Button). When panning is possible you get the traditional "hand" cursor.
· If Mouse Down Blow Up is ON you still can pan a cropped image using the Right Mouse Button (or using CTRL+Left Mouse Button).
· If MDBU is OFF and the image is NOT cropped you can still get MDBU because now it does not interfere with left mouse panning.

Rotate Left (L) and Rotate Right (R): Rotate the preview by 90° steps.

· Of course, the original image itself is not modified.
· The rotate state is remembered for a preview until the file is unselected. You can even switch between Floating and Full Screen Preview while keeping the rotation as long as the file is not unselected.
· Press F5 (Refresh) to show the preview in non-rotated state, respectively in auto-rotated state if that's enabled.
· Pixel-exact Mouse Down Blow Up works just fine in rotated previews.
· The image preview in the Info Panel, if active at the same time as the Floating Preview, is rotated as well. This has technical reasons but might as well be useful.
· Works for all previewed file types, even for RAW images, PSD, TGA, PDF, and video thumbs.

Flipped (F): If ticked then the preview is flipped (mirror image) horizontally (relative to the preview, also if rotated).

· All notes given for rotated images also apply to flipped images.
· For a flipped image Rotate Left and Right are interpreted as being applied to the flipped image, not to the original. This seems to better match the user expectation. Nevertheless, the status info displays the correct rotation degrees with reference to the original.

Copy Original (C): Copy the original image (bitmap) to the clipboard.

Copy Preview (Ctrl+C): Copy the preview image (bitmap) to the clipboard.

Delete File (Del): Delete the previewed file right from the preview by pressing DEL or Shift+DEL.

Rename File (F2): Rename the previewed file right from the preview.

Full Screen (F12): Toggle Full Screen and normal mode while the preview is on.

Note that the Quick File View is auto-opened on a file that's not supported by the Floating Preview.

There is a menu command (menu File | Floating Preview, Default Shortcut: F11) and a toolbar button to toggle the Floating Preview.

Zip Support: When you call the Floating Preview on a Zip file, the contents of the Zip are shown in a list. See details here:


Labels, Tags, Comments, and Extra Tags

Labels, Tags, Comments

XYplorer lets you assign labels, tags, and comments to individual files and folders. This can be done through various interfaces: The Tags Tab on the Info Panel, various Toolbar buttons, the Favorites menu, the context menu of the tags-related columns in the Details view, and scripting.

Labels

Labels let you put files into a closed set of freely definable categories. You can have your "blue" files, your "ready" files, your "important" files, your "junk" files, etc.

Labels are visual helpers in that they give colors to file names in the file list. You can sort files by Labels. And you can search files by Labels.

The labeling is done very comfortably via keyboard shortcut, toolbar button, or context menu. Labels are retained across sessions.

There is a choice of seven predefined color schemes (background and text color), which can easily be exchanged for other colors, and extended to up to 15 color schemes. The names of the schemes can be customized in Configuration | Tags. Here you can also choose how and where the colors are displayed in the file list.

The Toolbar offers the handy buttons Labels and Find by Label. You can configure the latter button to Search Everywhere (whole computer) or Search This Branch (current location including subfolders) or Search Here (current location excluding subfolders). The options are found at the bottom of the button's dropdown menu. Of course, the buttons also have a right-click menu with various useful commands.

Tags

You can define any number of Tags for any file or folder, and show them in the column "Tags" in Details view. They can also be shown in the File Info Tips, and you can find files by them (with all Boolean splendor, and extremely fast because these searches are indexed).

· Tags are not case-sensitive (A==a).
· Tags can contain any characters apart from:
, (comma) which is used as separator between the tags.
| (pipe) which is used as separator between the fields.
(space) at the left and right end of a tag. Spaces within a tag are okay.
· In the database and in the Tags column, tags are separated by comma and space (, ) for better readability. However, the space is not necessary for parsing and can optionally be omitted wherever tags are fed into the app.
· Commands to add or remove tags are found in the Favorites menu.
· A "Tag List" (similar to a tag cloud, but not weighted) is automatically maintained in the background and across sessions that lets you select tags rather than type them again and again. In the Add Tags and Edit Tags dialogs there is a checkbox "Add new tags to tag list" by which new tags are automatically added to the tag list (always to the top of the list).
You can also manually manage the Tag List in List Management. This way you can easily load a new cloud to have a different set of tags ready for selection. Note that editing the Tag List does not change or remove any tags from your files or folders! The Tag List is only your interface to selecting/attaching tags.
· The Toolbar offers four handy buttons to Add Tags, Set Tags, Remove Tags, and Find by Tags. They pop a menu with the top 20 tags from the tag list. All buttons work on the selected items only and show a "Nothing Selected" pseudo item in the popup menu if there are no selections.
Especially interesting is the Find by Tags button because the "Tag List..." item allows for easy multi-tag searches. Tick Match All if all ticked tags must match (Boolean AND). You can configure the button to Search Everywhere (whole computer) or Search This Branch (current location including subfolders) or Search Here (current location excluding subfolders). The options are found at the bottom of the button's dropdown menu.
Of course, the buttons also have a right-click menu with various useful commands.
· See Usage here below for more ways to handle Tags.

Comments

You may as well attach individual comments of virtually any size to your files and folders.

Unlike labels, comments are not taken from a closed set. You can have thousands of different comments, and they can be as long as you like.

Usage

In the file list, in Details View, tags (Labels, Tags, Comments) are displayed in individual columns (show them using menu View | Columns), which can be sorted and thus used to group items according to their tags.

Note that you can add or edit tags directly in the file list by clicking into the respective column: A Left-click in the Label column will set/unset (toggle) the current Label. A Right-click in the Label, Tag, or Comment column will pop a context menu with several options. Note that the latter needs Configuration | Tags | Popup by tag columns right-click enabled, and Full Row Select (in menu Tools | Customize List) should be disabled for the list.

File Operations

During file operations within XYplorer the tags are preserved in the most natural ways possible. Note that any file operations occurring outside of XYplorer will obviously not have the tags preserved (even for items in the current location with auto-refresh enabled).

Moving Items

Moving items, the tags will move along with the items. When moving an item and replacing an already existing one, any existing tags from source items will be set to destination items, replacing any previously existing tags on the destination items. If a source item does not have tag, but the previously existing destination item does, they will be preserved.

Copying Items

Copying items, by factory default the tags will not be copied along with the items, in an effort to keep your database tidy and avoid multiplying tags which could eventually slow things down. Any previously existing items will keep their original tags.

However, you can enable copying tags by ticking Configuration | Tags | Copy tags on copy operations respectively Configuration | Tags | Copy tags on backup operations. Tip: Tick Configuration | Tags | Confirm copying tags and you are prompted before any tags are copied from the source items to the target items.

Renaming Items

Renaming items, the tags are obviously preserved.

Deleting Items

Deleting items, the tags are removed from the database.

Find Files by Tags

You can search items by tags using the Tags tab in the Find Files tab in the Info Panel.

Configuration

See Configuration | Tags.

The Database: tag.dat

All tag data are retained across sessions and stored in one file, tag.dat, located in the application data folder. The file is kept in an open, simple, and human-friendly text format (UTF-16 Text File) so that you can easily edit it manually using an editor or programmatically using any scriptable software.

OLDER VERSIONS, NOW OBSOLETE: File Format of the XYplorer Tag Database (version 2 -- till 13.70)

Line 1: Header and version info: XYplorer File Tags v2

Line 2: Label schemes, separated by ";". Each scheme: Name|TextColor|BackColor. Colors are in RRGGBB.

Line 3: (empty)

Line 4: Tagged item #1: Full filename|LabelID|Tags|reserved1|reserved2|reserved3|Comment

Line 5: Tagged item #2: ... etc. ...

CURRENT VERSION: File Format of the XYplorer Tag Database (version 3 -- from 13.80 onwards)

Line 1: Header and version info: XYplorer File Tags v3

Line 2: (empty)

Line 3: Labels:

Line 4: Label schemes, separated by ";". Each scheme: Name|TextColor|BackColor. Colors are in RRGGBB.

Line 5: (empty)

Line 6: Extra Tags:

Line 7-11: Extra Tag Definitions: Caption|TypeID|0|0||||| . Some fields are reserved for future use.

Line 12: (empty)

Line 13: Data:

Line 14: Tagged item #1: Full filename|LabelID|Tags|Extra1|Extra2|Extra3|Extra4|Extra5|Comment

Line 15: Tagged item #2: ... etc. ...

In case you edit tag.dat manually...

Sort Order. The tagged item lines must be in binary ascending sort order (A < B ... < a < b ...). If you manually edit tag.dat and are unsure about the correctness of the sort order, you can have the data sorted by using "Database Clean Up..." in Configuration | Tags.

Capitalization matters. You must care for the right capitalization of the file names. Reason: For better performance, the comparisons are done by byte, not by character.

Portable Tags

Tick Configuration | Tags | Enable portable tags to store tags in a portable manner.

Notes:

· Tags are stored in a portable manner only if XYplorer and tag.dat is located on the same drive. Otherwise the checkbox is disabled. And, of course, only tags on this very drive are stored portably.
· Technically, portability is achieved by replacing the removable drive letter by a "?" when saving the tags, and reversing that operation when reading the tags.
· List Management | Tagged Items always shows the resolved tags as they are in memory.

Usage:

· Tick "Enable portable tags". Have a copy of XYplorer.exe on your USB-stick, along with the application data folder (it will be automatically generated as subfolder "Data"). Do your tagging, then save the tags (they are saved to tag.dat in a portable way).
· Now you can carry around a stick full of tagged items together with the application (XYplorer) that displays them -- regardless of the drive letter assigned by the host system.

Extra Tags

Additionally to the above Label, Tags, and Comment, you get five optional Extra Tags, that can be shown in the file list as Extra Columns. Via clicking into these extra columns (or via scripting) you can assign user data of various formats (free text, checkboxes, rating stars, date stamps, linked locations, and more; see Extra Column Types below) to any file and folder. By these data you can then sort the file list and find files across your system at lightning fast speed.

Usage:

· Show the columns just like the other regular columns: via menu View, or via right-clicking the currently shown column headers (not with Size and Date columns, which show their special context menu), or the zone right of the column headers.
· Edit the column type by right-clicking the header of the column you want to edit (see below).
· Edit the content of the columns by right-clicking the cell you want to edit.
· Checkbox columns can be directly toggled by left-click.
· There is scripting support: See the scripting commands ExtraTag and Tag.

Notes:

· The extra tags support all characters (even line feeds) with one exception: the pipe (|).
· This feature is only available in the Pro Edition.

Behavior on clicking a cell in an extra column

Left click: Only apply to the clicked file.

Right click: If other files are selected than the clicked file then only apply to the clicked file, else apply to all selected files.

Extra Column Types

Each extra column can be set to a certain type. Do this via Customize Extra Column..., available from the column headers right-click menu. Here you can set the caption and the type of the column. The extra column type concerns sorting, ways to input data, and the display of the data.

Note that changing a column type will not affect any data in that column or in tag.dat. It will just affect how the data is displayed and what happens if you click a cell of that column.

The following types are supported:

Text

Free text, multiline.

Number

Integer value, negative allowed. Sorted numerically.

Date

Displayed in the current Date column format. Stored in tag.dat in format yyyy-mm-dd hh:nn:ss.fffffff, local time (not converted to UTC; reasons: performance and readability). Kept in memory also in format yyyy-mm-dd hh:nn:ss.fffffff (nicely sortable). Predefined options to set Current Date, and Created Date, Modified Date, Accessed Date of the right-clicked item.

Checkbox

Two states, internally "1" and "" (empty), displayed as a checkbox. Left-click toggles the state.

Rating Stars

Ratings (one to five) are printed as stars (Unicode character U+2605). Predefined options in right-click menu.

Pop-up List

Closed set of string values (defined in tag.dat section Extra Tags). Selectable via right-click, menu options. The set of string values is editable via Customize Extra Column, available from the column headers right-click menu.

Location

Location (folder or file, or anything that can be fed into the Address Bar; one per line). You can add more than one location. On left-click XYplorer will go to the first location. On right-click all locations are offered as menu options. Editable via right-click, multi-line edit box.

Optional captions (prefixed in quotes to the location) are supported:

"Test" E:\Test\

"A" E:\Test\A.txt

C:\

"Say Hi" echo "hi";

Location columns also support scripts as locations (just like the Address Bar). In a location column script you can refer to the clicked cell (item and column) by these temporary variables:

<taggeditem> resolves to the item (full path) that is being tagged via clicking a column cell

<taggedcolumn> resolves to the column caption that is being tagged via clicking a column cell

Example:

::echo <taggeditem>;

Find Files by Extra Tags

Of course, you can find files by Extra Tags. The field prefixes to use are either "ex1" to "ex5" (the current column names are irrelevant), or the actual (and localized to your interface language) column captions. The matching is done as simple text matching with wildcard support (as e.g. in the Name or the Comment field). Of course, Multi Field Search is fully supported.

For example, to find all Text files associated with "Byron" in the "Author" column (Extra 1) you can use either of these search terms (the leading colon specifies the term as a Boolean search).

:*.txt AND ex1:Byron

:*.txt AND Author:Byron

Comparison operators for number and dates are supported. For example, if Extra 2 is of type Number then this would work as expected:

ex2: >= 5

Dates should be stated in yyyy-mm-dd hh:nn:ss format since they are also stored in that format. For the comparison you can skip any part of the right side, e.g. (if Extra 5 is of type Date):

ex5: > 2014

ex5: > 2014-02

ex5: > 2014-02-09 10

See also Search only among Tagged Items under Find Files by Tags.

Reporting Extra Columns

All reporting functions in the Report tab (Info Panel) support the extra columns. Additional options are offered by scripting command report().


Catalog

Showing/Hiding the Catalog

First Step: Turn it on! Right after a fresh install you won't see the Catalog. To show it, go to menu Window and select Show Catalog (or simply press Ctrl+F8). The (now still empty) Catalog will be show below the Tree. If you think there's not enough space for Tree and Catalog and Info Panel on top of each other then uncheck Wide Info Panel in menu Window: The Info Panel will move to the right to make space for Tree and Catalog.

What is it? A very cool alternative to the Tree!

The Tree is an image of your computer's file system. It shows you all what's there. But, most of the time all is just too much...

The Catalog is the answer: here you can grow your own personal tree. Your favorite locations are deep down in some heavily nested structures? Lift them to the surface! Side by side with locations from the other end of your hard disk. You can navigate by the Catalog (finally a one-click favorite solution!) and you can drop onto the Catalog's items.

Adding categories and items to the Catalog

In the beginning the Catalog is empty. Open the Catalog's context menu (right-click) and start adding categories and items.

Under Insert as New Category Here you find a number of commands:

Selected List Item(s). Will create a new catalog category auto-named to "List Items", and add to it all items currently listed/selected in the List. Note that the items are added in the order in which there are currently shown. This feature allows you, for example, to easily store search results for later reuse.

Current Mini Tree. Will create a Category containing all unexpanded folders of the current Mini Tree (the command is not available if Mini Tree is off). The first folder is set to the current folder.

Favorites Folders and Favorite Files: a little service to give you quick start into the Catalog in case you are upgrading from a previous XYplorer version and already have a nice Favorites collection.

Tabs: Imports all open Tabs into a new Category called "Tabs". Search Results and locked tabs are skipped. It's the complementary function to "Open Folders in Tabs" (see below).

Dropping on a category heading (cursor turns to a white-on-black cross) will add the dragged item(s) to that category (appended at the bottom).

Under Insert as New Item(s) Here you find the following commands:

Selected List Item(s). Will add all items currently listed/selected in the List to the current Category. Note that the items are added in the order in which there are currently shown. This feature allows you, for example, to easily store search results for later reuse.

Current Mini Tree. Will create a new Item consisting of an auto-generated loadtree() script line containing all unexpanded folders of the current Mini Tree (the command is not available if Mini Tree is off). The first folder is set to the current folder. This is a slick way to save a MiniTree for later usage within a single Catalog Item. If you later click this item, the Mini Tree is loaded.

Current Tree Folder, Current Address Bar Text, Current Tab Location, Clipboard Items. Self-explaining.

Duplicate Item. Will insert a copy of the current item above the current item.

Using the Catalog

Going to folders and files using the Catalog: simply click an item to browse to it. The Tree will stay in synch. If the item is a file, it will be selected in the file list. If a tab pointing to the clicked location exists already, this tab is selected instead of opening the location in the current tab.

Action On Click: decide what happens on a single left click on a catalog item.

(1) Go to Location: go to the file or folder the catalog item is pointing to.

(2) Open Item: open the file the catalog item is pointing to. An EXE file will be launched; any other file type will be opened with the associated application (minding XY's own file associations). As visual feedback you'll see an overlay on the item's icon.

(3) Open selected List item(s) with Application: will open all currently selected List item(s) with the application the catalog item is pointing to. As visual feedback you'll see an overlay on the item's icon.

Launching Applications from Catalog

Simply enter the application into the application field! Short forms are allowed for registered applications, so these lines will work the same (if the path is okay, of course):

C:\Program Files\Adobe\Photoshop 7.0\Photoshop.exe

Photoshop

The short form is, of course, more portable.

Command Line Parameters are fully supported. If you use them, the application must be in quotes. As an example, the following term in the application field...

"winzip32" -a test.zip <items>

... will pack all selected files into an archive called "test.zip", when you choose the action "Open selected List item(s) with Application" (and when you have WinZip installed). See the chapter "User-Defined Commands" for further details of the syntax.

Opening folders and files using the Catalog: You’ll find a command in the catalog items' context menu called "Open Selected List Item(s)". It is only enabled if the item is an application. The currently selected list item(s) will be opened with that application item you right-clicked in the Catalog.

Alternatively Ctrl+Shift+Click an application item. Note: The application will open minimized or in the background. Or press Ctrl+Shift+Enter on the selected application item. This way, the application will open in the foreground.

Dropping onto the Catalog: Works just like dropping on Tree and List. When drag-hovering over unexpanded category it is auto-expanded; the original expansion state is restored afterwards. What happens depends on the drop target:

Drop on items pointing to a folder: will move or copy the dropped items into that folder.

Drop on items pointing to an application (i.e. an EXE file): will open the dropped items with that application.

Drop on items pointing to an archive (i.e. an ZIP file): will add the dropped items to the archive.

On right-mouse-dropping a context menu with advanced options is popped up.

You can as well use Ctrl+V to paste items from the clipboard into the current item of the Catalog.

Dropping onto the Scripts: You can as well drop items onto scripts in the Catalog. The variable <get drop [separator=CRLF]> returns the dropped items and can be used in the script to process the dropped items. Here are two sample scripts to illustrate the usage of <get drop>:

text <get drop>;

text <get drop |>;

Notes:

· The <get drop> variable is cleared after the script is processed, so it cannot be used after the drop event is completed.
· If the script contains no <get drop> variable it is run nevertheless just as if you clicked the Catalog item.
· <drop> is a synonym for <get drop>.
· See scripting command self for an example.

Copying from the Catalog: So you think to copy an item to the clipboard you have to go and fetch it where it lives? Not anymore! Now you can order it from the Catalog: Simply right-click it (left-click would go to it) in the Catalog and choose the new "Copy" (Ctrl+C) command in the context menu. If the destination property of that item (file or folder) is copyable (and not a Name Search, URL, Computer etc.) it will be copied to the clipboard and ready for pasting. But it gets even better...

Copy All Items in Category: You can copy all items contained in a Catalog category at once! Simply select a category and press Ctrl+C, or choose the "Copy All Items in Category" command from the category's context menu. Note that, of course, only files and folders are copyable, but not drives, name searches, or web-URLs.

This little feature is a revolutionary new way to quickly and repeatedly copy distributed items onto the clipboard by a single click. You just have to collect them one single time under a catalog category, and they are ready for repeated joint copying. Note: of course, if you happen to have same-named items (from different locations, naturally) on the clipboard you'll run into a collision-situation when pasting them.

Open Folders in Tabs: This feature allows you to easily switch sets of tabs. Selecting the command from the Context Menu will do the following:

(1) Close all unlocked tabs (apart from the current).
(2) Create a new background tab for each folder contained within the Category. Items pointing to anything but straight folders (like non-existing-folders, files, searches, scripts, filters, etc.) are ignored.

Make Mini Tree From Folders: Will create a Mini Tree from all valid folders found within the Category.

(1) If Mini Tree is not active it will be activated by this command (if any folders are found within the Category).
(2) The current tree folder will be set to the first (from top) folder found within the Category.
(3) Portable Paths, XYplorer Native Variables and Environment Variables are supported.

Configuring the Catalog

Positions: Need a new order? Freely move catalog items up and down (also between categories!) be dragging them to their new position. Hold Ctrl while dragging items to duplicate them. When you duplicate a category the new copy comes without child items. Or sort a whole Category by selecting Sort Category from the context menu.

Colors: For visual grip you can totally control the Catalog's colors per item. Select "Properties" in the context menu of an item.

Icons: You can define the icon for each Catalog item. Simply append any file spec to the Caption in Properties, separated by a | (pipe). It can be an icon file or any other file or folder with associated system icon. XYplorer native variables, environment variables, and portable paths are supported. For example: Love|E:\Test\Kiss.ico. You can as well reference internal icons (toolbar icons) using ":" as prefix, for example: Add Tags|:tagsadd. Tip: Keys to toolbar icons, e.g. [tagsadd], can be seen in square brackets when choosing Customize Toolbar from the right-click menu of a user button.

Memory: Of course, the Catalog is saved between sessions (if you enable "Save settings on exit", and unless you "Exit without Saving"). The data are stored in a file called "Catalog.dat" located in the "Catalogs" subfolder in the application data path.

Tip: Dbl-click on left 9 pixels opens Item Properties.

Working with many Catalogs

Part 1: One Catalog at a time

You can switch catalogs on the fly and manage any number of Catalog resources. You find the usual commands in the right-click menu of any Catalog Category and of an empty Catalog in the submenu Catalog.

· New: Create a new empty Catalog. The initial filename defaults to "<xydata>\Catalogs\CatalogNew[##].dat", where [##] is a number suffix that makes it a unique name. You are prompted to save any changes if the current Catalog is dirty.
· Open...: Open an existing Catalog file, after saving any changes in the current Catalog. If you choose a filename that does not exist, a new empty Catalog of that name is created. You are prompted to save any changes if the current Catalog is dirty.
· Revert to Saved: Reload the current Catalog from file without saving any changes first.
· Save: Save the current Catalog.
· Save As...: Save the current Catalog under a new name.
· Save Copy As...: Save a copy of the current Catalog under a new name, without making this the current Catalog. Useful for making quick backups.
· Import Catalog...: Here you can import other catalogs into the current catalog at the position right before the currently selected category.
· Export Category...: Here you can export the current category as a self-contained catalog. This one-category-catalog can later be imported, but also be loaded stand-alone.
· Refresh All Icons: Refresh all Catalog Icons.

Recently Used Catalogs: At the bottom of the Catalog submenu you find the most recently used Catalogs. They can be managed via menu Tools | List Management | Recent Catalogs. Note that the most recently used Catalogs are also found in the context menu of the Catalog toolbar button.

Part 2: Many Catalogs simultaneously - Including Catalogs

You can include any number of catalogs in the current catalog. Contrary to imported catalogs (using the Import command) included Catalogs are read-only and kind of temporary: Their contents are not saved with the parent catalog, and you can remove them from the master catalog at any time. On the other hand, as long you don't explicitly remove them they are retained across sessions (i.e. they are auto-included in the current catalog on start up).

Interface

· The category context menu features a new submenu "Include" where you find commands to open a catalog to include, and to Reload or Unload all included catalogs (Open Catalog to Include, Reload All Included Catalogs, Unload All Included Catalogs).
· At the bottom of the menu you find a MRU list of recently included catalogs. A click on any of them will include it with the current catalog. If it is already included, it will be reloaded (updated).
Tip: You can edit this list in Tools | List Management | Recently Included Catalogs.
· Above that MRU list, catalogs that are currently included are shown with a checkmark. To unload any of them simply click on their name (as if to remove the checkmark).
· Both lists are limited to 8 items, although the number of included catalogs is not limited.
· In the Catalog, included items are marked by a colored square symbol at the right end of the row. 6 colors are predefined and cycled if more are needed, i.e. items from the 7th include source will get the same color as items from the 1st source.
· The items' tooltips show the included source if any.

The Mechanics of Merging

Included Catalogs are not simply appended or inserted, but merged into the master catalog, so that items from different catalogs are combined within the same categories.

· The current and the included catalog are compared category by category. If a category with the same caption (case-sensitive) already exists the items inside the included category are appended to the existing category. If a category does not exist yet, it is appended to the existing categories with all its items.
· After merging you can move the position of the included items just like normal items. But note that the new positions won't be retained across sessions as the catalogs are freshly included at next start up.
· You may also alter the Properties of a included item. However, also these edits are not retained across sessions! You are warned about this in the Edit dialog.
· When XYplorer is closed with included catalogs, their names are stored in the INI file (but their contents are not saved since they are read-only), and they are freshly reloaded (included) on next start up.

Remarks

· On exporting included categories (or categories containing included items), they will be locally saved as normal catalogs.
· Also when duplicating included categories or items, the "included nature" is not inherited.
· The MRU list of included catalogs is stored in a portable manner, so you can carry included catalogs around on a USB stick without problem (the drive letter is not hard-coded).

Usage

· This is mainly a company-oriented feature. Employees can access read-only catalogs that are centrally stored on a server and thus include extended functionality such as scripts, links, drop targets, text data, etc. right into their XYplorer interface.
· However, the feature also provides an elegant way to temporarily load read-only functionality into the interface.

Supported protocols

The Catalog (just like the Addresss Bar!) supports the http:// protocol and the file:/// protocol. These files are executed by the Shell, so http[s]:// URLs are opened by your default browser whereas file:/// URLs are opened by the associated application. Which means:

You can add URLs to the Catalog and they'll work just like web favorites. One-click surfing! And you can add files to the Catalog and they'll work just like links. One-click-opening!

The 1-level grouping by categories ain't enough?

Since you can have an unlimited number of parallel installations of XYplorer, you can have as well an unlimited number of Catalogs to work with, depending on your current task.


Status Bar

Sections of the Status Bar

Objects/Files Found

Displays the number of objects currently listed in List. In Browse mode this is the number of objects within the current folder, in Find mode the number of objects found.

Bytes

Displays the bytes sum of all currently selected items in List. If nothing is selected, the bytes sum of all items is shown.

Name/Progress

Displays the icon and name of the currently focused item (file or folder). By double-clicking these items you can copy them to the clipboard.

Version in the Status Bar: Tick Configuration | Controls and More | Miscellaneous | Show version information in the Status Bar to show the embedded version information of executables, DLLs, DRVs, etc. (if they have any) right in the Status Bar on selecting such a file.

If nothing is selected, the used and free bytes of the current drive are shown.

During File Find the same section gives you feedback on the progress of the search by displaying the name of the currently searched location. When the find is finished, the used time is shown, and the number of files scanned (this is the number of all files that match at least the Name filter of the search).

Clicking the Status Bar

Tick Configuration | Menus, Mouse, Safety | Mouse | Click on status bar toggles info panel for the following:

Single left-click anywhere on the status bar to show/hide the Info Panel. You'll note a 300 msec delay -- it's necessary to wait for a potential dbl-click (which does copy the clicked label to the clipboard).

Single right-click anywhere on the status bar to toggle the Info Panel's last size/min size.


Status Bar Buttons

Status Bar Buttons

There's an optional mini toolbar at the right end of the Status Bar containing two buttons. You can show/hide it using Show Status Bar Buttons in menu Window.

1. The Background Jobs Button

This button tells you about the status of background jobs (if any) by showing an animated icon. If the animation is active the button's tooltip tells you how many jobs are not yet completed (either in progress or pending).

Clicking the button will open the Background Jobs dialog (see below). The button also has a right-click menu with some handy commands.

Background Jobs Dialog

The right-click menu of the Background Jobs button and the "Queue file operations" toolbar button has an item Background Jobs... where you can display the background file operations that are completed, in progress, or pending within the current session, as list in a non-modal window. You will also see which jobs have been skipped, cancelled, or only partially completed. The position and size of the window is stored between calls and sessions.

The status is auto-updated each second. You can force an immediate update by pressing F5.

Hide completed and skipped

Check to show only pending and in-progress jobs in the list.

Pause queue

You can completely pause the queue using the checkbox "Pause queue". Jobs that are already in progress are not affected by pausing. On unpause the processing starts with the next pending queued job.

The setting is also available in the context menu of the Background Jobs button.

When you close XYplorer all pending jobs in a paused queue are forgotten. You are prompted whether you really want to purge the jobs.

Note: Pausing only affects *queued* (pending and new) jobs. If Queue file operations is off then new background jobs will be started immediately regardless of the state of "Pause queue".

Tip: While the queue is paused you can still add new jobs to the queue. Once the queue is to your liking you can release the Pause and go have a coffee while your machine is working the queue.

Background Jobs Context Menu

Each job has a context menu with a number of commands.

Details...

Here you can view the list of each job's source files.

Skip Job

Here you can temporarily or permanently skip pending jobs. A job will not be started as long as it is skipped.

You can unskip a job at any point in time. If other jobs are in progress while you unskip a job then it will be started whenever its turn comes.

Start Job Now

This command is only present in the context menu of paused pending jobs. It allows you to single-click-start a particular job from a paused queue, regardless of the paused state and regardless of the original queue order.

The command is also available on the context menu of skipped jobs, so if you change your mind and want to do a skipped job now you don't need to unskip it first. Simply click "Start Job Now".

2. The Info Panel Toggle

This button toggles the Info Panel. The button's right-click menu has a couple of related commands.


Info Panel

Showing/Hiding the Info Panel

The Info Panel is located at the bottom of the main window. You can toggle its visibility by pressing F12.

Tabs on the Info Panel

The Info Panel contains the following tabs:

Properties Tab

Version Tab

Meta Tab

Preview Tab

Raw View Tab

Tags Tab

Find Files Tab

Report Tab


Properties Tab

Info Panel: Properties

Properties Tab

Gives you various information on the selected file.

Tip You can copy virtually any information on this tab by double-clicking it. Double-clicking the key copies key and value, double-clicking the value copies just the value.
Tip To read a value that is too long to be fully displayed, position the mouse over this values to see the complete string in a tooltip.

Various File Information

Pretty self-explaining: you know this stuff from the Explorer Properties dialog.

The filename in bold: Right-clicking the bold filename (i.e. the name of the selected item) pops a small menu with the following items:

· Copy Name: Copies this filename to the clipboard.
· Copy Name with Path: Copies this filename with path to the clipboard.
· Show Character Table: Click it to get a vertical list of the characters and their Unicode ordinals in decimal and hexadecimal, and their utf8 sequences. It also shows short descriptions for the Directional Formatting Codes, e.g. "Right-to-Left Override" for U+202E.
· Convert to ASCII: See Rename Special | Convert to ASCII (only enabled if the filename contains extended ASCII (ANSI) or Unicode characters).

Space used: Files use up disk space by clusters, not by file bytes. Check out the IE Favorites folder to see that this information is pretty interesting.

Compress.: The actual size on disk of a compressed file (XP or later). "Space used" in such cases should be read as "Space that would be used if the file would not be compressed".

Contents: If a folder is selected Size shows the total bytes of all contained files (subfolders included), and Contents tells you the number of files and folders found below this folder. This feature has to be explicitly activated in configuration since for large deeply nested folders it takes some time to gather this info.

Icons

Any embedded icons are extracted from a selected file and displayed (embedded icons are typically found in EXE and DLL files).

Tip You can copy the displayed icons by double-clicking them.

Time-stamping

Clicking any of the three file times on Properties tab will activate the interface to actually set those times to the currently selected file(s).

Press ENTER or click the green icon to set the new time-stamp (the changed time-stamps are applied to all currently selected files), or press ESC or click the red icon to cancel and reset the display to the original state.

Note Under NTFS the milliseconds in file times will be set to 0 (zero) when you touch a file date and do not pass milliseconds (see below).
Note Under VFAT (Win95a) dates before 1980 and after 2107 cannot be set, and dates 28.02.2106 - 31.12.2107 set filetime to "unknown".

Milliseconds Support

Time Stamping fractions of a second (up to 7 decimal digits) is supported. The fraction should be appended to the time expression separated by a dot. The following example stamps the selected files with milliseconds precision:

2013-05-28 14:13:23.888

If "Show Milliseconds" is enabled (Tools | Customize List | Date Column Format) then the file dates on the Properties Tab always show the full precision of seven decimal places, regardless of the precision shown in the file list.

UTC Support (Universal Time Stamp)

By appending "Z" (or "z") you can mark the time expression as UTC (Coordinated Universal Time). This way you can modify the UTC date of a file directly (as it is internally used by NTFS). For example, this will set the modified date to UTC 12:00 today (displayed as 14:00 in Germany with Daylight Saving Time in effect):

timestamp "m", "<date yyyy-mm-dd> 12:00Z";

That way you can guarantee the same universal timestamp regardless of any DST (Daylight Saving Time) offset in effect. Very nice for software developers with a global market.

The ISO 8601 formats for UTC and time offsets from UTC are supported. The following time expressions all refer to the same point in time:

2013-05-14 10:00:00+02:00

2013-05-14 08:00:00+00:00

2013-05-14 08:00:00Z

2013-05-14 03:00:00-05

2013-05-13 23:00:00-0900

2013-05-13 20:00:00-12:00

Changing file attributes

The file attributes of the currently focused file are displayed as (un)checked boxes. You can change the settings of four attributes (Read-Only, Hidden, Archive, and System).

Click the green icon to set the new attributes (applied to all currently selected files), or click the red icon to cancel and reset the display to the original state.


Meta Tab

Info Panel: Meta

Meta Tab

Here some basic file-specific metadata provided by the shell are displayed. The default metadata layouts differ by file type (images, audio, and so on...).

Right-click offers "Show in Popup" (handy if you want to select can copy particular metadata) and "Copy to Clipboard".


Preview

Info Panel: Preview

Preview Tab

Here you can preview files of the following types: Text files, Web & Office, Font files, Icon files, Image files, and Audio/Video files. All previews are invoked by selecting a file in the List by left-mouse click or keyboard. No preview is shown when you select a file with the right mouse button.

The order of precedence of the various previews is:

Text > Web & Office > Font > Icon > Image > Media

So, to preview HTML using the Browser (embedded IE), simply go to Configuration | Previewed Formats and uncheck HTML under "Text" and check it under "Web & Office". If you want to preview HTML as source code leave it checked under "Text".

Note that also shortcuts (LNK files) are resolved and then previewed where applicable.

Invoking a preview needs the Preview tab selected and visible.

Tip To enlarge or shrink the display area, use the horizontal splitter, which is the 3 pixel high line located just above the Info Panel tabs, and below the status area for the list. When positioned on the splitter, your cursor will become double headed arrows.

Text preview

Preview more than 50 different plain text formats. For huge text files only the first 5 MB are shown for performance reasons.

Dropdown Menu

In the dropdown menu on the Preview tab, you can manually select a different encoding for text file to preview. Choosing System Default enables auto-detection for UTF-16LE, UTF-16BE, and UTF-8. In parentheses "System Default" shows the Default ANSI Code Page, e.g. "System Default (1252)". Choose UTF-16LE, UTF-16BE, UTF-8, and UTF-7 to force decoding the current file in any of these formats.

A couple of Western code pages and East Asian languages using DBCS encoding are also supported. Click any of the code pages to reload the current file with that specific encoding. When reloading a previewed text the scroll position is preserved as good as possible.

Edit User Code Pages: Here you can add any number of user-defined code pages. You can optionally also state the line length, aka record size.

General Format:

CodepageName=CodepageValue[,RecordSize]

Examples:

IBM 437 (DOS-US)=437

IBM 850 (DOS-Latin-1)=850

IBM EBCDIC International=500,82

Image preview

Shows a thumbnail for the following image file types:

*.arw, Sony Raw Image

*.bmp, ACDSee BMP Image

*.cr2, Canon Raw Image

*.crw, Canon Raw Image

*.cur, Cursor

*.dcr, Kodak Raw Image

*.dib, ACDSee DIB Image

*.dng, Adobe DNG Image

*.emf, EMF-Bild

*.erf, Epson Raw Image

*.fff, Hasselblad Raw Image

*.gif, ACDSee GIF Image

*.ico, Icon

*.jpe, JPEG-Bild

*.jpeg, JPEG-Bild

*.jpg, JPEG-Bild

*.mef, Mamiya Raw Image

*.mrw, Minolta Raw Image

*.nef, Nikon Raw Image

*.nrw, Nikon Raw Image

*.orf, Olympus Raw Image

*.pef, Pentax Raw Image

*.png, ACDSee PNG Image

*.psb, Adobe Photoshop Large Document Format

*.psd, Adobe Photoshop Image

*.raf, Fuji Raw Image

*.raw, Leica Raw Image

*.rle, ACDSee RLE Image

*.rw2, Panasonic Raw Image

*.rwl, Leica Raw Image

*.sr2, Sony Raw Image

*.srf, Sony Raw Image

*.srw, Samsung Raw Image

*.tga, ACDSee TGA Image

*.tif, ACDSee TIF Image

*.tiff, ACDSee TIFF Image

*.wmf, ACDSee WMF Image

*.x3f, Sigma X3F Image

Note that Codecs for RAW image formats need to be installed on the system (they are not included in XYplorer).

Previewing Animated GIFs is supported since version 12.90 in the Preview tab, in Mouse Down Blow Up, and in the Floating Preview. The number of frames is displayed in the info section.

Depending on the image format you get various information:

Size: the original size of the image in pixels, and the size of the thumbnail.

Colors: maximal number of different colors used in the picture (aka color depth).

Area: space used by the image display in square pixels.

Video bytes: number of bytes used up by your video memory when displaying the image in full size. This number is calculated by multiplying the area of the image with the current color depth of your monitor. For example: if your system is set to 32-bit (True color), 4 bytes are used for the display of every pixel.

File size: number of bytes used by the image file.

Compression ratio: tells you the degree of compression of the image file. Percentages below 100 mean that the file is compressed. This number is calculated like this: FileSize / (Width * Height * (BitsPerColor / 8)), where BitsPerColor is the color depth of the image, not of your display.

Hotspot at: (cursor files only) the position (x, y) of the hotspot, that's the pixel of the cursor image that corresponds to the exact mouse position.

Icons contained: (icon files only) number of icons contained in the file. Icon and Cursor files can contain more than one image. (This information is only given when more than image is contained and only for icons, since it's rare to find multiple images in cursors and there the space is used up already by the hotspot information.)

PSD files: PSD files (Photoshop Documents) can include embedded thumbnail previews. Note that with PSD files, you can preview only the embedded thumbnail, not the original sized image.

Popup Menu Button

Copy Compact Info: copy a one-liner describing the currently previewed file to the clipboard.

Copy Extended Info: copy all information available on the currently previewed file to the clipboard.

The following for images only:

Copy Original: copy the image (original size) to the clipboard.

Copy Preview: copy the image (preview size) to the clipboard.

Full Screen: enter full screen mode. Note that you can full screen preview the currently selected image file even when the Info Panel is hidden by simply pressing Shift+F11!

The Full Screen Preview (Shift+F11) also works for HTML, MHT, URL, NWS, EML, and MSG files in perfect original size quality. Note that -- just like with thumbnails for non-picture files -- this service depends on the capabilities of your operating system and the installed software.

Shortcut: Shift+F11

Full screen preview: Press Shift+F11 to see the image in full screen mode. If the image is larger than the screen it is shrunk to fit. In Configuration | Preview you find options regarding background color, zooming, and more.

While in full screen mode, you can use the these keys to browse through the images found in the current list.

Other keyboard tricks see here.

Mouse Down Blow Up

Showing the preview image in original size: When you move the mouse over the preview image, the cursor changes to something that is meant to mean "Original size". When and while you now hold down the left mouse button the original image pops up. If the image is larger than XYplorer's window, you can scroll about the image by moving the mouse while holding it down. This feature is called "Mouse Down Blow Up".

Note that the blow up exactly zooms into the point where you downed the mouse. Of course, this positioning only applies if "Configuration | Preview | Shrink to fit" is OFF.

Note that also the Thumbnails, the Floating Preview, and the Full Screen Preview support Mouse Down Blow Up.

Previewing PNG and TIFF images

To preview *.png and *.tif images XYplorer needs GdiPlus.dll (GDI+) to be installed. GDI+ is included with XP and higher but not necessarily present on older operating systems. However, it is easy to install it on any OS from Win98 upwards. You can download the file from this site:

http://www.microsoft.com/downloads/details.aspx?FamilyId=6A63AB9C-DF12-4D41-933C-BE590FEAA05A&displaylang=en

Installation instructions: run the self-extracting executable file gdiplus_dnld.exe, which you have downloaded from the above site. When prompted for an unzip folder, click the "Browse..." button and browse to the directory of XYplorer.exe (probably C:\Program Files\XYplorer\), then click the "Unzip" button and you are done. (Do not copy GdiPlus.dll into the system directory.)

Audio/Video preview

Plays an audio/video file, and shows various information depending on the format of the file:

Size: (for videos only) the original size of the video in pixels, and the size of the thumbnail.

Length: [hours:]minutes:seconds milliseconds

Format: [depends on the type of file] sample rate (Hz), bits per sample, and number of channels (Mono/Stereo), number of tracks (MIDI).

Tracks: (CD-Audio only) choose the track you want to play ...

Progress Bar

The progress bar indicates the relative position of the sound currently playing. It also allows for some interaction:

Left Click Play from here.
Right Click Toggle pause/play (also by key Space).
Shift+Click Restart the sound from beginning (also by key Shift+Space).

The progress bar's tooltip shows the timeline position of the cursor.

Backwind and Forewind

There's keyboard-driven backwind and forewind. Works in paused and running mode, on audio and video.

Left Frame step backward (Audio: 100 msec backward)
Right Frame step forward (Audio: 100 msec forward)
Shift+Left 1 sec backward
Shift+Right 1 sec forward

A-B repeat

To repeat any particular section of the medium (audio or video), aka "A-B repeat", looping must be enabled (tick "Play Again"). The section is defined by clicking anywhere (no matter where) on the progress bar while the medium is previewed (no matter whether running or paused):

Ctrl+Left Click Set start of section to now
Ctrl+Right Click Set end of section to now
Ctrl+Alt+Click Unset any section

If a section start is defined then "Go To Beginning" (Shift+Space, or Shift+Click) will go to the beginning of the section. There is no visual marking of the section, so this is a low-comfort feature for the time being. But it works okay and can be useful.

The section is auto-unset when you preview the next file.

Media Control Buttons

Both "Play" and "Pause" have identical functionality, namely toggle Play / Pause, with inverse pressed-states. "Stop" rewinds to beginning and stops there.

Snapshot (Video only)

Copies a bitmap image (preview size) of the current scene to the clipboard (shoot a film still). Note that this works while the video is running or stopped.

Important: You cannot snapshot non-AVI videos when you have OS hardware acceleration on! If you want you have to Adjust Hardware Acceleration. Here's what to do in Win2K, XP, and higher:

1. Right-click on your desktop

2. Select Properties->Settings->Advanced->Troubleshoot

3. Then set the hardware acceleration slider to the third notch (from left) and apply the changes

4. Press Ok (Computer Restart maybe required)

Note You cannot rename, copy, move, or delete an audio/video file while it is playing. The preview is automatically stopped when you start dragging a file.

Supported Audio/Video file formats

Among the supported files types are: *.aif; *.aifc; *.aiff; *.ape; *.asf; *.au; *.avi; *.cda; *.flac; *.m1v; *.m4a; *.m4r; *.mid; *.mov; *.mp+; *.mp2; *.mp3; *.mp4; *.mpa; *.mpc; *.mpe; *.mpeg; *.mpg; *.mpp; *.mpv2; *.ogg; *.ogm; *.rmi; *.snd; *.ts; *.vob; *.wav; *.wma; *.wmv

What formats actually work is dependent on the configuration of your local system: the Windows version, the version of Media Player is installed, the version of Internet Explorer is installed. By a rule of thumb you can say: if WindowsMediaPlayer can play it, XYplorer can play it too.

ID3v1.1 tag editing

While previewing an MP3 file you can view and edit its ID3v1.1-tag.

Font preview

Preview for installed or uninstalled Windows font files. The following types are supported:

*.ttf = TrueType fonts

*.otf = OpenType fonts

*.pfb; *.pfm = Type-1 fonts (both files must be present in the same path)

*.fon = Bitmap/raster fonts

Additionally you get some version and copyright information.

With currently installed fonts, the displayed font name is blue.

Font size selection: Right of the sample text box you find a scrollbar where you can set the font size of the first preview line (1-128). Set size to 0 (zero) to hide the first line.

Activate/deactivate fonts on the fly

You can activate/deactivate fonts on the fly by simply clicking on the bold font name shown in the font preview's info frame. Very comfortable for screen and print designers who often need a number of fonts for a quick one-time job, and do not wish to go through the awkward font installation procedure provided by Windows while cluttering up their fonts folder with hundreds of never-again-used fonts.

The font file to be activated can sit anywhere. Take care however, that you do not move/delete it while it is activated, else you can neither use it nor deactivate it.

An activated font file will NOT be copied to the Windows font folder.

Deactivation does NOT delete the font file.

The activation/deactivation lasts only for the current Windows session -- no files are moved, the registry is not touched.

Web & Office preview

Preview for web and Office files of the following types: *.asp; *.csv; *.doc; *.docx; *.dot; *.htm; *.html; *.mht; *.pdf; *.php; *.php3; *.php4; *.php5; *.pps; *.ppt; *.rtf; *.shtml; *.svg; *.svgz; *.swf; *.url; *.xls; *.xml; *.xps

From the web preview you can follow links to the internet. It's nothing less than a fully capable browser based on the IE rendering machine.

You can drag pictures from the previewed page to file list: drag with right-mouse or hold CTRL when start dragging to force a copy operation.

Word Preview

The Word preview (*.doc; *.docx; *.rtf) does not use the Internet Explorer but uses a different way to show the contents of Word documents. Of course, MS Word has to be installed on the machine to make it work.

Note that you can select and copy any parts of the previewed contents. An unwanted side-effect is that you now can apparently edit the contents -- however, there is no risk: the changes will not be saved; it is just the preview you edit, not the original file.

Server Mappings

Configurable server mappings allow you to pass local files through a local web server (eg your local Apache installation; this server must be running, of course) before displaying them in the preview. In Configuration | Preview | Web Preview:

Check the "Enable server mappings" option.

In the 1st field enter the local file path where documents are stored, for example: D:\wwwroot\.

In the 2nd field enter, for example, http://localhost/ if using a web server installed on the local system that's configured to serve files from the path above. Or enter a remote web server address to preview files that are stored on a remote server. The mapping is a simple string replacement.

Note: Web preview needs Internet Explorer to be installed.


Raw View

Info Panel: Raw View

Raw View Tab

Raw View displays the contents of ASCII and binary files (the file type is detected automatically).

Display options

ASCII file options

Line #: Display line numbers.

Hex: Toggle Hex view and Byte (text) view.

Word wrap: Wrap lines at window border. Also applies to Extract text (see below).

Binary file options

Extract text: Extract text portions out of binary files. The minimal text length is 5 bytes (smaller text portions are not displayed because they are probably junk). The left column shows the offset (start position in file) for each text. Individual texts can be selected and copied (see below). In the header area, the ordinal of the first currently displayed text is shown.

International: Extracted text includes upper-ASCII characters as used in French, German, Italian, Portuguese, Scandinavian, and other locales. Useful to grab text from non-english binaries.

Context Menu

Tail: Check it to view the "tail" of a file, i.e. to jump to the end directly after opening the Raw View. Find the option in the context menu of the Raw View, respectively in the orange button drop down menu.

Copying lines

Although Raw View is a viewer, not an editor, there is a handy way to select and copy parts of the displayed files).

Selecting works line-wise: to un/select a line simply left-click it. Hold the Shift-key to multi-select larger zones.

While you cannot select individual strings as in an editor, you can select as many different lines as you like, and then copy them to the clipboard in one block.

Copy a single line by dbl-clicking it (no need to select it first).

The copy command is located in the context menu (right-click the view area).

Note While a file is opened in Hex or Extract Text mode, you cannot do any file changing operations (delete, move, rename) on it (you'll get an "Access denied" error if you try).
Tip To enlarge or shrink the display area, use the horizontal splitter (the 3 pixel high zone right above the Info Panel).


Tags Tab

Info Panel: Tags

Tags Tab

This is the main interface for adding and editing Tags (Labels, Tags, Comments) to/of the items currently selected in the file list.

Viewing and Editing Tags

When you select an item in the file list the three fields are set to the Label, Tags, and Comment of that item. If more than one item is selected the fields are set to the tags of the focused item.

You can edit the tags in the fields and then apply the edited tags using the Apply button. On Apply all ticked tags (Labels, Tags, Comments) shown in the Tags tab are applied to all currently selected items.

The Reset button will reset the three fields to the current item's tags.

Tagging Mode

The Tags field has a small dropdown where you can select the tagging mode:

· Add Add given tags to the existing tags of all selected items.
· Set Replace any existing tags in all selected items with the given tags.
· Remove Remove given tags from the existing tags of all selected items.

Keyboard Tricks

You can trigger Apply by pressing <enter> right in the edit fields (<ctrl+enter> for Comments). In that case the tag of this type is applied even if the checkbox is not ticked.

· Label: Press <Enter> to apply only the Label.
· Tags: Press <Enter> to apply only the Tags.
· Comment: Press <Ctrl+Enter> to apply only the Comment.


Find Files

Index

Buttons "Find Now" and "Reset Filters"

Checkboxes "Applied Filters"

Tab "Name & Location"

Name

Mode

Type

Location

Comparison Operators

Find Files by Size

Find Files by Tags (Labels, Tags, Comments)

Find Files by Multi Field Search

Find Files by Meta Properties

Find Files by the Length of their Name

Tab "Size"

Tab "Date"

Tab "Attributes

Tab "Tags"

Tab "Contents"

Tab "Dupes" (Duplicate File Finder)

Tab "Excluded"

Tab "Options"

Search Results Context Menu

General File Find Tips

Find Files Tab

The Find Files Tab is found on the Info Panel (F12) at the bottom of the application. The Find Files Tab itself has a couple of subtabs, the so-called filter tabs. Let's start with the main buttons and options right of the filter tabs.

Find Now / Stop (ESC)

Start a file find by clicking the Find Now button, or by pressing Ctrl+Alt+F. You can abort a running find process by clicking the Stop button or by pressing Esc (Escape Key).

Reset Filters

Resets all settings on the filter tabs to factory defaults and deactivates all filters.

Untouched remain only the Location settings (Include Subfolders etc.) and the "Search Results to tab" setting.

Applied filters

On the Find Files tab there are seven sub-tabs. The first six of them represent different search parameters/filters. These filters can be individually activated (applied by the current search process) by checking the corresponding checkbox below Applied filters. The tab of an active filter has a colored caption (the color "Marked Text 1" can be defined in Configuration).

A file must pass each active filter to be found. In other words, the logical relationship between the filters is AND.

Note On the first tab (Name & Location), the Location parameter is always active. Thus, deactivating this tab means you don't care how the file is named (equivalent to leaving the Name field empty or to entering just an asterisk).

There's a bit of "smart" automation built in: If you change any setting on a given tab, it is assumed that you're interested in that filter, and it will be automatically activated.

Tab "Name & Location"

The Name dropdown list provides a space where you can state the name or a pattern that the file to be found shall match. You may use various Wildcards, Boolean Logic Operators, and Regular Expressions.

Mode

There are different Name Pattern Modes:

(1) Standard

(2) Boolean

(3) RegExp

You can easily switch between modes via the Mode dropdown list, located directly below the Name dropdown list. "Mode" refers to the way the search pattern is interpreted. For example, in "Boolean" mode the sequence " & " is interpreted as Boolean AND, whereas in Standard mode it would simply be interpreted as those three characters.

Note that you can alternatively select the Boolean and RegExp modes by prefixing the name pattern with : respectively > and thereby *overwrite* the setting of the Mode dropdown! If you do, the dropdown will be replaced by a static label reflecting the current mode.

Wildcards (Pattern Matching Special Characters)

Characters in pattern Matches in string

? Any single character

* Zero or more characters

# Any single digit (0-9)

[charlist] Any single character in charlist

[!charlist] Any single character not in charlist

[[] [

Loose Match and Exact Match

Simple patterns are interpreted as in Windows Explorer: If you state a pattern without wildcards, all files are found whose name contains this pattern as a substring (equivalent to "*pattern*"). This is called Loose Match.

Additionally XYplorer also supports Exact Match: If the pattern is quoted, only files are found, whose name exactly matches the pattern.

If any wildcards are contained in a pattern, the pattern is matched as is.

Simple multiple pattern search

You can enter multiple wildcard patterns separated by ";" into the Name field.

Examples:

*.jpg;*.gif;*.png Finds all *.jpg and *.gif and *.png

*.jpg; *.gif ; *.png same (the blanks are cropped)

Simple search results inversion

A leading ! will invert the results, i.e. list all items *not* matching any of the patterns. For example:

a*;b* Finds all items starting with "a" or "b".

!a*;b* Finds all items not starting with "a" or "b".

If you want to find items starting with "!" you have to escape it with "\":

\!a*;b* Finds all items starting with "!a" or "b".

The inversion prefix also works with RegExp patterns (see below):

!>.*(\.bmp|\.jpg)$ Finds all but *.bmp and *.jpg files

The inversion prefix overpowers the state of the Invert checkbox (see below).

Loose Boolean Match (LBM)

Mimics Windows Explorer behavior, where you can enter two or more strings separated by blanks and find al items that match ALL of the strings (i.e. they are AND-combined logically).

For example, "work 2006" (without the quotes) will find all items that have "work" and "2006" somewhere in their name (regardless of the order). In other words, "work 2006" is internally-smartly-automatically-conveniently transmutated into the Boolean expression "*work* AND *2006*".

- LBM does only work in Standard Mode (see above)
- Note that OR-combining patterns (using ";", see Simple multiple pattern search above) has precedence over LBM, so the following search term

a;b c

is interpreted as

"*a*" OR "*b c*"

and not as

"*a;b*" AND "*c*"

- To avoid LBM and find all items containing "work 2006" somewhere in their name enclose it in asterisks: "*work 2006*".
- To avoid LBM and find all items matching "work 2006" exactly put it in quotes (a leading quote is enough).
- Note that LBM can be inverted by "!", and it does work from the Address Bar as well, for example:

Desktop?a b c Find all items that contain the characters a, b, and c in
their name.

Desktop?!a b c Find all items that do not contain all the characters a, b,
and c in their name (but only some or none of them).

Boolean Logic Operators and Syntax

Logical function Symbols (alternatives) Comments

OR | (or, OR) Must have a space on both ends.

AND & (and, AND) Must have a space on both ends.

NOT ! (not, NOT) Prefixed to the negated term,

no space after "!"

one space after "not/NOT".

Default operator precedence

NOT > AND > OR

Nesting terms with parentheses

You can overwrite the default operator precedence by using parentheses (up to 256 nesting levels). Also complex terms can be negated, for example "!(cat | dog)" is equivalent to "!cat & !dog".

Escape parsing

Use the backslash \ to escape critical sequences:

!\!cat = NOT "!cat"

cat \& dog = "cat & dog"

cat \and dog = "cat and dog"

!(\(1\) or 2) = NOT ("(1)" OR "2")

Alternatively you may quote your patterns to protect them from parsing. You must, however, supply all needed wildcards in quoted patterns, else they are taken as "exact matches".

!"*!cat*" = NOT "!cat"

"*cat & dog*" = "cat & dog"

"*cat and dog*" = "cat and dog"

!("*(1)*" or "*2*") = NOT ("(1)" OR "2")

Boolean Logic Examples

Find all files that have cat or dog in the name:

:cat | dog

:cat OR dog

Find all files that have cat and dog in the name:

:cat & dog

:cat AND dog

Find all files that have cat but not dog in the name:

:cat & !dog

:cat AND NOT dog

Find all files that have neither cat nor dog in the name:

:!(cat | dog)

:NOT (cat OR dog)

Note that you can as well use RegExp patterns in Boolean expressions. The RegExps must be preceded by ">" in that case. Find all files that have ####-#[#]-#[#] in the name and have the extension *.doc:

:>"\d{4}-\d{1,2}-\d{1,2}" AND "*.doc"

Regular Expressions

XYplorer's Find Files gives you the power of Regular Expressions (RegExp).

Prefix > for RegExp To activate the regular expressions mode simply prefix the search term with the character ">". If Regular Expressions mode is active, all rules described here above do not apply.

XYplorer supports Boolean RegExp, i.e. you may combine any number of Regular Expressions with Boolean operators. The RegExps must be quoted in that case, e.g.:

"\d{4}-\d{1,2}-\d{1,2}" AND "\.doc$"

XYplorer uses the VBScript RegExp Object (library: C:\WINDOWS\system32\vbscript.dll) which is similar to JavaScript's regular expression flavor. For information on the VBScript RegExp syntax consult the internet.

Checkboxes modifying the pattern matching

Match Case: Check to do a case-sensitive search (where "A" is not the same as "a"). Note that Windows Explorer can do only case-insensitive searches ("A"="a").

Whole Words: Check to do a whole word only search. Word delimiters are

()[]{}\,.;=+~-_'$%&#@, space, string start, string end

Whole word searches can be freely combined with Boolean Logic, Match Case, Check Full Path, Exact Match (implied in Whole Words anyway), and Invert.

Note that Whole Words cannot be combined with RegExp and Fuzzy matching, and you cannot use wildcards: if the search pattern contains wildcards Whole Words is internally set to False.

Fuzzy: Fuzzy searches are searches that tolerate typographical errors and misspellings (either in the search pattern or in the found filenames). The similarity measurement of XYplorer's fuzzy search is based on the Ratcliff/Obershelp pattern recognition algorithm (Ratcliff 1988), also known as "gestalt pattern matching".

Fuzziness is configurable (Configuration/Advanced). The higher the fuzziness (default 25%), the more items will be found:

0% fuzziness = 100% minimum similarity (= non-fuzzy)

25% fuzziness = 75% minimum similarity

100% fuzziness = 0% minimum similarity (all items match)

Note that actually useful values might lie between 10% and 35% of fuzziness. Also bear in mind that with the Ratcliff/Obershelp algorithm the correct order of any submatches is relevant, and the similarity decreases with the mean length of the compared strings, eg:

"mahatma ghandi", "mahatma gandhi" = 93% similarity

"gandhi mahatma", "mahatma gandhi" = 50% similarity !

"gandhi", "mahatma gandhi" = 60% similarity !

Invert: If checked the search will return everything that does not match your search term.

Path: If checked, the search term is compared with the whole path/name instead of the name only.

Note that in the search patterns you have to escape any backslashes "\" with backslashes "\" (i.e. double them: "\\"). For example, if "Path" is ON then:

The term "!\\temp\\" will exclude all items inside/below a "temp" folder from the results.

The term ":\\keyboard or \\mouse" will find all items inside/below a "keyboard*" or "mouse*" folder.

The term ":*\\Inbox\\*.msg and not *\\Inbox\\*\\*.msg" will find all *.msg files the are located directly inside all folders named "Inbox".

Alternatively to adding backslashes, you can quote the pattern to protect it from parsing:

:!"*\temp\*"

:"*\keyboard*" OR "*\mouse*"

Ignore Diacritics: Tick it to match a pattern "Koln" with files "Koln.txt" and "Köln.txt" and "Kóln.txt" etc. Note that all accented characters (i.e. characters with diacritics) in the name pattern AND in the tested filenames are reduced to their base characters before the matching is performed. So an accented pattern "Köln" would also match files "Koln.txt" and "Köln.txt" and "Kóln.txt" if "Ignore diacritics" is ticked.

Type

Right of the Name field there's the Type Filter, a dropdown where you can select a general file type to narrow down the search results to only that type of files. Some of the available file types exactly correspond to the lists under Configuration | Previewed Formats and even can be extended there.

All types (= no type filtering at all)

Text files

Image files

Audio files

Video files

Media files (= Audio files + Video files)

Font files

Vector files

Web files

Office files

Archive files

Executable files

Notes

Any extensions excluded from Preview in Configuration | Previewed Formats are nevertheless used by the find files type filter.

Note that the types partly overlap, e.g. *.txt is in "Text files" and in "Web files".

Apart from "All types" all type filters will return only files, not directories.

Tips

To quickly list e.g. all Images simply select type "Image files" and leave the Name field empty.

Focus the Type Filter field and press F1 for a listing of the contained file types.

The Type Filter field and dropdown support a simple Type Ahead Find. Simply type "t" to select "Text files", "v" to select "Vector files" or "Video files", etc.

Location

The Location field is automatically set to the current location in Tree (if Auto-Sync is checked, see below). You may also enter a path manually or select a path from the dropdown list. When you do a search, the search location is stored in the dropdown list and preserved between sessions. Up to 64 locations are remembered.

Include Subfolders

Check this box to include in the search all folders below the Location location.

Follow folder links

Similar to "Include subfolders", the search will treat folder links (aka "Shell Links to Folders") as if they were subfolders and search the links' target directory as well (again recurring it if necessary). This is a very nice feature. For example, you can cultivate folder link farms, i.e. collections of links to various folders in the wildest locations, which you then can search all at once by just running a search on their parent folder.

How to create a folder link: have the folder in the file list, then choose the Create Shortcut command from the folder's context menu, then move the newly created *.lnk file where you want to have it.

Notes

"Follow folder links" is independent of "Include subfolders" and both can be freely combined.

Note that there's a simple recursion blocker to avoid severe trouble: If a folder link points to a location that again has a folder link, that 2nd folder link is not followed anymore.

Auto-Sync

Check this box to always (and now) automatically set the location field to the current location.

Selected Locations

Check this box to enable Multiple Location Search (via selection in the List) If any folders (or folder links!) are selected in List, the find operation will search these folders (thus ignoring what's currently entered into the Location dropdown). If no folders are selected, things work as before: Find searches the currently selected folder in Tree, or the selection in the Location dropdown (if different from Tree selection).

Note that multiple location search also works for find results. Here it is possible to select folders for a further search where one is a subfolder of the other. In this case, of course, you will probably get duplicates in the result list.

Multiple location search works also for drives, so if you want to search for example drives C:, E:, and Z:, simply browse to Computer, select these drives in the list, and click Find (F3).

Multiple Location Search

All Disk Search: To perform a search covering several drives at once, simply enter Computer (or whatever you called it on your system) into the Location dropdown, or more simple: select the topmost node of the Tree and you're set. Removable drives (Floppies, CD-ROM, ZIP) are not included in the search. To exclude specific non-removable drives ("Local Disks"), add their name to the Exclude Folders list. For example, to exclude drive D, add D:\ to the list.

Location field: Another way to do a search over a bunch of different directories is to simply type a list of directories, separated by "|" (pipe) or " | " (space-pipe-space; the spaces are optional), into the location dropdown, for instance: C:\John\Letters\ | C:\Contracts\ | D:\Work\. Alternatively to "|" you can use ";".

Edit Locations: An easier way to achieve the same is using the Edit Locations dialog that is reached via the Browse... button's right-click menu. Here you can edit the search location(s) like in an editor. The dialog has its own Browse button. Selected locations are appended to the ones already present in the exit box. The Browse dialog is preselected to the last location in the box.

To activate the Name parameter the corresponding checkbox below the Find Now button must be checked. Location and Include Folders are, of course, always active.

Comparison Operators

The Name field supports comparison operators. This means you can e.g. list all files from A to M.

< Less than
> Greater than
<= Less than or equal to
>= Greater than or equal to

The operators must be surrounded by spaces and are prefixed to the patterns.

Examples

When strings are compared it's about alphabetical order. Find all files before "m":
< m

Find all items from "d.txt" through "m.txt". Watch the double space after AND: Boolean " AND " must be surrounded by spaces as well! The leading ":" is the inline Boolean search mode marker.
: >= d.txt AND < m.txt

When numbers are compared it's about numerical values. Find all items whose full name (incl. path) is longer than 100 characters:

len: > 100

Notes on using Comparison Operators

· Patterns with comparison operators should not contain wildcards; they make no sense here anyway and will just be treated as characters "*" and "?" in the comparison.
· The settings "Whole words" and "Fuzzy" are ignored with patterns using comparison operators. But, of course, the settings are applied with non-comparison-patterns. E.g., with "Whole words" enabled, the following term will match "a d.txt" but not "ad.txt", and not "d a.txt" (because it's > c.txt):
:a AND < c.txt
In words: Find all items that contain "a" as a whole word, and are alphabetically sorted before "c.txt".
· It does not make sense to combine comparison operators with RegExp patterns; the RegExp will not be analyzed but simply be used as a string in the comparison.

Find Files by Size

You can find files by size using the field prefix (selector) "size:". Sure, there is also the "Size" tab (see below) but this enhancement opens find-by-size to the Quick Name Search and hence also to Scripting.

Examples

· Find all files exactly 999 bytes long: size: 999
· Find all files of 1 MB or larger: size: >= 1MB
· Find all folders (here folders have no size): size:
· Find all empty files: size: 0

The Size field is particularly useful for reducing the work when searching for files with a certain hash value. When you happen to know the exact size or at least the approximate size of the files you are looking for you can save a lot of time. For example:

· Find all files between 5MB and 6MB AND with a certain hash value (the first colon marks Boolean mode):

:size: > 5MB AND size: < 6MB AND prop:#Hash.MD5:db24bcdf4098bda916a949f5554d2110

Find Files by Tags (Labels, Tags, Comments)

You can directly search for Labels, Tags, and Comments. Simply prefix the selector "lbl:", "tags:", or "cmt:" (case does not matter) to the search term in the name field, and the whole term is matched against the label, tags, respectively comment of each file instead of against the name.

All other things work as usual, including Boolean and RegExp search.

Examples

· lbl:"red"
find all tagged items with label "red"
· lbl:!"red"
find all tagged items with no label "red"
· lbl::"red" or "green"
find all tagged items with label "red" or "green"; the second ":" after "lbl:" is the inline Boolean search marker
· lbl:"red";"green"
same using "Loose Boolean Match" OR syntax
· lbl:r
find all tagged items with "r" in the label
· lbl:r a p
find all tagged items with "r" and "a" and "p" in the label, employing the "Loose Boolean Match" syntax with " " separator as AND
· tags:cats
find all tagged items with a tag "cats"
· tags:cats,dogs
find all tagged items with a tag "cats" AND a tag "dogs" (see more examples here below under Examples for searching tags)
· tags:""
find all tagged items with no tags
· tags:""quotedtag""
find all items with tag "quotedtag" (including the quotes)
· cmt:2008;2009;2010
find all tagged items with 2008 or 2009 or 2010 in the comment field, employing the "Loose Boolean Match" syntax with ";" separator as OR

Examples for Searching Files by Tags

Loose and Full Boolean: Of course, Tags call for Boolean search terms. This is very easy to do:

Name Pattern Find all items with

---------------------------------------------------------------

tags:cats tag "cats"

tags:cats;dogs tag "cats" OR "dogs" (loose Boolean syntax)

tags:cats dogs tag "cats" AND "dogs" (same)

tags:"cats dogs" tag "cats dogs"

tags:"cats dogs";ants tag "cats dogs" OR "ants"

tags::cat* OR dog* tag "cat*" OR "dog*" (full Boolean syntax, with Boolean marker : prefixed)

tags::cat* AND dog* tag "cat*" AND "dog*" (same)

tags:?* any tag

Comma as AND, Pipe as OR: There is a special shorthand syntax that's only applicable for the tags selector: You can use the comma as an AND operator, and the pipe as an OR operator. Here are some examples, including possible combinations with Loose Boolean operators ; (OR) and [space] (AND):

tags:cats,dogs,ants tag "cats" AND "dogs" AND "ants"

tags:cats,dogs;ants tag ("cats" AND "dogs") OR "ants"

tags:cats|dogs|ants tag "cats" OR "dogs" OR "ants"

tags:cats|dogs ants tag ("cats" OR "dogs") AND "ants"

tags:"birds,m m" tag "birds" AND "m m"

The quotes in the last example are necessary because of the space in "m m".

Note that you cannot mix commas and pipes.

Wildcards in Tags

Tags can have wildcards ("*" or "?") and still be searched for in an easy manner. To enable searching for wildcards you use the switch /v ("verbatim") which tells the interpreter that "*" and "?" in the search term shall not be taken as wildcards but as normal characters. The verbatim switch is exclusively used for label, tags, and comments search. Here are some examples for Quick Name Searches passed through the Address Bar and searching the current location:

Address Bar Finds (recurring subfolders) all items with

------------------------------------------------------------

?tags:a* /rv a tag "a*"

?tags:a* /r a tag matching pattern "a*"

?cmt:"*" /rv a comment "*" (note that "*" must be quoted in the term;

a single non-quoted "*" means "ignore comments")

?a /v all items named exactly "a"

Note that, of course, even without the verbatim switch you can search for wildcard characters by enclosing them in square brackets. For some jobs there is no other way, for example to find all items with a "*" anywhere in the tags:

?tags:*[*]* /r

Search only among Tagged Items

Append the switch /t to the search term to confine the search to all items present in the tags database (tag.dat). Examples (ready for pasting into the Address Bar):

List all items (excluding any orphans) in the database:

*?* /t

List all TXT items in the database:

*?*.txt /t

List all tagged items in the current location with no comment:

?cmt:"" /t

List all tagged items in the current location without comment AND number 5 in ex2:

?:cmt:"" and ex2:5 /t

----------------------------------------

? = search

: = Boolean term

cmt: = comment

"" = empty

and = Boolean AND

ex2: = extra tag 2

5 = value 5

/t = in tags database

----------------------------------------

Invert the previous results: List all tagged items in the current location NOT without comment AND number 5 in ex2:

?!:cmt:"" and ex2:5 /t

Notes

· Quick Name Search supports this syntax, for example:
E:\Test\?lbl:"blue";"red"
· The selector "comment:" is a valid alternative to "cmt:".
· The selector "tag:" is a working (but deprecated!) alternative to "lbl:" (for historical reasons).
· Tip: The asterisk "*" is an alias for "Computer" as location. For example, to find all items on all local drives with a comment containing "India" you simply run this through the Address Bar:
*?cmt:India /r
· Tip: To find all items on your computer with any tags defined run this through the Address Bar:
*?tags:?* /r

Find Files by Multi Field Search

In a Boolean search you can also mix different fields, e.g. find all images with 1024 x 768 pixels AND labeled "Red" AND having "2012" in the name.

The available fields are:

name: Name (default field)

size: Size

lbl: Label

tags: Tags

cmt: Comment

prop: Property

len: Length of path and file

lent: Length of file title (no path) only

Examples:

Name Pattern Find all items with

-------------------------------------------------------------------

1) tags:cats,dogs OR name:a* tags ("cats" AND "dogs") OR name "a*"

2) tags:cats|dogs AND name:a* tags ("cats" OR "dogs") AND name "a*"

3) tags:cats|dogs AND ants tags ("cats" OR "dogs") AND tag "ants"

4) xy*.exe AND prop:fileversion:10.80* (self-explaining)

5) *.jpg AND lent: > 12 JPGs with long filenames

6) *.jpg AND size: > 10MB JPGs larger than 10 MB

Field Type Inheritance

The 3rd example above shows that the field type is inherited from left to right. This is done for backward compatibility and also for comfort. The following pairs are equivalent:

lent: > 12 AND < 20

lent: > 12 AND lent: < 20

tags:cats|dogs AND ants OR name:a* AND *.png

tags:cats|dogs AND tags:ants OR name:a* AND name:*.png

a* AND (*.png OR lbl:green OR yellow OR red)

name:a* AND (name:*.png OR lbl:green OR lbl:yellow OR lbl:red)

Boolean RegExp

Multi Field Search is also supported in Boolean RegExp, for example:

:>.*test.* AND NOT >.*not.*test.* OR lbl:>^Gre.*

Further Remarks on Multi Field Search (MFS)

· Of course, MFS also works in Quick Name Searches which makes it available for Address Bar, Catalog, Favorites, User Buttons, Scripting etc. Remember that the Boolean marker ":" has to be prefixed, e.g.:
?:tags:dogs and name:t*
· The Match Case checkbox applies to all operands of the MFS term.
· The Whole Words checkbox applies to all operands of the MFS term, with the exception of tags (tags:), which are always treated as whole words unless they are stated with wildcards.

Find Files by Meta Properties

You can directly search for the extended properties of file items, also known as Meta Properties. Their names and indices vary strongly between different Windows versions. A list is available in Configuration | File Info Tips (those properties are also featrured in the File Info Tips). The syntax is simple: Prefix "prop:[propertyname]:" to the search term. To identify properties by their index use "#[index]" as propertyname.

Examples

prop:fileversion:8.60 // find all items with version *8.60*

prop:fileversion:"8.60" // with version 8.60 (exactly)

prop:#8:Donald // with owner *Donald*

prop:#26:"1024 x 768" // with image dimensions "1024 x 768"

prop:#AspectRatio: 16:9 // with aspect ratio 16:9

prop:#Hash.MD5:58172fd15526e1249ac8bfd690ced076 // with a certain MD5 hash

Tip: The latter example should be logically combined with other criteria to increase the speed (by avoiding unnecessary lengthy calculations), e.g.:

:*.png AND prop:#Hash.MD5:58172fd15526e1249ac8bfd690ced076

:size: > 5MB AND size: < 6MB AND prop:#Hash.MD5:db24bcdf4098bda916a949f5554d2110

Find Files by the Length of their Name

Simply prefix "len:" to the search term in the name field. For example, to find all items whose full name is longer than 260 characters:

len: > 260

Find all items whose title (name excl. path) is:

lent: < 12 shorter than 12 characters

lent: 12 exactly 12 characters

Tab "Size"

Search files of a certain size, defined by a lower and an upper limit (both limits are inclusive). Leave field empty to ignore a limit, e.g. to find all files bigger than 1 MB select the MB option, enter a 1 in the at least field and leave the at most field empty.

Note that you may also state fractions, e.g. 0.0001 GB (= 100 KB), or 0.000000000001 TB (= 1 byte).

FAT32: the highest allowed value is 2 GB (= 2,024MB = 2,097,152KB = 2,147,483,648 bytes) minus 1.

NTFS: you can search files of up to 1 TB (1024 GB, 2^40) by size filter.

Search for folders as well: If you use this setting then the search results will display the folder sizes, even if they are not shown by general user settings. BTW, finding emtpy folders is even easier now than before. Simply set "At most" to 0 (zero) and check "Search for folders as well". Found are all folders that are empty (displayed as "[Empty]") or contain a total of zero bytes (displayed as "0").

To apply this filter the corresponding checkbox below the Find Now button must be checked.

Tab "Date"

Search files of a certain date/time. There are three types of dates associated with Windows files and folders:

Created The date when the file has been created at this location, where location is the path of the file (this date is only set once).

Modified The date when the file has been last modified (set at each write operation).

Accessed The date when the file has been last accessed (set at each open operation).

Created or Modified Select this option to find all files that pass either of these filters.

In the last Find file relative to Now.

From start of unit When checked, the lower margin is set back to the start of the chosen unit (eg days start 00:00 midnight, weeks start Monday). Note that this setting does also apply to the "and/add"-field when filled with relative time units!

Between ... and/add Here you can enter a date range manually. When you omit the time part of the date, 00:00:00 is assumed. Fractions of a second (up to 7 decimal digits) are supported.

Here are some keyboard tricks:

When the fields are empty:

key arrow up: set to today

key arrow down: set to yesterday

Else:

key arrow up: scroll days up

key arrow down: scroll days down

key arrow up + SHIFT: scroll months up

key arrow down + SHIFT: scroll months down

UTC Support (Universal Time Search)

By appending "Z" (or "z") you can mark the time expression as UTC (Coordinated Universal Time). This way you can find files by their UTC date (as it is internally used by NTFS) and use the same search pattern/template irrespectively of the time zone of the host system. Pretty cool, especially if you are a pilot (or love a pilot).

For example, this will match all files modified (or whatever date you are looking for) in Bamako between 08:20 and 08:40 Bamako time, no matter where on the planet you are now:

Between: 2013-05-14 08:20:00Z

And: 2013-05-14 08:40:00Z

The ISO 8601 formats for UTC and time offsets from UTC are supported. The following time expressions all refer to the same point in time:

2013-05-14 10:00:00+02:00

2013-05-14 08:00:00+00:00

2013-05-14 08:00:00Z

2013-05-14 03:00:00-05

2013-05-13 23:00:00-0900

2013-05-13 20:00:00-12:00

For example, to find all files modified in Cologne today between 16:00 and 17:00 Cologne local time (DST in effect), you can use these time strings, regardless of the time zone of your current host system:

Between: 2013-05-14 16:00:00+02

And: 2013-05-14 17:00:00+02

The +02 means: Cologne (DST in effect) is 2 hours later than UTC.

Date Range Popup Menu For the lazy ones, there are some preset date ranges available to save you some typing. Click the menu button to enter a date range by selecting an option of the date range popup menu. The Unknown option allows you to search for files with the time-stamp "unknown" (that is, no date set on this file, which is sometimes the case with certain system files and folders). The Like option sets the date range to the date of the last selected file or folder plus/minus 10 minutes.

Check Not if you want to find files whose specified date is outside the given range.

To apply this filter the corresponding checkbox below the Find Now button must be checked.

Tab "Attributes"

Search files with or without certain attributes. For example, if you don't want to find any folders, check Directory and the corresponding Not. If you want to find only hidden files, check Hidden.

Note that Normal, Temporary, Compressed, Offline, Not Content Indexed, and Encrypted are supported only by Windows NT/2K/XP, and higher.

Tip: If you have no idea what Not Content Indexed is, search the web for FILE_ATTRIBUTE_NOT_CONTENT_INDEXED (aka the "the FANCI bit"). It's around since Win2K.

To apply this filter the corresponding checkbox below the Find Now button must be checked.

Tab "Tags"

Find files with specific Labels, Tags, or Comments. Like all filters they are connected by logical AND, so e.g. if Labels and Tags are both ticked then both must match else the file in question will not be among the search results.

All three fields are treated case-insensitive (A==a) and support wildcards. Here are some field-specific details:

Filter "Labels"

Supports stating multiple labels combined by logical OR (|); surrounding spaces are ignored. Examples:

green

Green

green|red

green | red

g*|*e*

Logical AND is not supported, of course, because each file can only have one label by definition.

A "Select Labels..." button is added for comfort.

Filter "Tags"

Supports stating multiple tags, combined by either logical OR (|) or logical AND (,); mixing both operators is not supported; surrounding spaces are ignored. Examples:

dogs

Dogs

dogs|cats dogs OR cats

dogs | cats dogs OR cats

dogs,cats dogs AND cats

dogs, cats dogs AND cats

A "Select Tags..." button is added for comfort.

Filter "Comment"

Wildcards (*) are auto-added left and right if no wildcards (* or ?) are contained in the pattern (aka "loose match").

Search everywhere

Tick it to search the whole computer. It will overwrite what is stated in the Location field on the "Name & Location" tab.

Finding Empty Fields

Contrary to the Name field, leaving the fields on the Tags tab empty is NOT equivalent to "*" (match all) but means "empty". For example, to find all items that are tagged (are present in the tags database) but have no comment: Simply tick the Comment checkbox and leave the Comment field empty. Same way works for Labels and Tags.

Speed

All searches including the Tags filter are ultra-fast because they work directly on the tags database, i.e. they are indexed searches.

Tab "Contents"

Find files containing a specific text string, aka content search.

Mode. You can choose between various modes, which refers to the way the given search pattern is to be interpreted.

1. Normal: The pattern should match any part of the file contents.

2. Whole Words: Like Normal, but the matching string should be a whole word, not just a part of a word.

3. Wildcards: The pattern contains wildcards (* or ?). For example, the pattern drag*drop will find all files that contain the words "drag" and "drop" in that order and with any characters in between them.

Notes:

(1) Since larger files are read chunkwise (performance!) there are certain limits to the scope of your pattern: A pattern "a*b" is guaranteed to be found if "a" and "b" are within a range of 1,024 bytes! It also *might* be found if "a" and "b" are within a range of 1,025 to 32,768 bytes! It will certainly not be found if "a" and "b" are only within an even larger range.
(2) Just like with non-wildcard searches it is assumed that you look for a match anywhere within the file, so asterisks (*) are silently added to your pattern at both ends in case they are missing. This is just to spare you typing too many asterisks. So you may simply enter "D?g" to look for "D?g" anywhere in the file (match file contents with "*D?g*").
(3) You need to check Wildcards (see below) to enable pattern matching support.

4. RegExp: The pattern is a Regular Expression (aka "Grep"). Examples:

· Match 2011-10-20 or 2011-1-2 etc.: \d{4}-\d{1,2}-\d{1,2}
· Match lines that begin with "New": ^New
· Match lines that end with "*/": \*\/$

Note: Since larger files are read chunkwise (performance!) there are certain limits to the scope of your pattern: A pattern is guaranteed to be found if it matches a range of 1,024 bytes! It also *might* be found if it matches a range of 1,025 to 32,768 bytes! It will certainly not be found if it matches only an even larger range.

Match Case: If checked string search is case-sensitive, else case is ignored.

Invert: Check it to find all files NOT containing the given text string. Note that the Contents filter never returns folders (although they naturally do NOT contain any given text string).

It's a Hex String: Activates Hex mode. Check this option to look for any binary sequence contained in a file, including the null char. Binary sequences are to be represented in hexadecimal code. Hex strings must have 2 valid hex characters per byte and each pair may be separated from another by spaces or line feeds. Example: 00C0FF or 00 C0 FF (lower case letters are also ok: 00 c0 ff ). In hex string mode the coloring and font of the text is changed to make it dramatically clear that you are in a special mode.

Match unicode: If enabled then a text string "Text" will match with "T0e0x0t0".

Note In either mode, the text entered cannot be be longer than 32,533 chars; of multi-line texts only the first line and a maximum of 1,024 characters is remembered between sessions.
Note The string search routine takes care that the Accessed date of the scanned files is reset to its original value when scanning is done.

To apply this filter the corresponding checkbox below the Find Now button must be checked.

Tab "Dupes" (Duplicate File Finder)

Find duplicate files by name, date, size and/or content in any location. Spotting duplicates, especially those by content, can be useful for freeing up storage space.

XYplorer's Duplicate File Finder is implemented as filter "Dupes" in the Find Files tab. If the filter is active then only duplicate files are listed in the search results, i.e. files that have one or more duplicates in the searched location(s).

What counts as a "duplicate" can be defined in the Dupes tab: It's either match by Name, or Date (modified), or Size, or Content, or any combination of these.

· Name: The name of the file.
· Date: The modified date and time of the file.
· Size: The exact size of the file. Note that Size is logically implied when Content is checked.
· Content: The content of the file.

For Content you can further define the method of comparison: The choices go from MD5 (fastest but least reliable) via SHA-1, SHA-256, SHA-512, to Byte-to-byte (slow but most reliable). Generally, SHA-1 is thought to be reliable enough for real world usage and hence it is also the factory default.

Tick the Invert option to find all singular/unique files; quite useful when comparing two folders that should be in sync.

The Dupes filter is fully integrated with the XYplorer Find Files module and can be combined with all other search filters. Note that the duplicate check is applied *after* the other filters so if you know what you are looking for you can save a lot of time by pre-filtering the checked files by Name, Size, Date, Tags etc.

The results list of a dupes search features a special column "Dupes" where each group of dupes is referred to by a unique ID starting from number 1 for the first group detected. Sorting the list by this column will bring the duplicate files that belong together into adjacent order. A dupes search results list is always initialized to be sorted by the Dupes column. If sorted by Dupes, the list is internally set to grid style "Highlighted Groups", and the Dupes column is additionally highlighted with a color depending on the "highest" match criterion:

If by Content: white-on-green

ElseIf by Size: white-on-brown

ElseIf by Date: white-on-purple

ElseIf by Name: white-on-blue

Right-clicking the Dupes column when the list is sorted by this column pops a special context menu with two commands for selecting items based on the dupe groups:

· Select the First Item in Each Group
· Select the Non-First Items in Each Group

Further Notes:

· The Dupes filter finds only files, no folders. Equally the Invert option will return only singular files.
· Of course, checking for dupes by content can take a lot of time. Still XYplorer is pretty fast here due to some smart logic. The bottleneck, however, is the hard drive read speed.
· Also search results caching is supported by dupes searches. But always remember that caches can get stale: It might be that files marked as dupes are not dupes anymore.

Tab "Excluded"

Here you can exclude specific files, folders, or drives from file search. Any subfolders of excluded folders are automatically also excluded. The matching of the excluded items is case-insensitive (A==a).

Add Current: Will add the current path, or the currently focused list item.

Browse...: Browse for a folder to exclude.

Manage...: Manage the excluded items using the List Management interface.

File: This checkbox shows and controls whether the selected item in the excluded items list is a folder (or drive) or a file, in other words: whether it defines an excluded location or an excluded item. If the checkbox is ticked the pattern is marked by the prefix "file:". Note that the "file:" patterns are matched with the item name only, not with the whole path, so they should not contain any other path components or backslashes.

Note It's possible to use wildcards, eg to exclude the Recycle Bins on all drives, add ?:\Recycled\ (XP) respectively ?:\$Recycle.Bin\ (Vista/Win7). Or adding *~* would exclude all folders containing the "~"-character anywhere in their path specification.
Note The matching is loose, e.g. file:Lucky will match all items with "Lucky" somewhere in the name.
Note When you start your search from an excluded folder, this folder is not excluded.

To apply this filter the corresponding checkbox below the Find Now button must be checked.

Tab "Options"

Name Match Fuzziness

File find fuzziness is configurable. The higher the fuzziness (default 25%), the more items will be found:

0% fuzziness = 100% minimum similarity (= non-fuzzy)

25% fuzziness = 75% minimum similarity

100% fuzziness = 0% minimum similarity (all items match)

Note that actually useful values might lie between 10% and 35% of fuzziness. Also bear in mind that with the Ratcliff/Obershelp algorithm the correct order of any submatches is relevant, and the similarity decreases with the mean length of the compared strings, eg:

"mahatma ghandi", "mahatma gandhi" = 93% similarity

"gandhi mahatma", "mahatma gandhi" = 50% similarity !

"gandhi", "mahatma gandhi" = 60% similarity !

Search Results Context Menu

The context menu of items in Search Results and Branch View contains a couple of useful extra commands.

Go to Focused Item

Go to the focused item in its containing folder.

Keyboard Shortcut: Ctrl+Alt+Left

Go to Focused Item in New Tab

Go to the focused item in its containing folder in a newly opened tab.

Open Containing Folder in New Background Tab

Open the focused item's containing folder in a newly opened background tab.

Copy Containing Folder(s)

Copies the containing folders of all selected items to the clipboard.

Usage: Use Find Files to identify folders by their contents, and then copy those folders using Copy Containing Folder(s) for further processing.

Notes:

· The containing folders are the direct parent folders.
· If the containing folder is a drive it will NOT be copied.
· If more than one item is selected the list of containing folders is silently cleared from duplicate and folders contained in other folders in the list before it is copied to the clipboard. So it will not be unusual that less folders are copied than items are selected.

General File Find Tips

Tip You can abort a running file find process by pressing Esc (Escape Key).
Tip Press Ctrl+left arrow to jump to the currently focused file in the folder where it was found (this trick works for search results only, and obviously it does only make sense when file find included subfolders)


Search Templates

Search Templates

The command to open the Search Templates dialog is found in menu Edit.

You can save your current Find Files settings to template files, which are stored as simple INI files in a subdirectory of the application data path called "FindTemplates". For the template name you can use all characters including those that are invalid for filenames (<,>,?,",: etc.).

A template contains all settings found on the Find Files tab, with the exception of the Name and Location dropdowns, where only the current top entry is remembered.

Load Template

Load the selected template and close the Search Templates dialog. Alternatively double-click the template name in the list. There are some options:

Load saved results: Here you have a choice whether to load any cached results (see Caching below) or not. The enabled state of the checkbox tells you whether cached results are existing in the template or not. Any implied states of the other options are auto-handled for you.

Run search at once: If checked the search will start immediately after you clicked Load Template.

Load search location: When loading a (previously stored) template you have the option whether to use the current location or the location stored in the template for the search.

Load Excluded Folders: Check to overwrite the current excluded folders listing by the one stored in the template. The default is unchecked because it is assumed that the excluded folders are usually a global affair.

Save to Template...

Save current Find Files settings to template file. If you enter an already existing template name this template will be overwritten/updated.

Save search results: If checked then search results are stored with the template and can be reloaded at a later point. Of course, the option is only enabled when search results are present in the file list.

Note: You cannot store any Quick Name Searches, but only searches triggered through the Find Files tab.

Note: You cannot cache the results of any visually filtered searches anymore. Reason: The filter is not stored along with the template so when loading the Search Templates you have no way to find out by what the data had been filtered.

Caching

Beginning with version 8.40 Search Templates support caching. i.e. you can save search results in a template file (in <xydata>\FindTemplates), and load them back into the list at any point in future via the Search Templates dialog.

Writing the cache: You can control whether search results are stored on a per-template basis using the new option "Save search results" below the "Save to Template..." button.

Reading the cache: Any previously cached results are read when you check the Load saved results option. If you do, the other three options are implied as well. Reason: Otherwise the displayed results would be out of synch with the Find Files panel.


Branch View

Branch View

Branch View (BV), also known as "Flat View", is a mode of the file list that lets you view the contents of all subfolders of a folder in one list.

To turn on Branch View for the current tab, use the toggle "Branch View" in menu View | Views (also available in the file list's white space and the tabs' context menu), or the "Branch View" toolbar button.

Implementation

Branch View is implemented in a flat, human-readable, and editor-editable way. It is triggered by a switch at the end of the location spec, e.g.:

E:\XYplorer\appdata\? /:flat

The question mark is a part of it, no wonder since BV is technically nothing but a recursive search, and the normal name search syntax applies, for example:

? /f:flat = Show only files in BV. The BV switches are appended to any normal switches, separated by colon (:).

?a*;b* /:flat = Show only items beginning with a* OR b* in BV.

This flat syntax enables you to trigger BV from the Address Bar, Catalog, Favorites, User-Defined Commands, Scripting, etc. Note that also Boolean Logic and Regular Expressions are supported.

Types of Branch View

There are three types of Branch View:

1. /:flat = Show files and folders (= Mixed Branch View)

2. /:flatfiles = Show files only

3. /:flatdirs = Show folders only

By factory default the first one is used when BV is toggled via menu or toolbar. You can change this default in Configuration | Find Files & Branch View | Default branch view type.

Configuration

See Branch View Configuration. Note that the toolbar button has a context menu featuring some configuration options.

Filtered Branch

By ticking Let folders pass all filters you get the following behavior: On a mixed Branch View (i.e. /:flat = showing files and folders), any Visual Filters or Name Search patterns only apply to files, not to folders. So the folders always stay visible while their contents are filtered.
This feature, combined with level-indent and tree-like sort order (see here below), enables you to view a Filtered Branch in the file list, for example a branch showing only images or only EXE files. A real time-saver when perusing the file system under certain aspects.

Tree-Like Sort Order

Sorting the list (in Branch View and also in general Search Results) by Path will create a perfect tree-like sort order, that is all folders sorted like in the tree and in each folder you get the files listed ahead of any subfolders. Sorting by Path again will reverse this order.

Note: To make this happen sort settings must be so that folders are NOT sorted apart, so either you turn off "Configuration | Sort and Rename | Sort folders apart" (which is unlikely) or you turn on "Configuration | Sort and Rename | Mixed sort on path columns" (which you will likely do).

Multi Branch View (MBV)

You can select multiple folders in the list view and then branch view them together in one list. The containing/top level folders in a Multi Branch View are shown as well, not just the items contained in those folders.

To trigger an MBV from the toolbar or by keyboard, the list must have the focus and more than one folder (or LNK to a folder) must be selected. A MBV can also be triggered via the Address Bar, Catalog, Favorites, etc. using the following multi location syntax (paths separated by ;):

E:\Test\A\;E:\Test\B\? /:flat

This syntax also allows MVB for folders in completely different locations, for example:

D:\Work\;E:\Test\B\;\\Server\Docs\? /:flat

Tip: You can even trigger a Multi Branch View from a Branch View when two or more folders are selected in the focused list. The "Branch View" toggle silently turns into a "Branch View" command under these conditions.

Tip: Toggling back to normal view from a Multi Branch View will restore the multi-folder selection, the scroll position, and the focus position.

Note: Unless the tab captions are set to "Full path" in Configuration | Tabs, the tab headers show the suffix /M to make clear that the contents are from multiple locations. The folder tree turns grey on an MBV to show that the current tree folder is not equivalent to the current search location.

General Properties of Branch View

· Like Search, BV is stored tab-wise and remembered between sessions.
· Unlike Search, BV is always done in the current tab (even if it is locked).
· A tab on BV is marked by a special icon.
· When toggling BV, the sort order (unless you enabled Default to tree-like sort order) and view mode remains the same. Other list settings (back color, column order, column visibility, column widths) are taken from the Find mode (aka Search Results).
· Refresh List will refresh BV, it will not rebrowse the folder in normal view.
· BV never follows folder links or junctions.
· You can drag-n-drop items from one folder into another within BV.
· BV can be combined with Visual Filters.
· BV can be combined with Name Searches (including Boolean Logic and Regular Expressions).
· Specific BV patterns can be stored in and triggered from Address Bar, Favorites, Catalog, User-Defined Commands, and Scripts..
· Press ESC to interrupt a running BV.


Visual Filters

Visual Filters

Visual Filters let you control what you see in the file list by stating simple wildcard patterns like *.txt. The Visual Filter is per-tab and, of course, saved between sessions. The current filter is displayed on the tab headers in blue color.

The main commands for Visual Filters are found in menu View | Tab, which is also available by right-clicking the tab headers. There is also a toolbar button "Visual Filter" to quickly toggle the last used filter.

Configuration Options

All configuration options for Visual Filters are also located in the right-click menu of the toolbar button "Toggle Visual Filter". See here for the details.

Filter Syntax

OR: You can state an unlimited number of wildcard patterns separated by ";" (logically treated as OR). Further you can use the wildcard "?" for any single character and "#" for any single digit (0-9). To match opening square brackets ( [ ) you need to enclose them in square brackets ( [[] ). Visual Filter pattern matching is not case-sensitive: a==A.

Desktop|*.txt = List all TXT files on Desktop

Desktop|???.txt = List all TXT files on Desktop with exactly 3 characters in the base name

Desktop|???*.txt = List all TXT files on Desktop with at least 3 characters in the base name

Desktop|*##*.txt = List all TXT files on Desktop with at least 2 digits in the base name

Desktop|*[[]* = List items on Desktop containing an open square bracket in the name

Note that you can separate Visual Filters by "|" as well, not only by ";". The | has priority of over ; so using | you can filter items containing the ";" character:

Desktop|;|, = List all items on Desktop containing ";" or ","

If you state only one pattern and this pattern contains a ; then you have to add another dummy | to avoid that the ; is treated as separator:

Desktop|;| = List all items on Desktop containing ";"

Desktop|;a| = List all items on Desktop containing ";a"

Desktop|"*; *"| = List all items on Desktop containing "; "

AND: Boolean AND is supported. The operator is AND (surrounded by spaces!); it's not case-sensitive, so and works as well. Examples:

cat AND dog AND pig = all these animals must be in the name

water and ageM: w = "water" in the name, modified this week

size: < 1KB AND *.txt; size: < 100 AND *.gif = TXT < 1 KB, or GIF < 100 bytes

"Image Files 2013" {:Image} and 2013 = image files with "2013" in the name

If you want to show items containing " and " you have to escape it with "\", or quote the whole pattern:

cat and dog //matches items with "cat" and "dog" in the name

cat \and dog //matches items with "cat and dog" in the name

"cat and dog" //matches items named "cat and dog"

NOT: A leading ! (exclamation mark) will invert the filter, i.e. show only items *not* matching any of the patterns. If you want to show items starting with "!" you have to escape it with "\":

Examples:

a*;b* -> show all items starting with "a" or "b".

!a*;b* -> hide all items starting with "a" or "b".

\!a*;b* -> show all items starting with "!a" or "b".

The operator can also be used for individual operands in a Boolean expression. Note that this works only for non-first operands, since the NOT operator in front of the first operand is interpreted as NOT operator for the whole expression:

!a*;b* -> hide all items starting with "a" or "b". (NOT operator refers to whole expression)

a*;!b* -> show all items starting with "a" or not starting with "b". (NOT operator refers only to 2nd operand)

water and !ageM: w -> "water" in the name and not modified this week

Special Operators:

You can define a filter to apply only to files but show all folders. Simply prefix "\|" to the pattern(s). For example:

\|*.txt -> show only *.txt files and all folders

\|!* -> show all folders and no files

To hide all folders simply prefix "!\|" to the pattern(s). For example:

!\|*.txt -> show only *.txt files and hide all folders

!\|* -> show all files and no folders

You can also define a filter to apply only to folders but show all files. Simply prefix "*|" to the pattern(s). For example:

*|a* -> show only folders beginning with "a" and all files

*|!* -> show all files and no folders

Captions

You can also define a caption for each Visual Filter. Simply prefix a quoted string followed by at least one space to the filter:

"Images" *.gif|*.png|*.jpg

"Items ending with g" >g$

The tab captions will show only the (unquoted) caption of a Visual Filter with caption.

The caption of a Visual Filter can have a short and a long version, the former used for tab captions (where space is scarce), the latter for menu captions (where space is abundant). The short and the long version are separated by "|" (pipe). This feature has been added especially to improve the appearance of the new Powers Filters which otherwise take too much space in the tab headers. Here are some examples:

"30 Mins|Modified In The Last 30 Mins" ageM: <= 30 n

"3 Hours|Modified In The Last 3 Hours" ageM: <= 3 h

"Today|Modified Today" ageM: d

"Week|Modified This Week" ageM: w

"Year|Modified This Year" ageM: y

Comments

Trailing comments are allowed after "//", e.g.:

ageM: w //modified this week

Matches

Loose matches are supported, i.e. wildcards are auto-added on both ends if no wildcards are passed with the pattern. For example, to show all items containing the letter "e" in the name simply state "e" as filter:

e -> show all files containing "e" in the name

To force exact matches (as opposed to loose matches) you can quote a filter. If you state multiple filters then each filter that should be matched exactly should be quoted.

"readme.txt"|"setup.txt" -> show only files readme.txt and setup.txt

"sel" "readme.txt"|"setup.txt" -> the same with caption "sel"

Regular Expressions

Visual Filters also support the Regular Expressions syntax. Like elsewhere in XYplorer to activate the regular expressions mode simply prefix the pattern with the character ">". For example:

>\.doc$ -> show only *.doc files

>.*(\.png|\.jpg)$ -> show only *.png and *.jpg files

Usage

Note that Visual Filters in combination with tabs allow you to show completely different listings ("filtered views") of the same location. You could for example have a tab "DLLs" (Visual Filter set to *.dll) and and tab "OCXs" (Visual Filter set to *.ocx) and have both pointing to Win\System32.

If a Visual Filter is on, the item count on the status bar tells you the total number of items, and it does it in blue (or whatever you set the Marked Color to) as a further indication that a filter is active and effective.

Variables in Visual Filters

Visual Filters support environment variables and XYplorer native variables. Using variables can make filters portable (adaptive to their host system).

For example:

· <date yyyy>
Shows only items with the current year in the name.
· %username%
Shows only items with the current user name in the name.
· %pathext%
A special case: %pathext% happens to return a list of patterns which is quite compatible with XYplorer's Visual Filter syntax:
%pathext% => .COM;.EXE;.BAT;.CMD;.VBS;.VBE;.JS;.JSE;.WSF;.WSH
So you'd see a list of what the host system considers executable files.

Notes:

· The tab headers show the resolved values of the variables.
· The MRU list under the Visual Filter Toolbar button shows the variables.
· The Visual Filter toolbar button's tooltip shows the variable form of the current VF.
· Visual Filters are stored as variables (e.g. "%username%") only when passed through the Set Visual Filter interface. Visual Filters passed through the Address Bar are resolved (e.g. "Donald") *before* being passed to the Visual Filter engine and stored as the hard invariable value.
· The Visual Filter toolbar button's tooltip and the Status Bar first section's tooltip both show the current Visual Filter pattern, which is the active pattern after any variables have been resolved.
This is useful when you have a VF like this and want to know what your filter actually looks like:
"Matching Clipboard" <clipboard>

Visual Filters by Attributes, Size, Date, and Age

Besides Name, also other item properties can be used for visual filtering. The syntax is very similar to the Color Filters syntax in that a selector is prefixed to the pattern:

Filter Type Selector Example

-------------------------------------------------------------

Name [name:] *.txt (or name:*.txt)

Attributes attr: attr: readonly

Size size: size: > 100 KB

Date Created dateC: dateC: 07.12.2012

Date Modified dateM: dateM: 2012.12.01 - 2012.12.31

Date Accessed dateA: dateA: 07.12.2012

Age Created ageC: ageC: > 5 y

Age Modified ageM: ageM: d

Age Accessed ageA: ageA: <= 5 d

Examples:

*.txt = named *.txt

name: *.txt = named *.txt

attr: system = SYSTEM attribute set

size: >= 1.5 GB = 1.5 GB or bigger

size: 0 = empty

dateM: 2010.01.01 - = modified 2010 or later

dateC: dw 6-7 = created on a weekend

ageM: y = modified this year

ageA: < 5 d = accessed less than 5 days ago

Like Name filters also these filters can be inverted by a prefixed "!":

ageM: d //modified today

!ageM: d //not modified today

And they can be freely combined separated by ";" or "|" (both meaning logical OR), for example:

size: <= 10 KB; name: *.png; ageM: w

Scope Suffixes

Visual Filters with selectors also support scope suffixes.

For example, this filter will show only folders created today: ageC d: d

And this filter will show only files modified yesterday: ageM f: 1d

Notes:

· The date has to be given in a form that is recognized as a valid date format on your locale. The time part can be skipped in which case it is internally set to 00:00:00.
· The selector is not case-sensitive: Datem: would work as well.
· The selectors date:/age: default to dateM:/ageM: ("Date/Age Modified").
· Spaces after the selector are optional: "ageM: d" is equivalent to "ageM:d"

Visual Filters by File Types

You can filter certain file types, e.g. image, using the syntax {:Type}, for example {:Image}. This spares you typing long list of extensions (*.png; *.jpg; *.psd; ...). The following types are supported:

{:Text} *

{:Image} *

{:Audio} *

{:Video} *

{:Media} * = Audio & Video

{:Font} *

{:Vector}

{:Web} *

{:Office} *

{:Archive}

{:Executable}

Examples that can be pasted right into the Address Bar:

|{:Image} Show only image files in the current location

D:\|{:Text} Show only text files in the root folder D:\

Note:

The types marked * in the list above can be customized in Configuration | Previewed Formats.

Power Filters

The "Toggle Visual Filter" toolbar button got an arrow dropdown featuring a set of predefined visual filters called "Power Filters", e.g. "Image Files", "Modified Today", "Empty Files" and many more. These filters can be customized in List Management.

Using Power Filters to Select Files

You can as well use the Power Filters menu to (un)select files by type, just like you know it from the "Type Stats and Filter" menu:

· Hold CTRL: Add all files of this type to the selection.
· Hold SHIFT: Remove all files of this type from the selection.

The actually applied selection filter patterns are displayed in the Status Bar.

Note, however, that more complex Power Filters (age, size, attr) are not supported here.


Report

Info Panel: Report

Report tab

You can create two sorts of reports: Current Folder reports are on folders and have basically the format known from the classic DOS directory dump, Current List is on the stuff currently listed in the Listbeing either the contents of the current folder or the results of a previous file find.

All reports can be sent to a popup text box (To Popup), the clipboard (To Clipboard), to an ASCII text file (To File), or directly to the printer (To Printer).

The interface for reports is found on the Report Tab on the Info Panel. It's subdivided into two tabs, Current Folder and Current List:

Current Folder

You have the choice here between quite different things:

Classic directory dump

Mimics the classic DOS way of listing directory contents. Additionally includes file version information for those file who actually got a version info. Example

Version Info: Additionally you can have version information included, and choose between String Version Info (which is more commonly used) and Fixed Version Info (which is claimed to be more exact). This concerns only files that have version resources (*.exe, *.dll, etc.). Note that obtaining version information takes some time: if you don't need it, select No file version.

Basic info to CSV

Exports Path/Name, Size (Raw), and Modified Date for each file item in CSV-format.

CSV: CSV stands for "Comma-Separated-Values" (the actually used list separator is taken from the current locale, and is often not comma but semi-colon), a very simple database format which can be read and written by any ASCII editor. CSV-files can be easily imported for example to Excel tables or Access tables or probably any table format existing. This feature makes XYplorer a superb tool for exhaustive file system documentation. Will save you not hours but days!

Extended info to CSV

Exports extended file information of whole directories (or even directory trees) in CSV-format. The exported info includes all data shown on the Properties and Version tab in the Info Panel. Example

Metadata to CSV

Exports the complete set of metadata (also known as "Extended Properties", and identical to the fields used in File Info Tips) in CSV format. The first line has the field names (column headers). The first field "Path" has been added to the standard set.

This is the "total report". Everything that the system knows about a file is exported in a well-defined, easily processable, and widely portable file format. It's the documentation junkie's wildest dream come true.

Tree structure only

The other type of folder report mirrors what you see in Tree. Example

Include subfolders: report includes all subfolders (and their subfolders, etc.) of the current folder. When you do a structure report you would normally check this box.

Tip Straight Directory Print: choose Classic directory dump, uncheck the Include subfolders checkbox and press the To printer button.
Tip You can abort a running report process by pressing Esc (Escape Key).

Current List

Reports the List as is. That is, the current column order, visibility, and item sort order is exactly reproduced in the report. This report is your choice when you want to document find results or make a detailed snapshot of the current state of your system directory.

Selected items only: kind of self-explaining ...

Output header format

Current date Adds the current date to the top of the report.

Path (Find settings) Adds the current path to the top the report.

In Find mode: adds the find parameters of the last File Find to the top the report (does only make sense, when you just made a File Find, of course).

Column headers Adds the column headers to the report.

Subitem separator

Tab separate items by Tabs

Other separate items by any chars of your choice

Padd blanks separate items by right-padding blanks: the current column widths are reproduced (as good as it gets) in the report (example).

Tip Make sure the columns are adjusted to the lengths of their contents to get a straight result with this option (to do this, either dbl-click the line number column header, or choose the Adjust All Column Widths (Ctrl + Numpad Add) command from the column headers context menu).


Folder View Settings

Introduction

Folder View Settings (FVS) is the commonly used label for a feature that allows you to associate certain folders with certain view settings. It should really be called "Save and Automatically Restore Folder-Specific View Settings" but that wouldn't look good in a menu.

You know this feature from Windows Explorer: You can save the view settings (view type, sort order, column layout...) of any particular folder and have them automatically restored whenever you come back to this folder. It's a great time saver when e.g. column widths, sort order, or thumbnails view are remembered and automagically adjusted for you.

Of course, the settings are retained between sessions. They are stored in a data file named fvs.dat which is located in your application data path.

Basic Usage

The usage could not be easier: You like the settings of the current folder and want to preserve them? Use the command Save Folder View in menu View | Folder View Settings.

Or even simpler: Use the toolbar button for Folder View Settings (shaped like letter F). And if you ever want to get back to default settings, simply press the button again. The toolbar button also shows you the state of affairs. If there is a Folder View assigned to the current folder, the button is in pressed state.

How it works

What is saved. The following view settings are saved by default with each folder view:

(1) View mode (details, thumbnails...)
(2) Sort order (column, direction)
(3) Column layout (positions, widths, visibility)
(4) List style (line numbers, auto-size, grid...) (see menu Tools | Customize List)

Optionally a Visual Filter can be saved that will be applied to the folder.

What is restored. You will see later that you can further configure which of these settings are actually restored on a per-folder basis.

When it is restored. If FVS is enabled and you go to a folder for which you have previously saved the view settings, then those settings are restored.

Note that XYplorer's multi-tabs also store view settings, of course. When going to a folder via tab switch, the tab's memory is valued higher than any associated Folder View. This way it is ensured that you always find a tab in the state you left it. The same is true on application startup: The last state will be exactly restored regardless of any active Folder View.

Advanced Usage: Editing a Folder View

You can customize the active Folder View using the Edit Folder View dialog (menu View | Folder View Settings | Edit...). Here you can basically modify two things: which folder(s) are associated with the given Folder View, and which of the saved settings are restored.

How Folders Are Identified

Folder to apply the settings to. Folders are identified by their full name, or by a wild-carded pattern. By using a pattern e.g. like *\Images* you can define a common Folder View all folders named "Images". Note that it's also possible to state a list of patterns separated by | (pipe). An example for a list of patterns would be *\Images*|*\Pics*.

If more than one folder view matches the current folder, then the Best Match Algorithm will decide (see below).

Include subfolders. Check to apply the folder view settings also to all subfolders of the matching folder.

Match case. If checked a pattern *\Images* would not match a folder D:\images.

Tip: You don't need to add a trailing backslash "\" to your patterns. XYplorer knows that this is about folders and cares for it. So a pattern "C:" will match folder C:\.

Folder View Settings with Visual Filters

Visual Filter to apply to the folder. Here you can define a Visual Filter that will be applied to the folder.

Tip: When you select the Save Folder View command from the main menu any active Visual Filter is automatically stored along with the other Folder View Settings.

Which Settings are Restored

Applied Settings. Here you can define per-folder (respectively per-folder-view in case of a wild-carded pattern which applies to many folders), which of the following settings are restored:

(1) View mode (details, thumbnails...)
(2) Sort order (column, direction)
(3) Column layout (positions, widths, visibility)
(4) List style (line numbers, auto-size, grid...) (see menu Tools | Customize List)

For the settings that are not restored, the Default Folder View is used (see below).

Auto-Save Changes. If checked then any manual changes to the current folder's view (e.g. you alter a column width) are automatically stored to the active folder view and will be remembered the next time you come back to the folder.

Make Default. Make the current selections the default for new Folder Views. Note that the "Auto-save changes" setting is also part of this default. The factory default is: All options ON, but "Auto-save changes" OFF.

Best Match Algorithm

If more than one folder view matches the current folder then the best match is determined like this:

(1) Match ranking from best to worst in 4 groups: Full Match > Pattern Match > Full Match Including Subs > Pattern Match Including Subs.
(2) If more than one pattern matches within one group, then the longest pattern (character count) wins.

This way you don't have to care about manually sorting the Folder Views (which could be a lot of work if there are hundreds of them!).

Apply this Folder View Also To

The command Apply this Folder View Also To... will open the same dialog as Edit.... The only, but important, difference comes up when you press OK. When the dialog was invoked by Apply this Folder View Also To... any currently active folder view will not be overwritten when you have defined a different name/pattern.

The Default Folder View

By using the command Define this Folder View as Default you can define a Default Folder View (DFV) for all folders with no associated specific folder view.

Note that even if you do not define a DFV, an internal default folder view is always applied if no specific folder view is active! The advantage of saving an explicit DFV is that you can configure it using Edit Folder View dialog, i.e. you can determine which settings are applied and whether Auto-Save Changes is enabled. The internal default folder view always restores all settings and auto-saves all changes.

Further Remarks

Portability of Folder View Settings

Folder specifications support portability, however in a slightly restricted way since wildcarded patterns are allowed as well, so ambiguities have to be avoided.

If XYplorer is at C:\Programs\XY\XYplorer.exe then

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Pattern is resolved to

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

MyFolder C:\Programs\XY\MyFolder\

.\MyFolder C:\Programs\XY\MyFolder\

..\MyFolder C:\Programs\MyFolder\

..\..\MyFolder C:\MyFolder\

..\MyFolder* C:\Programs\MyFolder*\

?:\MyFolder C:\MyFolder\

D: ... [unchanged: not relative]

\\ ... [unchanged: not relative]

*MyFolder* [unchanged: is pattern]

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Note that "..\MyFolder*" is resolved because the initial "." (dot) is interpreted as "Please, resolve this relative path!".

Browse mode only: Note that FVS is only implemented for browsing folders. Not for the drives listing, and not for search results listings.

Menu Commands. See Folder View Settings (Submenu).


Mini Tree

A Tree-Shaped History

The Tree is a great user interface for file management... but it quickly becomes a problem when it's too large. And isn't it always too large? Much too large?? How many of the displayed folders do you really need to see? 20%? 10%? Maybe just 5 out of 400?

This is where Mini Tree comes to the rescue. It's an extremely simple idea, but it might change your way of browsing the file system forever: The Mini Tree displays only the paths you have actually used. This makes browsing blindingly fast (it's instantaneous even with deeply nested subfolders), it makes the tree ridiculously small, and it makes you feel like being back in control (because you look at just the folders you are actually using, instead of being avalanched by all the folders that have accumulated on your drives over the years).

Usage

You turn it on/off in menu View | Mini Tree. Immediately the tree is reduced to the current folder. You now typically use Favorites, History, Recent Locations, the Hotlist, the Catalog, the Address Bar, or the file list to jump to another location. It will be added to the Mini Tree automatically. Soon, the Mini Tree will show the locations you actually need. It has learned.

Features of the Mini Tree

(1) The Mini Tree is retained across sessions: When you start XYplorer on Monday you'll look at exactly the same tree you left Friday afternoon.
(2) You can easily hide folders from the Mini Tree via the context menu command "Hide Folder".
(3) There's the scripting command loadtree by which you can load a previously stored Mini Tree, add folders to it, or remove folders from it.
(4) The Catalog supports storing and restoring Mini Trees via its context menu.
(5) There's a toolbar button "Mini Tree" which works as a one-click toggle between Mini Tree and normal tree (Maxi Tree). The button also features a context menu with a couple of related commands.
(6) The extreme speed and smallness of the Mini Tree makes it especially valuable for network browsing. If you work in an environment with hundreds or thousands of servers, you might welcome the idea of seeing just the two servers you actually need...
(7) If you fully collapse a tree folder (Numpad Divide, or Ctrl+Click the minus-icon of the folder) it is not only collapsed but reset to initial state: When you expand it in the tree it will do a fresh browse and show all existing subfolders.
(8) The Mini Tree is distinguished from the normal tree by inverted plus/minus icons (white-on-blue).
(9) Pressing Shift+F4 (Refresh Current Folder) will list all existing subfolders of the current folder. So you can quickly inject some reality into your Mini Tree.
(10) If the current node is Computer, then pressing Shift+F4 (Refresh Current Folder) will reset the Tree and list all child folders of Computer in collapsed state while keeping the tree in "Mini" mode.
(11) Pressing F4 (Refresh Tree) will it will take care that all available drives are shown, and it removes all non-existing childs.
(12) Via menu Tools | List Management you can directly edit the Mini Tree.

Tree Node Crumbs

Right-click the plus/minus symbol of a folder to pop a list of all child folders of that folder. That way you can select any child folder of a visible folder without opening the whole node. This is especially useful in the Mini Tree. See also here.

Toolbar button "Mini Tree"

The button has a context menu with some Mini Tree related commands.


Custom File Icons

Custom File Icons (CFI)

Introduction

Custom File Icons means you can define which icons are shown for files and folders within XYplorer.

The customization does not change the system at all (other applications will still show the standard icons). All information is stored within XYplorer.ini and thus is fully portable. This means you now can take your file icons with you and have the same icons on any host system. Hence this feature is also called Portable File Icons (PFI). Needless to say that PFI nicely complements the Portable File Associations (PFA) feature.

How to Customize Your File Icons

Open the interface to customize the file icons via menu Tools | Customize File Icons... Alternatively you can use Tools | List Management | Portable File Icons...

To (de)activate the feature (un)tick Configuration | Refresh, Icons, History | Icons | Enable custom file icons.

Rules

· Custom icons can be assigned to generic file types (e.g. "*.png"), to specific file names (e.g. "Readme.txt"), and also to specific files ("C:\pagefile.sys"). Actually to any wildcard pattern your fantasy is able to create.
· Custom icons can also be assigned to folders, drives, servers, and shares. For this to work the patterns must end with a backslash.
· Custom icons can also be assigned to special folders. In this case the matching is case-sensitive and the patterns should NOT end with a backslash and have no wildcards. Actually it is recommended to use environments variables for the patterns since these names are system-specific. Supported are the following six special folders: %computer%, %desktop%, %personal%, %user%, %net%, %recycler%.
· General syntax for a CFI definition:
"Caption" Pattern(s)>Icon Source
The caption is optional and has no function anywhere in the GUI. You might use it as a place for personal comments.
· You can create as many CFI definitions as you like.
· You can assign one or more pattern to an icon source, separated by "|" or ";", e.g. *.jpg;*.png.
· Patterns support XY native and environment variables.
· Matching is case insensitive (A==a).
· The patterns are tested from left to right, top to bottom. The first match wins.
· The patterns are matched against the whole path of the item that wants an icon. Wildcards *, ?, and # are supported as well as character groups (e.g. [2-8] or [a-f]).
A bit of built-in smartness auto-adds implied wildcards, so e.g. "test.txt" would match all files called "test.txt" in any location because the pattern in internally completed to "*\test.txt" to match the whole path of the items in question.
· You can as well state whole filenames or even full paths as pattern. If you don't provide any wildcards then by default an asterisk (*) is prefixed to the pattern internally (unless the pattern is a full path).
· Use "*." as pattern for files without any extension.
· You can also customize the generic icon for files of an unknown file type, i.e. those files that would normally show the default system icon for unknown file types. The pattern to be used for this is "*?".
· You can also customize the generic icon for folders, in normal and selected state (the later is only used in the Tree). So you can have Win8 folder icons in WinXP or vice versa, or whatever other icons you prefer to see. The pattern for the generic folder icon is "*\", the one for the selected state is "**\". If no generic icon for the selected tree folder (**\) is defined, then it defaults to the generic icon for all folders (*\) if one is defined.
· Portable syntax is supported: Use the "?:\" notation to refer to the drive of this XYplorer instance. Relative paths are resolved relative to the path <xyicons> (= the "Icons" subfolder of XYplorer's application data folder).
· Anything that has a system icon (the icon shown in the file list) can be stated as custom icon source, typically you would take either executables or *.ico files. The icon source can be stated as full path, portable path, or ProgID ("Notepad"). Even XY native and environment variables are supported.
· If an icon is not found, the definition is skipped (ignored).
· Changing icon definitions or enabling/disabling the feature all works smoothly, ultra-fast, and on the fly. No restart required.
· Customizing file icons is a one-time job. Once you have customized your icon associations there is nothing else to do or to learn. The feature is simply there for you and works for you. All you have to do is sit and watch. As simple as TV.

Tips

In the Customize File Icons dialog you can dbl-click an item to trigger the Browse... button an select a new icon.

A Bunch Of Useful Patterns That Will Start You Off

%computer% matches the Computer special folder

%desktop% matches the Desktop special folder

%personal% matches the Personal special folder

%user% matches the User special folder

%net% matches the Network special folder

%recycler% matches the Recycle Bin special folder

E:\ matches drive E:\

E:\*\ matches all folders in E:\

E:\ /r matches all folders in E:\ and E: itself

E:\Jobs\*\ matches all folders in E:\Jobs\

[F-L]:\*\ matches all folders on drives F-L

*\ matches all folders that have no specific icon

**\ same as above for the current tree folder

pics\ matches all folders named "pics"

E:\* matches all files in E:\

pics\* matches all files in folders named "pics"

pics*\* matches all files in folders beginning with "pics"

*.jpg;*.png matches all JPG and PNG files

*.fnd matches all FND files and is used for Search Results

*. matches all files with no extension

*? matches all files of unknown file type

*23* matches all files containing "23" in the name

*2013*.txt matches all TXT files containing "2013" in the name

readme.txt matches all files named "readme.txt"

<xyicons>\* matches all files in the default Icons folder

\\Wagner\ matches server "Wagner"

Switches

A couple of optional switches provide advanced possibilities. Switches have to be appended to the pattern list separated by a single space. Switches can be combined in any order (e.g. /dr or /rd) and apply to all patterns in the pattern list.

Switch /d

A switch to spare folder icons from customizing where the folders are already customized using desktop.ini. The switch is "/d" and it has to be appended to the pattern list separated by a single space. It applies to all patterns in the pattern list.

Examples:

a*\>Red.ico [assign red.ico to all folders beginning with "a"]

a*\ /d>Red.ico [the same, but skip folders with a desktop.ini custom icon]

Switch /r

A switch to assign a folder icon also to all subfolders of a folder.

Examples:

code\>Green.ico [assign red.ico to all folders named "code"]

code\ /r>Green.ico [assign red.ico to all folders named "code" and their subfolders]

Icons for the Selected Tree Folder

You can also define special icons for the currently opened/selected tree folder. So in the folder tree, each item can be assigned two icons, one for the normal state and one for the open state. In the CFI definition simply append the desired open state icon to the normal icon, separated by a "|" (pipe).

Some examples for defining the normal and the open state icon for all selected tree folders in drive E:\:

E:\*\>pot.ico Show pot for normal and for open state

E:\*\>pot.ico| Show pot for normal, system default for open state

E:\*\>|honey.ico Show system default for normal, honey for open state

E:\*\>pot.ico|honey.ico Show pot for normal, honey for open state

Notes:

· The Customize File Icons dialog does not fully support the double-icon syntax. The icon is not displayed in the list, and the "Browse..." button will only set the normal icon, so you will have to type or paste the open state icon name.
· If no open state icon is defined the normal icon is used by default.
· The open state icon is only shown in the Tree. Its typical use is to make the selected folder stand out from the crowd.
In post-XP Windows Explorer this functionality has been completely dropped. Now you have it back in XYplorer.

Exclusions

You can exclude certain folders and files from the customization and show them with their standard icons. To exclude all items matching a pattern simply leave the icon source empty in the CFI definition. Examples:

E:\*\ exclude all folders in E:\

E:\ /r exclude all folders in E:\ and E: itself

pics\ exclude all folders named "pics"

E:\* exclude all files in E:\

pics\* exclude all files in folders named "pics"

pics*\* exclude all files in folders named "pics*"

*23* exclude all files containing "23" in the name

<xyicons>\* exclude all files in the default Icons folder

Of course, the exclusions will only take effect when they match before any customization patterns, i.e. when they are positioned higher in the list of definitions.

By the way, adding the separator ">" after the pattern is optional and makes not difference.

Examples

For testing you can paste these examples into Tools | Customize File Icons... (toggle to Editor mode first!). The icons are given without path so they should be located in the Icons subfolder of the application data path.

Of course, for these examples to work you first need to get hold of ICO files with matching names!

+%computer%>cup_coffee.ico

+C:\WINDOWS\>machine.ico

+"XYplorer Configuration Files" <xypath>\*.ini;<xydata>\*.ini>rubberduck.ico

+"XYplorer Script Files" xys>xys.ico

+"XYplorer Icon Path" <xyicons>\>SmileyHearts.ico

+*\>Blue.ico

+**\>Blue_Open.ico

+code\>Green.ico

+docx>D:\Programs\OpenOffice.org 3\program\swriter.exe

+xy*\>xy.ico

+"No Extension" *.>Notepad


Customize Keyboard Shortcuts

Introduction

Open the Customize Keyboard Shortcuts dialog by menu Tools | Customize Keyboard Shortcuts (Shift+F9). The dialog largely follows the de facto standard for such interfaces in Windows applications, so you’ll immediately find your way.

Remarks

You can use any combination of Ctrl/Shift/Alt (incl. none) with any key on your board (with a few obvious exceptions, see next).

Some special keys like the Windows key, the Context Menu key, and the Numlock key are not available for customization. They are not used at all by the program.

Also the Tab key, the Space key, and the eight navigation keys are not customizable: they are internally hard-coded to their traditional tasks in navigating the GUI, and cannot be assigned nor removed by the user. Exceptions: Tab can be used in all combinations with Ctrl. The Space key and the navigation keys can be used in all combinations with Alt.

Note that shortcuts of the form Alt+Key may generate a beep sound since they interfere internally with the so-called menu accelerators.

You can assign as many different shortcuts as you want to each of the functions.

You can also assign shortcuts to (non-clickable) menu items heading a submenu. On pressing the shortcut the submenu will pop-up at the current position of the mouse cursor.

You may also press new shortcuts while the focus is in the Commands list. Press <Enter> (or click Assign) to assign a new shortcut to the selected command. Press <Del> (or click Remove) to remove an existing shortcut from the selected command.

Click Default to add the factory default shortcut to a command.

Commands list context menu

The Commands list got a little context menu where you can copy the selected command to clipboard in various formats.

You can as well trigger any command right from here by chosing Close Dialog and Trigger Command. This is especially useful with the miscellaneous commands, which are not available anywhere else. You now can use them without having to assign a shortcut first.

Button "Options..."

The button pops a tiny menu with a couple of useful commands.

Copy Cheat Sheet. Create and copy a cheat sheet of all current (where "current" is the current state of the CKS dialog, even if it’s not OK-ed yet) shortcuts and commands in various layouts and sorting orders.

Reset All Shortcuts To Defaults... Sets all shortcuts back to factory defaults.

Reset Unused Shortcuts To Defaults... Will assign those shortcuts to their factory default function that are currently unused. Might come handy when upgrading and new functions with default KS have been added.

Remove all Shortcuts... Well, removes all shortcuts.

Button "All Free Shortcuts..."

Pops a dialog presenting you all key combinations that are currently unused.

There's keyboard support. You press your desired key (including Ctrl, Shift, Alt combinations) and if it is in the list, it will be focused. Otherwise, if at least your key (without Ctrl, Shift, Alt) exists, its first occurrence will be focused. The Enter, ESC, and cursor keys are excluded from this service to keep the dialog efficiently usable for keyboard users.

Button "Jump..."

Allows you to directly to jump to a command via a filtered list, similar to the "Jump to Setting" button in Configuration.

Portable Storage

The shortcuts are saved in the application path in a binary file called "ks.dat". This allows you to carry your personal keyboard shortcut set with you.

Category “Miscellaneous”

This category contains commands that do not actually have any interface/menu (and, therefore, can only be triggered using the shortcuts assigned to them).

Scope

Each function has its scope: only if the focus is within that scope pressing the shortcut will actually trigger the command. The scope can be Global (not restricted), or limited to certain parts of the interface like Tree, and/or List, etc.


Custom Context Menu Commands

Tree Context Menu Commands

Configurable in Configuration | Menus, Mouse, Safety | Context Menus | Custom items in shell context menu | Folder Tree.

Open in New Tab

Opens the right-clicked folder in a new tab.

You can as well "Open in New Tab" by simply holding Shift when clicking a tree node.

Open in New Background Tab

Opens the right-clicked folder in a new tab without actually selecting the tab and listing the folder's contents.

You can as well "Open in New Background Tab" by simply holding Ctrl when clicking a tree node.

Open in Other Pane

Will open the selected folder in the other pane (whether that pane is visible or not). Note that it also works when right-clicking a folder other than the current folder.

Shortcut: Alt+Click

Create New Subfolder Here

Creates a new subfolder to the right-clicked folder, selects it, and invokes rename mode.

Shortcut: Ctrl+N

Copy Path

Copies the full path of the right-clicked folder to the clipboard.

Shortcut: Ctrl+P

Empty Folder

Empties the right-clicked tree folder.

Hide Siblings from Mini Tree

Removes all siblings (folders under same parent) of the current folder from the Mini Tree.

Open Command Prompt Here

Opens a command prompt in the right-clicked folder.

Shortcut: Ctrl+Alt+P

Expansion (submenu)

Fully Collapse: Fully collapses the right-clicked folder.

Shortcut: Numpad Divide, or Ctrl+Click the minus-icon of the folder

Fully Expand: Fully expands the right-clicked folder.

Shortcut: Numpad Multiply, or Ctrl+Click the plus-icon of the folder

Fully Collapse Drive: Fully collapse current drive. The drive root will automatically be selected.

Shortcut: Ctrl+Numpad Divide

Optimize Tree: Only expand the current path, collapse all other paths.

Shortcut: Shift+Numpad Divide

Mark (submenu)

Contains various commands for highlighting folders.

Move/Copy/Backup To

Contains commands for file operations.

See menu File | Move To.

Add Folder to Toolbar

On selection a new Droppable User Button is appended to the right end of the Toolbar pointing to the folder. The command is only available if the Scripting feature is enabled.

List Context Menu Commands

Configurable in Configuration | Menus, Mouse, Safety | Context Menus | Custom items in shell context menu | File List.

Open in New Tab [folders only]

Opens the selected folder in a new foreground tab.

Open in New Background Tab [folders only]

Opens the selected folder in a new background tab.

Open in Other Pane [folders only]

Opens the selected folder in the other pane (whether that pane is visible or not)

Empty Folder [folders only]

Empties the right-clicked folder.

To Clipboard

See menu File | To Clipboard.

Rename Special

See menu File | Rename Special.

Zip

Zip View: The contents of the selected archive are shown in a list. You get four columns: Name, [Path,] Size, Modified.

· The items are sorted by path/name ascending.
· The items can be live-filtered to quickly find a particular file in an archive.
· Encrypted archives are marked as such in the top section of the dialog, and with a "+" behind the filenames.
· You cannot extract from or add to the zip via this interface, it's merely a view.
· The dialog shares size and position with the Quick File View.
· If you opened the preview by F11 you can also close it by F11 (or whatever other KS you have assigned to Floating Preview).
· The dialog is non-modal, so you can leave it open and preview Zip archives by simply selecting them in the file list.

Extract Here: Extracts the selected archive here. If more than one zip archive is selected only the one owning the context menu is extracted.

As a special service the command "Extract Here" also shows the top level folder, e.g. "Extract Here (Icons\)", if all contents of the archive are internally subsumed under one top level folder. This tells you that you can safely use "Extract Here" without making a mess of your current location.

Extract to {Folder}: {Folder} is auto-generated from the name of the archive, and auto-suffixed on collision.

Paste into this Zip: Lets you paste the items in the clipboard into the right-clicked zip file.

Add to Zip Archive...: Lets you add items to an existing or new archive. You are prompted for a name for the archive.

Add to {Zipname Item}: {Zipname Item} is auto-generated from the item owning the context menu, and auto-suffixed on collision.

Add to {Zipname Parent}: {Zipname Parent} is auto-generated from the parent folder of the item owning the context menu, and auto-suffixed on collision.

Note that Zip Support needs Zip Folders enabled in Windows (which it is by default).

Move Up

Moves the selected items to the folder above the current folder.
In search results the selected items are moved to the folder above their current location. If the selected items are in different locations, the command is disabled.

Open With...

Pops the Portable Open With menu.

Replace with File in Clipboard [files only]

Replaces the contents of the selected file with the contents of the file in clipboard. The selected file keeps its filename, just the contents are updated. Notes:

You are prompted before the replacement happens.

The action cannot be undone, always runs in the foreground, and is performed by kernel API (no Custom Copy or Shell Copy involved).

The file in clipboard is not deleted even if it had been "cut" to the clipboard.


Custom Drag'n'Drop Context Menu

Custom Drag and Drop Context Menu

Note

To show the Custom Drag and Drop Context Menu you have to check Configuration | Menus, Mouse, Safety | Custom Drag and Drop context menu. Else the standard Shell Context Menu is shown.

Custom Drag and Drop Context Menu Commands

Move Here

Move dragged stuff to drop location.

Copy Here

Copy dragged stuff to drop location.

Duplicate a file: If you want a copy/duplicate of any file, drag it with right-click just a little bit (you don't need to drop the file in another place). On mouse up, a popup menu will open with all sorts of copy, backup, create and move operations - even more than in the File | Duplicate submenu. Choose Copy Here to create a duplicate in the same location as the original.

Copy/Move Here As...

Allows you to create a renamed copy of the dragged file. The command is available only if exactly one file is drag-dropped, respectively, when triggered by keyboard, applies only to the focused file. If source and target path/file are identical, the copy is auto-renamed to "Copy of Original Name" (auto-rename scheme varies depending on Operating System locale).

Shortcut for Copy Here As: Ctrl+S (think "Save As...")

Copy/Move Here With Number

Creates auto-serial-numbererd duplicates of the dragged file(s). Examples:

My.txt => My-01.txt

My.txt => My-02.txt (if My-01.txt already exists)

My.txt => My-03.txt (if My-01.txt and My-02.txt already exist)

etc.

Shortcut for Copy Here With Increment: Ctrl+D (think "Duplicate")

Copy/Move Here With Current/Last Modified Date

Makes a copy [respectively move] of the selected item(s) and automatically appends the last modified date [respectively current date] of the copied/moved item(s) in a format defined by a template. Date-stamped copies are very, v-e-r-y, useful when working with versions. If an item by the new name already exists, auto-incremented numbers are suffixed.

Shortcut for Copy Here With Last Modified Date: Ctrl+Shift+D (think "Duplicate Dated")

Copy/Move Here to New Subfolder...

Usage:

(1) select any number of files
(2) right-drag them somewhere
(3) click "Move (Copy) Here to New Subfolder..." in context menu
(4) dialog opens, enter new folder name, click OK
(5) this folder is now created under the dragged-to folder...
(6) ... and the selected files are moved (copied) into it

You are presented an array of 4 possible default names for the new subfolder about to be created. The first three are (can be) defined in the [NewTemplates] INI section. Here's an example:

  [NewTemplates]

  Folder0=\N\e\w \F\o\l\d\e\r   'date/time sensitive, shortcut Ctrl+N

  Folder1=yyyymmdd              'date/time sensitive

  Folder2=yyyy-mm-dd            'date/time sensitive

The fourth is made from the first item to be moved [copied, pasted] into the new subfolder, i.e. the item that was focused in the moment of cutting, copying, dragging. The index of the last selection is remembered between sessions.

Tip: You can as well define a whole new subpath (e.g. download\2008\new) as target. It will be created on the fly (if necessary).

Tip: The forward slash "/" is supported as alternative folder separator. It will be auto-converted to "\".

Tip: The dialog suggests the last used Selection Filter as new subfolder name, if that filter is a valid filename, and if it was used less than 2 minutes ago.

Copy/Move Here with Path...

Copy or move items together with parts of their path. In other words, the copies will end up somewhere deeper below the actual drop target depending on your choice.

The dialog offers you a complete set of path choices auto-generated from the drop target and the source item(s). Any non-existing subpaths will be silently created in the target; non-existing paths are marked by the "New Folder" icon in the dialog (unless the target is a network location, where the standard icon is shown for better performance).

Note that in the dialog there is some smartness at work: The path which XYplorer thinks you are likely to choose is preselected. E.g., if you drag directly onto a drive root (or network share), the path that will mirror your source path is preselected. Of course, you can change the preselection, and even type in a different path from the ones offered in the dropdown (it has to be located below the drop target though).

The same functionality is available for pasting from clipboard in menu Edit | Paste Special | Paste Here with Path....

These commands come in very handy when restoring or updating individual files from one deeply nested place to another one.

Rich Move Here

Move dragged stuff to drop location, recreating the source's folder structure in the destination folder. This command is only available in this context menu and only when dragging find results. See details.

Rich Copy Here

Copy dragged stuff to drop location, recreating the source's folder structure in the destination folder. This command is only available in this context menu and only when dragging find results. See details.

Backup Here

Backup dragged stuff to drop location. See details.

Create Folder(s) Here

Drag a folder (or several folders) onto a target location and create a copy of this folder without any of its contents in the target location. It's the flat version of "Create Branche(s) Here" (below). Very handy feature to quickly create some folders by simply drag-dropping them to their birth-place.

Create Branch(es) Here

Drag a folder (or several folders) onto a target location and create a copy of this folder and all nested folders below it in the target location, without copying any contained files. What you get is a perfect copy of a tree structure, completely empty.

Note This operation obviously will only work when you drag folders, not just files. If you forget, you will be kindly reminded.

Extract Here

Extracts the dragged archive here.

Zip Here

Creates a Zip archive from the dragged items here.

Go to Dragged Item

Will go to the dragged item's containing folder and select the item, or simply open the folder if the item is a folder. If more than one item is dragged the first item is taken.

The command is only available for the List and the current Tab of the active pane. But, of course, each hovered tab becomes the current tab after a configurable while.

Main usage is probably when dragging items or paths from other apps into XYplorer. It's a kind of "Go to by Drag and Drop".

Shell Context Menu

Show the standard Shell Context Menu.

Cancel

Abort drag and drop operation.

Drop on Zip

You can right-button-drop items into a zip file. A mini menu pops up with one command: Drop into Zip.

Drop-Text-To-File

Yet another revolutionary XYplorer-only feature. Now you can drag & drop a text chunk onto Tree, List, Catalog, or Tab header, where it will be automatically converted into a *.txt-file called something like "DroppedText-20061007.txt". The "-20061007" part is the date now (format defined in INI at key PostfixDate). After creation of the file, rename-mode is invoked. Try it, for example, with your web browser. Select a piece of text on a web page and drag it onto XYplorer...

Tips

Now you can do some pretty amazing things, for example:

(1) You can drag-drop selected text bits from XYplorer's own Web and Office preview!

(2) You can drag-drop selected text bits from PDF documents and they will be saved as "Untitled[-##].rtf"!

(3) You can even drag-drop selected image bits (details of embedded images) from PDF documents and they will be saved as a BMP named to the full path/file of the source file!

(4) You can drag-drop images directly from web pages Browser-to-XYplorer.


Copying files with XYplorer

There are 3 different file copy commands in XYplorer, so here's a quick comparative overview.

Copy

The standard Windows file copy operation (the only copy Explorer can do).

Source: all currently selected files/folders in List (normal browse or find results), or the currently selected folder in Tree.

Target: all files contained in the source are copied to one and the same target folder. Any folders contained in the source are created below the target folder including all their contents.

Prompts: when a file or folder with the same name already exists in the target location, you are asked whether you want to overwrite the existing item. Your choices are Yes, Yes to All, No, or Cancel. If you answer Yes or No, you will be asked again every time this happens.

Issue 1: since there is no No to all button you'll have a hard time clicking Yes or No when doing a large synchronize job. This issue is one of the reasons why there's the Backup command (see below).

Issue 2: when using this command on find results of a recursive file find (subfolders included), the operation might lead to unwanted results: first, if the copy cargo contains files of the same name (eg. you might have found a lot of "index.htm" files in various locations), you'll face the overwrite prompt for every non-first file of the same name, since Copy puts all files to one and the same location; second, if the copy cargo contains folders, all their contents will be copied, too, although they probably do not all match your find criteria. This issue is one of the reasons why there's the Rich Copy command (see below).

Backup

Details of this command are described here.

Source: same as Copy above.

Target: all files contained in the source are copied to their relative path below the target folder (any needed subfolders are automatically created along the way).

Prompts: no prompts. If a file of the same name is found in the target location, it is only overwritten when it is older than the source file.

Issues: this command avoids Issue 1 (above).

Rich Copy

A special command only available in XYplorer: Copy find results along with their original folder structure. Details are described here.

Source: all currently selected files/folders in List, but only when find results are displayed.

Target: all files contained in the source are copied to their relative path below the target folder (any needed subfolders are automatically created along the way).

Prompts: same as Copy above.

Issues: this command avoids Issue 2 (above).


Rich Copy

Rich Copy/Move

Copy/Move items with their folder structure

Rich Copy (Rich Move) is a highly useful feature for archiving recursive search results or Branch Views: It enables you to copy/move files to a destination along with their folder structure, i.e. whatever directories are needed are automatically created under the destination path. You get a perfect image of the files as they were organized in their original location.

Note: You find the Rich Copy commands only in the drag and drop context menu. To do a Rich Copy, drag the selected items from the search results list to the destination folder (in XYplorer's folder Tree, in the file list, the Catalog, or a Tab header) using the right mouse button: On drop, a popup menu will give you the choice between normal and rich operations.

Note: Of course, Rich Copy commands will not appear when you drop outside XYplorer, e.g. to the Desktop! This is because Rich Copy is a feature of XYplorer, not of the Desktop.

Target folder structure

The target folder created by Rich Copy structure is defined by the path where you started the File Find and the target path of your copy/move operation. Example: let's say you do an Rich Copy of just one file, which you have found by doing a find starting in J:\Test\MyStuff\, and you drag and drop this file to E:\MyStuffArchive\, the new folder Dir1\ is created under the destination folder and the file is copied there.

Source: J:\Test\MyStuff\Dir1\Bvb.ico

Target: E:\MyStuffArchive\Dir1\Bvb.ico

As you see, for every file in the find results, the File Find start path is replaced by the target path of the operation.

If the File Find started in Computer, the drive letter of the found files is converted into a folder, eg:

Source: [Computer]J:\Test\MyStuff\Dir1\Bvb.ico

Target: E:\MyStuffArchive\J\Test\MyStuff\Dir1\Bvb.ico

Automatic Redundancy Removal

Recursive Search Results and Branch Views: In such "deep data" (where containers can be listed side by side with their contents) you will run into name collisions or other unwanted situations when you select e.g. a folder AND any of its contents and then copy, move, or delete the selected items. To avoid this there is smartness built-in which will silently remove any redundant items from the job before processing continues.

Automatic Rich File Operations

Any copy/move operation (drop, paste, to new subfolder, etc.) will check whether its direct sources are "rich" (= come from more than one folder), and then offer to do a Rich Copy or Move instead of the standard flat operation (where things might collide/merge).

An example for a Rich Paste would be pasting two files D:\Test.txt and E:\Test.txt in one go to F:\Target:

Sources:

D:\Test.txt

E:\Test.txt

Targets:

F:\Target\D\Test.txt

F:\Target\E\Test.txt

Note that "rich sources" typically come from recursive search results or branch views.

The root path for such a rich operation is the greatest common parent folder of the sources.

Scripting and Rich Operations

Note that the scripting commands copyto and moveto support rich operations.


Backup

Backup

What is called "Backup" in XYplorer is a highly customizable file copy operation. You don't necessarily have to use it for backing up files. "Backup" is just a label for an alternative copy, alternative to Windows's shell copy (which has so many pitfalls).

Where to find the Backup command

You find the backup command in various menus:

Backup Here in the drag and drop context menu (popped up when dropping files dragged with the right-mouse button).

Backup To in the Edit menu and in the file context menu (which as well available in the main window menu when any files are selected).

Backup To Other Pane in the Panes menu.

All those commands offer exactly the same operation (as it is configured in Configuration | File Operations | Backup Operations) and differ only in the way you choose your target.

The laws of backup

1st, copy only those files that need to be copied.

If a file does not exist in the target location, it will be copied.

If a file does exist in the target location, the target file will be overwritten only if it is older than the source file.

Note: This behavior ("Overwrite if newer") can be modified in Configuration | File Operations | Backup Operations.

2nd, recreate the folder structure of the source.

The folder structure of the backup will be an exact image of the source's folder structure.

3rd, have a documentation of the backup.

A log-file is optionally created for every backup operation, where every single file operation is exactly documented.

A progress dialog tells you exactly what's happening and provides you with a final report. Alternatively (progress dialog turned off) you get a status bar message after the operation is completed giving you a minimal summary report:

- new: files of that name did not exist in target
- over: files of the same name were overwritten
- skip: files were not copied, e.g. because they were older than files of same name in target
- fail: files that failed for some reason

Note: This behavior ("Show progress dialog", "Create log file") can be modified in Configuration | File Operations | Backup Operations.

4th, preserve all file dates.

The Backup file operation preserves all three dates (modified, created, accessed) in all copied files and folders.

Note: This behavior ("Preserve item dates") can be turned off in Configuration | File Operations | Backup Operations.


Undo/Redo

Undo & Action Log

Multi-level Undo/Redo

XYplorer gives you multi-level undo/redo for the file operations Move, Copy, Rename, Delete, and New. Up to 100 user actions are logged and can be undone at any point. They are even remembered between sessions so you can fix today what you broke yesterday.

Usage

Undo is your friend when something went wrong. A typical use for Undo is when you drag-moved some items into the wrong folder, maybe by a slip of the finger, the famous accidental drop. You might not even know which folder it was. With Undo, just one click will bring everything back to normal. Even on the next morning after having closed and restarted XYplorer.

Or a batch rename of 250 files went wrong. No problem: Undo it with one click.

Optionally you can perform a cumulative undo, which means that you can undo a whole bunch of actions with a single click. Or you can perform a non-sequential undo, which means that you can undo any particular action from your action history without undoing the actions that came after.

The default keyboard shortcuts are Ctrl+Z for Undo and Ctrl+Shift+Z for Redo. However, the superior interface for these tasks is probably the toolbar. Because the Undo and Redo buttons inform you about what will be undone/redone, either by a tooltip when hovering the buttons, or by a dropdown list of recent actions when clicking the buttons' arrows.

Things to keep in mind

(1) Undo only knows item names and locations, not data. It will not restore lost data.
(2) Redo is not the Undo of Undo but it will redo the original action.

What is logged and what can be undone

The following operations are logged and can be undone/redone:

- Move: Move To, Cut & Paste, Move Here As (...), etc.
Note that a command like "Move to New Subfolder" consists of two actions: (1) creating the subfolder, (2) moving the item. They are logged (and undone) separately.
- Copy: Copy To, Copy & Paste, Copy Here As (...), etc.
Note that Undo will delete the copies for good. Redo will not recreate the deleted copies but copy the originals again.
- Rename: Inline Rename, Batch Rename.
Note that a Batch Rename operation is logged as one action and can only be undone as a whole.
- New: Create New File/Folder, New Path, New Folders, New Items.
- Delete: Delete to Recycler.
Note that undoing a deletion of more than 5 selected items at the same time will take much longer (depends on the number of items in your Recycle Bin) than smaller numbers. This is caused by certain Windows behaviors (at least under XP).When you redo a deletion (i.e. delete again) there will be no confirmation prompt. When undoing a deletion results in a name collision you get an overwrite prompt.
- Create Folder(s)/Branch(es) Here.
Note that folders that should be created but were already existing will be permanently removed on Undo.
- Create Shortcut(s): Paste Special, Drag Context Menu.
- Rich Copy.
Note that Undo will remove the copied items, but it will not remove any created subfolders.

The following operations are logged but cannot be undone/redone:

- Delete: Delete (no Recycler), Wipe.
No Undo because it's gone. Use recovery software to undo (unless Wipe which cannot be recovered).
- Backup: Backup, Backup To, Backup Here.
No Undo because Backup is about overwrite/no overwrite. Either it cannot be undone, or there is nothing to undo.

How to Undo

The recommendations for best Undo results are:

- Trigger Undo immediately after the logged action. The closer you are to the action, the better your chances that it can be perfectly undone.
- Start with the youngest logged action.
- Move through the action log in tight sequence (no skipping).

However, XYplorer's Undo grants you all kinds of liberties:

- You can pick out any logged action and (attempt to) undo it, also known as non-sequential undo.
- You don't have to care about the original sequence of actions. This does not mean, of course, that any sequence necessarily works, but it *might* work.
- The action log is saved between sessions, so theoretically you can undo actions that were done months ago.

Of course, since all logged actions are happening within one file system, it should be clear that they are interrelated. So undoing action #2 might be impossible before having undone action #1, or undoing action #2 might make impossible to undo action #1 later.

The Limits of Undo

"A man can undo what a man can undo."

Just keep in mind that XYplorer's Undo is not a forensic recovery tool for lost data. Not a single byte that was overwritten or permanently deleted will be brought back to life by Undo. Always remember:

(1) Undo only knows item names and locations, not data. It will not restore lost data.
(2) Redo is not the Undo of Undo but it will redo the original action as if you would redo it manually now.

Here are some examples that should be obvious by now:

(1) Create a New File; Undo will delete it; Redo will create a file of that name again. If you put any contents to that file then they will not magically come back when you Redo the creation of the file. Same with New Folder.
(2) Delete a file for good (no recycle bin): Cannot be undone using Undo.
(3) Move/Copy a file and overwrite same named items in the target folder: The overwritten data are lost and no Undo will bring them back.
(4) XYplorer disallows that any data are overwritten by an Undo or Redo operation. So e.g. if you try to undo a move, but in the meantime a file of the same name as the originally moved file came to existence, the Undo will not happen. In case of undoing a delete to recycler the shell will pop an overwrite prompt.
(5) If you undo the creation of a folder, any contents the folder might have gathered in the meantime will be lost and don't come back by redoing the creation.
There's a configuration option to have undo/redo delete to the recycle bin. This might save your neck in case of an erroneous undo.
(6) If you undo a Copy and then Redo it, the copy will be made from today's state of the original source and thus will differ from the original copy if the source has changed in the meantime.

Further Notes on Undo/Redo

You can stop an ongoing undo/redo by pressing ESC.

Action Log

The Action Log is the database for Undo/Redo. It tells you in chronological order what you have done, when you have done it, whether it can be undone, or whether it has already been undone and can be redone. It's optionally remembered across sessions so you can finally find out what you did yesterday.

(1) Note that also actions are logged that cannot be undone. E.g. no-recycle-deletions: you can still see what items you have permanently deleted and when; information that can be very useful when trying to recover them using a recovery application.
(2) The Action Log currently holds a maximum of 100 entries, older entries are forgotten. The actual size can be lowered in configuration in case you want to save a little memory. But don't worry, it does not take much memory anyway, so it's recommended to leave it at the max.
(3) Note that you can undo actions right from the Action Log using the right-click menu.
(4) The Action Log works as a history where you can go back and forward and be at a certain position between both ends. Now when you go back (Undo - Undo - Undo - ...) and then trigger some logged action (e.g. delete a file), then the previous future branch is dropped in favor of the new one.
(5) In the Action Log Dialog the green highlighted item is the current item in action history. It's the action that will be undone when you click Undo. Usually it will be the top item, but it moves downwards when you undo actions. When the complete action history is undone you are in "Prehistory". Take care.
You can set any item to be the current action using the right-click menu of the Actions list.
(6) The action is limited to save resources: Only actions with 32,767 or less items (that's the directly selected items, not any folder contents) involved are stored in the action log and can be undone.
(7) The Action Log is stored in the file "actions.dat".

Icons in the Action Log

The two lists in the lower part of the Action Log show the items involved in the selected action, before and after the action. Items that exist at this very moment show an icon, items that don't exist show no icon. So for example with a Move operation, the upper list will typically show no icons (the items have been moved away from that location), and the lower list will show icons (if the items are still where they have been moved to).


Recycle Bin

Recycle Bin Deluxe

XYplorer's Recycle Bin special folder surpasses Explorer's Recycle Bin in a number of ways:

1. The real path/name for each item is displayed in a separate column "Recycled Name". Ctrl+P will copy that info to the clipboard.
2. The context menu's custom command "Go to Real Location" will beam you to the real location of the item and select it in XYplorer's raw recycle bin view.
3. The context menu's custom command "Go to Original Location" will beam you to the original location of the item.
4. You can open (Enter, Dbl-Click) a deleted folder to browse its contents.
5. You can show the recursive folder sizes of deleted folders right in the list (as usual in the Size column).
6. You can see the Space Used or Real Size of deleted items (Explorer shows only Space Used).
7. You get the exact time of deletion down to the second (Explorer only tells you the minute).
8. Apply Visual Filters to the Recycle Bin.
9. Sort folders separately from files.
10. Color code items in the Recycle Bin just like normal files.
11. Spot and jump to items
12. Compare deleted items.
13. Preview deleted items.
14. Open deleted items.
15. You can hide the node from the tree (Configuration | Tree and List).
16. And, last not least, it's faster.

Remarks

The Shell default action (Enter, Dbl-Click) for Recycle Bin items is to show the item's Properties dialog. This will happen in XY as well, unless you have a PFA defined for the file type in question.

The Recycle Bin is a pretty singular construct superimposed onto the regular file system and comes with a couple of pecularities:

- It is slower than "normal" folders.

- No drag from the Recycle Bin (but you can drop items onto the Recycle Bin to delete them).

- No renaming or cutting or moving or duplicating.

- No pasting.

- No custom File Info Tips, just the default ones.

The Len column refers to the original Path/Name, not to the Recycled Name.

The Info Panel refers to the Recycled Name because this is the file that exists, has properties, and can be previewed.

Raw Recycle Bins

The Recycle Bin special folder is a virtual folder that has its real base in a set of regular file system folders, one per volume (drive letter). Such a folder might be called "C:\RECYCLER\" under XP or "C:\$Recycle.Bin\" under Vista/Win7. This is where the deleted files continue their half-life until they get either restored or permanently deleted.

Contrary to Explorer, XYplorer allows you to browse these "Raw Recycle Bins" just like any normal folder. It is not recommended to delete any files out of a Raw Recycle Bin, unless you really know what you are doing! You risk corrupting the database underlying the virtual Recycle Bin.


Admin Settings

Admin Settings

You use XYplorer in your company and don't want your employees to check for updates? You don't want them to edit the user commands? You don't want them to change the configuration? All this and more is possible through Admin Settings.

You (respectively your administrator) simply place a file "Admin.ini" in XYplorer's application path. The contents of this file will control the layout and functionality of the application in a way that a user without admin rights cannot influence. XYplorer will read this file at startup but never write to it.

Section [Settings]

Key: Profile

For example, to hide and disable the Check for Updates feature, you simply enter this into Admin.ini:

[Settings]

Profile=64

Here's an overview over the available values and their respective effects:

8 Disable menu User | Manage Commands...
16 Hide menu Tools | Configuration...
32 Hide menu Tools | Open Configuration File.
64 Hide menu Help | Online Support (includes Check for Updates and other online functions).
128 Hide menu Help | Update Registration Details.
256 Hide clickable URLs in Help | About Box.
512 Disallow the user to modify tags (Labels, Tags, and Comments).

Now you simply add the values of the desired effects. For example, if you want to hide Tools | Configuration... (16), Tools | Open Configuration File (32) and Help | Online Support (64), you add 16 + 32 + 64 = 112 and use this value in Admin.ini:

[Settings]

Profile=112

Key: Lic

You can pass the full path (or relative to application path, all variables and portability supported) to a file where the license data are stored. This is quite useful when installing XYplorer in companies for large numbers of users that are covered by a single Corporate License, or when you have many parallel XYplorer installations on your machine.

Examples for the Lic key in Admin.ini pointing to a local and to a remote license file:

[Settings]

Lic="appdata\Lic.ini"

[Settings]

Lic="\\CentralServer\XYdata\Lic.ini"

The contents of Lic.ini (or whatever you call it) should look like this (fill in your license data between < and >!):

[Register]

Name=Your Registration Name

Code=Your Site License Key

If Lic.ini is not found, not accessible, or empty, then the procedure silently falls back to reading the license data from XYplorer.ini.

Keys: Name, Code

You can also place your site license key directly in the file Admin.ini. From here the key will unlock all XYplorer instances in the network.

[Settings]

Name=Your Registration Name

Code=Your Site License Key

This way is simpler than using the Lic key and makes the latter rather obsolete.

Section [Paths]

The section [Paths] can be used to overwrite some otherwise hard-coded data paths. The following keys are supported (here with sample values):

[Paths]

Catalogs=C:\CommonXYCatalogs\

NewItems=\\North\Share\XY\NewItems\

FileTagDat=\\North\Share\XY\CommonTags.dat

Usage

These settings can be used for example to share Catalog or NewItems resources, or file tagging (Labels, Tags, Comments) data across a network by different members of a team. Or to let different configurations (/ini=...) share the same resources respectively data.

The administrator is responsible for a sensible rights management. E.g. shared Catalogs or a shared tags database should be read-only for the normal user to avoid write conflicts.

The tags database can also be protected per-user via setting eAPDisallow_Write_Tags (512) in Admin.ini, which will deny the user to modify tags (Labels, Tags, and Comments):

[Settings]

Profile=512

Section [AccessControl]

Access Control is a powerful corporate feature by which an admin can easily control which locations can be accessed by the user of XYplorer. If this feature is enabled then browsing and file operations are only possible in, from, and to the explicitly allowed paths. Apart from locations you can also limit the kind of allowed file operations, and disallow certain program features.

Access Control is invoked using Admin.ini, a plain text file located in the path of XYplorer.exe. If it is not there yet, simply create it. Create with admin rights so that the normal user cannot modify it. The section name for Access Control related keys in [AccessControl].

Allow only certain locations

The key AllowedDirs can be used to allow operations only in certain locations. In this example, access is allowed only for Desktop, D:\, and E:\Test. Note that allowance includes all subfolders.

[AccessControl]

AllowedDirs=Desktop|D:|E:\Test

Any number of paths can be concatenated, separated by a | (pipe). If the key AllowedDirs is not empty then the Mini Tree mode is forced on the user.

Note that environment variables and XYplorer native variables are supported. That way you can easily assign account-specific user rights. For example, allow only the User special path and drive D::

[AccessControl]

AllowedDirs=%user%|D:

Disallow certain locations

The key DisallowedDirs can be used to disallow operations in certain locations. In this example, the user is allowed to operate anywhere apart from E:\Test and E:\Secret. Note that disallowance includes all subfolders.

[AccessControl]

DisallowedDirs=E:\Test|E:\Secret

Any number of paths can be concatenated, separated by a | (pipe).

If both keys, AllowedDirs and DisallowedDirs are given then the logic is like this: First AllowedDirs is checked; if the path in question passes then it is checked against DisallowedDirs. For example:

[AccessControl]

AllowedDirs=E:|F:

DisallowedDirs=E:\Test|E:\Secret

Result: The user is allowed to operate only in drives E: and F:, but not in the folders E:\Test and E:\Secret.

Note that environment variables and XYplorer native variables are supported.

Disallow certain file operations

The key DisallowedOperations can be used to disallow certain file related operations. The value is a made by OR-ing (here equivalent to adding) the values of the following bit field:

eAACFO_Move = 1

eAACFO_Copy = 2

eAACFO_Delete = 4

eAACFO_Rename = 8

eAACFO_New = 16

eAACFO_Open = 32

eAACFO_Tag = 64

eAACFO_ShellCtxMenu = 128

For example, to disallow Move, Delete, and Rename, add 1 + 4 + 8 = 13:

[AccessControl]

DisallowedOperations=13

Disable certain features

The key DisabledFeatures can be used to disallow certain program features. The value is a made by OR-ing (here equivalent to adding) the values of the following bit field:

eMdlScripting = 1

eMdlUDC = 2

eMdlCKS = 4

eMdlPFA = 8

eMdlCacheServers = 16

eMdlCatalog = 32

For example, to disable Scripting:

[AccessControl]

DisabledFeatures=1

Summary Example for Access Control

Here's an example for how to set up XYplorer to limit activity to Desktop and \\ServerB\Work, disallow Move, Delete, and Rename even in this allowed locations, and generally disable Scripting and User-Defined Commands (UDC). Create Admin.ini in the path of XYplorer.exe and paste this:

[AccessControl]

AllowedDirs=Desktop|\\ServerB\Work

DisallowedOperations=13

DisabledFeatures=3

Access Control Interface

When Access Control (AC) is active the title bar caption displays "[AC]" at its right end.

Also the status bar shows a button with the AC icon when AC is active. Click it to get some information about how you are limited by AC.

The menu popped by the AC status bar button has a toggle item "Use Status Bar for Messages". Check it if you need it. The setting is retained across sessions via the normal INI file, so this part of AC is customizable by the user.

Remarks

Access Control partly overlaps with the Profile key in the Settings section (see here above). A difference is that the latter has no interface or messages. It simply and silently removes features.


Portable File Associations

Portable File Associations (PFA)

Introduction

XYplorer can maintain private portable file associations independent of the global ones defined in the Windows registry. These associations are stored in the local INI file, which allows you to travel with your own file associations.

To define a private file association simply open "File Associations..." in menu Tools/List Management and add it to the list. The general syntaxt is: pattern>application, where pattern and application can have various formats. For example "extension>application (full path)":

png>C:\Programs\Viewer\Viewer.exe

png>?:\Programs\Viewer\Viewer.exe

The 2nd example is particularly interesting if you use XYplorer on portable drives: the little "?"-trick makes you independent of the local drive mappings! Double-clicking (or <enter>ing) a file in XYplorer will cause it to open in an application stored on your thumbdrive, independent (a) of the file associations maintained by the local copy of Windows, and (b) of the local drive mappings. What more portability do you want?

You can as well state several extensions in a row, separated by ";", for example:

png;jpg>C:\Programs\Viewer\Viewer.exe

You can as well state a path *relative* to this XYplorer's path, for example:

png;jpg>..\Viewer\Viewer.exe

png;jpg>..\..\Viewer\Viewer.exe

If this XYplorer is at C:\Programs\XYplorer\ then the examples will be resolved to C:\Programs\Viewer\Viewer.exe respectively C:\Viewer\Viewer.exe.

The PFAs are used on Dbl-Click, <Enter> and <Ctrl+Enter>, and they are processed from top to bottom. Hence their order is important because the first matching pattern will make it.

If none of the patterns matches the file to be opened then the global registry-based file association is used to open it. You still have direct access to the registry-based file associations via

(a) the files' context menu's "open" command,
(b) the Portable Openwith Menu (POM), or
(c) CKS | Miscellaneous | File Operations: Added "Open Selected Item(s) with OS Default" [Ctrl+Shift+Enter].

The checkboxes in the list allow you to easily (de)activate particular file associations without the need to delete and retype them. As always in XY's checkbox lists, a right-click menu offers (Un)Select All.

The Patterns

A file's extension is not the only possible pattern in XY's portable file associations. You can state whole file names or even full, relative, or portable paths; patterns containing wildcards are allowed.

Rules

If the pattern contains the character "\" then

it's treated against the full path (relative/portable syntax supported)

Elseif the pattern contains wildcards (*, ?, #) or a dot (.) then

it's treated against the file name

Else

it's treated against the extension

Special patterns:

To match all files use a single * (asterisk).

To match all folders use a single \ (backslash).

To match all files and folders use \;* (backslash- semicolon- asterisk).

To match all files without extension use *. (asterisk-dot).

Examples

?:\*.xys>::load <curitem>

Loads selected XYS file, but only if it's on app drive. This is very nice, since in a "portable situation" (e.g. you stick your USB-drive into another computer), you can have files on your drive opened by your apps, all other files opened by the system's default app, or by some other app you define; for example:

?:\*.dat>?:\app1.exe

*.dat>?:\app2.exe

The second definition will match all files that have not been matched by the first definition (= all DAT files that are not on app drive).

a*;b*>UEdit32

Opens a file with UltraEdit if its name starts with "a" or "b".

Captions

A caption can be prefixed as quoted string. This caption is used in the Portable Openwith Menu (POM).

"No extension" *.>UEdit32

Open all files (not folders) without extension with UltraEdit. The item shows the caption "No extension" in the POM.

Icons

You can define the icon that's shown for each item in the the Portable Openwith Menu (POM). Simply append any file spec to the Caption (see above), separated by a | (pipe). It can be an icon file or any other file or folder with associated system icon. XYplorer native variables, environment variables, and portable paths are supported.

"No extension|E:\Test\Kiss.ico" *.>UEdit32

"PS|<xy>" jpg;png;gif>Photoshop

"Say hi!|E:\Test\Kiss.ico" jpg>::msg "hi";

"Say hi!|C:\WINDOWS\notepad.exe" jpg>::msg "hi";

|"Append date|E:\Test\Kiss.ico" \;*>::rename b, '*-<datem yyyymmdd>'

The Applications

There are two sorts of "applications" allowed in PFAs: Executables and Scripts.

Executables

Using short forms for applications: If the EXE to run is registered (known by the registry) it is not necessary to state the full path. The base name of the EXE file is enough. Both ways will work the same:

png;jpg>C:\Programs\Viewer\Viewer.exe

png;jpg>Viewer

Also environment variables are allowed:

txt;htm>%windir%\notepad.exe

Using command line parameters: Just as in User-Defined Commands of category "Open With", PFAs accept command line parameters.

Scripts

You can also state a one-line script (see Scripting) as "application" in the definition of a PFA.

Examples:

xys>::load <curitem>

Now dbl-clicking a *.xys file will actually load that file, and pop up the menu defined by it, respectively run the script contained in it if it's the only one.

readme.txt>::status "Who cares?!"

Any attempt to open a readme.txt file will just result in a status bar message "Who cares?!".

The special variable <pfaitem>

In PFA scripts the temporary variable <pfaitem> is supported. It resolves to the item (full path) the opening application or script in a PFA is associated with. Only in a script called via PFA <pfaitem> can be used. After the PFA is processed the variable is reset to nothing.


Portable Openwith Menu

Portable Openwith Menu (POM)

Introduction

You probably know the situation: You need to open a file with a specific application that happens to be not the one associated to that file by Windows. What now? You may be lucky to find the application listed in the "Open With..." section of the file's Shell context menu -- but even then this is a clumsy way to work (at least one right click, then expand a submenu, then a left click), it lacks configurability (what if you need command line parameters?), and it's not portable (away from home, the Shell's "Open With..." is defined by the host systen, not by your needs). All these issues are elegantly tackled by the revolutionary Portable Openwith Menu (POM), introduced with XY 7.10.

The Portable Openwith Menu (POM) is opened via menu File | Open With... (Ctrl+Alt+Enter), or via the "Open With" toolbar button. It is closely interrelated with your Portable File Associations (PFA) and will not show anything interesting before you have defined a couple of PFAs. Once done, a single click or keyboard shortcut will popup a context specific menu presenting an array of applications to open the currently selected file(s) with. The specific contents of this menu depend (A) on the currently selected files, and (B) on your Portable File Associations (PFA) setup, hence it is portable and utterly easy to manage.

With POM it makes sense to have more than one PFA match the same pattern. As before, the standard "Open" command (Dbl- click/Enter) will only make use of the first matching PFA. However, the new "Open With" popup menu will list all matches, in the order given in the PFA customization dialog.

The POM has up to 3 sections (the first is only present, of course, when matching PFAs are found):

----------------------------------------

[Portable File Association(s)]

...

----------------------------------------

[OS File Association]

----------------------------------------

Customize File Associations...

----------------------------------------

Basic Usage

The following example assumes you have Photoshop ad ACDSee32 installed.

Set up these PFAs:

jpg;png;gif>ACDSee32

gif>C:\Programme\Adobe\Photoshop 7.0\ImageReady.exe

jpg;png;gif;tif>Photoshop

Now, when open the POM on a GIF file, it will offer the following apps to open it with:

ACDSee 32

ImageReady

Adobe Photoshop

When open the POM on a PNG file, it will offer the following apps to open it with:

ACDSee 32

Adobe Photoshop

And when open the POM on a TIF file, it will offer the following apps to open it with:

Adobe Photoshop

Advanced Usage

For advanced users the POM, in close collaboration with PFA, has a lot to offer:

(1) Rather than just extensions, you can define any wildcarded filename patterns, including paths and individual filenames. Thus you can have specific context menus for all "Readme.txt" files, or for all items in C:\Windows\, or for all items containing German umlauts (pattern: *[äöü]*, see also here below.
(2) Rather than just files, you can also associate folders with applications. Tip: A single backslash (\) will match all folders.
(3) Rather than just executables, you can specific any kind and number of command line parameters in your Portable File Associations, which then will be used when triggering an Open operation from the POM.
The syntax is identical to all the other places where command line parameters are supported: Catalog (Open Selected Item(s) With), UDC Open With, scripting "openwith". It's basically one simple rule: The application must be quoted when command line parameters are used. For example:
jpg;png;gif;tif>"ACDSee32" /v
jpg;png;gif;tif>"C:\Programme\ACDSee32\ACDSee32.exe" /v
By the way, quoting is also okay (but not necessary) when you have no parameters.
(4) Rather than just applications, you can also associate scripts with filename patterns, and thus directly run a specific script from the POM.
(5) Within the Portable File Associations dialog, you can define friendly captions for the POM items that make it easier for you to spot the right item in a POM. The syntax is identical to captions in Favorites. Simply prefix the caption in quotes (optionally followed by any number of blanks). For example:
|"Edit with Notepad" txt;ini;xys>C:\WINDOWS\notepad.exe
|"Edit with UltraEdit" *>UEdit32
If a caption is defined for a PFA, then the caption will be shown in the menu instead of the app's friendly name (which is drawn from the registry if the app is registered).
You can define an accelerator by prefixing the "&" (ampersand) character to the desired character.
(6) The captions may contain XY variables. They are resolved in the moment the POM is generated. For example:
|"Search IMDB for '<curbase>'" *>::Open("http://www.imdb.com/find?s=tt&q=<curbase>");
Will show the caption "Search IMDB for 'Mad Max'" when the current file is "Mad Max.jpg".
(7) In the POM, hold Ctrl when clicking an item to go to the application instead of opening it.
(8) Tip: Ctrl+Alt+Enter is identical to AltGr+Enter, so you can pop up the POM easily using the right hand only.
(9) You can define associations that should only be listed in the POM, but not be triggered on "open". It's done by simply prefixing the | (pipe) character to the PFA. The following example allows you to have this PFA enabled and listed in the POM:
|exe;dll>::copytext <curname> <curver>
while double-clicking an EXE file will still run the EXE, and not the PFA. In the PFA dialog, prefixed (= POM-only) items are shown in color "Marked Text 2" (see Configuration | Colors).

Examples

The following PFA will add a command to the POM that will open the selected folder(s) in ACDSee32:

\>ACDSee32

Open *.txt, *.ini, and *.xys files with Notepad (Editor), but only show this command in POM, do not trigger it on "open":

|"Edit with Notepad" txt;ini;xys>C:\WINDOWS\notepad.exe

Open any file (but not a folder) in UltraEdit:

"Edit with UltraEdit" *>UEdit32

Open any folder in UltraEdit:

"Edit with UltraEdit" \>UEdit32

Open any file or folder in UltraEdit:

"Edit with UltraEdit" *;\>UEdit32

Open PNG files in ACDSee, using comand line parameter /v

"ACDSee in View Mode" png>"ACDSee32" /v


User-Defined Commands

User Menu

User Menu Commands

Manage Commands…

Open the Manage User-Defined Commands interface.

Shortcut: Ctrl+Alt+F9

Goto, Open, Open With… etc

These submenus contain all the UDCs (User-Defined Commands) that you have defined before. See next paragraph…

User-Defined Commands

Introduction

UDCs are basically menu commands (all located in menu User), where you decide (1) what they do when clicked, (2) and what their caption is. Optionally, as with all menu commands in XYplorer, you may assign keyboard shortcuts to them.

Example 1: You currently work on a project with distributed locations you need quick access to. Define a UDC of type Go To for each of the Locations and assign a KS (Keyboard Shortcut) to each of them. This will take you maybe 20 seconds, and then, say, Ctrl+1 will take you to \\yourserver\theshare\projectdata\ and Ctrl+2 will take you to E:\project\images\.

Example 2: You like to open certain image files either with Photoshop or with ACDSee. Define two UDCs of type Open With, one pointing to Photoshop, the other one to ACDSee. Again, assign a KS (Keyboard Shortcut) to each of them, and you are done. Ctrl+Alt+P (for example) will open all selected files with Photoshop, Ctrl+Alt+A (for example) will open all selected files with ACDSee.

Example 3: You regularly have to do certain rename operations for which you need a complex Regular Expression you always tend to forget. Define a UDC of type Rename, enter your Regular Expression into the Pattern field, and give it a descriptive caption (so that you later know what it does). Again, assign a KS (Keyboard Shortcut) to the UDC, and you are done. From now on, a single key stroke, e.g. Ctrl+Shift+8, will apply the rename operation to all selected items.

Example 4: You quickly want to list only the *.exe and *.dll files present in the current folder. Define a UDC of type Go To and set the Location to |*.exe;*.dll – this will activate a Visual Filter for the current location. As you see in this example, UDCs know the full richness of XYplorers location syntax. The possibilities are endless…

How to create a User-Defined Command

Open the Manage Commands (Ctrl+Alt+F9) interface.

Select a Category.

Click the "New" button and select Add New Command, or simply press INS.

Now enter the Command Properties. First you specify the main argument: that's the critical piece of data. It's where you specify the object of the Action which can be (depending on the Action) a Location, an Item, an Application, or a Pattern. Often it will be a file or folder, in which case a Browse button to the right of the edit field is enabled.

Some Actions have further Options that can be specified in the Options field. Required fields are marked by a bold label.

Optionally enter the Caption (for the menu item). If left empty, the Argument will be used for the caption.

The changes are auto-applied when you OK the dialog, or select another category, another command, or create a new command. To undo any changes in the current Command Properties (an asterisk is shown in the frame title) press ESC. To undo all changes you made since opening the dialog simply Cancel the dialog.

Repeat for all UDCs you need.

Finally press OK to apply your changes to the current session of XYplorer. The new menus will be generated in a blink. Open the User menu and see yourself...

Now you can assign a Keyboard Shortcut to your new UDC. Either click the Assign Keyboard Shortcut button and choose one, or open Customize Keyboard Shortcuts (Shift+F9) from menu Tools (the UDCs are listed under category "User").

Of course, as always in XY, the UDCs will be saved to file on exit unless otherwise wanted. This file is called udc.dat.

On KeyUp

For UDCs with a Keyboard Shortcut assigned, this checkbox gives you control about the exact point of action. When checked, the command is triggered when the key is released, else (default) the command is triggered when the key is pressed down.

It is actually recommended that you enable "On KeyUp" on UDCs that pop a menu (and have a keyboard shortcut assigned, of course); otherwise you might experience that you trigger one of the menu items on releasing your keyboard shortcut because it is interpreted as an accelerator key!

How to quickly edit an existing User-Defined Command

You can directly open the Manage User-Defined Commands dialog for a particular user command by holding CTRL while you click the menu item pointing to the command. The command will not be triggered then, of course.

How to smartly pre-fill the dialog when creating a new User-Defined Command

The Toolbar's Manage User-Defined Commands button's right-click menu enables you to directly create a new UDC with the argument field preset to some current context value. How? Simply hold CTRL while clicking one of the menu items! The preset values adjust to the command category:

- "Go To", "Open", "Open With", "New", "Load Script File" -> current file (if any is selected)

- "Rename" -> [empty]

- "Run Script" -> [empty]

- else -> current path

How to quickly duplicate a User-Defined Command

You can duplicate the current command by holding CTRL when pressing "New" or by pressing Ctrl+Ins. If the current command has a caption, then the new command's caption will have "(Copy)" suffixed.

Command Line Parameters are supported

The Open and Open With commands, when applied to applications, support the usage of Command Line Parameters. Of course, it is the called application that controls (1) which parameters are recognized, (2) what they do, (3) what format they must have, and (4) in which order they are expected. So, to use this feature, you must know the command line syntax of the application you want to open files with.

The only rule you have to know is: If you use Command Line Parameters, then the application term has to be in quotes!

The possibilities arising from the support of parameters are absolutely astounding. For the following examples, I chose WinZip as the called application.

Example 5: Adding selected items to an archive. Open menu User | Manage Commands, and select category "Open With". Set the option to "Pass all the items to the same instance...". Then enter this line into the Application field in UDC | Open With:

"winzip32" -a UDCmade.zip <items>

<items> is a XYplorer variable, that in this context is set to a blank-separated list of all currently selected list items. Triggering this UDC will create (if not already existing) the archive UDCmade.zip in the current path and pack all currently selected files into it. If want the *.zip in some other place than the current path, state it with the desired full path.

Example 6: You may as well use XY date variables, e.g.:

"winzip32" -a UDCmade-<date yyyymmdd>.zip <items>

will create UDCmade-20071107.zip if today is 2007-11-07.

Example 7: Create a password protected archive and name it depending on the current folder:

"winzip32" -a -s"Secret password " <curfolder>-Secret.zip <items>

Remember that the quoting of the blank-containing password is part of WinZip's command line syntax! XYplorer is just passing this on to WinZip. What XYplorer does, however, is resolving the new XYplorer variable <curfolder>: it is set to the name of the current folder (not the whole path).

Example 8: Extracting items from an archive to some folder:

"winzip32" -e <items> newfolder

Will extract all items of the selected archive file into a newly created folder "newfolder" under the current path. Of course, you can as well give a full path for the target folder. Note that <items> here stands for the archive to extract! This example will only succeed when just *one* archive file is selected. This is a restriction of WinZip's command line syntax, not of XYplorer.

Example 9: Extracting items from an archive to some auto-named folder:

"winzip32" -e <items> <curbase>

The new XYplorer variable <curbase> will be set to the base (= name without extension) of the currently selected file (here: the archive to extract) -- it is always the file that is displayed in the status bar. For the case that the base contains blanks, you should put it in quotes else WinZip will choke:

"winzip32" -e <items> "<curbase>"

Of course, you can combine variable as you like:

"winzip32" -e <items> "<curbase>_<date yyyy-mm-dd>"

If the archive is called "test.zip", this would create a subfolder named "test_2007-11-07" and unpack the archive into it.

Example 10: With any compare-tool accepting two-way comparisons via command line you can easily set up a one-click file comparison. Assuming you have a 3rd party software installed and registered called "compare.exe" then you could do:

"compare" <item1> <item2>

This will your tool with the first two of all selected items in the given order. Any other selected items are ignored.

Some interesting examples for the "New" category

If the currently focused file is E:\Pics\ChristinaAguilera.jpg, dated 20070602:

==============================================================

Name field: New empty file created:

--------------------------------------------------------------

<curfolder>.txt Pics.txt

<curtitle>.txt ChristinaAguilera.jpg.txt

<curbase>.txt ChristinaAguilera.txt

<curbase>-<curext>.txt ChristinaAguilera-jpg.txt

<curbase>-<datem yyyymmdd>.txt ChristinaAguilera-20070602.txt

<curbase>-<date yyyymmdd>.txt ChristinaAguilera-20071209.txt

==============================================================

The variable <curver> will extract the version number of the current file (if it has one). If the currently focused file is E:\XYplorer.exe, v6.60.0053:

--------------------------------------------------------------

<curbase>_<curver>.txt XYplorer_6.60.0053.txt

--------------------------------------------------------------

If you set the Source field to <curitem>, you can emulate the behavior of "Copy Here With Last Modified Date" (see below). Or you can "Copy Here With Version":

==============================================================

Name field: Clone of Source created:

--------------------------------------------------------------

<curbase>_<datem yyyymmdd>.<curext> XYplorer_20071207.exe

<curbase>_<curver>.<curext> XYplorer_6.60.0045.exe

==============================================================

If a source is defined then the following variables in the Name field refer to the source: <srcbase>, <srcext>, <srctitle>, <srcver>, <srcdatem yyyymmdd>, <srcdatec yyyymmdd>, <srcdatea yyyymmdd>. They obviously correspond to <curbase>, <curext>, <curtitle>, <curver>, and <datem yyyymmdd>, which always refer to the current item.

Passing the full path

You may as well pass a full path/name in the Name field (only if no path is passed, the current path is taken as default). If the target folder does not exist it is created on the fly. The "last target" path (used by Ctrl+Alt+F7) is set to the target folder.

Further remarks

No limit: There's virtually no limit to the number of commands, although, being menu-based and having a finite number of keys on your board you will hit a usability wall at some point.

Accelerators: You can create an accelerator simply by prefixing the letter to be used by the ampersand sign (&). If you want to use the & character itself in your caption, simply double it, e.g. "This && That".

Separators: If you want to organize your menus into sub sections you can use separators. Simply create a new command, and put the minus sign (-) as argument.

Short forms for applications: You will have noted the use of "winzip32" above. If the EXE to run is registered (known by the registry) it is not necessary to state the full path. The base name of the EXE file is enough. Both ways will work the same (UDC type OpenWith):

"C:\Programs\WinZip\Winzip32.exe" -a UDCmade.zip <items>

"winzip32" -a UDCmade.zip <items>

Of course, the latter version is more portable, because it will call WinZip successfully on systems where it has a different installation path from your home system.

Specifying Menu Icons: You can optionally pass a pointer to an icon along with the caption. The icon will be shown in the User menu. The general form is MenuCaption|MenuIcon, where MenuIcon can have various formats:

MenuCaption|C:\Beta\ full path/file to file or folder

MenuCaption|Icons\fun.ico relative path (to app data path)

MenuCaption|<xydata>\Icons\fun.ico support of XY native variables

MenuCaption|:minitree internal icon (toolbar buttons resource)

MenuCaption| nothing (no icon shown)

Variables: See Variables.


Scripting

Index

Boolean Constants

Boolean Operators

Commands and Functions

Comments

Comparisons

Control Structures

If/ElseIf/Else Blocks

While Loops

Foreach Loops

General Command Syntax

Using Quotes in Scripting

Heredoc Syntax

Math

Multi-line Scripts and Multi-Scripts

Nested Expressions

Operator Precedence

Quick Scripting

Remote Control

Script Files

Script Files for the Advanced

Scripting and User-Defined Commands

Scripting by Numbers

Step Mode: Stepping Through Scripts

Ternary Conditionals

Variables

Variables Scope and Lifetime: Local, Global, and Permanent Variables

Introduction

XYplorer Scripting, introduced with version 7.0, can truly be seen as the ultimate in file management efficiency. Roll your own custom commands, combine them to scripts, wrap them in an XYplorer Script file (XYS), or a User-Defined Command, and trigger them by just a click or a keystroke. You may share scripts with colleagues, or download them from the internet. Just drop a script file into your app folder and fresh plug-in commands are at your finger tips.

Without doubt, scripting is an advanced feature that only pays off if you take the time to dive into it and explore the ways and possibilities. However, you will eventually find out that it ain't rocket science at all.

More information, downloads, and a growing pool of examples is available here:

http://www.xyplorer.com/

Warming Up

To get you started let's try something easy:

(1) Select menu Scripting | Run Script...

(2) Paste msg "Hello world!" into the edit box.

(3) Click OK.

You should see a "Hello world!" message box now. Well done, you just wrote your first XYplorer script!

Okay, now for something a little bit more interesting:

(1) Try msg %temp%. You should see a message box that displays your TEMP path. %temp% is a standard Windows environment variable.
(2) Try msg "XYplorer.exe runs from <xypath>". <xypath> is a native XYplorer variable that resolves to XYplorer's application path.
(3) Try msg "Press OK to copy the time!"; copytext "<date hh:nn:ss>". When the message box is OKed, the second command copytext is immediately executed and the current time is copied to the clipboard.
(4) Try set $a, "<curpath>"; msg $a. You should see a message box displaying the current path. First the variable $a is set to the current path, then it is used in the msg command.
(5) Try $a = "Year " . "<date yyyy>"; msg $a. You should see a message box displaying "Year 2009" (or whatever the year might be when you try this). First the variable $a is set to two strings, one literal and one variable, concatenated by a dot, then it is used in the msg command.

General Command Syntax

(1) There are commands consisting of a function name like msg or copytext, and arguments that can contain literals like "Hello!", and variables like %temp% (environment), <curpath> (XYplorer), or $a (user-defined).
(2) An argument can have more than one part. The parts are concatenated by dots ( . ).
(3) A command can have more than one argument. The arguments are separated by commas ( , ).
(4) A script can have more than one command. The commands are separated by semi-colons ( ; ).

Examples:

rename b, "*-<datem yyyymmdd>"

This little script will rename all currently selected items by appending the current date.

goto "Desktop|"; sortby m, d; sel 1; focus List;

This script goes to the Desktop folder (ensuring that the listing is unfiltered), sorts the list by date modified (descending), selects the first item, and moves the focus to the list.

Concatenation

Strings and variables can be concatenated by dots. Any number of blanks surrounding the concatenator are ignored. The following scripts are identical:

msg "Hi there!"

msg "Hi "."there!"

msg "Hi " . "there!"

msg "Hi " . "there!"

msg "Hi"." "."there!"

Using Quotes in Scripting

It's strongly recommended that you (double- or single-) quote your strings! While the script engine is currently still permissive with unquoted strings (msg Hi! works) this might not be so in the future, so you better do msg "Hi!" right away!

Here's the basic laws of quoting:

(1) Everything is either in double-quotes, or in single-quotes, or outside of any quotes.
(2) To have double-quotes inside double-quotes they must be doubled.
(3) To have single-quotes inside single-quotes they must be doubled.
(4) Variables are resolved in double-quotes and outside of any quotes, but not in single-quotes.

Commands and Functions

There are two types of commands: commands (proper) and functions. Contrary to commands (e.g. echo), functions (e.g. quote()) return an in-place value.

In the first example, the quoting is achieved by doubled double-quotes. The only command in the statement is echo. In the second example, the quoting is achieved through the function quote():

echo """Hi!"""; //"Hi!"

echo quote("Hi!"); //"Hi!"

Remarks on functions

(1) Function names are not case-sensitive: QUOTE() = quote().
(2) Even without any argument -- e.g. quote() -- the parentheses are mandatory, else a function is not recognized.
(3) You can call a function without caring for the return argument (but you need the parentheses!):
renameitem("John", , , "-01");
Optionally you can use the dummy command call:
call renameitem("John", , , "-01");
(4) Functions are not resolved (interpolated, see below) when inside double-quotes.

Quick Scripting

Quick Scripting means: Scripts, when prefixed with "::" (double-colon), can be executed directly (i.e. quickly) through any interface in XYplorer that can process locations: Address Bar, Go To, Favorites, Catalog etc. This gives you a lot of choices for usage and storage of scripts.

Let's try:

Paste ::msg "Hello world!" into the Address Bar and press Enter. You should see a "Hello world!" message box.

Now, for mouse users, the Catalog is a very good place for scripts. Using the "::" prefix, scripts can be simply entered into the Location field of a catalog item. They are executed on a single click.

For example:

(1) Add a new category "Scripts" and add a new item to it.
(2) Set item's Location field to ::#1026 and save it. The icon turns into the script symbol.
(3) Now click the item. The Find Files tab on the Info Panel is opened, all search filters are reset, and the cursor is placed into the Name field. Nice!

But how did this work? And what is #1026? Read on...

Note: From version 9.70 onwards the prefixed with "::" is not necessary anymore when you end your script line with a trailing ";" (appended comments after the ";" are allowed). This behavior is enabled by the INI setting ScriptSmartDetect=1.

Scripting by Numbers

In XYplorer almost every function has a fixed number, the function ID, by which it can be referred to in a script. ID #1026 happens to refer to "Miscellaneous / Find Files / Open Find Files and Reset". Open the Customize Keyboard Shortcuts dialog (menu Tools) and find this function in category Miscellaneous. At the bottom of the dialog you'll see a button showing the function's ID. Clicking this button will copy the function's ID to the clipboard, making it easy to use it in a script.

You can execute almost any function in XY in a script by referring to its function ID. E.g. #230 will pop up the submenu "New" of menu Edit.

Step Mode: Stepping Through Scripts

Suppose you have an older script #230, and you forgot what #230 refers to. Or you downloaded a script from the internet, and don't know exactly what it does. What now? Very simple, enter Step Mode:

(1) Open the Scripting menu and select Step Mode.
(2) Now execute your mysterious script.

A small window, the Step Dialog, will pop up and tell you what is about to happen. You can now decide whether to execute the command, or skip it, or cancel the whole script. In stepping mode you are on the safe side. It is highly recommended when writing or debugging scripts!

There's also a toolbar button for toggling the stepping mode. When pressed (stepping is ON) its color changes to red to make the current state very clear.

Error Messaging and Risk Classes

The Step Dialog also tells you what went wrong where, and it informs you about the potential risk associated with the command to be executed. There are the following risk classes:

#3 Potentially harmful because the function ID might refer to some risky process which is unknown at this point (either an internal command or a UDC): #[function ID]
#2 Potentially harmful because files or folders are affected: backupto, copyto, delete, download, moveto, new, open, openwith, rename, rotate, run, setkey, swapnames, timestamp
#1 Potentially harmful because Step Mode is terminated: unstep
#0 Harmless: (all others)

Class #3, #2, and #1 are marked with a yellow "warning" icon, class #0 with a blue marble (think "cool") icon.

Script Context

The first two lines in the Step Dialog display (1) the current script resource, and (2) the current script caption. Valuable information when writing and debugging scripts.

How Functions are Stepped

Functions are individually stepped. The current script line is marked green when a contained function is stepped as opposed to the main command of the line. You can even skip (button Skip) functions individually, in which case the function name is returned with the resolved arguments. For example:

msg quote(chr(64));

If you continue both functions the result is: "@"

If you skip chr() and continue quote() the result is: "chr(64)"

If you continue chr() and skip quote() the result is: quote(@)

If you skip both functions the result is: quote(chr(64))

When you "Continue without Stepping" on a function, the stepping is only suspended for all functions in the current script line / command.

Scripting and User-Defined Commands

Now, for passionate keyboarders, there are User-Defined Commands (UDCs). Using the "::" prefix, scripts can be simply entered into the Location field of a UDC Go To item, which then can be assigned a keyboard shortcut to.

For example:

(1) Click menu User | Manage Commands...
(2) Select the category Go To, and click the New button.
(3) Enter ::text "<clipboard>" into the Location field.
(4) Assign a keyboard shortcut, say Ctrl+Alt+3.
(5) Click Apply and OK.

Now press Ctrl+Alt+3. You should see a small window displaying the current textual contents of the clipboard.

Of course, you don't have to abuse the UDC Go To for scripts. There's also the UDC Run Script which accepts scripts without a prefixed "::", e.g. text "<clipboard>".

Run Script can also handle more advanced stuff like multi-line scripts, and multi-scripts, the rules and possibilities of which will be further explained below under "XYplorer Script Files".

Multi-line Scripts and Multi-Scripts

A script can have more than one line (multi-line script), and a script resource can have more than one script (multi-script). There is one important formatting rule for multi-line scripts:

In a multi-line script all lines apart from the first line have to be indented by at least one space.

Each non-indented line is interpreted as the first line of a separate script, and if there are more than one scripts in a loaded script resource (i.e. a multi-script) then a menu is popped where you can select the script to run.

For example, this is a multi-script containing two multi-line scripts. In the first script, the script caption (which is used as the menu caption) forms the first line:

"Go to C:\"
goto "C:\";
goto "%winsysdir%";
selectitems "calc.exe";

Comments are an exception: Any number of non-indented comments can be prefixed to a multi-line script. Actually non-indented comments can be inserted anywhere. This script is functionally identical to the above one:

// comment 1
// comment 2
"Go to C:\"
// comment 3
goto "C:\";
// comment 4
goto "%winsysdir%";
selectitems "calc.exe";
// comment 5

Initialize and Terminate

You can define two special-named scripts within multi-scripts, "_Initialize" and "_Terminate". They can be placed anywhere in the multi-script, and they are not shown in the popup menu. The script called "_Initialize" will be auto-processed before the menu is popped. The script called "_Terminate" will be auto-processed after the script selected from the menu has been processed (or after the menu has been canceled).

Note: If a script within a multi-script is called directly (SCs Sub or Load), then "_Initialize"/"_Terminate" are NOT called.

For example, this multi-script defines a permanent variable (which is also global by definition), then offers various scripts in a popup menu, then finally removes the variable from memory:

"_Initialize"
// if variable already exists it is NOT reset here but keeps it current value
perm $p_a;
// explicitly initialize it to zero
$p_a = 0;
"_Terminate"
unset $p_a;

"Show Variable"
echo $p_a;
"Plus One"
$p_a = $p_a + 1;
echo $p_a;
"Minus One"
$p_a = $p_a - 1;
echo $p_a;
"Load Plus One"
// will NOT call "_Initialize"/"_Terminate"
Load "*", "Plus One";
// WILL call "_Initialize"/"_Terminate"
Load "*", "*";
"Sub Plus One"
// will NOT call "_Initialize"/"_Terminate"
Sub "Plus One";

Script Files

Here we are talking popup menus that are user-defined by a text file. Let's make one:

Create a new text file in any editor.

Paste the following multi-line script (see above):

// some little test scripts
"Go to C:\"
goto "C:\"
"Go to System Folder"
goto "%winsysdir%"
"Go to XYplorer Folder"
goto "<xypath>"

Save the file as "test.xys" (XYplorer Script File) in XYplorer's Scripts folder. In case you don't know that path, use menu Scripting | Go to Scripts Folder to go there.

Now, in XYplorer, click menu Scripting | Load Script Files... and open "test.xys". The following menu should pop up at your mouse cursor:

Go to C:\

Go to System Folder

Go to XYplorer Folder

Now you can choose where you want to go.

A script file is basically a library of scripts. It is nothing more than a simple text file, which can contain one or more scripts. You will be able to either call one of those scripts directly, or simply load the entire file. In such case, XY will create a menu based on the contained scripts in that file and pop it up, allowing you to choose which script to execute.

The syntax for the scripts themselves within script files is exactly the same as for scripts anywhere else in XY since this is just another way to store and execute scripts.

Syntax rules for XYplorer Script Files

(1) Lines starting with // are ignored and can be used for comments.
(2) One script can run over multiple lines. Simply indent the lines after the first line using any number of space or tab characters.
(3) You can have more than one script inside a script file. In that case, loading the script file will pop up a menu presenting all scripts inside the script file by their captions.
(4) To set a script caption simply prefix the desired caption to the script, and wrap it in quotes.
(5) Within a caption you may define a label that allows you to execute a script from a file directly.
(6) Using the command sub in a script file you can execute other scripts inside the same file.
(7) You may hide scripts by prefixing an underscore (_) to their caption.

To Load a Script File do one of the following:

(1) Use menu Scripting | Load Script File...
(2) Use a UDC from category "Load Script File".
(3) Use the script command load [scriptfile].

The existence of a command load, of course, means that one script file can load another. You will get an idea of the potential of scripting by now...

Drop on a Script File

You can drop files onto XYS-files. The dropped files are referred to in the dropped-on script by <get drop>.

This can get pretty cool in Dual Pane mode. You can have a folder with assorted script files in one pane, and your working folder in the other pane. Now you just drag-and-drop files onto the scripts for automated processing.

Primitive example script in a file "drop_on_me.xys":

text <get drop>;

Even cooler: You can also drop on multi-scripts. In that case you get the usual popup menu of choices, and the <get drop> will be available in each of the scripts.

Primitive example script in file "drop_on_me_2.xys":

"Text"
text <get drop>;
"Echo"
echo <get drop>;

Notes:

· If more than one file is dropped <get drop> returns one per line. Alternatively you can pass a separator like this:
text <get drop |>;
· The <get drop> variable is cleared after the script is processed, so it cannot be used after the drop event is completed.
· <drop> is a synonym for <get drop>.
· If the script contains no <get drop> variable it is run nevertheless just as if you loaded the script file.
· You can as well drop files on shortcuts (LNK) to XYS-files.
· You can also drop text onto XYS-files (and LNKs to XYS-files), e.g. selected text from a webpage. Just like with dropped files, the dropped text can be referred to in the dropped-on script by <get drop>.

Script Files for the Advanced

Labels

By using labels you can execute a script inside a file directly, avoiding the popup menu. The label is attached to the caption, separated by " : " (space-colon-space). For example:

// some little test scripts, using labels
"Go to C:\ : croot"
goto "C:\"
"Go to System Folder : system"
goto "%winsysdir%"
"Go to XYplorer Folder : xy"
goto "<xypath>"

If the above is saved to a file called "test.xys" in application data path then the following command will directly bring you to the System folder: load "test.xys", "system".

You may as well specify a list of labels, by which you can easily control which scripts are displayed in the popup menu, and in which order. See load for the details.

Wildcard catch-all label: The label "*" matches all load calls if more than one label is stated. The third command will be shown on load "test.xys", "croot;system":

// some little test scripts, using labels
"Go to C:\ : croot"
goto "C:\"
"Go to System Folder : system"
goto "%winsysdir%"
"Go to XYplorer Folder : *"
goto "<xypath>"

Hiding scripts inside a script file

Hidden scripts can be executed but are not shown in the script file's popup menu. To hide a script simply prefix an underscore to the caption or label (a hidden script does not need a caption anyway). For example, create a script file "date.xys" in application data path with the following contents:

// this is in script file "date.xys"
"_date"
msg "<date yyyy-mm-dd>"
"_time"
msg "<date hh:nn:ss>"
"Show Date : date"
sub "_date";
"Show Date && Time : datetime"
sub "_date";
sub "_time"

Now execute the script load "date.xys". The popup menu will show only two of the four contained scripts. Select either and see what happens.

Now run the script load "date.xys", "date". The script with the label "date" will be executed directly. It has only one command: sub "_date";. The sub command is a special command to call a script inside the same script file. In this case the hidden script with the label "_date" is called and executed. Its command msg "<date yyyy-mm-dd>" produces the message box showing the current date.

Variables in Captions

The captions of scripts in multi-script resources may contain XYplorer native variables. They are resolved in the moment the menu is popped up. For example, paste this into the Try Script box:

"Go to <xypath>"
goto "<xypath>";
"Is it <date hh:nn:ss>?"
msg "It's <date hh:nn:ss>!";

The 2nd script will show two different times if you wait longer than a second before you click the menu item.

Also Environment Variables and Permanent Variables are supported in captions.

Icons and States

You can optionally define an icon and a state for each menu item.

Syntax:

"Caption|Icon|State : Label" Script
where
State Default = 1
State Checked = 2
State Disabled = 4

For example:

"Go C:|C:|1" goto "C:\"; //shown bold
"Go D:|D:|2" goto "D:\"; //shown checked
"Go E:|E:|3" goto "E:\"; //shown bold and checked

You can pass * as placeholder to use the caption as icon pointer:

"C:\|*" goto "C:\";
"C:\Windows|*" goto "C:\Windows";

Icon can be any file or folder, and its small system icon (the one you see in Details View) will be used for the menu. Relative (resolved relative to application data path) and portable paths are allowed. You can as well use XYplorer's internal toolbar icons using the button key, e.g.:

"Funny Script|Icons\fun.ico" echo "Ha!";
"Say Ho!|iexplore / 12" echo "Ho!";
"Recent Locations|:mru" button "mru"
"Hotlist|:hotlist" button "hotlist"

Note that the icon specification in a multi-script resource supports permanent global variables.

The Goto-Shorthand

In a multi-script resource you can now pass a plain path/file spec as a shorthand for a well-formed goto script. Such a line will be auto-converted to a valid goto command including the appropriate icon in the generated popup menu.

Long version using well-formed goto scripts with captions:

"C:\|C:\" goto "C:\";
"C:\Windows|C:\Windows" goto "C:\Windows";
"C:\WINDOWS\SoundMan.exe|*" goto "C:\WINDOWS\SoundMan.exe";

Equivalent shorthand version:

C:\
C:\Windows
C:\WINDOWS\SoundMan.exe

The goto-shorthand additionally supports environment and native variables, name searches, and visual filters. For example:

Desktop
%tmp%
<xydata>
C:\WINDOWS\system.ini
C:\WINDOWS\system32
C:\WINDOWS\system32?a*
C:\WINDOWS\system32?:a* or b*
C:\WINDOWS\system32?:a* | b*
C:\WINDOWS\system32?lbl:blue
C:\WINDOWS\system32|a*

Comments

Two types of comments are supported, line end comments, and block comments.

Line End Comments

Line end comments begin with a double-forward slash (outside of any quotes) and end at

the end of the line:

$a = "<xypath>"; assert $a=="<xypath>"; //should not fail

$a = "<xypath>"; //assign XY path
assert $a=="<xypath>"; //should not fail

"get CountSelected" // comment
$count = get("CountSelected"); // comment
assert $count!=0, // comment
"You must select a file before running this script!"

Block Comments

Block comments (aka C-style comments) start with /* (outside of any quotes) and end with the next */ (outside of any quotes) and can span any number of lines:

/* This is
a multi-line
block comment
*/ msg "hi!";

msg /*they can be inserted anywhere!*/ "hi!" /* anytime */;

Remarks on Comments

(1) Line-end and block comments overwrite each other:

msg "Hi!"; // /*this is not a block comment starting...
msg /* //this is not a line end comment starting... */ "Hi!";

(2) Make sure you don't nest block comments. It is easy to make

this mistake if you are trying to comment out a large block of

code:

/*
msg 'This is a test'; /* Will cause a problem */
*/

This, however, will work since // overwrites the /* */ comment:

//msg 'This is a test'; /* This comment is NO problem */

Variables

Advancing in script writing, you will soon feel the need for variables. XYplorer allows you to define and use as many variables as you want, using a number of commands like set, input, replace, etc. The script set $a, "Hi!"; msg $a; will define a new variable $a and assign the string "Hi!" (without the quotes) to it; then a message box will display "Hi!". The same can be achieved using the assignment operator (=):

$a = "Hi!"; msg $a;

Variables are resolved wherever they are found in the arguments of all subsequent commands of the script, even if they are found inside double-quoted strings (see below, Interpolation); for example:

$name = "Ted"; msg "Hi, I'm uncle $name!";

will display the message "Hi, I'm uncle Ted!".

Format and Scope

Variables have to conform to the following rules:

(1) Variables are represented by a dollar sign ($) followed by the name of the variable.
(2) Names start with a letter or underscore, followed by any number of letters, numbers, or underscores.
(3) Letters are a-z and A-Z.

Good variables: $a, $ABC, $good_variable, $a1, $a_, $_a, $_

Bad variables: a, ABC, $1, a$, $ä, $., $

Variable names are case-sensitive.

The scope and lifetime of a variable begins and ends with the script where it has been defined.

Using the equal-operator (=)

To assign a value to a variable you can simply use the following syntax (as an alternative for the set command):

$a = "b"; or $a="b"; (spaces are ignored)

For the additional "reprocess" operand see description of the set command.

Increment Syntax (++/--)

The common increment syntax using the ++ (--) operator is supported.

$i=5; $i++; msg $i; //6

$i=5; $i--; msg $i; //4

$i++; msg $i; //1

You can also use $i++/$i-- as an argument. The value is incremented/decremented before it is passed to the function:

echo $i++; echo $i++; echo $i++; //"1", "2", "3"

echo $i++ . $i++ . $i++; //"123"

Interpolation

Interpolation means that variables that are embedded in double-quoted or unquoted strings are resolved (replaced with their corresponding value). Examples:

$name = "Ted"; msg "Hi, I'm uncle " . $name . "!";

Displays "Hi, I'm uncle Ted!". The variable is concatenated with literal strings.

$name = "Ted"; msg "Hi, I'm uncle $name!";

Displays "Hi, I'm uncle Ted". The variable is interpolated inside double-quoted literal strings.

$name = "Ted"; msg "Hi, I'm " . uncle $name!;

Displays "Hi, I'm uncle Ted". The variable is interpolated inside non-quoted literal string uncle $name!. Note that using non-quoted literal strings is not recommended and might even be deprecated in a future version!

You can block interpolation by using single-quotes:

$name = "Ted"; msg 'Hi, I''m uncle $name!';

Displays "Hi, I'm uncle $name!". The variable is not interpolated inside single-quoted literal strings. Note that single-quotes embedded in single-quotes have to be doubled (I''m).

msg '%TMP% = ' . %TMP%;

Displays "%TMP% = C:\Temp". The first %TMP% is blocked from interpolation by being embedded in single-quotes.

$date = "<date>"; msg '$date = ' . $date;

Displays "$date = 28.08.2008 12:23:12".

Variables Scope and Lifetime: Local, Global, and Permanent Variables

Local Variables

By default, all variables in XY scripting are local, i.e. they are not shared between called and calling scripts. In other words, whenever one script calls another script (e.g. using commands "sub" or "load"), a new local namespace is created by the called script and pushed on the stack.

Global Variables

Generally, global variables are shared between scripts. This can make scripts hard to maintain. However, the mechanism of "globalization" -- (almost) identical to the one used in PHP -- used by XY scripting gives you maximum control over what is shared and where. Global variables are implemented by means of the command global.

Permanent Variables

The lifetime of local and global variables ends with the current script respectively script stack. Permanent variables, however, stay alive in memory for the whole XYplorer session, or even across sessions if configured like this (Configuration | Refresh, Icons, History | Remember permanent variables). Hence permanent variables can be easily shared between scripts. Global variables are implemented by means of the command perm.

Permanent Variables created / modified in a called script are immediately visible / updated in the calling script when the called script returns.

Note the scripting commands writepv and readpv by which you can read and write permanent variables from/to file. This allows for some interesting use as portable data storage.

To release all permanent variables from memory use the command releaseglobals. You can as well unset them individually via menu Scripting | Permanent Variables directly from the right-click menu in the variable list.

To view the current permanent variables use menu Scripting | Permanent Variables.

Initial Values

Local variables that have never been set to a value return their name as value (strictly speaking they aren't variables but normal strings). Global and permanent variables that have never been set to a value are initialized to "" when they are declared by global respectively perm:

msg $a; // displays "$a" if $a is has not set to any value before, and has not been declared as global or permanent.

global $b; // declare global variable

msg $b; // displays "" if $b has not been set to any other value before.

perm $c; // declare permanent variable

msg $c; // displays "" if $c has not been set to any other value before.

Nested Expressions

You can nest expressions using parentheses, aka round brackets: ( ). There's no practical limit to nesting depth and superfluous parentheses are silently removed.

Examples where parentheses are merely decor:

msg "a" . "b";

msg ("a" . "b");

msg ("a") . ("b");

msg (("a") . ("b"));

msg ((("a") . ("b")));

msg "a" . "b" . ();

= ab

msg "a" . ("b" . "c");

msg ("a" . "b") . "c";

= abc

msg "a" == "a" . "a" == "b";

msg ("a" == "a") . ("a" == "b");

= 10 ("1" . "0")

Examples where parentheses actually make a difference:

msg "a" == "a" . "a";

msg ("a" == "a") . "a";

= 1a

msg "a" == ("a" . "a");

= 0

Examples for nesting errors:

msg ("a" . "b"; // ')' missing!

= ("a" . "b"

msg "a" . "b"); // '(' missing!

= a"b")

Math

Scripting can do basic calculation using math operators +-*/, and also \ (integer division), % (modulo), and ^ (exponentiation). Fractions and parentheses are supported. Also unary operators + and - are supported.

Examples

echo 1 + 1;

echo 1 - 2 - 3; // -4

echo 1 - (2 - 3); // 2

echo 1/3 + 1/3;

echo 1 + 2 * 3;

echo (1 + 2) * 3;

echo 1/0; // ERROR: division by zero

$a=3; $b=2; echo $a / $b; // 1.5

$fraction = 1.5; echo $fraction == 3/2; // true

echo 1.2 + 2.1; // 3.3

echo 1 + --1; //2

echo --(1 * ----2); //2

echo 5 \ 2; //2 (integer division)

echo 5 / 2; //2.5

echo 5 % 2; //1 (modulo)

echo 2 ^ 3; //8

echo 4 ^ 0.5; //2

echo 4 ^ -1; //0.25

Remarks

(1) Strings are converted to numbers as possible (just like in comparisons).
$a=""; $b="2"; echo $a + $b; // = 2
$a="1a"; $b="2b"; echo $a + $b; // = 3
(2) The decimal separator is NOT locale specific (e.g. dot in US, comma in Germany) but hard-coded to dot (period). This way scripts are interchangeable between regions.
(3) Calculation uses 8-byte floating point numbers with the following ranges:
negative: -1.79769313486232E308 to -4.94065645841247E-324
positive: 4.94065645841247E-324 to 1.79769313486232E308
Floating point arithmetic has its natural shortcomings so don't expect too much in terms of precise accuracy down to the 12th digit. A file manager is not a scientific calculator.
(4) The operator precedence is ^ > (*,/) > (\,%) > (+,-) meaning that * and /, \ and %, + and - are of equal weight.
Processing of math terms is from left to right:
echo 36 / 4 * 3; // 27! (not 3)
(5) With integer division (the portion of the result after the decimal point is lost) and modulo (the remainder of integer division) the operands are rounded before the operation!
echo 5.9 \ 2.1; //3!
echo 7.9 % 2.5; //2! (8 % 3 = 2)
echo 7.9 \ 0.4; //ERROR: Division by zero.
echo 7.9 % 0.4; //ERROR: Division by zero.
(6) Fractional numbers should be stated with a dot as decimal separator, or alternatively in quotes with the local decimal separator:
echo 7.5 / 2.5; //3 -- works under each locale
echo "7,5" / "2,5"; //3 -- works only where comma is the decimal separator
Internally decimal separator are stored and processed according to the system locale:
$n = 2.5; echo $n; //$n is "2,5" internally where comma is the decimal separator

Comparisons

Comparisons of two values are evaluated in-place. The "comparison" has the general form

"a" operator "b"

where "a" and "b" are string expressions, and "operator" can be one of the following:

== Equal

!= Not Equal

< Less than

> Greater than

<= Less than or Equal to

>= Greater than or Equal to

Like Matches Pattern (case-sensitive)

LikeI Matches Pattern (case-insensitive)

UnLike Does not match Pattern (case-sensitive)

UnLikeI Does not match Pattern (case-insensitive)

If the comparison evaluates as True it is set to "1", else it is set to "0".

Examples

msg "a" == "a";

= shows '1'

msg ("a" == "a") . ("a" == "b");

= shows '10'

$r = ("a" == "a"); $r = ($r?"True":"False"); msg $r;

= shows 'True'

$comparison = "a == a"; assert $comparison == "a == a";

= no assertion error

$minver = "7.60.0009"; assert "<xyver>" >= $minver, "This script needs at least XY $minver!"

= no assertion error if XY version is >= 7.60.0009

Strings and Numbers

If you compare two numerical strings, they are compared as integers:

msg ("2" < "10"); // -> true! (both parts are numeric)

msg ("2" < "10a"); // -> false! (only one parts numeric)

msg ("2a" < "10a"); // -> false! (both parts are non-numeric)

The Like (LikeI) and UnLike (UnLikeI) operators

General form:

String Like Pattern (case-sensitive)

String LikeI Pattern (case-insensitive)

Where string is any string expression and Pattern may contain the usual wildcards and special chars used in XY patterns (*?#[]). Note that exact capitalization matters: "Unlike" or "unlike" won't work. These operators must be surrounded by spaces.

Examples:

echo "abc" Like "a*"; //1

echo "Abc" Like "a*"; //0!

echo "Abc" LikeI "a*"; //1!

echo "abc" UnLike "a*"; //0

echo "Abc" UnLike "a*"; //1!

echo "Abc" UnLikeI "a*"; //0!

echo "It's " . ("<date yyyy>" Like "20??"?:"not ") ."the 21st century";

Boolean Operators

Scripting supports Boolean operators in the following order of precedence (see also Operator Precedence):

! NOT (unary operator)

&& AND

|| OR

and AND (case-insensitive: AND, And...)

xor XOR (case-insensitive: xOR, Xor, XOR...)

or OR (case-insensitive: OR, Or...)

Examples

echo not 1; // 0

echo not 0; // 1

echo ! 1; // 0

echo !1; // 0

echo !!!1; // 0

echo !(1 and 0); // 1

// parsed as: (TRUE and FALSE) or (TRUE and TRUE);
echo TRUE and FALSE or TRUE and TRUE; //1

// will show "1", then "done"
$i = 1;
while ($i < 2 && $i > 0) {
echo $i;
$i++;
}
echo "done";

Boolean Constants

The Boolean constants TRUE and FALSE (case is ignored) are recognized if they are used unquoted.

TRUE is resolved to 1.

FALSE is resolved to 0.

Examples

echo TRUE and TRUE; // 1

echo TRUE and FALSE; // 0

echo TRUE and false; // 0 (constants are case-insensitive)

echo TRUE and "false"; // 1! (quoted "false" is NOT a constant)

echo (1==1) == TRUE; // 1

echo (0==1) == FALSE; // 1

echo (1==1) != FALSE; // 1

Note that in a Boolean context the values "" and "0" evaluate to 0 (FALSE). All other values evaluates to 1 (TRUE):

echo "dog" and TRUE; // 1 (TRUE and TRUE)(Boolean context)

echo "dog" == TRUE; // 0 ("dog" == "1") (no Boolean context)

echo "0" == FALSE; // 1 ("0" == "0")(same strings)

echo "" == FALSE; // 0 ("" == "0") (no Boolean context)

echo "" XOR TRUE; // 1 (FALSE XOR TRUE)

echo "0" XOR TRUE; // 1 (FALSE XOR TRUE)

echo "dog" XOR TRUE; // 0 (TRUE XOR TRUE)

Note that "0" and 0 ("1" and 1) are the same in XY scripting, so:

echo 0 == FALSE; // 1 (0 == 0)

echo 0 XOR TRUE; // 1 (FALSE XOR TRUE)

Ternary Conditionals

Scripting knows so-called "ternary conditionals" as used in many other programming languages. The logic is this:

if (condition) {

variable = value-if-true;

} else {

variable = value-if-false;

}

As ternary conditional the same can be written like follows:

variable = (condition) ? value-if-true : value-if-false;

The parentheses and the blanks are optional, so these are identical:

variable = (condition) ? value-if-true : value-if-false;

variable = (condition)? value-if-true: value-if-false;

variable = condition?value-if-true:value-if-false;

The part "condition" has the form

"a" operator "b"

where "a" and "b" are string expressions and "operator" can be one of the following:

== Equal

!= Not Equal

< Less than

> Greater than

<= Less than or Equal to

>= Greater than or Equal to

(none) True if expression is not 0 and not ""

The parts "value-if-true" and "value-if-false" are string expressions.

Examples

$a = "<date hh>" >= "12"? "afternoon": "morning"; msg "Good $a!";

$a = ("<date mm-dd>" == "12-24")? "": "not "; msg "It's $a"."X-mas!";

You can employ ternary conditionals in any argument or part of argument:

msg "Good " . ("<date hh>" >= "12"? "afternoon": "morning") . "!";

msg "It's " . ("<date mm-dd>" == "12-24"? "": "not") . " X-mas!";

Control Structures

Scripting offers various Control Structures by which you can control the order in which the individual statements are executed. Within these structures blocks of statements are grouped by encapsulating them with curly braces.

· If/ElseIf/Else Blocks
· While Loops
· Foreach Loops

If/ElseIf/Else Blocks

General syntax:

if (expression) {
statement;
}
elseif (expression) {
statement;
}
else {
statement;
}

If expression evaluates to TRUE, the following statement block is executed and the other blocks are ignored. If expression evaluates to FALSE the following statement block is ignored and processing continues with the next Elseif or Else block.

Remarks

· Parentheses around the expression are mandatory.
· Curly braces around the statement block are mandatory (even if there is only one statement).
· The Elseif block(s) and Else block are optional. There can be only one Else block and it must be the last block in the whole control structure.

Examples

if (1 == 1) {echo "Hi!"}

// shows "Relax."
if (1 == 2) {
echo "Help!";
}
else {
echo "Relax.";
}

// shows "else", "elseif", "if"
$i = 1;
while ($i) {
if ($i == 3) {
echo "if";
break 2;
}
elseif ($i == 2) {
echo "elseif";
}
else {
echo "else";
}
$i++;
}

While Loops

General syntax:

while (expression) {
statement;
}

The nested statement(s) are executed repeatedly, as long as the while expression evaluates to TRUE. The value of the expression is checked each time at the beginning of the loop. If the while expression evaluates to FALSE from the very beginning, the nested statement(s) won't even be run once.

Remarks

· Parentheses around the expression are mandatory.
· Curly braces around the statement block are mandatory (even if there is only one statement).

Examples

// will show 1, then 2, then terminate the script
while ($i < 2) {$i++; echo $i;};

// will show 1, 2, 3, then terminate the script
$x = 3;
$i = 1;
while ($i <= $x) {
echo $i;
$i++;
}

// nested while blocks are okay
$x = 3;
$i = 1;
while ($i <= $x) {
$w = "Word";
while ($w != "") {
echo "$w No. $i";
$w = "";
}
$i++;
}

// expression is FALSE, message will never show
while (1 == 2) {echo "Help!"};

Foreach Loops

General syntax:

foreach($variable, ListOfTokens, [separator="|"], [flags], [MsgOnEmpty]) {
statement(s);
}

Remarks

· $variable is the variable which receives the value of the next token in each round of the loop. You can use a new variable or an already used one, it does not matter.
· The last value of $variable remains even after the foreach loop.
· ListOfTokens is a string of tokens, separated by a separator.
· The separator defaults to "|" (pipe), but can be set to anything, also multi-character strings.
· Surrounding spaces are not trimmed off on each side of the tokens.
· If ListOfTokens is nothing ("") the loop will still be executed one time with $variable set to nothing.
· flags can be either empty (default) or set to "r" for "reverse direction".
· In MsgOnEmpty you can state an error message for the case that ListOfTokens is empty. If MsgOnEmpty is given (even as empty string "") the loop will not be executed at all.
· SC break and SC continue are supported.

Examples

// returns 3 strings (moon, sun, venus):
foreach($token, "moon,sun,venus", ",") {
echo $token;
}

// returns 3 strings in reversed order (venus, sun, moon):
foreach($token, "moon,sun,venus", ",", "r") {
echo $token;
}

// nested foreach loops
foreach($token, "a|b|c") {
foreach($token2, "1,2,3", ",") {
echo $token . $token2;
}
}

// selected list items
foreach($token, <get selecteditemspathnames |>) {
echo $token;
}

// shows "No files selected!" if no files are selected, and skips the loop
foreach($item, <get selecteditemspathnames>, <crlf>, , "No files selected!") {
echo $item;
}

Heredoc Syntax

Heredoc, using the <<< operator, is a way to define multi-line strings "as is" without the need to escape quotes etc.

The rules follow the PHP rules for Heredoc:

(1) After the <<< operator, an identifier (your free choice) is provided, then a new line. The string itself follows, and then the same identifier again to close the quotation. The closing identifier must begin in the *first* column of the line (no indent!). The line with the closing identifier must contain no other characters, except possibly a semicolon (;) directly after the identifier.
(2) Heredocs overwrite comments, and comments overwrite heredocs, depending on who comes first.

Within the Heredoc section:

(3) Line feeds, empty lines, and all kinds of comments survive.
(4) Lines are not trimmed (leading and trailing spaces are preserved).
(5) Quoting is handled automatically (no need to add outer quotes or to double inner quotes).
(6) Variables are resolved.

Example

A multiline script using Heredoc. Note that the Heredoc block is not indented, that comments are not removed, that quotes are not doubles, and that the variables are resolved, even within comments.

$name = "Bond";
text <<<FOO
My name is $name, "James $name". // line end comment: $name

Follow /* note: there's one space after me, */ me,
FOO
."please!";

Output:

My name is Bond, "James Bond". // line end comment: Bond

Follow /* note: there's one space after me, */ me, please!

Alternative Heredoc Syntax

A more radical parsing where the ending identifier can be anywhere is enabled when the identifier starts with a "#". These examples show two ways to code the same script.

$isOk = Confirm (<<<#FOO
Blah
BlahFOO#FOO); echo $isOk;

With the old-school parsing the ending identifier must be on its own line:

$isOk = Confirm (<<<FOO
Blah
BlahFOO
FOO
); echo $isOk;

Operator Precedence

The precedence of an operator specifies how "tightly" it is connected to its surrounding operands. For example, in the expression 1 + 2 * 3, the answer is 7 and not 9 because the multiplication ("*") operator has a higher precedence than the addition ("+") operator. Parentheses may be used to force precedence, if necessary. For instance: (1 + 2) * 3 evaluates to 9.

The following table lists the precedence of operators with the highest-precedence operators listed at the top of the table. Operators on the same line are evaluated from left to right (3 - 2 + 1 evaluates to 2, not 0):

Operators Additional Information

++ -- Math: Increment, Decrement

! Not Boolean: NOT

+ - Math: Unary Plus, Unary Minus

* / Math: Multiply, Divide

% Math: Modulo

\ Math: Integer division

+ - Math: Add, Subtract

< <= > >= == != Like LikeI UnLike UnLikeI Comparison

&& Boolean: AND

|| Boolean: OR

And Boolean: AND

Xor Boolean: XOR

Or Boolean: OR

? : Ternary

. String concatenator

= Set

Remote Control

*** For software developers only ***

You can run an XYplorer script from an external program using the WM_COPYDATA command with XYplorer's hWnd. This means if you are a programmer you can fully remote control XYplorer.

· cds.dwData: 4194305 (0x00400001)
· cds.lpData: The syntax is identical to the one of the command line switch /script=<script resource>, so you can either pass the path to a script file (commonly called *.xys), or pass the script directly (must be preceded by ::).


Scripting Commands Reference

abs, asc, assert, attrstamp, backupto, beep, box, br, break, button, catalogload, catalogreport, ceil, charview, chr, colorfilter, compare, confirm, continue, copier, copy, copyas, copydata, copyitem, copytext, copyto, ctbicon, ctbstate, datediff, delete, download, echo, end, eval, exists, exit, extratag, filesequal, filesize, filetype, filter, floor, focus, folderreport, format, formatbytes, formatdate, formatlist, fresh, get, getkey, getpathcomponent, gettoken, gettokenindex, global, goto, hash, hashlist, hexdump, hextodec, highlight, html, incr, input, inputfile, inputfolder, inputselect, internetflags, isset, isunicode, listfolder, listpane, load, loadsearch, loadtree, makecoffee, md5, moveas, moveto, msg, new, now, open, openwith, perm, popupmainmenu, popupmenu, property, quickfileview, quote, rand, readfile, readpv, readurl, recase, regexmatches, regexreplace, releaseglobals, rename, renameitem, replace, replacelist, report, resolvepath, rtfm, rotate, round, run, savesettings, sel, selectitems, self, selfilter, seltab, set, setkey, setting, settingp, showhash, sortby, sound, status, step, strlen, strpos, strrepeat, sub, substr, swapnames, sync, tab, tabset, tag, taglist, text, timestamp, toolbar, trim, unset, unstep, urldecode, urlencode, utf8decode, utf8encode, wipe, writefile, writepv, zip_add, zip_extract, zip_list

abs()

Returns the absolute value of a number.

Syntax

abs(number)

number: Must be a number. A string will raise an error.

return: The absolute value of the number.

Examples

echo abs(1); // 1

echo abs(0); // 0

echo abs(-1); // 1

echo abs(-2.3456); // 2.3456

asc()

Returns the ASCII value of a character. This function complements chr().

Syntax

asc(string)

string: character

If string is larger than one character the first character is used.

If string is empty asc() returns "" (empty).

return: ASCII value, range 0-65535 (0xFFFF)

Examples

echo asc("a"); //97

echo asc(chr(20000)); //20000

assert

Interrupts processing on certain conditions.

Syntax

assert condition, [message], [continue=0]

condition: [required] any expression that evaluates to True or False

message: [optional] message that's displayed if condition evaluates to False

continue: [optional] set to 1 to allow continuing the script after displaying the message; else the "Continue" button is disabled; default is 0

Usage

This is mainly a debugging feature to interrupt processing on certain conditions. If the condition evaluates to True the program flow is not interrupted, otherwise you are notified and can investigate what went wrong and decide whether to continue and cancel (if continue=1). So, "assert" can be very useful to keep your scripts under some control.

Apart from debugging you may use it to check (continue=1) or enforce (continue=0) critical preconditions for your scripts to run successfully.

Examples

$a="A"; assert $a=="A", '$a has wrong value!'

= no message (condition is True)

$a="A"; assert $a=="B", '$a has wrong value!', 1

= message (condition is False)

$a="A"; assert $a=="B", '$a has wrong value!', 0

= message (condition is False) and no option to continue

$count = get("CountSelected"); assert $count!=0, "You must select a file before running this script!"

= if no files are selected: message

attrstamp

Sets the attributes for files or folders.

Syntax

attrstamp([attr], [mode=1], [itemlist])

attr: a = FILE_ATTRIBUTE_ARCHIVE (32)
h = FILE_ATTRIBUTE_HIDDEN (2)
r = FILE_ATTRIBUTE_READONLY (1)
s = FILE_ATTRIBUTE_SYSTEM (4)
They can be combined in any order and any case, e.g. "raH".
mode: 0=get, 1=set [Default], 2=replace, 3=toggle, 4=remove.
itemlist: |-separated list of items (full path) to attrstamp;
if empty then the currently selected list items are attrstamped.
return: Old attributes of the last processed item. The return value is made from summing up the attributes bit values, e.g. RAH = 1 + 32 + 2 = 35.

Examples

attrstamp("r"); //set readonly to selected items

attrstamp("rh"); //set readonly and hidden to selected items

attrstamp("r", 2); //set readonly to selected items (any other existing attributes are removed)

attrstamp("r", 3); //toggle readonly in selected items

attrstamp("R", 3); //toggle readonly in selected items (same as above)

attrstamp("r", 4); //remove readonly from selected items

attrstamp("r", , "E:\Test\x"); //set readonly to "E:\Test\x"

If no attributes are passed it just returns the old attributes of the last processed item:

text attrstamp(); //e.g. 5 = 1+4 (readonly and system)

backupto

See moveto.

beep

Generates a simple tone on the motherboard speaker.

Syntax

beep [frequency=800], [duration=200]

frequency The frequency of the sound, in hertz. This parameter must be in the range 37 through 32,767.
Defaults to 800.
duration The duration of the sound, in milliseconds.
Defaults to 200.

Example

beep 800,100; beep 400,100; beep 600,100;

Notes

The function is synchronous; it does not return control to its caller until the sound finishes.

Win7 will send the tone through the soundcard.

box

Define the color for the Boxed Branch feature of the current location on Tree, or turn it off.

Syntax

box [color (rrggbb)], [folder]

color: The new box color in format RRGGBB. If empty or missing the current box color is removed.

folder: [optional] if stated then the highlighting is applied to that folder, else it is applied to the current folder.

Examples

box "00FFFF"

Will set the box color to cyan for the current location.

box

Will disable the Boxed Branch feature for the current location.

box "000000"

Will set the box color for the current location to the default Box color.

box "BBDDBB", "Desktop"

Set green box to Desktop folder.

br

Redefine the default line breaker to be used with scripting commands copytext, msg, and text.

Syntax

br linebreaker

linebreaker: The new line breaker.

Usage

The default line breaker is <br> (as in HTML). If this does not suit you, use br to specify another line breaker.

Examples

br "#" ; msg "line 1#line 2";

Will use a one-character new line-breaker ("#")

br " # "; msg "line 1#still 1 # line 2";

Will use a three-character new line-breaker (" # ")

br;

Prevent any line breaking in commands copytext, msg, and text.

break

Ends execution of a control structure (while loop).

Syntax

break [levels=1]

levels [optional] Numeric argument which specifies how many nested enclosing structures are to be broken out of.
The argument ignores IF blocks.

Example

// script will only show "done"
$i = 1;
while ($i <= 3) {
while ($i <= 2) {
break 2; //jump to echo "done";
echo $i;
}
$i++;
}
echo "done";

button

Emulates a click on a toolbar button.

Syntax

button key, [action=1]

key [required] Key that identifies the button.
You can retrieve the existing keys using the SC toolbar, or using the Customize Toolbar command from a user button's context menu.
action [optional]

0 = do nothing

1 = left-click [default]

2 = right-click

8 = dropdown arrow

256 = customize toolbar dialog, preselect button "key"

Examples

button "mru"; //pops MRU menu at key

button "minitree"; //toggles MiniTree

button "minitree", 2; //pops ctx menu of MiniTree button

button "back", 8; //pops dropdown menu of Back button

button "minitree", 256; //open customize toolbar dialog at MT

Usage

Note that using button you can trigger also buttons that are not part of the current toolbar! The command can become useful in the context menu definition of User Buttons. E.g., you can wrap a number of rarely used buttons into the ctx menu of a single button and thus save space on the toolbar. For example:

"Recent Locations|:mru" button "mru"
"Hotlist|:hotlist" button "hotlist"
-
"CKS|:cks" button "cks"
"UDC|:udc" button "udc"
-
"Exit no save|:exitnosave" button "exitnosave"

catalogload

Loads a Catalog file.

Syntax

catalogload file, [switches=sp]

file: The Catalog file to load.
Can be relative to app data path and portable. If empty the default Catalog (<xydata>\catalog.dat) is (re)loaded.
switches: (can be concatenated in any order):
s: Save any changes in the current Catalog.
p: Make [file] the permanent Catalog, i.e. load this Catalog on next app start.
n: Create a new empty Catalog named [file].
i: Include (temporarily merge) an external catalog in the current one.
u: Unload an included catalog.
[missing]: Defaults to "sp".

Note: If i or u is present all other switches are ignored.

Examples

//save the current Catalog, load <xydata>\catalog2.dat, and make it the new permanent Catalog
catalogload "catalog2.dat";

//do not save the current Catalog, load <xydata>\catalog2.dat, do no make it permanent
catalogload "catalog2.dat", "";

//save the current Catalog, create a new empty Catalog named catalognew.dat in <xydata>, and make it the new permanent Catalog
catalogload "catalognew.dat", "spn";

//discard the current Catalog and reload the default Catalog <xydata>\catalog.dat, and make it permanent
catalogload , "p";

//include a catalog, and unload it again
catalogload "cat_include.dat", "i";
catalogload "cat_include.dat", "u";

catalogreport()

Creates a report on the Catalog.

Syntax

catalogreport(template_category, template_item, [currentcategory=0])

template_category: Template for categories
The following variables are supported:
{Caption} = Caption field.
{Location} = Location field ("Description" in Categories)
{RGB Text} = Text color in RRGGBB format.
{RGB Back} = Background color in RRGGBB format.

template_item: Template for items.
Variables see template_category above.

currentcategory:
0: [Default] Report on whole catalog.
1: Report on current category.

return: The report.

Remarks

· The variables are case-sensitive: "{caption}" won't work.
· If a field is empty the variable is left unresolved.
· If "Apply Colors" in Catalog Properties is OFF then the color variables are left unresolved.
· Multi-line data in location fields (i.e. scripts) are folded into one line. The CR+LF sequences are replaced by PILCROW+TAB.

Examples

text catalogreport("{Caption}","- {Caption}: {Location}");

text catalogreport("Category: {Caption}", " {Caption}, {Location}, {RGB Text}, {RGB Back}");

ceil()

Rounds fractions up.

Syntax

ceil(number)

number Number to ceil.

Examples

echo ceil(3.2); //4

echo ceil(-3.2); //-3

echo ceil(3); //3

charview

Shows the characters of a string in a vertical list in various encodings and notations.

Syntax

charview string

string: The string to view the characters of.

Examples

charview "abcá";

charview <clipboard>; // show string in clipboard

The first example pops this table:

# dec hex utf8 char

1 97 61 a a

2 98 62 b b

3 99 63 c c

4 225 E1 Ã¡ á

chr()

Returns a specific character. This function complements asc().

Syntax

chr(charcode)

charcode: valid range 0-65535 (0xFFFF)

return: character

Examples

msg chr(88).chr(89);

msg chr(28888);

msg quote(chr(28888));

colorfilter()

Activates one or more color filters in Tree and List.

Syntax

colorfilter([filters], [separator=||])

filters: Filter, or list of filters separated by separator.
If empty ("") any color filters are deactivated.
If missing the function just returns the currently active filters.
separator: Separator for list of filters.
return: Currently active filters.

Examples

colorfilter("+lent:>12 //long filenames>BF6000,");

colorfilter("+len:>260 //overlong items>FFFFFF,FB4F04");

colorfilter("+dateM: dw 6-7 //last modified on a weekend>FFFFFF,B83E30");

colorfilter("+ageC d:d //folders created today>EEEEEE,4A97EC||+dir:xy*>FFFF00,FF8000");

colorfilter("prop:#AspectRatio: 4:3>FFFFFF,FB4F04");

colorfilter(""); //deactivate any color filter

text colorfilter(), 800; //return the currently active filters

Remarks and Usage

The filters applied via colorfilter() are functionally identical to Instant Color Filters. Details see Instant Color Filters.

compare()

Compares two strings.

Syntax

compare(string1, string2, [method=b])

method:

b: [default] binary, bytes: strings are compared alphabetically
i: same as b, but case-insensitive: A=a
n: numeric: strings are converted to numbers (fractions use dot) and then compared numerically
v: version: compares file versions of formats like #.## or #.##.#### or #.##.##.##
d: date: compares dates, optionally including times; both string1 and string2 default to the current date/time.
Valid date syntax depends on your locale. Fractions of a second (up to 7 decimal digits) are supported.

return:

-1 if string1 < string2
0 if string1 == string2
1 if string1 > string2

Examples

echo compare("a", "b"); // -1

echo compare("a", "A"); // 1 (a is sorted after A)

echo compare("a", "A", "i"); // 0

echo compare("2", "12", "b"); // 1

echo compare("2", "12", "n"); // -1

echo compare("10.20.0025", "7.60.0026", "b"); // -1

echo compare("10.20.0025", "7.60.0026", "v"); // 1

echo compare("24.08.2012", "25.08.2012", "d"); //-1

echo compare("24.08.2012", "24.08.2012", "d"); //0

echo compare("25.08.2012", "24.08.2012", "d"); //1

echo compare("24.08.2012 08:43:01", "24.08.2012 08:43:02", "d"); //-1

echo compare("24.08.2012 08:43:02", "24.08.2012 08:43:01", "d"); //1

echo compare("24.08.2012 08:43:01.000", "24.08.2012 08:43:01.001", "d"); //-1

confirm()

Pops message box with OK/Cancel, returns result.

Syntax

confirm(message, [linebreaker="<br>"], [defaultbutton=1])

message message

defaultbutton
1: [Default] First button (OK)
2: Second button (Cancel)

linebreaker [optional] Any character sequence to be replaced by a line break. Defaults to "<br>". Pass "" to prevent any replacing.
return 1 on OK, 0 on Cancel

Examples

msg confirm("Ok?");

msg "You pressed " . (confirm("Ok?")==1?"OK":"Cancel") . ".";

msg confirm("Ok?") . confirm("Are you sure?");

echo confirm("Should#I#stay#or#should#I#go#?", "#");

echo confirm("Should#I#stay#or#should#I#go#?", "#", 2);

continue

Skips the rest of the current control structure (while loop) and continues execution at the condition evaluation.

Syntax

continue [levels=1]

levels [optional] Numeric argument which specifies how many levels of enclosing loops it should skip to the end of.
The argument ignores IF blocks.

Example

// script will only show "done"
$i = 1;
while ($i <= 3) {
$i++;
continue;
echo $i;
}
echo "done";

copier

Defines an external program to handle copy and move operations.

Syntax

copier([definition])

definition: Defines which program to use and how.
General syntax: Caption|Executable|Switches
Details see External Copy Handlers.
Set to "" to use XYplorer's Custom Copy.
return: the current definition.

Examples

copier("FastCopy (AutoClose)||/auto_close"); //set copy handler

copier(""); //back to XYplorer's Custom Copy

echo copier(); //show current definition (don't change anything)

$old = copier(""); //store current definition, then reset it to ""

Notes

Custom Copy has to be enabled to actually use the external copy handler. Else Windows Shell copy is used.

copy

Copies item(s) to the clipboard.

Syntax

copy itemlist

itemlist: |-separated list of items (files or folders); items support environment variables, XY native variables, relative (to app path) and portable paths.

Examples

copy "E:\Test\Test.txt|E:\Test\a\alpha.png";

copy "D:\TestD.txt|E:\TestE.txt|F:\TestF.txt";

Usage

Allows you to copy any items to the clipboard without the need to go to their locations first to fetch them. It also allows you to copy items from distributed locations in one go which is not possible by any other means.

Note

The command will only copy those items that do exist/are available in this moment. Other items are silently ignored. If none of the passed items are available you get a message.

copyas, moveas

Copies item(s) under a pattern-based name.

The moveas command works analog to the copyas command, with the only obvious difference that the items are moved instead of copied.

Syntax

copyas [pattern], [targetpath], [itemlist]

pattern: [optional] Name pattern where
* stands for the file base, and
? stands for the file extension (without dot).
Variables are allowed.
If empty then you get prompted.
targetpath: [optional] Path to copy the items to.
If empty then the current list path is used.
The path is silently auto-created if it does not exist.
itemlist: [optional] |-separated list of items (full path, or relative to current path) to copy.
If empty then the current list selections are copied.

Incremental suffixes are appended as needed to avoid collisions.

Examples

Copies all selected items to the current list path under the name ["Copy" + original Extension]:
copyas "Copy.?"

Creates copies named [original name]_backup_20100117.[original extension] if today is 17-Jan-2010:
copyas "*_backup_<date yyyymmdd>.?";

Same as doing menu File | Duplicate | Copy Here As...:
copyas;

Copies all selected items to D:\ under their original name:
copyas "*.?", "D:\";

Copies two specific files to D:\ under a pattern-based name:
copyas "*-copy.?", "D:\", "E:\Test\alpha.png|E:\Test\beta.png";

You can run a line like this to locally backup each item with its modified date in the target name. Note that you have to pass the argument in single quotes to make it work as expected -- otherwise the date variable is resolved to the modified date of the *current item* before the argument is passed to copyas:
::copyas '*_backup_<datem yyyymmdd>.?';

copydata

Sends data to another window.

Syntax

copydata hwnd, data, mode

hwnd: Handle of the target window.
data: Text data to send.

mode:

0: Nothing special, simply send the text data.

1: Text data is an XYplorer script to be executed by the receiving window (which in this case, of course, has to be XYplorer.exe).

2: Resolve variables in data and return to sender immediately. Variables are XYplorer native and environment variables.

Examples

Run a small script in another XYplorer (197078):

copydata 197078, "::echo 'hi';", 1;

Return the contents of variable <curitem> from another XYplorer (197078) to this window (1573124), using copydata first in this XYplorer process and then again in the other XYplorer process for the return:

copydata 197078, '::copydata 1573124, <curitem>;', 1;

Determine <curitem> in another XYplorer instance (hWnd 197078):

copydata 197078, '<curitem>', 2; echo <get copieddata 3>;

Note that the single quotes in the example are essential else <curitem> would be resolved in *this* instance of XYplorer before being sent to the other instance.

Notes

· The command only returns when the receiving window has fully processed the data. For example if you send a script the command will return only after the script has terminated.
· The mode parameter in SC CopyData simply selects different dwData:
If called with mode 0 then cds.dwData == 4194304 (0x00400000)
If called with mode 1 then cds.dwData == 4194305 (0x00400001)
If called with mode 2 then cds.dwData == 4194306 (0x00400002)
So any application can use these dwData values to trigger a specific reaction in XYplorer when it receives data via WM_COPYDATA.

copyitem

Creates a copy of a file or folder (with all contents).

Syntax

copyitem [item], [copy]

item: [optional] Full path/name of the item to copy; if missing defaults to current item can be relative to current path.
copy: [optional] Full path/name of the copy to create; if missing defaults to current item plus an automatic incremental suffix.
Can be relative to current path.
Can contain * to stand for the base of item.
Can contain ? to stand for the extension of item.

Examples

If the current item is "blah.txt" then this will create "blah-01.txt" in the current folder:

copyitem;

Duplicates "blah.txt" as "blub.txt" in another location:

copyitem "C:\Temp\blah.txt", "D:\blub.txt";

Will create folder "new\" if necessary:

copyitem "C:\Temp\blah.txt", "D:\new\blub.txt";

Duplicates "blah.txt" in the current path as "blah-copy.txt":

copyitem "C:\Temp\blah.txt", "*-copy.?";

Backup XY data folder to [e.g.] "...\appdata_backup_20090515":

copyitem "<xydata>", "<xydata>_backup_<date yyyymmdd>";

Duplicates folder "C:\Temp" with all its contents as "C:\Temp-01":

copyitem "C:\Temp";

Remarks

(1) The command uses the shell copy engine for the job. Hence you get the usual prompts about overwriting and no support for overlong filenames (> 260 characters).
(2) Any non-existing folders in the target are silently created without asking you politely for your approval.
(3) Note the difference to the command "CopyTo": In CopyTo the "location" argument is the destination where the source is copied to. In CopyItem the "copy" argument is the name of the copy itself.
(4) You cannot pass a drive, server, or share, as argument.
(5) Trailing slashes for folders are optional.
(6) The "copyitem" command partly overlaps functionally with the "new" command when you pass a source argument to the latter. However, "copyitem" is straighter to use for the job and has additional powers (e.g. using wildcards * and ?). Also, "new" will never overwrite an existing file or folder whereas "copyitem" will (unless you omit the "copy" argument).
(7) The command sets last target (used by menu View | Go to Last Target).

copytext

This command allows you to copy or append text to the clipboard.

Syntax

copytext text, [append], [linebreaker="<br>"]

text The text to be copied/append to the clipboard.
append [optional]
[empty]: Copy text to clipboard
a: Append text to clipboard
linebreaker [optional] Any character sequence to be replaced by a line break. Defaults to "<br>". Pass "" to prevent any replacing.

Usage

Simply call the command with whatever text you want to copy into our clipboard, or add parameter a to append it . You can also, of course, copy any variables to the clipboard, which are resolved before being added. For multiline text you can use the line breaker <br> which will be converted to a CRLF (0D0A).

You can change the default line breaker (<br>) by using command br first.

Examples

copytext "Hey, it's some other Galaxy!";

Copies Hey, it's some other Galaxy! to the clipboard.

copytext """Hey, it's some other Galaxy!""";

Copies "Hey, it's some other Galaxy!" (with quotes) to the clipboard.

copytext "The current XYplorer running is:"; copytext "<br><xypath>\<xyexe>", a;

Copies XYplorer is running from: to the clipboard, and appends XY's app path and EXE name on a new line to the clipboard.

In the end, the clipboard would contain something like this:

The current XYplorer running is:

C:\Program Files\XYplorer\XYplorer.exe

copyto

See moveto.

ctbicon

Set/Get the icon of a Custom Toolbar Button (CTB).

Syntax

ctbicon([icon], [button_index])

icon Whatever can be entered into the Icon field in a CTB definition, e.g.:
- Path to an icon resource (ICO, ICL, EXE, or DLL file). Full path or relative to <xyicon>.
- Toolbar icon key of XYplorer's internal toolbar icons; e.g. ":home".
If empty the function only returns the current icon.
button_index Index of the button.
If empty then the index of the button owning the script is used.
If the script is called from outside a CTB you *have* to state a button index, else you will get an error message.
return The current icon (before any new icon was set).

Example

Use this script in the On Click event of a CTB; you need icons Apple.ico and Apple_Half.ico in <xyicons>:

// apple toggle
if (ctbicon() == "Apple.ico") {
ctbicon("Apple_Half.ico");
} else {
ctbicon("Apple.ico");
}

Notes

· The new icon set via scripting is treated just like an icon set via UI; so it is as well remembered across sessions.
· You can even set icons of buttons that are not shown in the current toolbar.

ctbstate

Set/Get the pressed state of a Custom Toolbar Button (CTB).

Syntax

ctbstate([state], [button_index])

state 0 = unpressed
1 = pressed
button_index Index of the button.
If empty then the index of the button owning the script is used.
If the script is called from outside a CTB you *have* to state a button index, else you will get an error message.
return The current state (before any new state was set).

Example

Use this script in the On Click event of a CTB:

// state toggle
if (ctbstate() == 1) {
ctbstate(0);
} else {
ctbstate(1);
}

Notes

· The state is remembered across sessions.
· You can even set the state of buttons that are not shown in the current toolbar.

datediff

Returns the number of time intervals between two dates.

Syntax

datediff(date1, [date2=now], [interval=d])

date1 [required] First (earlier) date/time.
date2 [optional] Second (later) date/time.
Defaults to now.
interval [optional] Time interval you want to use as the unit of difference between date1 and date2. Defaults to "d" (days).

y = years

m = months

w = weeks

d = days [default]

h = hours

n = minutes

s = seconds

ms = milliseconds

us = microseconds

ns = nanoseconds

return Number of time intervals between date1 and date2. Negative if date1 is later than date2.

Remarks

The date expressions should be formatted either in the current locale, or in the universal ISO 8601 format (YYYY-MM-DD hh:nn:ss).

Examples

text "The Beijing Olympics were opened " . datediff("2008-08-08") . " days ago.";

text "The current file is " . datediff("<datec>",,"h") . " hours old.";

text datediff("2008-08-08 14:22:50.222", "2008-08-08 14:22:50.224", "ms"); //2

delete

Delete selected Tree or List item(s).

Syntax

delete [recycle=1], [confirm], [itemlist]

recycle

1 = [default] use Recycle Bin

0 = delete (no Recycle Bin)

confirm

1 = confirmation prompt

0 = no confirmation prompt

[empty] = [default] user setting in configuration

itemlist |-separated list of items (full path) to delete. The | (pipe) respectively the items may be surrounded by any number of blanks. Folders should not have a trailing slash.
You can use wildcards ( * ? ) to delete multiple items at once.
Any non-existing items passed in itemlist are silently ignored.

[empty] = [default] current Tree or List selections are deleted, depending on the focus.

:tree = delete current tree selection

:list = delete current list selection(s)

Examples

delete 1, 0, ":list"

Send all selected list items to the Recycle Bin, no questions.

delete 0, 1, ":tree"

Delete the selected tree folder (NO Recycle Bin), ask before.

delete or delete 1

Delete selected Tree or List items (depending on focus), use Recycle Bin, confirmation prompt depending on user settings.

delete 0, 0

Delete selected Tree or List items (depending on focus), NO Recycle Bin, NO questions.

delete 1, 1, "E:\TestFiles\Temp\droptest\resource.h | E:\TestFiles\Temp\droptest\MainFrm.h"

Delete those two files, use Recycle Bin, ask before.

delete 1, 1, "E:\Folder\*.tmp | E:\Folder\*.bak";

Delete all INI and BAK files in E:\Folder, use Recycle Bin, ask before.

download

Download a file from the internet to a specified location.

Syntax

download url, [targetfile], [options]

url: [required] any URL (http:// or ftp://)
targetfile: [optional] full path/file of desired target; UNC works as well
Defaults:
- if empty: [current path]\sourceurlfilename
- if only file (or relative path): [current path]\targetfile
- if only path: [targetfile]\sourceurlfilename
- if sourceurl has no filename: "Download[current date].htm"
options: [optional]
[empty] = On collision: ask before overwriting.
o = On collision: overwrite without asking.
i = On collision: auto-increment targetfile.
b = Check byte count after download. On no-match the download fails.
s = Silent: No status bar progress and success messages.

Examples

download "http://www.xyplorer.com/tour/images/pfa.png";

Download "pfa.png" to "[current path]\pfa.png".

download "http://www.xyplorer.com/tour/images/pfa.png", , i;

Download "pfa.png" to "[current path]\pfa.png". Add increment (e.g. pfa-01.png) if pfa.png already exists.

download "http://www.xyplorer.com/download/xyplorer_full.zip","xy.zip";

Download "xyplorer_full.zip" to "[current path]\xy.zip".

download "http://www.xyplorer.com/";

Download "index.htm" to "[current path]\Download-20080905.htm".

download "ftp://ftp.editplus.com/epp230hlp.zip", "D:\Download\";

Download "epp230hlp.zip" to "D:\Download\epp230hlp.zip".

Remarks

The application waits until the download is complete. You can abort the download at any time by pressing ESC.

The downloaded data size is not limited. Files are streamed onto disk (you can see them growing in the file list).

The download progress is shown in the status bar.

If there is no internet connection, your system might attempt to establish one (if you configured it like that) and then continue with the download.

If sourceurl is ftp:// then there is currently no test for existence of the remote file, nor can its size be determined. Nevertheless the download works (but you cannot know how long it will take).

Only anonymous FTP is supported.

After a successful download the Last Target Path is set (menu Go | Go To Last Target).

The format of [current date] is defined in Configuration | Templates under Filename affixes.

echo

Shows a simple message box.

Syntax

echo text

text: text

Examples

echo "hi!";

echo <date>;

Remarks

It's the smaller brother of msg. Added mainly for compatibility with PHP code.

end

Terminates a running script.

Syntax

end condition, [message], [scope=0]

condition: if True the script is ended else nothing happens
(True = anything but 0 or empty)
[message]: message before ending

[scope]:

0: [default] end whole script stack
1: (or any other value) end this script

Examples

end 1==2; msg "Still here!"; //"Still here!"

end 1==1; msg "Still here!"; //ends silently

end 1==1, "Bye!"; msg "Still here!"; //"Bye!", then ends

end confirm("Are you sure to continue?") == 0, "Bye!"; msg "Still here!";

eval()

Evaluates an expression.

Syntax

eval(expression)

expression: The expression to evaluate.

return: The evaluated expression.

Examples

$a = "1 + 1";
echo $a; //1 + 1
echo eval($a); //2

$a = '<xypath>';
echo $a; //<xypath>
echo eval($a); //C:\Progs\XYplorer

// Little calculator
$math = input("Little calculator", "Paste your math:", "1 + 1");
echo "The result is: " . eval($math);

// Also functions are resolved in eval(). Result: This is the time: 19:11:53!
$v = '" $x " . substr("exact time:", 6) . " <date hh:nn:ss>"';
$x = "the";
$s = eval($v); // will also evaluate the substr(), and concatenate it with the rest!
text "This is" . $s . "!";

exists()

Checks whether a file or directory or URL exists.

Syntax

exists(item)

item: Full path (local or UNC) to a file system item, or URL.
return: 0 = does not exist
0|404 = URL returned 404
1 = exists (file)
2 = exists (folder; drive; share; server)

Examples

echo exists("C:\autoexec.bat"); //1

echo exists("C:"); //2

echo exists("C:\"); //2

echo exists("C:\Windows"); //2

echo exists("C:\Windows\"); //2

echo exists("C:\*.bat"); //0 - wildcards are NOT recognized

Note on checking URLs

The function can take some seconds on first URL access.

Remarks

The API function used to determine the existence and nature of the item is inherently tolerant with trailing spaces, and it resolves relative syntax (\..\.. etc) before doing the check.

Some of those special cases:

echo exists("C:\autoexec.bat "); //1

echo exists("C:\autoexec.bat\.."); //2 (!)

echo exists("XYplorer.exe"); //1 (!)

echo exists("appdata"); //2 (!) - if folder "appdata" is below the current path (= xypath)

exit

Exit XYplorer, optionally with restart.

Syntax

exit [mode]

mode: exit mode

[empty]: exit (= #192)
Saving depends on user setting in Configuration | Startup & Exit | Save settings on exit.

s: exit with saving (no menu command)

n: exit without saving (= #191)

sr: restart with saving (no menu command)

nr: restart without saving (= #190)

Examples

exit; //default exit, like clicking X-xlose

exit "nr"; //restart without saving

extratag()

Sets or gets an Extra Tag definition.

Syntax

extratag([id], [definition])

id: Extra Tag index: 1 to 5.
OR: Extra Tag field prefix: ex1 to ex5.
OR: Current column caption.
If missing: Return the definitions for all Extra Tags, one per line.
definition: Extra Tag definition.
Format 1: Caption|Type|Prop|DefaultIndex|List[|Reserved|Reserved|Reserved|Reserved]
This will change the whole definition.
Format 2: Caption
This will change just the column caption.
If missing then only the current definition is returned.
return: The previous definition.

Examples

echo extratag(4); //get Extra Tag 4

extratag(4, "Colors|6|0|0|blue;red;yellow;green||||"); //set Extra Tag 4

echo extratag(4, "Colors|6|0|0|blue;red;yellow;green||||"); //set/get Extra Tag 4

extratag(4, "Shades"); //set caption of Extra Tag 4

extratag("ex4", "Shades"); //set caption of Extra Tag 4 to Shades

extratag("Shades", "Sharks"); //set caption of Extra Tag "Shades" to "Sharks"

text extratag(); //return the definitions for all Extra Tags

Notes

Changes, e.g. new column captions, are immediately applied to the list when applicable.

filesequal()

Compares two files for identity.

Syntax

filesequal([file1], [file2], [algo])

file1 First file. Defaults to first selected file.
file2 Second file. Defaults to first or second (if first file defaulted to first selected file) selected file.
algo Hash algorithm; one of the following:
(empty) Compare files bytewise.
md5: MD5.
crc32: CRC-32.
sha1: SHA-1.
sha256: SHA-256.
sha512: SHA-512.
return -1 = Function failed.
0 = Files are different.
1 = Files are identical.

Examples

echo filesequal(); //first two selected files, bytewise

echo filesequal("D:\a.txt", "D:\b.txt", "sha256");

filesize()

Retrieves the size of the specified file, in bytes.

Syntax

filesize([filename])

filename File full path/name, or relative to current path;
defaults to the current file.

Examples

echo filesize();

echo filesize("C:\WINDOWS\explorer.exe");

filetype()

Analyzes a file by its contents.

Syntax

filetype(file)

file full path/file name to analyze;
defaults to the current file.

return

Ascii It's an ASCII text file.
UTF-8 It's a UTF-8 file.
UTF-8 BOM It's a UTF-8 BOM file.
UTF-16LE It's a UTF-16LE file.
UTF-16LE It's a UTF-16LE file.
UTF-16BE It's a UTF-16BE file.
Binary It's a binary file.
Empty It's an empty file.
Cannot Cannot open file.
Nofile It's not an existing file.

Example

echo filetype(<curitem>);

filter

Define a Visual Filter or remove any existing Visual Filter.

Syntax

filter [filterspec], [flags]

filterspec The Visual Filter to apply to the List.
If empty or missing any existing Visual Filter is removed. See Visual Filters for syntax.
flags (bit field)
1: Handle open square brackets, i.e. convert "[" to "[[]" to allow matching "[". Without this conversion "[" and "]" are interpreted as group markers by the pattern parser.
Note that setting this flag is necessary only if the closing square bracket is present as well right of the opening bracket. Otherwise there is no ambiguity and the necessary things are done automatically even without the flag.

Examples

filter "*.txt" // show only *.txt files

filter "*.zip;*.rar"; // show only ZIP and RAR files

filter "*[*"; // show only items with [

filter "*[ab]*", 0; // show only items with "a" or "b"

filter "*[ab]*", 1; // show only items with "[ab]"

filter; // remove any filters (show all files)

floor()

Rounds fractions down.

Syntax

floor(number)

number Number to floor.

Examples

echo floor(3.7); //3

echo floor(-3.7); //-4

echo floor(3); //3

focus

Set the focus to a specified control of the XYplorer main window.

Syntax

focus [control (L|A|T|C|P1|P2|PI)]

control: The control to focus

L: [Default] List

T: Tree

C: Catalog

A: Address Bar

P1: Pane 1 (left/top pane)

P2: Pane 2 (right/bottom pane)

PI: Inactive Pane

The command focus does NOT show a control if it's not visible already; in that case the focus won't move from its current position.

Examples

focus or focus "L"

Set focus to the List.

focus "C"

Set focus to the Catalog.

folderreport()

Creates a report on a folder.

Syntax

folderreport([type=dump], [target=clipboard], [folder], [flags], [outputfile], [separator])

type Type of report, one of the following:
dump: [Default] Classic directory dump.
bcsv: Basic info to CSV.
ecsv: Extended info to CSV.
tree[:template]: Tree structure only. (see Remarks)
dirs[:template]: List of subfolders (like a flat Tree). (see Remarks)
dirsrel: List of subfolders relative to current folder.
files[:template]: List of files in current folder (absolute paths). (see Remarks)
filesrel: List of files in current folder (relative paths).
items[:template]: List of items in current folder (absolute paths). (see Remarks)
itemsrel: List of items in current folder (relative paths).
list: The current list contents.
target Target of report, one of the following:
u, popup: Show in popup.
c, clipboard: Copy to clipboard.
f, file: Write to file.
p, printer: Print.
r, return: Return data to running script.
folder Folder to report on; defaults to the current folder.
flags A combination of these in any order:
a: Append to output file. Only for target "file".
j: Include Junctions.
p: Prompt to view output file. Only for target "file".
r: Recurse subfolders. Not for type "list".
v: Include version information. Only for types "dump" and "bcsv".
outputfile Output file. Only for target "file".
separator Separator between records. Only for types tree, dirs, dirsrel, items, itemsrel, files, filesrel.
If missing records are returned one per line.
return The report data (if target is "return").

Remarks

· The function provides scripting access to the commands available in the Report tab in the Info Panel. But, in particular through the folder parameter, and through format templates (see below), it goes well beyond the UI commands.
· The behavior is not fully controlled by scripting, but also by settings in Configuration | Report, and in Info Panel | Report. However, the properties that *are* controllable by scripting overwrite the interface settings. E.g. the state of the "Include subfolders" checkbox has no impact on the behavior of folderreport; this property is only controlled by the "flags" parameter.
· Types "tree", "dirs", "files", and "items" support a format template. The template is appended to the selector separated by a ":" (colon), and it fully supports the syntax of the template argument in report.
When the template contains the {size} field the size of each listed folder is freshly calculated! This can take time with large folders.

Examples

folderreport("dump", "clipboard", "E:\Test\", "r");

folderreport("dump", "file");

folderreport("dump", "file", <xypath>, "a", "C:\temp\test.txt");

folderreport("bcsv", "c", "C:\Program Files\XYplorer\", "v");

text folderreport("dump", "r", "C:\Program Files\XYplorer\", "v");

This returns a pipe-separated list of all files in the current path (recursive):

text folderreport("files", "r", , "r", , "|");

Examples for using format templates

Recursive report on the current folder:

text folderreport("dirs:{fullname}; {size kbr}; {modified yyyy-mm-dd}", "r", , "r");

Non-recursive report on C:\Temp:

text folderreport("dirs:{name} ({size} bytes)", "r", "C:\Temp");

Recursive tree report on C:\Temp:

text folderreport("tree:{name} ({size mb}, {count} items)", "r", "C:\Temp", "r");

Return similar to dos command 'dir /b /s':

text folderreport("items", "r", , "r");

Returns path and name for an folder, additional size and mod date for files:

text folderreport("items:{dir {fullname}|{fullname}; {size kbr}; {modified yyyy-mm-dd}|}", "r", , "r");

Returns CSV with user chosen info and self-defined separator TAB:

text folderreport("items:{fullname}<tab>{size kbr}<tab>{modified}", "r", , "r");

format()

Returns a string formatted.

Syntax

format(string, style)

string String to format: can be a number or a date.
style Description of the desired format.

Remarks

Date expressions should be formatted either in the current locale, or in the universal ISO 8601 format (YYYY-MM-DD hh:nn:ss).

Examples

text format(1, "000"); //001

text format(1, "@@@"); // 1 (leading spaces)

text format(1234.56, "#,0.00"); //1,234.56

text format(<date>, "yyyy"); //2010

text format(<date>, "dd-mmm-yy"); //20-Sep-10

text format(<date>, "dddd"); //Monday (in your locale)

// create a number of empty TXT files in the current folder
$numfiles = input("Number of files to create", , "10");
$i = 1;
while ($i <= $numfiles) {
new("file" . format($i, "000") . ".txt");
$i++;
}

formatbytes()

Formats a number as bytes, respectively converts byte formats.

Syntax

formatbytes(bytes, [format=FLEX], [decimals=-1])

bytes The number to format.
Can be a raw number or a string like "2 KB".
format The desired formatting. One of the following:
FLEX: [Default] Flexible (best unit is auto-selected).
FLEXR: FLEX, but rounded up.
KB, MB, GB, TB, or PB: usual bytes unit.
KBR: KB, but rounded up.
BB: Bytes (with unit)
B: Bytes (no unit)
RAW: Raw number (no unit, no thousand separators).
decimals The number of decimal points.
Ignored if format is B, BB, KBR, or FLEXR.
-1: System default.
return Formatted number.

Remarks

- The returned numbers are rounded to 2 digits and have thousand separators (unless "R" is stated as format).
- Note that the function is locale-specific! Decimal and thousand separators may be different from locale to locale. However, the first argument accepts the dot and the local decimal separator as decimal separator. This is relevant only in locales where the decimal separator is not the dot, of course. For example:
echo formatbytes("1.5 KB", "bb"); //1.536 bytes -- works in any Windows
echo formatbytes("1,5 KB", "bb"); //1.536 bytes -- works in German Windows

Examples for US locale:

text formatbytes("1.34 MB", "KB"); //1,372.16 KB

text formatbytes("1,372.16 KB", "MB"); //1.34 MB

Examples for German locale:

text formatbytes("1,34 MB", "KB"); //1.372,16 KB

text formatbytes("1.372,16 KB", "MB"); //1,34 MB

More examples for German locale:

text formatbytes("2 kb", "b"); //2.048

text formatbytes("2 kb", "bb"); //2.048 bytes

text formatbytes(2560); //2,50 KB

text formatbytes("2560"); //2,50 KB

text formatbytes("2560", "FLEX"); //2,50 KB

text formatbytes("2560", "FLEXR"); //3 KB

text formatbytes(2048 * 1024); //2,00 MB

text formatbytes(2048 * 1024 . "KB"); //2,00 GB

text formatbytes("1,5 MB", "RAW"); //1572864

Rounding (German locale):

text formatbytes(1, "KB"); //0,00 KB

text formatbytes(1, "KB", 0); //0 KB

text formatbytes(1, "KB", 2); //0,00 KB

text formatbytes(1, "KBR"); //1 KB

text formatbytes(512, "KB"); // 0,50 KB

text formatbytes(512, "KB", 0); // 1 KB

text formatbytes(512, "KB", 2); // 0,50 KB

text formatbytes(512, "KBR"); // 1 KB

formatdate()

Returns a date/time expression in a specific format, optionally shifted by a specific interval.

Syntax

formatdate([date], [format], [shift_unit], [shift_num])

date [optional] Date expression to be formatted.
Defaults to now.
The date expression should be formatted either in the current locale, or in the universal ISO 8601 format (YYYY-MM-DD hh:nn:ss).
format [optional] e.g. yyyymmdd_hhnnss;
also supports named formats Zodiac and ISOWeek.
Defaults to general system date/time format.
shift_unit [optional] unit to shift date by
y = years
m = months
w = weeks
d = days
h = hours
n = minutes
s = seconds
Legal results: between 01.01.0100 and 31.12.9999, else error
shift_num [optional] number of units to shift date by;
negative to go back in time;
must be an integer value.

Examples

text formatdate(); //16.08.2009 08:27:05

text formatdate(, "yyyymmdd_hhnnss"); //20090816_082217

text formatdate("", "yyyymmdd_hhnnss"); //Error: Invalid date

text formatdate("16.08.2009", "Zodiac"); //Leo

Examples for shifted dates

// returns 16.08.2009 08:00:03

text formatdate("16.08.2009 08:00:00", , "s", 3);

// returns 16.08.2009 08:03:00 (+ 3 minutes)

text formatdate("16.08.2009 08:00:00", , "s", 180);

// returns 16.08.2009 07:59:59

text formatdate("16.08.2009 08:00:00", , "s", -1);

// returns 16.08.2009 11:30:00 (+ 3.5 hours)

text formatdate("16.08.2009 08:00:00", , "n", 210);

// returns 16.08.2009 08:00:00 with error "Date shifting failed"

text formatdate("16.08.2009 08:00:00", , "y", 7991);

Usage

A practical example would be to shift the timestamp of your photos after coming back from a holiday in a different time zone:

//set modified date of current file to its EXIF + 6 hours

timestamp m, formatdate("<dateexif>", , "h", 6);

formatlist()

Formats a list of items.

Syntax

formatlist(list, [format], [separator="|"], [param])

list The list to format.
format Switches for the desired formatting. Can be freely combined in any order. (Of course, the combinations should be meaningful.)
t = trim (remove surrounding spaces)
u = unquote the items
s = sort ascending (by default case-insensitive: A==a)
r = sort descending (think "reversed order")
c = sort case-sensitive (A!=a)
n = sort naturally (can only be case-insensitive!)
v = reverse sort (reverse the current order, whatever it is)
x = shuffle (randomize order)
e = remove empty items
d = remove duplicate items (think "dedupe")
f = filter
q = quote the items
p = perforate (split by length of parts, not by separator; the separator is inserted between the parts)
separator Separates the items in the list; defaults to | (pipe).
If you pass "" (empty) the list is treated as a list of single characters.
param On format x: Seeds the randomizer used for shuffling. Can be any number. If a seed is passed, the randomizer always generates the same random sequence for this seed.
On format p: Length of parts the list shall be split into. If missing or smaller than 1 it is set to 1.
On format f: A list of filters, separated by separator (3rd argument). The filters support the usual pattern wildcards (*?#). Format f also supports inversion by a prefixed "!". If inverted, the filter returns all non-matching items. If more than one filter is stated (OR-ed list of filters) the inversion is applied to combined result of all filters. You cannot invert individual filters. See examples below.
return The formatted list.

Notes

- Trimming is done before unquoting.
- Unquoting is done before sorting.
- Sorting is done before removing duplicates.
- Sorting is by default case-insensitive (A==a). Passing switch "c" forces it to be case-sensitive, unless "n" is passed as well which overwrites "c" and forces case-insensitive sorting.
- Sorting naturally (3 < 20 < 100) is only supported from XP onwards.
- Passing "r", "c", or "n" implies "s".
- Passing "x" (shuffle) overwrites any other sorting flags.
- Removing empty items is done before removing duplicates.
- Removing duplicates only works on adjacent items, so if the list is not sorted non-adjacent duplicates remain in the list.
- Duplicates are matched case-insensitive (A==a).
- Quoting is done as the last step. Items that are already quoted in the source are not quoted again.
- If "list" is empty then an empty (and unquoted) string is returned, even if the "q"-switch is passed.
- If "format" is empty then "list" is returned unchanged.

Examples

text formatlist("b|a|c", "s"); //a|b|c

text formatlist("b|a|c", "r"); //c|b|a

text formatlist("b|a|c", "v"); //c|a|b

text formatlist("b||a|c", "s"); //|a|b|c

text formatlist("b||a|c", "se"); //a|b|c

text formatlist(" b | |a | c", "s"); // | c| b |a

text formatlist(" b | |a | c", "set"); //a|b|c

text formatlist('b|"a"|c', "s"); //"a"|b|c

text formatlist('b|"a"|c', "su"); //a|b|c

text formatlist("bac", "s", ""); //abc (empty separator)

text formatlist("3b|10a|200c", "s"); //10a|200c|3b

text formatlist("3b|10a|200c", "n"); //3b|10a|200c

text formatlist("3b|10a|200c", "nr"); //200c|10a|3b

text formatlist("b|a|C|D", "s"); //a|b|C|D

text formatlist("b|a|C|D", "c"); //C|D|a|b

text formatlist("b|a|a|a|c", "s"); //a|a|a|b|c

text formatlist("b|a|a|a|c", "sd"); //a|b|c

text formatlist("b|b|a|b|c", "d"); //b|a|b|c

text formatlist("b||b|a|b|c", "ed"); //b|a|b|c

text formatlist("b||b|a|b|c", "eds"); //a|b|c

text formatlist("b||b|a|b|c", "edsq"); //"a"|"b"|"c"

text formatlist("ba|a|c", "f", , "a|b"); //a

text formatlist("ba|a", "f", , "a*"); //a

text formatlist("ba|a", "f", , "*a"); //ba|a

text formatlist("b|a|c", "q"); //"b"|"a"|"c"

text formatlist("b", "q"); //"b"

text formatlist("", "q"); //returns empty string, *not* quoted

text formatlist("b|a|c", "x"); //a|c|b ... b|c|a ... c|b|a ... (no seed passed)

text formatlist("b|a|c", "x", , 19); //always b|a|c (seed 19 passed)

text formatlist("abcdefg", "pr", , 2); //g|ef|cd|ab

text formatlist("abcdefg", "p", "." , 1); //a.b.c.d.e.f.g

Format f and inversion by prefixed "!": To use "!" as a normal character in the first position of the filter list you can escape it by "\":

text formatlist("a|ba|ac|ed|!a", "f", , "a*|*d"); //a|ac|ed

text formatlist("a|ba|ac|ed|!a", "f", , "!a*|*d"); //ba|!a

text formatlist("a|ba|ac|ed|!a", "f", , "\!a*|*d"); //ed|!a

fresh

Runs a new XYplorer instance with factory defaults.

Syntax

fresh

Example

fresh;

get()

Returns various information.

Syntax

get(info, [param1], [param2])

info: [required] sort of info (not case-sensitive!)
param1: [optional] depends on info
param2: [optional] depends on info
return: retrieved info

Possible values for info and param1

- "Alias", [AliasName]
Returns the value of the alias "AliasName". If the alias does not exist then AliasName itself is returned unchanged.
The value of the alias is returned without resolving any arguments within the alias. Example:
alias: @Greet=::echo "Hello, <@1>! It's <@2 Dewey>!";
echo get("alias", "Greet"); //::echo "Hello, <@1>! It's <@2 Dewey>!";
- "BytesSelected", [pane=a]
Returns the sum of bytes of all selected items of any of the two panes. If folder sizes are shown then they are included in the byte count.
The optional "pane" argument can be:
a = [default] active pane
i = inactive pane
1 = pane 1
2 = pane 2
- "BytesTotal", [pane=a]
Returns the sum of bytes of all items of any of the two panes. Syntax see "BytesSelected" above.
- "CopiedData", [token]
Returns the last data copied to this window via WM_COPYDATA. The returned data depends on the value of the "token" argument:
0: hWndSender|dwData|Data
1: hWndSender
2: dwData
3: Data
For example, this 2-line script will retrieve the value of <curitem> in another instance of XYplorer (721424), and then display it in a message box in this XYplorer (<hwnd>):
copydata 721424, "::copydata <hwnd>, " . '<curitem>' . ";", 1; echo <get copieddata 3>;
- "CountItems", [pane=a]
Count of items in List.
- "CountSelected", [pane=a]
Count of selected items in List.
- "curitem", [part] and "curitemprev", [part]
Return the current respectively previous current item on whatever pane. Both take optional parameters path, file, base, and ext.
Note: get(curitem) differs from the native variable <curitem> in that it will return the previously selected and focused item if the currently focused item is not selected.
Examples:
echo get("curitem",); //E:\Test\b\c\Jane.txt
echo get("curitem", "path"); //E:\Test\b\c
echo get("curitem", "file"); //Jane.txt
echo get("curitem", "base"); //Jane
echo get("curitem", "ext"); //txt
- "drop", [separator="|"]
Returns the items dropped onto a script in Catalog or onto a script file.
See Drop on a Script File.
- "driveletter", [drivename], [path]
Returns the first drive letter matching the given drivename (aka volume label). An optional path parameter can be used to format the returned string.
drivename: Drive name (defaults to the current path).
path: Any path with a drive letter, or a "?" in the place of the drive letter. If the function finds a matching drive letter then it will replace the drive letter in [path] with it and return the new path.
return: The drive letter, or the path with the drive letter. If no matching drive letter is found nothing is returned.
Example (drive F:\ is named "Fun"):
echo <get driveletter "Fun" "C:\Windows">; //F:\Windows
- "drivename", [path], [flags]
Returns the name of the drive (aka volume label) where path is on.
path: Path (defaults to the current path).
flags:
0 = return drive name without drive letter
1 = return the drive letter as well (formatted according to system settings found in registry)
- "drives", [type], [separator="|"]
Returns a list of drives.
The "type" parameter corresponds to the Windows drive types enumeration:
DRIVE_UNKNOWN = 0
DRIVE_NO_ROOT_DIR = 1
DRIVE_REMOVABLE = 2
DRIVE_FIXED = 3
DRIVE_REMOTE = 4
DRIVE_CDROM = 5
DRIVE_RAMDISK = 6
If you omit the "type" parameter then all existing drives are returned.
Examples:
text get("drives"); //A:\|C:\|D:\|E:\|F:\|H:\|T:\|X:\|Y:\|Z:\
text get("drives", 0); //
text get("drives", 1); //Z:\
text get("drives", 2); //A:\
text get("drives", 3); //C:\|D:\|E:\|F:\|T:\
text get("drives", 4); //X:\|Y:\
text get("drives", 5); //H:\
text get("drives", 6); //
- "find_contents", [(unused)]
Returns the contents of the Contents field of the last search in the current pane in this session.
- "FocusedControl", [(unused)]
"A" for AddressBar, "T" for Tree, "C" for Catalog, "L" for List, "X" for other.
- "FocusedPos", [pane=a]
Position of focused item from top (top = 1) in List.
For the optional "pane" argument see "BytesSelected" above.
- "Instance", [on_first=1], [on_nonfirst=2]
Tells you, if you have multiple instances of XY, whether the current instance is the first instance or not.
[on_first]: String to return if current instance is the first instance. Defaults to "1".
[on_nonfirst]: String to return if current instance is not the first instance. Defaults to "2".
Example: echo get("instance", "First", "Second");
- "Item", [pane=a]
Returns the focused item of any of the two panes.
For the optional "pane" argument see "BytesSelected" above.
Example: echo get("Item", i); //inactive pane's focused item
- "list_copyto", [separator=CRLF]
List of current MRU items used in Copy To / Move To / Backup To.
- "list_hilitefolder", [separator=CRLF], [flags]
[separator]: String to place between items. Defaults to CRLF (line feed).
flags: Defaults to "fc".
f = Return folders.
c = Return colors.
fc = Return folders and colors.
return: List of highlighted tree folders with their colors in RRGGBB (depending on flags). Format is identical to that used in the INI file.
This example loads a Mini Tree with all highlighted folders:
loadtree get("list_hilitefolder", "|", "f");
- "list_recentlocations", [separator=CRLF]
List of recent locations (identical to menu Go | Recent Locations).
- "list_recentlyopenedfiles", [separator=CRLF]
List of recently opened files (as used in menu File | Open...). Example:
open inputselect("Open any of the Recently Opened Files", get("list_recentlyopenedfiles"), <crlf>, 5);
- "MenuCaption", command_ID, flags]
Returns the command's menu caption in the currently loaded language.
command_ID: Command ID.
flags: (bit field)
1 = Append the currently assigned KS, separated by a TAB.
2 = Strip accelerators.
return: The menu caption.
- "Pane", [(unused)]
Returns "1" if the first pane is active, "2" if the second pane is active.
- "Path", [pane=a]
Returns the unslashed path (see note below) of any of the two panes.
For the optional "pane" argument see "BytesSelected" above.
Example: echo get("path", i); //inactive pane's path

Note on returning unslashed paths: "C:" and "C:\" do not necessarily point to the same location according to Microsoft:
If a file name begins with only a disk designator but not the backslash after the colon, it is interpreted as a relative path to the current directory on the drive with the specified letter. Note that the current directory may or may not be the root directory depending on what it was set to during the most recent "change directory" operation on that disk. Examples of this format are as follows:
"C:tmp.txt" refers to a file named "tmp.txt" in the current directory on drive C.
"C:tempdir\tmp.txt" refers to a file in a subdirectory to the current directory on drive C.
- "PropertyIndex", PropertyName
- PropertyName: Name of the property. It's identical to the column header in Details view, and has to be in the system locale (e.g. in German in a German Windows).
- return: The numerical index of that property.
Note: The return varies from Windows to Windows, and from system to system.
Usage: Make scripts using extended properties (SC property, SC report with "prop:") portable and working under different Windows versions.
Examples:
text get("propertyindex", "besitzer"); // -> might return "8" in a German XP
text get("propertyindex", "orientation"); // -> might return "254" in a English Win7
- "regcmd", extension
Retrieves the default verb and command line (the one triggered by dbl-click) for any registered file type from the registry.
Example: text get("regcmd", "mp3");
- "Screen", [width|height|dpi]
Returns the screen width or height in pixels, respectively DPI (dots per inch).
- "SelectedItemsPathNames", [separator=CRLF], [pane=a]
All selected items (full path) in List, separated by param1.
Note that before v9.40.0007 the separator was actually a delimiter (i.e. it was returned after each item, not between the items.
- "SelectedItemsNames", [separator=CRLF], [pane=a]
All selected items (name, no path) in List, separated by param1.
See note above.
- "Sort", [pane=a]
Sorted column name and order.
Examples for returns:

"Name,a" //Name, ascending

"Name,d" //Name, descending

"Modified,d" //Modified, descending

"Random" //Random Order

"Unsorted" //Unsorted

- "SpecialFolder", [CSIDL]
[CSIDL]: Numerical constant predefined by the OS. Defaults to 0 (= Desktop folder). You can easily find those values in the web.
Returns the full path to the special folder.
- "Status", [section]
Returns the current contents of the Statusbar.
The optional "section" argument can be:
1,2,3: Index of the section, the first section being number 1.
help: Last displayed help text (shell context menu hovering).
If missing all numbered sections are returned.
- "Tabs", [separator="|"], [pane=a]
Returns the paths of all tabs in the current pane, from left to right, separated by separator.
For the optional "pane" argument see "BytesSelected" above.
- "Tabs_sf", [separator="|"], [pane=a]
Same as "Tabs" above but the path of the selected tab returned first.
For the optional "pane" argument see "BytesSelected" above.
- "Tree", [separator="|"]
List of paths present in the current tree, separated by separator. The current path is the first in the list.
Usage: Mainly useful for creating the pathlist argument for the loadtree command.
- "Trigger", [mode=mousebtn]
mousebtn: Returns the mouse button that triggered a script. Returned values:
None = 0
LeftClick = 1
RightClick = 2
MiddleClick = 4 (planned)
ctbindex: Returns the user button index that triggered the script.
Notes:
- The <get trigger> variable is cleared after the script is processed.
- Currently implemented only for Custom Toolbar Buttons.
- "UTCoffset", [(unused)]
The offset in minutes of the local time from the UTC (Coordinated Universal Time).
- "XYcopy_Pending", [(unused)]
The number of file operations to be handled in the background (by XYcopy) that are not yet completed.
- "Username", [(unused)]
Returns the name of the user associated with the current thread.
- "Userrole", [(unused)]
Returns the user's membership (respectively his security role in the current process) in one of the following security groups: Admin, User, Guest, Power User. If any other groups apply then "Other" is returned.
- "View", [pane=a]
Returns the index of the current list view.
For the optional "pane" argument see "BytesSelected" above.
Possible returns and their meanings:
0 = Details
1 = Details with Thumbnails
2 = List
3 = Small Icons
4 = Thumbnails #1
5 = Thumbnails #2
6 = Thumbnails #3
- "VisualFilter", [pane=a]
Returns the currently active visual filter (or nothing if none).
For the optional "pane" argument see "BytesSelected" above.
- #CommandID, [ReturnOnTrue = 1], [ReturnOnFalse = 0]
Here you can retrieve the current state of a couple of toggles that have a command ID, and control what is returned on what state. Currently supported are the following Command IDs:
#178 = Floating Preview
#312 = Show Sort Headers In All Views
#333 = Sort Folders Apart
#471 = Enable Folder View Settings
#480 = Auto-Refresh
#488 = Lock Tree
#489 = Mini Tree
#491 = Show Floppy Drives
#492 = Show Hidden Drives
#493 = Show Hidden Files and Folders
#494 = Show System Files and Folders
#495 = Show Junctions
#496 = Show Folders in List
#660 = Show Address Bar
#661 = Show Toolbar
#662 = Show Tab Bar
#663 = Show Navigation Panel
#664 = Show Catalog
#665 = Show Info Panel
#668 = Show Tree
#669 = Show Status Bar Buttons
#670 = Show Status Bar
#685 = Wide Info Panel
#686 = Catalog Above Tree
#800 = Dual Pane
#801 = Horizontal Panes
#1061 = Miscellaneous | General Functions | Show/Hide Main Menu
For example, this returns "DP" when Dual Pane is enabled, and "SP" when it's not:
text get("#800", "DP", "SP");
And this returns "1" respectively "0":
text get("#800");

Examples

$a = get("CountSelected"); msg $a;

$a = get("SelectedItemsPathNames", "|"); msg $a;

msg get("selecteditemsnames", chr(10));

text get("tree", <crlf>); //one path per line

echo get("bytesselected", i); //inactive pane's sel. bytes

text get("selecteditemsnames", , "i"); //inactive pane's sel. items, one per line

getkey()

Gets the value of a configuration key in the current INI file, or of any INI file.

Syntax

getkey(key, section, [INIfile], [flags])

key The name of the key.
section The name of the section.
INIfile [optional] the name of the INI file. Expects a filename with extension, and can be absolute or relative to the running script's path. If the parameter is missing it defaults to XYplorer's current INI file.
Of course, the file to be loaded is expected to conform to the format of INI files.
flags (bit field)
1: Use XYplorer's native algorithm (see Notes below).
Note that key and section are case-sensitive with this algorithm!
return The value.

Usage

Note that getkey pairs with setkey. The getkey/setkey commands support reading/writing values of up to 32,766 characters.

Notes on XYplorer's native algorithm

XYplorer's native algorithm for reading INI values will return leading Tab characters. The standard Windows algorithm will not.
XYplorer's native algorithm is optimized for reading hundreds of keys out of huge INI files. It's not made for picking out single keys as the getkey() function does. So, performance-wise you will suffer a bit for the added functionality.

Examples

$a = getkey("StartPath", "General"); msg $a;

Sets variable $a to the value of key StartPath in section General of the current INI file; then displays it in a message box.

$a = getkey("timeout", "boot loader", "C:\boot.ini"); msg $a;

Sets variable $a to the value of key timeout in section boot loader of C:\boot.ini; then displays it in a message box.

Examples for flags=1 (XYplorer's native algorithm)

In these examples the key is Year=[TAB]2012, where [TAB] = Tab character.

text getkey("Year", "Vacation", "<curpath>\holiday.ini"); // "2012"

text getkey("Year", "Vacation", "<curpath>\holiday.ini", 1); // "[TAB]2012"

getpathcomponent()

Returns the specified component of a path.

Syntax

getpathcomponent([path], [component], [index=1])

path: The path to parse; can be a folder or a file. Defaults to the current folder or file.
component: The component to return; can be any of the following:

path: [default] The path without any file.

drive:The drive or share.

parent: The parent folder.

file: The file without path.

base: The file without path and without extension.

ext: The extension.

server: The server in case of an UNC path, else the drive.

count: The count of components.

component: The component referred to by index.

index: The index of the component to return. Only used if component is "component". The first component is 1, the last component is -1.
Invalid indices or index 0 (zero) return nothing.
UNC paths are stripped off the leading "\\" before applying the index.

Notes

Backward "\" and forward slash "/" are supported as component separators.

Double-slashes are converted to single slashes before parsing.

Paths are returned unslashed, and any trailing colon (:) is removed (so drives are returned as merely the drive letter).

Examples

echo getpathcomponent(, "file"); // current item without path

echo getpathcomponent("E:\x\y.txt", "ext"); // txt

echo getpathcomponent("E:\x\y.txt", "base"); // y

echo getpathcomponent("E:\x\y.txt", "file"); // y.txt

echo getpathcomponent("E:\x\y.txt", "parent"); // x

echo getpathcomponent("E:\x\y.txt", "path"); // E:\x

echo getpathcomponent("E:\x\y.txt", "drive"); // E

echo getpathcomponent("\\Mars\Venus", "server"); // Mars

echo getpathcomponent("\\Mars\Venus", "count"); // 2

echo getpathcomponent("E:\x\y.txt", "component"); // E

echo getpathcomponent("E:\x\y.txt", "component", 1); // E

echo getpathcomponent("E:\x\y.txt", "component", 2); // x

echo getpathcomponent("E:\x\y.txt", "component", 3); // y.txt

echo getpathcomponent("E:\x\y.txt", "component", 4); // <nothing>

echo getpathcomponent("E:\x\y.txt", "component", -1); // y.txt

echo getpathcomponent("E:\x\y.txt", "component", -2); // x

echo getpathcomponent("E:\x\y.txt", "component", -3); // E

echo getpathcomponent("E:\x\y.txt", "component", -4); // <nothing>

echo getpathcomponent("\\Mars\Venus", "component"); // Mars

gettoken()

Returns a substring by index.

Syntax

gettoken(string, [index=1], [separator=" "], [format], [flags])

string Source string; not changed by procedure.
index Index of token, 1-based; defaults to 1.
Negative indices reference items from the right end of the list.
"count": returns the count of tokens in the string. Returns 0 if string is empty.
separator Separator of tokens; defaults to " ".
format Switches for the desired formatting. Can be freely combined in any order.
t = trim returned string (crop leading and trailing spaces)

flags (bit field)

1: Return from start.

2: Return till end.

return The token.

Examples

echo gettoken("Donald Duck"); // Donald

echo gettoken("a,b,c,d,e", 4, ","); // d

echo gettoken("http://www.xyplorer.com", 2, "//"); // www.xyplorer.com

echo gettoken("a,b,c,d,e", "count", ","); // 5

echo gettoken("", "count", ","); // 0

echo gettoken("one,two,three,four,five", -1, ","); //five

echo gettoken("one,two,three,four,five", -4, ","); //two

Using the flags parameter:

echo gettoken("a,b,c", 2, ","); // b

echo gettoken("a,b,c", 2, ",", , 1); // a,b

echo gettoken("a,b,c", 2, ",", , 2); // b,c

gettokenindex()

Returns the first index of a token in a token list, or the count of its occurrences

Syntax

gettokenindex(token, tokenlist, [separator=|], [flags=iw]);

token Token to find in list of tokens.
tokenlist List of tokens.
separator Separator used in list of tokens.

flags

i: Matching is case insensitive (A==a).

w: Token has wildcards.
If missing then token is treated literally.
If included and token does not contain wildcards treat it as *token*.
c: Return count the occurrences.

returns

0: If token was not found in the list.
Otherwise return the index of the token within the list (1 = first position).
On flag c: Count the occurences.

Examples

echo gettokenindex("xls", "docx|doc|xlsx|xls"); //3 (*xls*)

echo gettokenindex("red;*", "Blue;12|Red;15|Green;28"); //2

echo gettokenindex("red", "Blue;12|Red;15|Green;28"); //2 (*red*)

echo gettokenindex("red", "Blue;12|Red;15|Green;28", , ""); //0 (red)

echo gettokenindex("xls*", "docx|doc|xlsx|xls", , "wc"); //2 (return count)

global

Define one or more variables as global.

Syntax

global variable(s)

variable(s) A single variable, or a comma-separated list of up to 10 variables. If a variable has already been defined as global before, then the global command initializes it to its current global value, else it is initialized to an empty string.

Usage

By default, all variables in XY scripting are local, i.e. they are not shared between scripts. The command "global" can be applied to share a variable between all scripts that used "global" on that variable.

Examples

global $foo, $bar;

= Define $foo and $bar as global variables.

Here are two scripts inside one script resource where the first is calling the second:

"script1"
$foo = 4; // set local value: new local var $foo is created
msg $foo; // 4 (local)
// now make $foo global
// it's initialized to [empty] (assuming nothing created
// a global $foo before with a different value, which is
// possible when "script1" has been called by yet another
// script that has declared $foo as global)
global $foo;
msg $foo; // [empty] (global)
$foo = 8; // set global value
msg $foo; // 8 (global)

sub script2; // go down

msg $foo; // 16 (global, as set in script2)
msg $bar; // $bar (uninitialized, not a variable)
// make $bar global
// it's set to "tequila" (as previously set in script2)
global $bar;
msg $bar; // tequila

"script2"
msg $foo; // $foo (uninitialized, not a variable)
$foo = 15; // set local value: new local var $foo is created
msg $foo; // 15 (local)
// now make $foo global
// it's set to 8 (as previously set in script1)
// also create a new global $bar
global $foo, $bar;
msg $foo; // 8 (global)
$foo = 16; // set global value
$bar = "tequila"; // set global value

Optionally you can immediately assign initial values to the declared variables:

global $a = "a"; echo $a;

global $a = "a", $b = "b"; echo "$a, $b";

These assigned values can be variables themselves, or even expressions or functions:

global $a = <clipboard>; echo $a;

global $a = 5*7; echo $a;

Notes

- You can have as many global vars as you like, but it can be no more than 10 per "global" statement for internal reasons. IOW, add a new "global" line for each pack of 10 variables if you really need that many.
- It's recommended that you reflect the global nature of a variable in the variable name, for example by prepending $g_ to global vars. It will make your code easier to read and maintain.

goto

Changes the current to a new location.

Syntax

goto location, [reuseexistingtab]

location: [Required] A path, a file, a Name Search, a Visual Filter, or a URL ... whatever is accepted in the Address Bar, Favorites, Catalog, and UDC Go To. Including Environment Variables and XYplorer native variables.

reuseexistingtab:

0: [default] overwrite current tab
1: reuse existing tab (else overwrite current)

Examples

goto "C:\";

Go to C:\.

goto "Desktop";

Go to the Desktop folder.

goto "Desktop?*.bmp";

Name Search: List all *.bmp files in Desktop.

goto "Desktop?*.bmp;*.jpg";

Name Search: List all *.bmp and *.jpg files in Desktop.

goto "C:\|*.bat";

Visual Filter: Go to C:\ and show only BAT files.

goto "C:\|";

Visual Filter: Go to C:\ and show all files (removing any previous Visual Filter).

goto <xypath>;

Go to the current application path.

goto %temp%;

Go to the system temporary path.

hash()

Creates hash of a string or file.

Syntax

hash([algo=md5], [string], [flags])

algo Hash algorithm; one of the following:
md5: [Default] MD5.
sha1: SHA-1.
sha256: SHA-256.
sha512: SHA-512.
crc32: CRC-32.
string Data or file to be hashed (see flags).
Defaults to current list file if flags AND 1.
flags (bit field)
0: [default] String is data to hash.
1: String is a file spec whose contents to hash.
2: Show progress and allow break out by ESC. Only applied if "1" is also set.
return Hash.

Notes

- The maximum supported size for strings is 2GB data. For files the size is not limited (the file is streamed).

- You cannot abort the process by ESC. XYplorer will be blocked while the process is running.

- hash("md5" ...) is about 20 times faster than md5().

- md5() is kept for compatibility, and for systems where hash is not supported (which might be the case on older Windows).

Examples

text hash("md5", ""); //d41d8cd98f00b204e9800998ecf8427e

text hash("sha1", ""); //da39a3ee5e6b4b0d3255bfef95601890afd80709

text hash(,,1); //md5 of current list file

text hash(,,3); //md5 of current list file, with progress

hashlist

Calculates and shows the hash values for a list of files.

Syntax

hashlist [algo], [filelist]

algo Hash algorithm; one of the following:
md5: MD5 [Default].
crc32: CRC-32.
sha1: SHA-1.
sha256: SHA-256.
sha512: SHA-512.
filelist List of files, separated by "|".
Defaults to all currently selected files.

Examples

hashlist; //shows MD5 values for all selected files

hashlist "sha256", "D:\a.txt|D:\b.txt";

hexdump()

Displays a string as hex dump.

Syntax

hexdump(string, [unicode])

string [required] String to display.
unicode [optional]
0 = one byte/char [Default]
1 = two bytes/char

Examples

text hexdump(chr(20000), 1), 700;

text hexdump("<clipboard>", 1), 700; //show current clipboard

Usage

Useful when you want to know what's really on the clipboard.

hextodec()

Converts a hexadecimal number into a signed decimal number.

Syntax

hextodec(hexnumber)

hexnumber: The hexadecimal number to convert. Can be in any of these formats:
"0x499602D2" (0x-prefix as used in C++, PHP etc)
"&H499602D2" (&H-prefix as used in VB)
"499602D2" (no prefix)
Anything above 8 digits (after the prefix) is ignored.
return: The signed decimal number.

Notes

The highest value is 0x7fffffff (2147483647), the lowest value is 0x80000000 (-2147483648).

Examples

text hextodec("0x499602D2"); // 1234567890

text hextodec("ffffffff"); // -1

highlight

Defines the color for the Highlighted Folder feature of the current location on Tree, or turns it off.

Syntax

highlight [color (rrggbb)], [folder]

color: The new highlight color in format RRGGBB. If empty or missing the current highlight color is removed.

folder: [optional] if stated then the highlighting is applied to that folder, else it is applied to the current folder.

Examples

highlight "FF8000"

Will set the highlight color to orange for the current location.

highlight

Will disable the Highlighted Folder feature for the current location.

highlight "000000"

Will set the highlight color for the current location to the default highlight color.

highlight "FF0000", "C:\"

Set red highlight to C:\.

highlight , "C:\"

Unset any highlight from C:\.

html()

Displays an HTML formatted string.

Syntax

html([html], [width=600], [height=400], [caption=XYplorer])

html HTML formatted string, or name of one.
If no "<" character is contained it is interpreted as a URL or filename pointing to an HTML formatted document, respectively any type of document that can be displayed in InternetExplorer (PDF, DOC, etc.).
Default is the current file.
width Width of window in pixels (minimum: 250; maximum: screen width; default: 600).
Percentages of screen width are supported, e.g. 75%.
height Height of window in pixels (minimum: 150; maximum: screen height; default: 400).
Percentages of screen height are supported, e.g. 75%.
caption Caption on window's title bar; default: "XYplorer".
return A special hypertext reference when a link starting with "xys:" was clicked (see example below).
On Close button or ESC, an empty string is returned.

Examples

html("<html><body>Hi!</body></html>");

html("http://www.xyplorer.com/", 800);

Shows a message box "Yes!" or "No!" depending on the link you click:

echo(html('<html><body><a href="xys:Yes!">Say "Yes!"</a><br><a href="xys:No!">Say "No!"</a></body></html>'));

Note that <xypath> is resolved before the argument is passed to html, so it is auto-interpreted correctly as filename:

html("<xypath>\XYplorer.pdf");

html("<b>Size is relative to screen!</b>", 75%, 75%);

incr

Increment a numerical value.

Syntax

incr outputvar, [value], [increment=1]

outputvar [Required] The variable that will receive the output.
value Value defaults to outputvar(!); can be negative.
increment Defaults to 1; can be negative.

Examples

incr $a; // returns $a + 1

set $a, 5; incr $a; // returns 6 (5 + 1)

incr $a, 1; // returns 2 (1 + 1)

incr $a, 1, 2; // returns 3 (1 + 2)

incr $a, -1, 2; // returns 1 (-1 + 2)

incr $a, 1, -2; // returns -1 (1 - 2)

incr $a, -1, -2; // returns -3 (-1 - 2)

incr $a, "Paul"; // returns 1 (0 + 1)

incr $a, "3Paul"; // returns 4 (3 + 1)

input()

Shows an input dialog to the user and returns user input.

Syntax

input(topic, [notes], [default], [style=s|m|w], [cancel], [width=600], [height=400)

topic topic line, printed in bold on white
[notes] on style=s: text, can be multiline, printed on grey
on style=m/w: text, singleline, printed on white
[default] text that will be given as default value
[style] style of the input dialog:
s [default] singleline
m multiline non-wrapped
w multiline wrapped
[cancel] value to be returned when user cancels
if missing the script is terminated on cancel
[width] Width of window in pixels (minimum: 250; maximum: screen width; default: 600). For multiline input only.
[height] Height of window in pixels (minimum: 150; maximum: screen height; default: 400). For multiline input only.
return user input

Examples

Ask the user for an extension to filter out, store it inside variable $ext. Then set a Visual Filter to hide all files with the given extension:

$ext = input("Enter the file extension you do NOT want to see on List", "Just the extension without dot, e.g. txt." , "zip"); filter "!*.$ext";

Ask the user to enter a script in a multiline textbox; then load it:

$a = input("Enter Script", ,'echo "Hi!"', "m"); load $a,,"s";

inputfile()

Shows a common "Open File" dialog to the user and returns the full path/name of the selected file.

Syntax

inputfile([path], [extension], [caption])

path The default path for the dialog. When left empty or non-existent, path defaults to app path. In the latter case you are prompted whether to continue the script.
extension A list of extensions (separated by pipe ( | ) or semi-colon ( ; ), no dots) of the files to list on the window.
caption The text that will be displayed as title of the window.
return The full path/name of the selected file.

Usage

If you press Cancel, the script execution will be aborted.

Examples

$file = inputfile("<curpath>", "rar;zip", "Select an archive to extract in the current folder"); open """winrar"" x ""$file"" "<curpath>\"";

Asks the user to select an archive (RAR or ZIP), puts its full name (with path) in variable $file. Uses WinRAR (must be a registered application on Windows) to extract its content to current location.

$file = inputfile("Desktop", "gif|jpg|png", "Select Image File"); text $file, 600, 200;

Asks the user to select an image file in folder Desktop. Then shows the selected file name in a textbox.

inputfolder()

Shows a common "Browse For Folder" dialog to the user and sets a variable to the full path/name of the selected folder.

Syntax

inputfolder([path], [caption])

path The default path for the dialog. When left empty or non-existent, path defaults to app path. In the latter case you are prompted whether to continue the script.
caption The text that will be displayed as title of the window.
return The full path/name of the selected file.

Usage

If you press Cancel, the script execution will be aborted.

Paths are returned without trailing backslash

The paths returned in scripting, either through variables or commands (like inputfolder), are never backslashed (no final \) so that you can use them in a predictable way. E.g. if the current location is C:\ then <curpath> will only return "C:".

Examples

$folder = inputfolder("C:\", "Select Folder"); copytext $folder;

Asks the user to select a folder (starting the dialog in C:\) and puts its full name in variable $folder. Then copies the folder name to clipboard.

$source = inputfolder("C:\", "Select folder to copy into current location"); copyto "<curpath>", $source;

Asks the user to select a folder (starting the dialog in C:\) and puts its full name in variable $source. Then copies the folder into the current location.

inputselect()

Pops a list of strings from which the selected one is returned.

Syntax

inputselect(header, listdata, [separator="|"], [style=1], [cancel], [width=600], [height=400], [windowcaption])

header First line is printed in bold; any other lines are printed non-bold; leave empty to show no header.
listdata String of list items, separated by separator.
separator Separator; defaults to |.
style 1 = show file system icons for the items (= default)
2 = show checkboxes; prefix items with "+" to pre-check them
4 = show empty list if there is only one empty item
8 = show generic icons (just from extension, files need not exist)
cancel Value to be returned when user cancels;
if not set then cancel will terminate the script.
width Width of window in pixels (minimum: 350; maximum: screen width; default: 600).
Percentages of screen width are supported, e.g. 75%.
height Height of window in pixels (minimum: 200; maximum: screen height; default: 400).
Percentages of screen height are supported, e.g. 75%.
windowcaption Window caption.
return The selected list item. If checkbox style then the checked items are returned, separated by separator.

Notes

If the list shows only one item OK will trigger it even if it is not selected.

Examples

Show header and a list of drives; then go to the selected drive:

goto inputselect("Select Destination", "C:|D:|E:");

Same with two-line header:

goto inputselect("Select Destination".<crlf>."Choose drive:", "C:|D:|E:");

No header:

goto inputselect(, "C:|D:|E:");

Use checkboxes and icons (1 OR 2 = 3):

text inputselect("Select Drives", "C:|D:|E:", , 3);

Use checkboxes, pre-check "D:"); return "-" on cancel:

text inputselect("Select Drives", "C:|+D:|E:", , 3, "-");

Shows one empty item:

inputselect("Test 3/1", listfolder(%windir%, "s*", 3), , 1);

Shows empty list:

inputselect("Test 3/5", listfolder(%windir%, "s*", 3), , 5);

internetflags

Tunes internet commands (Download, ReadURL).

Syntax

internetflags name, [value]

name: [Required] INTERNET_FLAG_NO_COOKIES (no other flags are currently supported).

value: [optional]

1 = On [default]

0 = Off

Examples:

The default is to use cookies:

$a = input("Enter URL",, <clipboard>);
download $a;

This will not use cookies:

internetflags "INTERNET_FLAG_NO_COOKIES";
$a = input("Enter URL",, <clipboard>);
download $a;

isset()

Determines if a variable is set.

Syntax

isset($var)

$var: The variable to be checked.
return: 0 = The variable is not set.
1 = The variable is set.

Examples

For example, check whether a permanent variable is set before using it:

$contents = isset($p_filenamestore)?$p_filenamestore:"";

isunicode()

Analyzes a text string for the presence of wide characters.

Syntax

isunicode(string, [mindcodepage])

string: Full path/file name to analyze.
mindcodepage: [optional]
1 = do not count wide characters that have a narrow pendant in the current codepage.
return: 1 if wide characters are present in string, else 0.

Examples

echo isunicode("abc"); //0

echo isunicode("abc", 1); //0

echo isunicode(chr(20000)); //1

echo isunicode(chr(20000), 1); //1

echo isunicode("€"); //1 (U+20AC EURO SIGN)

echo isunicode("€", 1); //0! e.g. on 1252 Western codepage,
where the Euro sign is mapped to 0x80

Also these refer to the Euro sign:

echo isunicode(chr(8364), 0); //True

echo isunicode(chr(8364), 1); //False on 1252 Western codepage

listfolder()

Lists the contents of a folder (non-recursive).

Syntax

listfolder([path=<curpath>], [pattern=*], [flags], [separator="|"])

path Path of folder to list; defaults to current list path.
Special paths ("Desktop") and portable paths ("?:\") are supported.
Recycle Bin (%recycler%) is not supported.
pattern Wildcard (?, *) pattern to filter returned items; defaults to "*" (show all).
If no wildcards are contained, the pattern is auto-embraced by "*" (unless flag NoAutoWildcards is set).
flags 0: return folders and files with full paths [default]
1: NoFolders (= return only files)
2: NoFiles (= return only folders)
4: NoPaths (= return the filenames without paths)
8: NoAutoWildcards (= allow exact matches)
separator Separates the items in the returned list; defaults to | (pipe).
return List of items.

Note

The order of items is determined by the OS respectively file system. For XP/NTFS and later it's alphabetical, files and folders mixed.

Examples

List all items in the current list folder:

text listfolder();

List all items in %windir% that contain "y" in the name:

text listfolder(%windir%, "y", , <crlf>);

List all folders in %windir% that begin with "s":

text listfolder(%windir%, "s*", 2, <crlf>);

List all folders in %windir% that begin with "s"and return the names without path:

text listfolder(%windir%, "s*", 2 + 4, <crlf>);

List all DLL files in %windir% (typically C:\Windows\) and give a short report on them:

$itemlist = listfolder(%windir%, "*.dll", 1);
text report("{Name}, {Size B} bytes, {Modified yyyy-mm-dd hh:nn:ss},
ver {FileVersion}<crlf>", $itemlist);

List all DLL files in %windir%, select one to go to:

$itemlist = listfolder(%windir%, "*.dll", 1);
goto inputselect("DLLs in %windir%", $itemlist, , 1);

listpane()

Lists the contents of a pane.

Syntax

listpane([pane=a], [pattern=*], [flags], [separator="|"])

pane Pane to list.
a: [default] active pane
i: inactive pane
1: pane 1
2: pane 2
pattern Wildcard (?, *) pattern to filter returned items; defaults to "*" (show all).
Also "character lists" in square brackets are supported, e.g. [ab] to match "a" OR "b".
If no wildcards are contained, the pattern is auto-embraced by "*" (unless flag NoAutoWildcards is set).
flags (bit field)
0: return folders and files with full paths [default]
1: NoFolders (= return only files)
2: NoFiles (= return only folders)
4: NoPaths (= return the filenames without paths)
8: NoAutoWildcards (= pattern must be exact match)
16: NoCharacterLists (= useful when you want to match square brackets)
separator Separates the items in the returned list; defaults to | (pipe).
return List of items.

Notes

- As you might have noted, this command is analogue to listfolder() with the exception of the first argument.
- The command also works on Search Results, Drives, Recycle Bin and whatever list modes we will get int he future.
- The order of items is determined by the current list order.

Examples:

inputselect("Items on pane 1", listpane(1));

inputselect("Items on pane 2", listpane(2));

inputselect("Items on active pane", listpane());

inputselect("Items on inactive pane", listpane("i"));

inputselect("Items a* on active pane", listpane(, "a*"));

//list all folders that are named "code" in active pane:
inputselect("Test", listpane(, "code", 2 + 8));

Examples for Character Lists and flag NoCharacterLists (16):

//list all items that contain "a" or "b" in the name:
inputselect("Test", listpane(, "[ab]"));

//list all items that contain "[ab]" in the name:
inputselect("Test", listpane(, "[ab]", 16));

load

Loads a script or a script file and either pops up a menu listing the scripts contained, or directly executes one of the scripts.

Syntax

load resource, [labels], [resource type]

resource: [Required] Can be one of the following:

(1) the path/name of a script file;
(2) a script or multi-script resource, actually anything the could work as contents of a script file.

Note: If you use load inside a resource you can also use * as resource, to specify the current resource. This is very useful to ensure that your scripts will keep self-referencing even if the script file is renamed, or to allow a resource to load its menu even when not used from an actual script file (for example from UDC "Run Script" or menu Scripting|Try Script...)

labels: This can either be

(1) A script label: must be a valid label of one of the scripts contained in the resource.
(2) A list of script labels, separated by semi-colons (;). To add a menu separator you may put "-" instead of a label. Note that, of course, the label list must be quotes in order to parse the ";" as expected.
(3) A number prefixed by #: must be the index of which script to execute. Note than only scripts get an index, while menu separators do not. The first index is 1.
(4) An asterisk (*) to show all (hidden and visible) scripts in the resource that have a caption.

Note that if the given labels cannot be found, XY will pop up the menu from the file as if no labels had been specified.

resource type: Defines the type of resource

f: [Default] File

s: Script

Loading a Script File

The file name can be specified with full or relative path. In the latter case the script file to load is looked for

(1) in the path of the calling script file (if any)
(2) in the Scripts subfolder of the application data path (variable <xydata>\Scripts)
(3) in the application data path (variable <xydata>)

If the given filename does not contain an extension, XY will automatically add .XYS as its extension ("XYplorer Scriptfile"). So, to load the file MyScript.xys located in the application data folder, all you need to specify as parameter is MyScript: load "MyScript"

For the syntax of XYplorer Script Files see here.

Loading a Script

Simply put the script as first argument. The syntax for the script is exactly the same as for Script Files, it can contain more than one script in which case a menu will be loaded and popped up, unless you have specified a script to be executed (using index or label).

This are some simple examples:

load 'goto "C:\"', , s

load 'msg "A loaded script.";', , s

Of course, these examples don't make a lot of sense since you could just as well call the scripts directly. Loading a script this way starts making sense when you create the script on the fly.

Examples

load "myscript"

Will load the file myscript.xys located in the calling script's folder, or if not found (or not used from a script file) then in the application folder.

load "?:\XYscripts\goto.xys"

Will load the file "Goto.xys" (see below) located in the folder "XYscripts" on the drive XYplorer is currently running from, and pop up a menu presenting all scripts contained in that file.

load "?:\XYscripts\goto.xys", "system"

Will load the file "Goto.xys" (see below) located in the folder "XYscripts" on the drive XYplorer is currently running from, and execute the script whose label is "system".

The contents of goto.xys could look like this:

"Go to C:\ : croot"
goto "C:\"
"Go to System Folder : system"
goto %winsysdir%
"Go to XYplorer Folder : xy"
goto <xypath>

Using a list of labels

All the following examples use the above displayed script file goto.xys, and expect it to be located in the default Scripts path.

(1) Make no use of the labels argument:

::load "goto.xys"

Pops up menu with all scripts contained in the file in original

order:

Go to C:\

Go to System Folder

Go to XYplorer Folder

(2) Use the the labels argument to pick only 2 of the scripts:

::load "goto.xys", "croot;xy"

Pops up menu:

Go to C:\

Go to XYplorer Folder

(3) Use the the labels argument to change the order and add a menu separator:

::load "goto.xys", "xy;-;system;croot"

Pops up menu:

Go to XYplorer Folder

---------------------

Go to System Folder

Go to C:\

loadsearch

Load a previously stored search template and (optionally) run a search based on it.

Syntax

loadsearch template, [options=rl]

template [required] search template name as displayed in the search template dialog
options [optional, default = rl]

r = Run Search: Run search after the template is loaded. Else just the Find Files tab is adjusted to the loaded template.

l = Load Search Location: Search the location that's stored with the template. Else search the current location.

e = Load Excluded Folders: Exclude folders as stored with the template. Else use the currently excluded folders.

c = Load Cached Results (if any): Instead of doing a fresh search load the results previously saved in the template. If this option is set the other options (r, l, e) are auto-implied.

x = (none of the above)

Examples

::loadsearch "Created or Modified This Hour", r

Load template "Created or Modified This Hour" and run a search in the current location.

::loadsearch "Reset Find Options", x

Load template "Reset Find Options" and do nothing else.

::loadsearch "Videos in Temp Internet Files"

Load template "Videos in Temp Internet Files" and run a search in the stored location (Temporary Internet Files).

Remarks

Search templates are INI-files that are all stored in a predefined folder: <xydata>\FindTemplates. The template name (as used in loadsearch) is usually identical to the base name of the template file. Template names, however, may contain characters that are illegal for file names; these characters are encoded in the filename using the scheme "% & Hex(charcode)". You create and manage search templates using menu Edit | Search Templates.

The loadsearch command is the nexus of two of XYplorer's strongest features: Scripting and File Search. In combination with the Catalog, UDCs, and XYS files, you can easily build handy libraries of complex live searches:

(1) First configure your search settings on the Find Files tab.

(2) Then save the settings as a search template using menu Edit | Search Templates.

(3) Then write a script ::loadsearch "[name of your template]" and test it.

(4) Finally wrap the script in a Catalog item, UDC, or XYS file. Or simple add it to your Favorite Folders (yes, they support one-line scripts).

loadtree

Loads a specific Mini Tree.

Syntax

loadtree [pathlist], [modify=0]

[pathlist] list of paths separated by | (pipe);
XYplorer native variables and Environment variables are supported;
if modify = 0 then the current tree folder is set to the first path;
defaults to the current path if missing.

[modify]

0: [default] fresh Mini Tree from scratch
1: add paths to current Mini Tree
2: hide paths from current Mini Tree
3: reduce the Mini Tree to just the paths of all tabs in the current pane

Remark

With modify = 1 and the current tree still non-Mini, loadtree will convert the tree to a Mini Tree without losing any of its present folders. Interesting option! You can convert a Maxi Tree to a Mini Tree without adding any paths using this line: loadtree , 1;

Examples

loadtree "C:|D:";

loadtree "<xydata>\scripts";

loadtree "<curpath>|%programfiles%|<xypath>";

loadtree "%temp%", 1; //add TEMP dir to the current tree

loadtree "E:|F:", 2; //hide drives E: and F:

loadtree "", 3; //minimize tree to just the paths of all tabs in the current pane

makecoffee

Makes a good cup of coffee.

Syntax

makecoffee

Example

makecoffee;

Remark

The coffee is served on the current pane. Call again for another cup.

md5()

Calculates the md5 hash of a string.

THIS COMMAND IS DEPRECATED! Use hash() instead.
md5() is kept only for older Windows versions where hash might not be supported.

Syntax

md5(string, [flags])

string String to md5.
Either the data itself, or a file spec (depends on flags).
flags (bit field)
0: string is data that will be md5-ed. The maximum allowed string size is 512 MB.
1: string is a file spec whose contents will be md5-ed. The maximum allowed file size is 512 MB.

Examples

echo md5(""); //d41d8cd98f00b204e9800998ecf8427e

echo md5("XYplorer"); //72b70e05bade8928abc97cc4a53abf48

echo md5("<xypath>\<xyexe>", 1); //md5 of the current application

moveto, copyto, backupto

Move/Copy/Backup the selected items to the specified location.

Syntax

moveto [location], [source], [rootpath], [flags]

copyto [location], [source], [rootpath], [flags]

backupto [location], [source], [on_collision], [preserve_dates], [create_log], [pop_stats], [skip_junctions], [verify], [show_progress]

location [optional] The destination where the selected items should be moved/copied/backed up to. Defaults to the current path.
source [optional] The item(s) that will be copied or moved. Alternatively it can point to the source control (":tree", ":list", or ":catalog"), or to a text file containing a list of source items ("*filename"; see below).
If missing then the selected items of the focused control (List, Tree, Catalog) are used.
rootpath [optional; moveto/copyto only] Common root for a rich operation (source paths are recreated in the target location relative to rootpath). Slashed or unslashed makes no difference.
flags [optional; moveto/copyto only] Binary flags (the desired values have to be binary-OR-ed).

0 = [Default]

1 = FilesOnly. For sources containing wildcards only files are copied.

2 = SkipPromptToCreate. Don't prompt, but create any non-existing destination folder without asking.

on_collision [optional; backupto only]

-1 = Ask

0 = [Default] Use global setting from Configuration | File Operations | Backup Operations | On name collisions

1 = Overwrite if newer

2 = Overwrite

3 = Skip

4 = Suffix number to copy

5 = Affix current date to copy

6 = Affix last modified date to copy

7 = Suffix number to existing

8 = Affix current date to existing

9 = Affix last modified date to existing

preserve_dates [optional; backupto only] Preserve all three file dates (only applied if the file itself is copied).

Empty = Use global setting from Configuration.

0 = Whether/which dates are copied depends on OS.

1 = All three dates are copied.

create_log [optional; backupto only] Create a detailed log file about the backup operation.

Empty = Use global setting from Configuration.

0 = Don't.

1 = Do.

pop_stats [optional; backupto only] Pop up a summary message about what was copied / overwritten / not overwritten.

Empty = Use global setting from Configuration.

0 = Don't.

1 = Do.

skip_junctions [optional; backupto only] Skip folder junctions and their contents.

Empty = Use global setting from Configuration.

0 = Don't.

1 = Do.

verify [optional; backupto only] Verify each copy operation on the fly.

Empty = Use global setting from Configuration.

0 = None (no verification)

1 = Byte-to-byte

2 = MD5

3 = SHA-1

4 = SHA-256

5 = SHA-512

show_progress [optional; backupto only] Show progress dialog.

Empty = Use global setting from Configuration.

0 = Don't.

1 = Do.

Usage

Non-Existing Paths

You can use non-existing paths as destination. If you do so, you will be prompted whether or not you want to create that path before continuing with the file operation.

Note that all parts can be new, not just the last subfolder. So D:\new\new too\also new will work just fine.

Variables

You can also use Environment Variables (XY supports both common Windows & XY-specific environment variables) as part of your destination, as well as XY variables and, when scripting, user-variables. For more on all those variables, please refer to Script Variables.

Relative Paths

You can use relative paths too. Unlike everywhere else on XY, relative paths here on destination for your Move/Copy/Backup To operations refer to the current location, and not XY's application path.

So to quickly move/copy/backup into a newly-created subfolder (of the current location), simply enter its name. If the subfolder doesn't exist, you'll be prompted whether to create it or not!

Using Date Variables

You can also use date variables in the destination, that will be resolved with the current date ! The syntax here is identical to the one you know from the Batch Rename, and the date format syntax is the same you know from other XY date terms, like in File Find.

Examples:

NewName<date yyyy> NewName2006

NewName<date yyyy-mm-dd_hh-nn-ss> NewName2006-08-16_15-49-03

Used together with the ability to enter non-existing paths, and relative ones, this is an extremely valuable addition! For example, you now can easily make regular dated backups by using a destination like this: D:\Daily Backups\<date yyyy-mm-dd> Then, when you Move/Copy/Backup To this destination:

(1) If not existing already, the folder (eg: D:\Daily Backups\2006-10-07) will be created
(2) The selected items are moved/copied/backed up there

Note that you even can have more than one date variable in the destination field. So you can also use something like: D:\Backups\<date yyyy>\<date mm>\<date dd>\<date hh'nn> to get a folder for the year, one for the month, one for the day, and one for the hour! (e.g.: D:\Backups\2006\10\07\10'42)

Source

You can specify a source for the operation. The source must be the path to a folder or a file, or a control. You can use relative paths (relating to XYplorer's application folder), and variables (see examples below). When the source is a path, a trailing backslash is allowed but not necessary.

You can also use multiple sources by using pipe ( | ) as separator, for example:

backupto "D:\Backup\XY folders\<date yyyy-mm-dd>", "<xydata>\Scripts|<xydata>\FindTemplates"

The source(s) may contain wildcards, for example:

copyto "D:\Backup\XY files\<date yyyy-mm-dd>", "<xydata>\*.ini|<xydata>\*.dat"

Copies all *.ini and *dat file from the XYplorer data path to D:\Backup\XY files\2008-04-22\ (if that's the date today).

Control as Source

The "source" argument can as well point to the source control by setting it to ":list", ":tree", or ":catalog". This makes the selections used as sources independent of the current input focus. Examples:

//copy all selected list items to "C:\Temp"

copyto "C:\Temp", ":list";

//copy the selected tree item to "C:\Temp"

copyto "C:\Temp", ":tree";

Source Items File as Source

You can pass a file containing a source items list as source. The source items file should be an ASCII or UNICODE text file, and containing one source item per line. Empty lines are ignored. Folders can be slashed or not. Example for the contents of a source items file:

E:\Test\file-01.txt

E:\Test\file-02.txt

C:\Temp\folder\

To mark the source argument as source items file simply prefix it with "*" (asterisk). Example:

copyto "E:\Target\", "*E:\Test\Sources.txt";

Remarks:

· This feature allows you to easily trigger "distributed file operations", i.e. operations on a set of items that cannot easily be defined by selecting the items in the file list. This can mean an enormous usability boost.
· The *-prefix was borrowed by TeraCopy, thanks for that!

Using Variables referring to the Source

When you specify a source, you will be able to use all variables <src...> in your destination location, which will refer to the first item in source:

<srcname> the full name of the first source item without path
<srcbase> the base name of the first source item without extension
<srcext> the extension of the first source item
<srcver> the version number of the first source item (if it has one)
<srcdatem ...> a date variable (usual XY date syntax) based on the Modified date of the first source item, e.g. <srcdatem yyyy-mm-dd>. Equally <srcdatec ...> for the Created date and <srcdatea ...> for the accessed date.

Examples

focus "List"; moveto "D:\Stuff";

Moves all currently selected list items to folder D:\Stuff.

backupto "D:\Backup\XYplorer v<srcver> (on <date yyyy.mm.dd>)", "<xypath>\XYplorer.exe";

Creates a copy of the currently running XYplorer.exe in D:\Backup\XYplorer v6.80.0108 (on 2008-03-12), where v6.80.0108 is the current version, and 2008-03-12 the current date. The folder is created on the fly.

Using rootpath for Rich Operations

By passing a common root through the rootpath argument you can trigger Rich Copy/Move Operations directly from a script. This allows you to copy/move files together with parts of their folder structure in a fully controlled yet automatic way.

Note: If a source file is not located under rootpath then its full path is recreated in the target location; colons (:) after drive letters and "\\" before UNC paths are removed to conform to general filename syntax.

Examples

Copies "D:\Download\New\Test.txt" to "E:\Test\Download\New\Test.txt":

copyto "E:\Test", "D:\Download\New\Test.txt", "D:\";

Copies "D:\Download\New\Test.txt" to "E:\Test\New\Test.txt":

copyto "E:\Test", "D:\Download\New\Test.txt", "D:\Download";

Copies "D:\Download\New\Test.txt" to "E:\Test\D\Download\New\Test.txt" because the source file is not under the given rootpath "E:\":

copyto "E:\Test", "D:\Download\New\Test.txt", "E:\";

Creates a copy of all selected files under "E:\Test" recreating their full source paths. Note that a dummy string "*" is passed as rootpath: it will never work as an actual rootpath, so all source paths are fully recreated:

copyto "E:\Test", , "*";

Using the FilesOnly and SkipPromptToCreate flags

To move/copy files only set the flags parameter to 1, AND use the source argument with wildcard * anywhere in the pattern. To skip any "create?"-prompts, OR the value 1 with 2 which gives 3.

copyto "c:\temp", "e:\test\*.*", , 1; //copies only files

copyto "c:\temp", "e:\test\*.*"; //copies all

copyto "c:\tempNew", "e:\test\*", , 3; //only files; no prompt

Examples for backupto

Backup selected items to E:\Test; on collision affix current date to the copies; preserve dates; create log:

backupto "E:\Test", , 5, 1, 1;

Backup all selected items to E:\Test; on collision number-suffix the existing items in E:\Test:

backupto "E:\Test", , 7;

Backup all selected items to E:\Test; on collision ask what to do:

backupto "E:\Test", , -1;

msg

Pops up a message.

Syntax

msg text, [buttons], [linebreaker="<br>"]

text The text to be shown in the window.
buttons Defines what button(s) to show on pop-up window:

0: [Default] Only one button, "Ok"

1: Two buttons, "Ok" and "Cancel". When you press "Cancel", the script execution will end there (useful for confirmations).

linebreaker [optional] Any character sequence to be replaced by a line break. Defaults to "<br>". Pass "" to prevent any replacing.

Usage

Simply call the command with whatever text you want to show the user in a pop-up window. You can of course use any variables in your text, as well as put your text over multiple lines, using the line breaker <br> which will be converted to a CRLF (0D0A).

You can change the line breaker (<br>) by using command br first.

Examples

msg "XYplorer is running from <xypath><br>The application data are stored in <xydata>";

Shows a pop-up with the application's folder (path to running XYplorer.exe) and the application's data folder (where all settings are stored).

set $dest, "D:\Backup\XYplorer Settings - <date yyyy-mm-dd>"; msg "Do you want to backup your XYplorer settings to ""$dest"" ?", 1; copyto $dest, "<xydata>\*.ini|<xydata>\*.dat|<xydata>\FindTemplates";

(1) Sets variable $dest to a subfolder of D:\Backup called "XYplorer Settings - " followed by the current date, eg. "XYplorer Settings - 2008-02-10".
(2) Asks the user whether to continue or not? Pressing "Cancel" will abort script execution here.
(3) Copies all INI and DAT files as well as subfolder FindTemplates. The target folder, e.g. D:\Backup\XYplorer Settings - 2008-03-13\, will be created if necessary.

new()

Creates a new file or folder.

Syntax

new(name, [type=file|dir], [source], [flags])

name [Required] Name of the new item to be created.
If no path is passed, the current path is taken as default.
If the target folder does not exist it is created on the fly.
The "last target" path (used by Ctrl+Alt+F7) is set to the target folder.
type Defines what kind of item to create:
file: [Default] a new file, or
dir: a new folder.
Note that this parameter will be ignored when a source is specified, obviously.
source Path of the item to "duplicate" when creating a new one. For more about this, please see below.
flags A combination of these in any order:
r: After the new item has been created, Rename mode in invoked (much like when using the New feature manually); ignored if new item is not in current path.
u: Allow Undo.
return The full path/name of the newly created item (if any).
If the rename argument is set to "r" then the returned value is the name of the created item before any rename.

Create Empty Files Or Folders

Let's start with the basics. All you need to do is to enter a Name for the newly created items, as well as choose its Type (File or Folder).

Examples

new("file.txt");

Creates a new file called "file.txt" in the current path.

new("NewFolder", "dir");

Creates a new folder called "NewFolder" in the current path.

Use Variables For New Name

Instead of having to use a fixed default new name, XY brings even more power by allowing the use of a few variables. Those variables are relating to the item currently both focused and selected (this item is displayed in the status bar).

<curfolder> the name of the current folder
<curname> the name (without path) of the item
<curbase> the base name of the item without its extension
<curext> the extension of the item
<curver> the version number of the item (if it has one)

Examples for using variables in the name parameter

If the currently focused & selected file is C:\Downloads\Updates\xyplorer_full.zip

name: <curfolder> - <curbase>.txt

resolved: Updates - xyplorer_full.txt

name: <curtitle>.txt

resolved: xyplorer_full.zip.txt

name: <curbase>_<curext>.txt

resolved: xyplorer_full_zip.txt

If the currently focused & selected file is the application file for XY v6.60.0042 (D:\Program Files\XYplorer\XYplorer.exe), then:

name:<curbase> v<curver>.txt

resolved: XYplorer v6.60.0042.txt

name:<curtitle> (<curver>).txt

resolved: XYplorer.exe (6.60.0042).txt

Example scripts

new("<date yyyy-mm-dd>.txt");

Creates a new file called "2008-03-13.txt" (respectively the date today) in the current path.

If the currently focused & selected file is the application file (XYplorer.exe) for XY v6.60.0042, modified December 4th, 2007 at 11:11, then:

new("<curbase>_<datem yyyymmdd>.<curext>");

Creates a copy called "XYplorer_20070412.exe".

new("<curbase>_<curver>.<curext>"):

Creates a copy called "XYplorer_6.60.0042.exe ".

new("<curbase> v<curver> (<datem mm.dd.yyyy>).<curext>");

Creates a copy called "XYplorer v6.60.0042 (04.12.2007).exe".

Name Collisions

If the name specified already exists then the default name presented on rename mode will use a suffix number, according to the format defined in Configuration | Templates | Incremental suffix.

Cloning a source: Create Files Or Folders With Content

In the same way as the New Items feature works, you can also define a source that will be "cloned" (e.g. copied) when a new item is created. Basically what XYplorer will do when using a source is to copy the specified item (Source) to the current location using whatever Name was specified as default (if left empty, the original name (of the clone item) will be used). So if the source was...

...a file, a new file with the same content will be created;

...a folder, a new folder with the same full content (files and subfolders) will be created.

When defining a Source you don't have to worry about the type parameter, as it will obviously be ignored.

With this feature you will be able to clone files and folders whenever you want, from wherever you are, simply by using one click or one keyboard shortcut.

What this means is, you can easily create a new file with content (e.g. a Word document with your usual headers, layouts, signature block, etc.) or even a full folder with content (e.g. a folder with the usual files and subfolders you always use when creating a new project)! There are absolutely no limitations.

Cloning the current item

You can also use the currently selected and focused item as source of cloning, by putting <curitem> as Source. That way, the current item will be copied and rename mode will be activated afterwards with whatever was defined on Name as default.

new(, , "<curitem>");

Creates a copy of the current item in the current path. Collisions a re avoided by an auto-appended number.

new(, , "<curitem>", "r");

The same, but invoking rename mode after creation.

new("<srcbase>-<srcdatem yyyy-mm-dd>.<srcext>", , "XYplorer.exe");

Creates a copy of XYplorer.exe called "XYplorer-2008-03-12.exe" in the current path (see below "Variables referring to the source").

Variables referring to the source

The following variables in the name parameter will relating to the source item (set in Source field):

<srcname> The full name of the first source item without path.
<srcbase> The base name of the first source item without extension.
<srcext> The extension of the first source item.
<srcver> The version number of the first source item (if it has one).
<srcdatem ....> A date variable (usual XY date syntax) based on the Modified date of the first source item, e.g. <srcdatem yyyy-mm-dd>. Equally <srcdatec ...> for the Created date and <srcdatea ...> for the accessed date.

Finally some examples using the full path and the return value

Creates new empty file "Kabul.txt" in folder "E:\Afgh\":

$newfile = new("E:\Afgh\Kabul.txt");

Creates new path "E:\Afgh\Kabul\EastEnd\":

$newfolder = new("E:\Afgh\Kabul\EastEnd\", "dir");

Copies "C:\Temp\Kabul.png" to "E:\Afgh\Kabul-copy.png":

$newfile = new("E:\Afgh\Kabul-copy.png", , "C:\Temp\Kabul.png");

Copies the current item to "E:\Afgh\", suffixed with "-copy":

$newfile = new("E:\Afgh\<curbase>-copy.<curext>", , "<curitem>");

now()

Returns the current date/time.

Syntax

now([format])

format Either the usual date format, e.g. "yyyymmdd", or "msecs" which returns the number of milliseconds that have elapsed since the system was started (after 49.7 days it wraps back to start from zero).
If missing the default system time format is used.

Examples

echo now(); // 27.04.2011 18:46:12

echo now("hh:nn"); // 46:12

echo now("yyyy"); // 2011

echo now("yyyy-mm-dd hh:nn:ss.fffffff"); // maximum resolution down to the 1/10 microsecond

echo now("msecs"); // 1221097715

Notes

The slash stands for the current system date separator, which might be set to a dot. To force a slash you have to escape it with a backslash:

echo now("dd/mm/yyyy"); // 27.04.2011 in Germany

text now("dd\/mm\/yyyy"); // 27/04/2011 in Germany

open

Runs an application or opens a document.

Syntax

open item, [Windows (|w)];

item [Required] Path to an application to start or a document to open.
Windows By default, the open command uses XY's PFA: this parameter allows you to force-open an item with the Windows associated application.

(empty): [Default] Use PFA (portable file associations).

w: Use Windows associated application.

Examples

open "C:\Temp\file.txt";

Open the file C:\Temp\file.txt.

open "C:\Programme\Mozilla Firefox\firefox.exe";

Run FireFox.

open "firefox";

Run FireFox (if it is a registered application).

open '"winzip32" -min' or open """winzip32"" -min";

Run Winzip minimized (if it is a registered application). Note that the application must be double-quoted when command line parameters are used! If the whole argument is single-quoted, the contained double-quotes don't have to be doubled.

openwith

Opens the currently selected List item(s) with the specified application.

Syntax

openwith application, [mode (s|m)], [itemlist]

application [Required] Path to the application to open the selected items with.
mode Defines which mode to use when sending the parameters (item's names) to the application.
s: [Default] Single instance (pass all the items to the same instance of the application).
m: Multiple instance (pass each of the items to its own instance of the application).
itemlist |-separated list of items (full path) to open (overriding any List selections).

Examples

openwith "UEdit32" or openwith "UEdit32", s;

Open the selected list items with UltraEdit (registered as "UEdit32"), single instance.

openwith "UEdit32", m;

Open the selected list items with UltraEdit (registered as "UEdit32"), one instance for each item.

openwith """D:\Program Files\WinZip\Winzip32"" -e <items> ""<base>""", m;

You can also create commands to extract currently selected archives. The above script will extract all selected archives, each into a folder with archive's name, minus the extension (e.g. "My Backup.zip" will be extracted to a subfolder "My Backup").

Note that the application must be quoted when command line parameters are used! Since the whole argument is quoted the inner quotes should be doubled.

openwith "UEdit32", , "<xydata>\XYplorer.ini";

Open XYporer.ini with UltraEdit.

perm

Define one or more variables as permanent.

Syntax

perm variable(s)

variable(s) A single variable, or a comma-separated list of up to 10 variables. If a variable has already been defined as global before, then the perm command makes it permanent.
If a variable did not exist before the perm command initializes it to "" (empty string).
Note that you optionally can initialize the variables to certain values (see below).

Usage

Permanent Variables stay alive in memory during the whole XYplorer session, and hence can be easily shared between scripts.

Examples

Run the following scripts one after the other through the Address Bar:

perm $foo; $foo = "hi!";

echo $foo; //"hi!"

unset $foo; echo $foo; //$foo

These two scripts illustrate that you can "perm" a global variable even after it was set:

global $foo; $foo = "hi!"; perm $foo;

echo $foo; //"hi!"

Optionally you can immediately assign initial values to the declared variables:

perm $a = "a"; echo $a;

perm $a = "a", $b = "b"; echo "$a, $b";

These assigned values can be variables themselves, or even expressions or functions:

perm $a = <clipboard>; echo $a;

perm $a = 5*7; echo $a;

Remarks

· Permanent Variables are always also global. However, contrary to normal globals, they don't need to be initialized to the current scope in order to be accessed. They are always available everywhere.
· To remove a Permanent Variable from memory use the "unset" command.
Note: The "global" command will *not* make it non-permanent; to use "global" on a Permanent Variable is not necessary and has no effect.
· The number of Permanent Variables is not limited.
· It's recommended that you reflect the nature of a Permanent Variable in its name, for example by prepending $p_. It will make your code easier to read and maintain.

popupmainmenu

Shows the main menu as popup menu.

Syntax

popupmainmenu [submenu]

submenu The caption of any of the main sub menus to pop just this menu.
If missing the whole main menu is popped.

Examples

popupmainmenu;

popupmainmenu "file";

popupmainmenu "edit";

popupmenu()

Pops a menu and returns the selected item.

Syntax

popupmenu(itemlist, [x=-1], [y=-1], [start=1], [count=-1], [flags=0], [sep_itemlist="|"], [sep_item=";"], [on_cancel=""])

itemlist List of items separated by sep_itemlist. Each item is made of a Caption and optionally a Data part, separated by sep_item: "Caption;Data"
x X position; -1 to use current mouse X.
y Y position; -1 to use current mouse Y.
start Index of first item to show; 1 = first item.
count Count of items to show; -1 = show all.
flags 1: Return index (instead of caption/data).
sep_itemlist Separates items; can have more than one char.
sep_item Separates caption from data; can have more than one char.
on_cancel String returned when menu is cancelled (ESC).
return Data of selected item; caption if no data defined; index if flags AND 1.

Examples

text popupmenu("a|-|b|c"); //- is a menu separator

text popupmenu("a;data returned on a|-|b;data b|c;data c");

text popupmenu(<get selecteditemspathnames |>);

property()

Retrieves a particular property from a file or folder.

Syntax

property([property], [item])

property [optional] One of the following:
(1) name of the shell property
(2) index of the shell property (number prefixed by #); suffix " n" to return the name of the property.
(3) name of the XYplorer-specific property (name prefixed by #)
Defaults to showing Shell Properties dialog.
item [optional] Name of the file or folder.
Defaults to current path / item.
return The desired property.

Examples

msg property("FileVersion", "%winsysdir%\msvbvm60.dll");

msg property("CameraModel", "F:\IMG_1926.JPG");

msg property("WhenTaken", "F:\IMG_1926.JPG"); //= EXIF date

msg property("Artist", "1.mp3"); //1.mp3 in current path

msg property("FileVersion"); //version of current file

property(, "<xypath>\<xyexe>"); //show Properties for XYplorer

property(); //show Properties for current item

Examples for using the Property Index

Note that Microsoft traditionally changes the indices with each new OS.

These two lines return the same under WinXP:

msg property("FileVersion", "%winsysdir%\msvbvm60.dll");

msg property("#37", "%winsysdir%\msvbvm60.dll");

Suffix " n" to return the (locale aware) name of the property:

msg property("#37 n", "%winsysdir%\msvbvm60.dll");

Under Vista you need to pass another index:

msg property("#145", "%winsysdir%\msvbvm60.dll");

Under Win7 you need to pass yet another index:

msg property("#156", "%winsysdir%\msvbvm60.dll");

XYplorer-specific properties

A couple of XYplorer-specific named arguments are also supported. They all have to be preceded by # to distinguish them from Windows shell properties. They are not case-sensitive.

#LinkTarget = Shortcut Target

#ShortcutTarget = Shortcut Target (same as #LinkTarget)

#JunctionTarget = Junction Target

#ResolveJunctions = Path with all junctions resolved, one pass (see below "Resolving Junctions")

#ResolveJunctionsAll = path with all junctions resolved, many passes

#Label = Label

#Tags = Tags

#Comment = Comment

#HardLinks = Number of Hardlinks

#AspectRatio = Aspect ratio of an image file

#Hash.MD5 = MD5 Hash value of a file (analog: SHA1, SHA256, SHA512, CRC32)

Examples:

text property("#label"); //defaults to current list item

text property("#linktarget", "E:\Test\funstuff\Icons.lnk");

text property("#AspectRatio"); //defaults to current list item

text property("#Hash.SHA512"); //SHA512 value of the current list item

text property("#Hash.MD5", "E:\Test\funstuff\goodfellas.jpg"); //MD5 value of "goodfellas.jpg"

Usage

This powerful function gives you direct and ultra-fast access to all available properties of all available files and folders in the system without any browsing involved!

Which particular property is available (and how it is called!) depends on the file, the file type, and on your OS. You have to experiment to find out what works.

Remarks

(1) Note that file times ("Write", "Create") are returned as Coordinated Universal Time (UTC), which is usually not identical to the System Filetime (unless you live around London).
(2) Also the formatting of the returned data is completely controlled by the Shell. E.g. the "FileVersion" of XYplorer.exe is returned as "8.10.0.4" as opposed to "8.10.0004" or "8.10.00.04".

Resolving Junctions

Example of a complex junction structure, where a part (C:\Backup\) of a junction target is itself a junction to yet another target (N:\):

C:\Dati\Condivisi\Musica\ = junction to C:\Backup\Condivisi\Musica\

and

C:\Backup\ = junction to N:\

Now this returns C:\Backup\Condivisi\Musica\:

text property("#ResolveJunctions", "C:\Dati\Condivisi\Musica\");

And this returns N:\Condivisi\Musica\:

text property("#ResolveJunctionsAll", "C:\Dati\Condivisi\Musica\");

Note that"#ResolveJunctionsAll" has built-in protection from endless recursion caused by cyclic junction structures.

quickfileview

Open the Quick File View for the specified file.

Syntax

quickfileview [filename], [codepage]

filename full path/name, or relative to current path;
defaults to the current file.
codepage codepage to use for decoding the file
empty: use system default codepage
else: use the passed codepage

Examples

Quick File View the current file as Japanese (Shift-JIS):

quickfileview , 932;

quote()

Double-quotes a string.

Syntax

quote([string], [flags=0])

string [optional] string
flags 0: Quote.
1: Unquote.
return quoted string

Examples

echo quote("a"); // "a"

echo quote(1); // "1"

echo quote(); // ""

echo quote('"Hola!"', 1); // Hola!

rand()

Generates an integer random number.

Syntax

rand([low=0], [high=1])

low [optional] the lowest value to return (default: 0)
high [optional] the highest value to return (default: 1)
should be same or higher than low
return random number

Examples

echo rand(); //returns 0 or 1

echo rand(2, 4); //returns 2 or 3 or 4

echo rand(-1, 1); //returns -1 or 0 or 1

readfile()

Read the contents of a file into a variable.

Syntax

readfile(filename, [mode], [numbytes], [codepage], [start=1])

filename full path/name, or relative to current path;
defaults to the currently selected file

mode

t: [default] text; whether file is ASCII or UTF-8 or UNICODE is auto-detected
b: binary: raw bytes; each byte is internally stored as double-byte character with a zero big byte; corresponds to mode "b" in WriteFile()

numbytes

empty: read whole file
else: number of bytes to read; if longer than file size then the number is silently set to file size;
if <= 0 the function returns an empty string (and does not even try to read the file)
codepage codepage to use for decoding the file
empty: use system default codepage
else: use the passed codepage
start byte position to start reading from;
1 = beginning of file

Examples

Reads text from "test-in.txt" (ASCII or UNICODE) and writes it back to "test-out.txt" (ASCII or UNICODE):

$a = readfile("test-in.txt"); writefile("test-out.txt", $a);

Reads text from "test-in.txt" (ASCII or UNICODE) and writes it back to "test-out-A.txt" in ASCII (1 byte per char):

$a = readfile("test-in.txt"); writefile("test-out-A.txt", $a, , "ta");

Reads text from "test-in.txt" (ASCII or UNICODE) and writes it back to "test-out-U.txt" in UNICODE (2 bytes per char):

$a = readfile("test-in.txt"); writefile("test-out-U.txt", $a, , "tu");

Read first 4 bytes of the current file:

echo readfile( , , 4);

Decode the current file as Japanese (Shift-JIS):

text readfile(, , , 932);

Read current file from position 100:

text readfile(, , , , 100);

You can actually use ReadFile() and WriteFile() for file copying on a low level (bypassing the Shell):

Copy "test-in.txt" to "test-out.txt" (text file):

writefile("test-out.txt", readfile("test-in.txt"));

Copy "xy.png" to "xy-out.png" (any file, binary or text):

writefile("xy-out.png", readfile("xy.png", "b"), , "b");

readpv

Reads permanent variables (PVs) from a file.

Syntax

readpv [file]

file The file to read from. Can be relative to the current path.
If empty it defaults to "<xydata>\pv.dat".

Examples

readpv; //read from "<xydata>\pv.dat"

Remarks

· The file should have been previously created by writepv, otherwise it will not match the expected format.
· The PVs will be added to the current PVs. Current PVs of the same name will be overwritten.

readurl()

Reads the contents of a web file into a variable.

Syntax

readurl(url, [nocookies], [StripHTML], [flags])

url [required] URL (supported are http:// , https:// , and ftp://).
nocookies [optional]
0: use cookies
1: don't use cookies
StripHTML [optional]
0: return unchanged HTML
1: strip HTML comments and tags, scripts and styles, convert some common HTML entities, and remove excessive tabs, spaces and empty lines
flags (bit field)
1: fail gently if offline
2: silent mode (no error messages)
4: Check byte count after download. On no-match the download fails.
8: No status bar progress and success messages.
return The contents of the web file.

Examples

text readurl("http://www.xyplorer.com/index.htm");

Displays the contents of the given URL (HTML code in this case) in a text box.

text readurl("http://www.xyplorer.com/download.htm", 0, 1);

Displays the pure text of that URL in a text box.

Notes

The data size is limited to 100MB.

recase()

Changes the case of a string.

Syntax

recase(string, [mode], flags)

string String to change case of.
mode One of the following (full word, or first letter):
l, lower: [default] to lower case
u, upper: to upper case
t, title: to title case (first letter of each word to upper case, other letters to lower case)
c, camel: like "title" but preserves any caMel-case.
i, invert: invert the case of each letter.
s, sentence: first letter upper case, all others lower case.
r, removediacritics: strip accents and the like from letters, e.g. converts "à" to "a".
flags (bit field)
1: set extensions to lower case
return String with changed case.

Examples

text recase("the caMel can't.", "lower"); //the camel can't.

text recase("the caMel can't.", "upper"); //THE CAMEL CAN'T.

text recase("the caMel can't.", "title"); //The Camel Can't.

text recase("the caMel can't.", "camel"); //The CaMel Can't.

text recase("the caMel can't.", "invert"); //THE CAmEL CAN'T.

text recase("the caMel can't.", "sentence"); //The camel can't.

text recase("Motörhead", "removediacritics"); //Motorhead

// returns This Is A Test.htm

text recase("this is a test.HTM", "title", 1);

regexmatches()

Returns a list of all matches of a regular expression pattern in a given string.

Syntax

regexmatches(string, pattern, [separator="|"], [matchcase=0])

string String to work on (haystack).
pattern The RegExp pattern to search for in string (needle).
separator Separator between matches in the returned list.
Defaults to | (pipe).
matchcase [Defaults to 0] Compare method.
0: A=a
1: A<>a
return List of matches.

Example

text regexmatches("tiger,frog,ball", "[^,]+"); //tiger|frog|ball

regexreplace()

Replaces parts of a string, using a regular expression pattern.

Syntax

regexreplace(string, pattern, replacement, [matchcase])

string String to work on (haystack).
pattern The RegExp pattern to search for in string (needle).
replacement String to replace with.
matchcase [Defaults to 0] Compare method.
0: A=a
1: A<>a
return The new string.

Usage

When no replacement is defined, all occurrences of pattern will simply be removed (replaced by nothing).

In pattern, the caret (^) & dollar ($) match the beginning and end of every line (not the very start and very end of the entire string).

Examples

$a = RegExReplace("Image[1].png", "(?#Remove common IE suffix)^(.+)\[[0-9]+\](\..+)$", "$1$2");

Sets $a to "Image.png", removing the common IE suffix [1] from the filename.

$a = RegExReplace("bob", "b$", "p");

Sets $a to "bop" (the final "b" is replaced by "p").

releaseglobals

Releases all global/permanent variables from memory.

Syntax

releaseglobals [flags=3]

flags (bit field, defaults to 3)
1: release non-perm globals
2: release perm globals

Examples

The following script illustrates that the Permanent Variable $foo is gone (unset, no variable anymore) or not gone after "releaseglobals" and depending on the flags:

// to release or not to release
perm $foo; $foo = "hi!"; releaseglobals;
echo $foo; //$foo
perm $foo; $foo = "hi!"; releaseglobals 1;
echo $foo; // "hi!"
perm $foo; $foo = "hi!"; releaseglobals 2;
echo $foo; //$foo

rename

Renames the currently selected List item(s) according to the defined pattern and options.

Syntax

rename [mode (b|r|s|k|e)], pattern, [preview (p)], [itemlist], [flags=1], [illegalcharsreplacewith]

mode Defines the mode for the rename operation:
b: [Default] Batch Rename
r: RegExp Rename
s: Search and Replace
k: Keep Particular Characters
e: Set Extension
pattern [Required] The pattern to be applied. Its syntax may vary depending on which mode is used, see below for more.
preview Defines whether or not to show the Rename Preview before the actual rename operation.
[empty]: [Default] No Preview. Omit this parameter to rename the files directly, without preview or confirmation first.
p: Show Preview. The rename preview will be shown before anything happens, allowing you to verify, change the pattern or cancel the operation at will.
itemlist |-separated list of items (full path) to rename. If empty then current list selections are renamed. The | (pipe) respectively the items may be surrounded by any number of blanks.
flags (bit field, defaults to 1)
1: PromptOnFailure (prompt on each failed rename attempt)
2: ShowListOfUntouched (show list of all items that kept their old name)
4: Replace illegal characters (with the value of argument illegalcharsreplacewith).
8: Increment on collision. Note that this does the same as the /i switch, but it's much easier to handle when taking patterns e.g. from the clipboard.
illegalcharsreplacewith Replace illegal characters with this string, IF flags has the "4" bit set.

Examples

rename b, '*-<datem yyyymmdd>', p;

Appends the modified date to each of the selected items. With preview.

Note the single quotes around the date variable: This ensures that it is only resolved inside the rename procedure on a per-file basis. If it were double-quoted then all selected files would be appended the modified date of the currently focused item.

rename b, '*-<datem yyyymmdd>';

Appends the modified date to each of the selected items. Without preview.

rename , '*-<datem yyyymmdd>';

Same as above since the first parameter defaults to "b".

rename , '<dateexif yyyymmdd.hhnnss>-*', p;

Prepends the EXIF date to each of the selected items.

rename r, "\.html$>.htm", p;

RegExp Rename replacing html extensions by htm.

rename s, "ü/ue";

Search & Replace Rename replacing all "ü" by "ue".

rename k, "0123456789", p;

Keep Particular Characters Rename, keeping only the numbers present in a filename.

rename e, "htm";

Change any current extension to "htm".

rename , "africa.png /e", p, "E:\TestFiles\asia.jpg";

Rename a specific file (here: E:\TestFiles\asia.jpg) to a hardcoded new name (africa.png), using itemlist and the /e switch (for renaming the extension as well).

rename b, <clipboard>, p, , 4; //drop illegal characters

rename b, <clipboard>, p, , 4, "_"; //replace them with _

rename b, <clipboard>, p, , 12, "_"; //same as before with increment

For the functionality of the different rename operations see also here.

renameitem()

Renames a file or folder.

Syntax

renameitem(newname, [sourceitem=<curitem>], [flags=0], [numsuffix])

newname The new name (will be used as base and/or extension, depending on flags).
The newname argument supports the following placeholders:
* = original base
? = original extension
sourceitem The item to rename.
Absolute or relative to current list path.
Defaults to the current item.
flags 0: [Default] Smart (keep extension unless extension is passed)
1: Rename base (keep extension)
2: Rename extension (keep base)
[1 + 2 = 3: Rename all (base and extension)]
4: Show dialog (Suffix / Overwrite) on name collision.
Notes:
1 and 2 are only applicable if sourceitem is a file, not a folder.
On 4 numsuffix defaults to the incremental suffix defined in Configuration | Templates.
numsuffix Number template to auto-suffix on collision.
Set the start value and use "0"s as placeholders for numerical increments (e.g. "-01", starting with "-01", "-02", "-03", etc.) or "a"s as placeholders for alphabetical increments (e.g. "-aa", starting with "-aa", "-ab", -ac", etc.)
return The new name if the rename was successful, else nothing (empty string).

Examples

Rename current file to "John[.ext]" (or current folder to "John") in current folder (fail on collision):

renameitem("John");

Same as above, but auto-suffix on collision:

renameitem("John", , , "-01");

Rename "Paul.txt" to "John.txt" in current folder:

renameitem("John", "Paul.txt", , "-01");

Rename current file" to "<clipboard>[.ext]" in current folder:

renameitem(<clipboard>);

Rename current item to "[base.]jpg" (i.e. change the extension):

renameitem("jpg", , 2);

Rename the current item to "John"; on name collision show the dialog with options to Suffix, Overwrite, or Cancel.

renameitem("John", , 4, "-001");

Same as above using the incremental suffix defined in Configuration | Templates.

renameitem("John", , 4);

Examples for using placeholders *and ?

This renames a current file "hash.jpg" to "Copy of hash.jpg":

renameitem("Copy of *");

This renames a current file "hash.jpg" to "(jpg) Copy of hash.jpg":

renameitem("(?) Copy of *");

Remark

Contrary to SC rename, SC renameitem is able to rename items that are not currently listed or selected, and it can auto-suffix numbers on collision. This gives you a number of fascinating new options.

replace()

Replace parts of a string.

Syntax

replace(string, search, replacement, [matchcase], [start=1], [count=-1])

string String to work on (haystack).
search String to be replaced (needle).
replacement String to replace with.
matchcase Compare method.
0: A=a [Default]
1: A<>a
start Position from left where the replacement starts.
count Maximal number of replacements.
return The new string.

Usage

When no replacement is defined, all occurrences of search will simply be removed (replaced by nothing).

Examples

echo replace("Maxi", "max", "Min"); // "Mini"

echo replace("Maxi", "max", "Min", 1); // "Maxi"

echo replace("aaa", "a", "b", , 2); //abb

echo replace("aaa", "a", "b", , 2, 1); //aba

echo replace("aaa", "a", "b", , , 1); //baa

The following line transforms the current location to a Unix-style path and copies it to the clipboard. For example, if the current location is S:\usr\local\apache2\conf then this script will copy /usr/local/apache2/conf to then clipboard:

$p = substr("<curpath>", 2); copytext replace($p, "\", "/");

replacelist()

Replaces substrings by list.

Syntax

replacelist(string, searchlist, [replacelist], [separator], [matchcase])

string String to work on (haystack).
searchlist Substrings to be replaced (needles).
replacelist Substrings to replace with.
empty: All substrings in searchlist are removed.
Special case: If you state only one replace unit, all items in the search list are replaced with that one unit. Consequently if the replace list is empty then all items in the search list are removed from the string.
separator Separates the strings in the lists.
empty: Each character is taken as a substring.
matchcase Compare method.
0: A=a [Default]
1: A<>a
return The new string.

Examples

text replacelist("Taxi", "ai", "ia"); //Tixa

text replacelist("Taxi", "ax,i", "-,Rex", ","); //T-Rex

text replacelist("Taxi", "ai"); //Tx (a and i removed from Taxi)

text replacelist("Taxi", "ai", "o"); //Toxo (a and i replaced by o)

text replacelist("Taxi", "a,i", "ou", ","); //Touxou (a and i replaced by ou)

Notes

- As you see from the 2nd example, the strings in search-replace pair can have different lengths.
- If the item count in both list differs, then the smaller count is used and the surplus items are ignored.
- The string is walked on time from left to right; any replaced parts are not processed again. So in this example, "Rex" will not be replaced by "Bone" in a second pass:
text replacelist("Taxi", "ax,i,Rex", "-,Rex,Bone", ","); //T-Rex
- The substrings are processed from left to right, first match wins. Therefore:
text replacelist("Taxi", "a,ax", "i,ox"); //Tixi
text replacelist("Taxi", "ax,a", "ox,i"); //Toxi

Usage

This command can be used for interesting things, e.g. to (roughly) transliterate e.g. Cyrillic to Latin, or do some simple encryption, or clean file names from undesired characters.

report()

Returns a report of the current file list contents.

Syntax

report([template], [itemlist], [header], [footer])

template Defines the layout of one line (file record); for each reported file one line is created based on this template.
If missing or empty: Take the current list data as is.
itemlist What to report on:
0: [default] all current list items
1: all currently selected list items
[else]: items in a pipe(|)-separated list of items (full path)
header Any string data to be put at the top of output.
footer Any string data to be put at the bottom of output.
return The report.

Omitting the Template

If you omit the template argument (or pass "") the report you get is identical to the list you see: Same types and sequence of columns, same file data in same format. The fields are by default separated by Tab characters.

You may overwrite the default separator by passing a different separator through the template argument.

Examples

Use the default field separator Tab: text report();

Use ", " as field separator: text report(", ");

Use "{Name}. " as template (see next paragraph): text report("{Name}. ");

Using the Template

If you use the template argument you are in full control and can decide what is shown, where it is shown, and how it is shown. The various file data are defined by fields, corresponding to the columns the file list. A field consists of a field name and, in some cases, an optional format definition, separated from the field name by a single blank. The fields are enclosed in curly brackets {}, and they are not case-sensitive (i.e. a=A). Example for a template argument:

"No. {#}, {name}, {size kb} ({size b}), {modified yyyy-mm-dd}"

The following fields are currently supported (they obviously match the file list's column headers):

Browse Mode: {#}, {Name}, {Ext}, {Size}, {Type}, {Created}, {Modified}, {Accessed}, {Attr}, {Len}, {Label}, {Tags}, {Comment}

Find Mode: {#}, {Name}, {Ext}, {Size}, {Type}, {Created}, {Modified}, {Accessed}, {Attr}, {Len}, {Label}, {Tags}, {Comment}, {Path}

Drives Mode: {#}, {Name}, {Type}, {Total Size}, {Used Space}, {Free Space}, {Free %}, {Per Cluster}, {Vol Serial}, {File System}

Optional format definitions for the {Size} field:

{Size KBR} KB (rounded up)

{Size KB} KB

{Size B} Bytes (no suffix)

{Size BB} Bytes (with suffix)

{Size FLEXR} Flexible (rounded up)

{Size FLEX} Flexible

{Size RAW} Raw bytes (no thousand separators)

{Size MB} MB

{Size GB} GB

{Size TB} TB

{Size PB} PB

{Size} [no format: use current Size Column Format]

Optional format definitions for {Created}, {Modified}, {Accessed}:

{Created yyyy-mm-dd hh:nn:ss}

etc. ... the usual date format definitions...

{Created} [no format: use current Date Column Format]

Optional format definitions for {#}:

{# @@@@} fill with leading blanks

{# 000} fill with leading zeroes

Note that you cannot combine @ and 0 to have first leading blanks and then leading zeroes.

Metadata (aka Extended Properties)

The so-called "Extended Properties" (the complete set of available metadata of file) are fully supported using the field {prop:[property]}. [property] can be a numeric as well as a literal property identifier.

For example, the following line reports the image dimensions for image files in the current list using the literal property identifier "dimensions":

text report("{name} ({prop:dimensions})<crlf>");

This line yields the same results in a different way:

text report("{name} ({prop:ImageX} x {prop:ImageY})<crlf>");

This line yields the same results in yet another way, namely with numeric property identifiers (note that these numbers only work in Win7!) :

text report("{name} ({prop:#162} x {prop:#164})<crlf>");

Note that MS made a total mess here so that each Windows version has a completely reshuffled set of numbers and keywords. But there is help: The line numbers in "Configuration | File Info Tips | Show custom file info tips" give you the actual values of all available extended properties in your current Windows version. Literal property identifiers are not documented at all by MS, so you can only guess, trial, and error.

Additional Special Fields

{DocTitle}, {DocSubject}, {DocAuthor}, {DocCategory}, {DocComments}

· These fields that will retrieve the respective meta properties from all file types that support meta properties.

{FileVersion} = version of EXEs, DLLs, etc.

{WhenTaken} = EXIF date of photos

{Dimensions} = width x height of images

· Note that these fields only work under XP! The labels have been changed in Vista and later.

{Fullname}

· The field is set to the full path/name of the file.
· Obviously only for Browse and Find modes, not Drives.

{Fullpath}

· Field is set to the full path of the item.
· The returned path has no backslash.
· In Find mode, the return is identical to the field {Path}.
· In Drives mode, "Computer" (or so) is returned.
· In Network mode, "Network Places" (or so) is returned.

{Basename}

· The field is set to the base name of the file (file name without extension).
· Folder names are returned unchanged.

{LabelID}

· Set to the item's Label ID. If the item has a comment but no color label assigned {LabelID} returns "0"; if the item is not tagged at all {LabelID} returns "".

{Count}

· Returns the (recursive) count of items (files and folders) contained within a folder. For files it returns nothing.

Note that calculating the count can take time with large folders.

Example, using the meta-field {dir} to fork returns between folders and files:

text report("{name}{dir , <DIR> with {count} items| ({size kbr})}<crlf>");

{Dir dir_value|file_value|drive_value}

· Field is set to "dir_value" if item is a directory.
· Field is set to "file_value" if item is a file.
· Field is set to "drive_value" if item is a drive.

Note that the field {Dir ...} may contain other fields (but not contain itself). For example, in

text report("{Name} - {Dir -|{Size B} ({Size FLEX})|}<crlf>");

the {Dir ...} field will return:

· for directories: -
· for files: {Size B} ({Size FLEX}) [resolved, of course]
· for drives: [nothing]

{Zebra odd_value|even_value[|divisor=2]}

· Field is set to "odd_value" in all odd lines.
· Field is set to "even_value" in all even lines.
· The divisor defaults to 2 but you can set it to any larger value so that e.g. the "even_value" (the value that divides by the divisor without remainder) is set to every 5th line, the "odd_value" to all other lines.

You can use this field to apply alternate formatting, e.g. to achieve a zebra striping effect if you use HTML for your report, or to group the output into blocks of a certain size. See examples below.

Extra Columns

Extra Columns are referenced by their case-insensitive canonic names (independent of any translations), e.g. "extra 1".

Example:

text report("{name}: {extra 1}, {extra 2}, {extra 3}, {extra 4}, {extra 5}<crlf>");

Columns of type Date can be formatted in the usual way:

{extra 5 yyyy-mm-dd}

Columns of type Checkbox can be formatted like this:

{extra 4 yn} = Show localized "Yes" (non-empty) or "No" (empty)

{extra 4 y} = Show localized "Yes" (non-empty) or nothing (empty)

{extra 4} = Show the raw contents

There is also a fully customizable format for the non-empty/empty states:

{extra 4 OnNonEmpty|OnEmpty} = Show "OnNonEmpty" on non-empty, "OnEmpty" else

Example (assuming Extra 4 is a Checkbox column):

text report("{name}: {extra 4 Done|To Do}<crlf>");

Examples

text report();

Displays the current file list "as is" in a multiline textbox.

text report("{modified yyyy-mm-dd hh:nn:ss}<crlf>", 1);

Displays the modified date of all selected items in a multiline textbox. Note that it's your turn to supply a carriage return / line feed if needed. In the example, the internal variable <crlf> (resolved to 0xd0a0) ends the line.

text report("{modified yyyy-mm-dd hh:nn:ss.fffffff}<crlf>", 1);

The same as above with maximum resolution down to the 1/10 microsecond.

text report("{name}; {size KBR}; {modified}<crlf>", , "Report on <curpath>, <date><crlf>", "---");

Displays a mini-report of the current file list in a multiline textbox.

text report('The item "{name}" has {size BB}.' . "<crlf>");

As you see, these fields have nothing to do with scripting variables, hence they are resolved whether single-quoted or not.

text report('The file "{fullname}" has {size B} bytes.' . "<crlf>");

Displaying the full name.

text report("{name} is a {dir folder|file|drive}.<crlf>");

Showing whether item is file, folder, or drive.

text report("{# @@@@} {name}<crlf>{zebra |<crlf>|5}");

Fill leading blanks to the line number, and add an empty line after every 5 lines. Note that the XY variable <crlf> works within the double-quoted argument.

text report("{name}, {free %}, {total size gb}<crlf>");

Mini-report for the drives listing (Computer node).

writefile("Report.htm",
report("<tr><td>{Name}</td>
<td align=right>{Size B} {dir [DIR]|bytes|}</td>
<td>{Created}</td><td>{Modified}</td></tr><crlf>", ,
"<table cellpadding=4>", "</table>"));

Generate an HTML table of the current folder and save it to Report.htm.

text report("{Name}, {Size B} bytes, {Modified yyyy-mm-dd hh:nn:ss},
ver {FileVersion}", "%winsysdir%\shell32.dll");

Report on a single specific item.

Remarks

(1) The sort order is the one currently present in the file list.
(2) The {#} field (line number) is not filled with the line number each file currently has in the file list, but simply numbers the lines in the report starting with 1. This coincides with the actual line numbers in the file list only if the report features all files (no just a subset of selected ones).
(3) You can use any number of fields in the template, and it's no problem to use the same field more than once with different format, as in "... {size kb} ({size bb}) ..."
(4) The Report() function allows you to create full blown HTML-reports of any parts of your file system or of search results! You may even show icons for file types if you provide the image files and give them names that match the extension, e.g. type-txt.gif, type-png.gif, etc. which then would be referred to like "C:\Your\Path\type-{ext}.gif".
(5) In cooperation with function WriteFile() you are able to easily write the created reports to your harddisk.

resolvepath()

Converts a relative or portable path to an absolute path.

Syntax

resolvepath([path], [base=<xypath>\], [abs2rel])

path relative or portable path
if empty or missing the function returns base
base base path; defaults to <xypath>\

abs2rel

0: normal function
1: reversed function: path is absolute, return path is relative to base
return absolute or relative path (dep. on abs2rel)

Examples

Assuming <xypath> = C:\Program Files\XYplorer:

echo resolvepath(); //C:\Program Files\XYplorer\

echo resolvepath("foo"); //C:\Program Files\XYplorer\foo

echo resolvepath("foo\"); //C:\Program Files\XYplorer\foo\

echo resolvepath("\foo"); //C:\foo

echo resolvepath("\foo\");//C:\foo\

echo resolvepath("\"); //C:\

echo resolvepath(".."); //C:\Program Files

echo resolvepath("?:"); //C:

echo resolvepath("?:\"); //C:\

echo resolvepath("?:\foo\bar\"); //C:\foo\bar\

echo resolvepath("?:", "D:\foo\bar\"); //D:

echo resolvepath("foo", "D:\foo\bar\"); //D:\foo\bar\foo

echo resolvepath("", "D:\foo\bar\"); //D:\foo\bar\

Absolute to relative:

echo resolvepath ("C:\Apps\XY\XYplorer.exe", "C:\Apps\", 1); //XY\XYplorer.exe

rtfm

Opens a specific page in the Help file XYplorer.chm.

Syntax

rtfm page

page Name of the HTML page, optionally with #anchorname.

Examples

rtfm "idh_find.htm";

RTFM "idh_find.htm#idh_findtabtags";

rotate

Rotates JPG images. Rotation is lossless for typical digital camera images.

Syntax

rotate [mode=90|180|270|h|v], [jpgfile_src], [jpgfile_trg], [only_if_lossless=0|1], [flags]

mode rotation in degrees (clockwise), or horizontal/vertical flip orientation; defaults to 90
jpgfile_src JPG file to rotate; defaults to current file if empty; relative to current path if path missing
jpgfile_trg target file name; defaults to jpgfile_src if empty; relative to current path if path missing

only_if_lossless
0: [default] rotate always
1: error if rotation cannot be done lossless

flags
0: [default] no refresh
1: refresh list, preview, and thumbnails.

Remarks

(1) ONLY if the width and height of the image are both multiples of 16, then indeed the rotation is lossless! Luckily, digital camera image dimensions are usually multiples of 16. MS has buried some deeper info on this here:
http://msdn.microsoft.com/en-us/library/ms533845.aspx
If the image dimensions are not multiples of 16 then colors and sharpness will slightly fade if you do many consecutive rotations on the same image.
(2) And yes, the function will ONLY work on JPG images.
(3) EXIF data are preserved.
(4) Thumbnails are refreshed only when in thumbnails mode.

Examples

rotate; //rotate current image by 90 degrees (clockwise)

rotate 180; //rotate current image by 180 degrees (clockwise)

//rotate "E:\my.jpg" by 90, but only if it can be done lossless

rotate , "E:\my.jpg", , 1;

//flip current image horiz., save to "flipped.jpg" in cur path:

rotate h, , "flipped.jpg";

//save vertically flipped "D:\pic.jpg" to "E:\pic-v.jpg":

rotate v, "D:\pic.jpg", "E:\pic-v.jpg";

Example for POM

Add the following item to your Custom File Associations (menu Tools), and you'll have a command to rotate the image 90° clockwise on the Portable Openwith Menu (POM) of each JPG file:

|"Rotate 90° clockwise" jpg>::rotate

round()

Rounds a number.

Syntax

round(number, [precision=0])

number Number to round.
precision Number of digits after the decimal point. precision can also be negative or zero (default). A negative precision refers to digits before the decimal point.

Examples

echo round(172.7368, -3); //0

echo round(172.7368, -2); //200

echo round(172.7368, -1); //170

echo round(172.7368, 0); //173

echo round(172.7368, 1); //172.7

echo round(172.7368, 2); //172.74

echo round(172.7368, 3); //172.737

echo round(172.7368, 4); //172.7368

run

Works (almost) identical to Windows Start | Run, i.e. you can start executables, open documents with the OS-asociated applications, open websites, and much more.

Syntax

run command, [directory], [wait=0], [show=1]

command: Anything that works in Windows Start | Run, usually a module name plus (optionally) arguments. Note that module names containing blanks must be quoted to correctly separate name and any arguments.
directory: The working directory, allows you to skip the path in command; defaults to current path.

wait:
0: [Default] Return immediately and continue the script.
1: Wait, with message: Only continue when the shelled process has finished, show message box "Please wait..." while the process is going on.
2: Wait, no message: Same as above but without message box.

show:
0: Hides the window.
1: [Default] Activates and displays the window.
2: Activates the window and displays it as a minimized window.
3: Activates the window and displays it as a maximized window.

The differences to the original Windows Start | Run are:

(1) Different error messages in case of failure.
(2) Quoting items with blanks slightly differs:

run '"C:\With Blank.txt"';
Names with blanks must be quoted. Note that the quotes have to be wrapped in single-quotes because an argument's outer quotes are auto-stripped by XY's script parser!

run '"C:\Program Files\Winzip32.exe" -min';
Also wrapped in single-quotes because otherwise the "-" in "-min" would be interpreted as a math operater.
(3) Using "run" with wait=1 differs even more to the Windows Run command. Not all sorts of commands work, there is less smartness built in. For example, you cannot call documents that will be opened by the associated application. This will NOT work:
run "C:\Programme\XYplorer\ReadmeXY.txt", , 1; //NO JOY
You also cannot use short forms like this:
run "winzip", , 1; //NO JOY
However this works (maybe because it's in the path):
run "notepad", , 1; //OKAY
See more examples below under Using the wait parameter.

Examples

run "calc";

Registered apps are recognized via "Prog ID" which is usually the base name of the *.exe file.

run "winzip32 -min";

No blanks in the filename: No quotes nececessary...

run '"winzip32" -min';

... but quotes are allowed.

run "www.xyplorer.com";

Open an URL.

run "control";

Show Control Panel.

run "charmap";

Show character map utility.

run "regedit";

Open registry editor.

run "winver";

Display the Windows verson installed on the computer.

run "mailto:support@xyplorer.com?subject=Wow!&body=Hi!";

Open email client with some fields prefilled.

run "rundll32.exe shell32.dll,Control_RunDLL timedate.cpl";

Show Windows Time/Date dialog.

run "rundll32.exe shell32.dll,OpenAs_RunDLL <curitem>";

Open the Windows Open With dialog for the current item. Note that in this case <curitem> has not to be quoted even if it contains blanks; rundll32.exe is smart enough to handle it.

run """C:\Program Files (x86)\WinMerge\WinMergeU.exe"" /e /r ""<get path 1>"" ""<get path 2>""";

Run WinMerge (a popular comparison tool) in order to compare the current panes.

Emulating Shell context menu clicks using run

User Buttons (see Custom Toolbar Buttons) allow you to get the action done quicker and with less clicks than by using the often slow Shell context menu. Here are some useful mini scripts:

For NIS to scan a selected folder:
run "C:\Program Files (x86)\Norton Internet Security\Engine\17.0.0.136\navw32.exe" "<curpath>\*";

For WinRAR to extract from multiple consecutive .RAR files by selecting only the first file:
run "C:\Program Files (x86)\WinRAR\winRAR.exe" "x" "<curitem>";
"x" in this example is their command to extract to the current folder and preserve folder structure within the compressed file.

Using the directory parameter

run "ReadmeXY.txt", "C:\Programs\XYplorer\";

Using the wait parameter

If wait=1 there's a modal dialog while the shelled process is being active. It blocks you from doing anything but wait or cancel the waiting and continue with the script.

run '"C:\Programme\WinZip\WINZIP32.EXE" -min', , 1; msg "Done!"

Shows "Done!" when WinZip is closed.

run "notepad C:\Programme\XYplorer\ReadmeXY.txt", , 1; msg "Done!"

Shows "Done!" when notepad is closed.

Using the show parameter

Note that it depends on the called application whether it honors the show parameter. Some ignore it.

run "notepad <xypath>\startup.ini", , , 0; //hidden

run "notepad <xypath>\startup.ini", , , 1; //normal

run "notepad <xypath>\startup.ini", , , 2; //minimized

run "notepad <xypath>\startup.ini", , , 3; //maximized

savesettings

Saves all current settings.

Syntax

savesettings

Remark

The command is equivalent to menu File | Save Settings and saves the current *.ini and *.dat files, including the pane data.

sel

Select and focus one item in the file list by position or pattern matching. Optionally select any number of the items following.

Syntax

sel [position/pattern], [count], [startfromtop]

position

(number): Define the new line to be focused and selected. Either an absolute line number, or a relative (to the currently focused) one when prefixed with + or -. Note that the argument must be quoted when + is prefixed! See examples below.
[pattern]: When this parameter is in between square brackets ( [ ] ), then the item to be focused and selected will be the first one matching the given pattern, starting on current position.
a: Select all.
i: Invert selection.
f: Select all files (no folders).
[empty]: Deselect all.

count

The number of items to get selected, starting with the one on position (that just got focused as well). Ignored when the first parameter is empty, or set to a, i or f. Defaults to 1.

startfromtop

0: [Default] start from current position
1: start from top of list
startfromtop is ignored if the first argument is not a pattern.

Examples

sel 1 // Select first item in list

sel 2 // Select second item in list

sel "+5" // Select item 5 positions after current; note the quotes (else +5 evaluates to 5)!

sel -1 // Select item before current

sel +, 3 // Select 3 items starting with the currently focused one.

Use the command sortby to have more control about the results of sel.

sortby size, d; sel 1, 5;

Sorts the List by Size in descending order, and selects the five first items. Focus will be on the first item on List.

sel f; sel i;

Selects all files (no folders), then inverts the selection = Selects all folders. Note that no items will be selected if there are no folders in the current location, or if they are not shown due to options (like Show Folders in List being disabled) or if a Visual Filters have them hidden.

sortby "Name", a; sel "[readme.*]";

Sorts the List by Name, ascending, then selects the first file whose name is "readme", regardless of its extension.

sortby "Name", a; sel 1,0; sel "[[ab]*.txt]";

Sorts the List by Name, ascending.

Puts focus on the first item.

Selects the first text file (extension .TXT) whose name begins with either a "A" or a "B".

sel "[Test.txt]", , 1;

Selects "Test.txt" in the file list (also if it is above the current focus position. On no match any current selections are unselected.

sel -1, , 1; //select the last item in the list

sel -2, , 1; //select the pre-last item in the list

You can identify items from the end of the list by using negative positions and setting the startfromtop argument.

selectitems

Selects items in the file list by a list of names.

Syntax

selectitems itemlist, [flags], [focusfirst=1], [mode], [pane]

itemlist [required] Pipe(|)-separated list of item names; the names can be title-only or full path.

flags
0: [Default] Mind extensions when matching the names.
1: Ignore extensions.
2: Match full paths.

focusfirst
0: Keep the focus where it is.
1: [Default] Auto-move the focus to the first selected file.

mode
n: [Default] New selection (drop current selections).
a: Add the matches to any current selections.
r: Remove the matches from any current selections.

pane
a: [default] active pane
i: inactive pane
1: pane 1
2: pane 2

Notes

· The matching is only done against the file titles; when paths are passed they are ignored.
· The matching is case-insensitive (A=a).
· If itemlist is empty all items are unselected.
· There is a bit of smartness built in: if itemlist contains no pipe (|) but CRLF(s) then the list us parsed by CRLF. This means you also can pass items one per line.

Remark

Using this command you can easily save and (later) restore a selection:

$selections = get("selecteditemsnames", "|"); //store

selectitems $selections; //restore

Examples

selectitems "Fiji.txt|Tahiti.txt"; //selects 2 islands

selectitems "Tahiti.txt", 1; //also selects Tahiti.wav (if exists in current list)

selectitems "<clipboard>", 2; //Match full paths from a list on clipboard (one item per line)

selectitems "C:\Fiji.txt"; //selects Fiji.txt in current list (no matter which folder)

selectitems "Canary.txt|Fiji.txt", , , "a"; //add to current selections

self()

Get info about the currently running script respectively script file.

Syntax

self(info)

info [required] any of the following:
file: current script file (empty if none)
path: current script file's path (app data if none)
base: current script file's base (empty if none)
script: current script
caption: caption of the current script
icon: icon resource of the current script
return Info.

Examples

msg self("path");

msg self("script");

Of course, the info types file, path, and base only make sense when the script is running from script file.

Using the Caption of a Script: self("caption")

A script's caption can be part of the script itself (typically in a multi-script resource) but also be stated in its container, e.g. a Catalog Item or a User-Defined Command. If the current script has no own caption then self("caption") returns the caption of its parent script (the script that called it, if any), or the parent of the parent etc. until a caption is found. The latter makes it possible to load script files in a Catalog Item via load() and still refer to the Catalog Item's caption by self("caption").

Here's an example for a Catalog-based script that tags the dropped items taking the actual tags (cats, dogs) from the caption of the script:

Caption:

Tag dropped items: cats, dogs

Script:

// Caption example = Set tag to dropped items: cats, dogs
$tags = gettoken(self("caption"), 2, ":", "t");
tag $tags, <get drop |>, 1;

Items dropped on this Catalog Item are tagged with "cats" and "dogs". Simply change the caption of the Catalog Item (e.g. to Tag dropped items: birds) to change the functionality of the drop event.

selfilter

Selects list items using a pattern.

Syntax

selfilter [pattern], [type (f|d)], [column], [add]

pattern

The pattern to filter which items to select. If empty or missing, then it will be the same all items will be selected.

type

The type of items to get selected

[empty]: [Default] Files and folders

f: Files only

d: Folders (Directories) only

column

[Default: Name] Defines the column which the pattern will be treated against.

Tip: The first partial match (from left) with the column's name will be used, so to match the column "Modified" you could use either "m", "Mod", or "modified", for example.

add

0: [Default] new selection

1: add to current selection

Examples

selfilter "readme";

Selects all items whose name contains "readme" (eg: readme, readme.txt, !readme.now).

selfilter """readme""";

Selects item named "readme" and only that one item.

selfilter h, , "attr";

Selects all hidden items (if hidden items are shown on List, obviously).

selfilter "2008", f, "mod";

Selects all files on List modified in 2008.

Note that this will only work if the Modified column display years in 4-digits format.

selfilter "###,## MB", , "size";

Selects all items of at least 100,00 MB. Folders will also be selected IF their sizes are calculated and shown on column Size.

Note that this will only work if the Size column uses format "MB".

selfilter "*.txt"; selfilter "a*", , , 1;

First selects all TXT files, and then adds all items starting with "a" to the selection.

selfilter "*.", f;

Selects all files without extension.

seltab

Selects a tab by position.

Syntax

seltab [position], [mru]

position: The position of the tab to be selected (opened, activated):
[empty] Activates the default tab (if any).
(position) The position of the tab to select, counting from left (as shown on Tab list - menu Window | Tabs). The first tab is number 1.
A negative position points to tabs from the right end (-1 points to the right-most tab).
0 points to the current tab.
+ (plus) Selects the next tab.
- (minus) Selects the previous tab.
mru: If position is relative ("+" or "-") then mru controls which tab is selected next.
0 left-right-order
1 recently used order

Examples

seltab 3;

Selects the third (left-most) tab.

seltab +;

Selects the next tab.

seltab;

Selects the default tab.

seltab "+", 1;

Selects the next tab, using MRU.

seltab "-", 1;

Selects the previous tab, using MRU.

seltab -1;

Selects the right-most tab.

seltab 0;

Selects the current tab (reverts to the tab's saved settings).

set

Sets a variable to a defined value.

Syntax

set output, value, [reprocess]

output: The output variable.
value: The value to set the variable to.
reprocess: [optional]
r = Post-process the value set in the variable to resolve any contained environment or XYplorer variable.

Usage Tip

See Using the equal-operator (=) below for a more common way to set variables to a value.

To unset a variable, see command unset.

The reprocess argument

Compare the following two examples to see the difference the reprocess "r" parameter makes.

copytext '%tmp%'; set $msg, <clipboard>; msg $msg;

Copy to the clipboard the string %tmp% (in single quotes: not resolved!).

Put the content of the clipboard (%tmp%) into $msg.

Show the content of $msg (%tmp%).

copytext '%tmp%'; set $msg, <clipboard>, "r"; msg $msg;

Copy to the clipboard the string %tmp% (in single quotes: not resolved!).

Process the content of the clipboard (%tmp%) to resolve any variable, and put the results (e.g. C:\TMP) into $msg.

Show the content of $msg (e.g. C:\TMP).

Using the equal-operator (=)

There's a common alternative for the set command. To assign a value to a variable you can simply use the following syntax:

output = value, e.g. $a = "b";

The optional reprocess argument is also supported, e.g.:

::copytext '%tmp%'; $a = <clipboard>, "r"; msg $a;

Displays "C:\Temp" (or whatever it is).

Adding strings (concatenation)

Set (or the equal-operator) can also be used to add strings (or variables):

set $a, "1"."2"; OR $a = "1"."2";

Set $a to "12".

set $a, "tr"; set $b, "ee"; set $c, $a.$b; msg $c; OR

$a = "tr"; $b = "ee"; $c = $a.$b; msg $c;

Display "tree".

Examples

set $year, "2008"; msg $year;

Set $year to "2008". Then show it in message box.

set $year, <date yyyy>; msg $year;

Set $year to the current year. Then show it in message box.

set $path, <curpath>; msg $path

Set $path to the current path. Then show it in message box.

setkey

Sets the value of a configuration key in the current INI file, or of any INI file.

Syntax

setkey value, key, section, [INIfile], [flags]

value The value to be set to the key.
key The name of the key.
section The name of the section.
INIfile [optional] the name of the INI file. Expects a filename with extension, and can be absolute or relative to the running script's path. If the parameter is missing it defaults to XYplorer's current INI file.
If the file does not exist yet, it will be created.
flags (bit field)
0: Automatic quoting: quote value when necessary.
- when the value is quoted
- when the value has leading or trailing spaces
1: Write the value in quotes.
2: Don't write the value in quotes.

Usage

Note that setkey pairs with getkey. The getkey/setkey commands support reading/writing values of up to 32,766 characters.

Examples

Set key StartPath in section General to value "C:\" in the current INI file:

setkey "C:\", "StartPath", "General";

Note: Only the key on disk is changed, not the current setting in memory! To realize any changes made via setkey you should use "Restart without Saving" in menu File!

Set key Year in section Vacation to value "2009" (resolved date now, if now is year 2009) in the INI file "C:\holiday.ini".

setkey "<date yyyy>", "Year", "Vacation", "C:\holiday.ini";

The INI file, if it was freshly created, will look like this:

[Vacation]

Year=2009

Similar to above, but value quoted:

setkey "2012", "Year", "Vacation", "<curpath>\holiday.ini", 1;

[Vacation]

Year="2012"

setting

Alter some of XYplorer's user settings, temporarily or permanently. Typically used in order to ensure the expected execution of a script, which might depend on certain settings.

Syntax

setting name, [value (1|0|r)], [permanent (p)]

name

[Required] One of the following (case insensitive):

ShowNav: Show Navigation Panel (Tree and, optionally, Catalog)

ShowTree: Show Tree

ShowFloppies: Show Floppy drives

ShowHiddenDrives: Show Hidden Drives

ShowHiddenItems: Show hidden files and folders

ShowSystemItems: Show system files and folders

ShowNethood: Show My Network Places

HideFoldersInList: Show folders in list

ShowFolderSizeInList: Show folder sizes in file list

SortFoldersApart: Sort folders apart

KeepFoldersOnTop: Keep folders on top

SortNatural: Natural numeric sort order (XP and higher)

ResortAfterRename: Resort list immediately after rename

AutoRefresh: Auto-refresh

LockTree: Lock Tree

WatchDuringFileOp: Auto-refresh during file operations

RegexpRenameSep: Set the separator used in a Regexp Rename Expression

AllowRecursion: Show no warning on script recursions

UseCustomCopy: Enable Custom Copy for file operations

BackgroundFileOps: Enable background processing (XYcopy)

BackgroundedFileOps: Define the file operations that should be backgrounded

EnableFolderViewSettings: Enable Folder View Settings

value

How to set the specified setting:

1: [Default] Enable the option.
0: Disable the option.
r: Restore the previous value (before script execution).

Note that some settings have values other than 1/0/r:

With RegexpRenameSep, you pass the separator, e.g.

setting "RegExpRenameSep", ">>";

With BackgroundedFileOps, the value is OR-combined from the following values

1 [x] Backup (currently unused; has yet to be coded)

2 [x] Copy

4 [x] Cross-volume move

8 [ ] Intra-volume move (always parallel = not queued!)

16 [ ] Delete (always parallel = not queued!)

Example:

setting "backgroundedfileops", 31; //= all fileops

permanent

Defines whether the state for the specified option should be "permanent", or restored on script execution end.

[empty]: [Default] Makes the change temporary, so the option will be restored to its previous value when the script execution ends.
p: Makes the change "permanent", so it stays that way even after script execution is over.

Note: You can also use command settingp to set options permanently.

Usage

Simple specify the option you want to change, and whether you want to enable or disable it. Obviously if the option is already on that state, no change will be done.

Note that restoring options to their previous values, or user values, is not required: all modified options are restored automatically by XY when script execution ends (unless specified otherwise by using "p" as third parameter) regardless of how the script ended: normal termination, error, user cancellation...

Examples

setting "shownethood", 1;

Ensure the network neighborhood is shown. A change of the setting is not permament. If the nethood was not shown before then it will automatically hidden again when the script has ended.

setting "HideFoldersInList"; msg "Folders are hidden!";

Hide folders in the list, show a message (to give you the chance to testfy that the folders are actually hidden). After the script is over, the folders will be shown again (if they were shown originally).

setting "HideFoldersInList"; setting "HideFoldersInList", r;

Hide folders in the list, then immediately and explicitly restore to the original setting. If folder were hidden anyway, this script will do absolutely nothing.

settingp

Alter some of XYplorer's user settings permanently.

Syntax

settingp setting name, [value (1|0]

name

[Required] The name of the setting. See command setting for a list.

value

How to set the specified setting:

1: [Default] Enable the option.

0: Disable the option.

Usage

Simply specify the option you want to change, and whether you want to enable or disable it. Obviously if the option is already on that state, no change will be done.

Command settingp is an alias to using command setting with parameter p (for "permament"). See there for examples.

showhash

Shows the most common hash values (MD5, SHA-1, SHA-256, SHA-512) for a particular file.

Syntax

showhash [file]

file The file.
Defaults to the current file, respectively the focused file if no file is selected.

Examples

showhash; //shows hash values for current file

showhash "D:\a.txt";

sortby

Set the sort order for the file list.

Syntax

sortby [column], [order], [secondary_sort]

column Defines the column on which the sort will be done. Defaults to Name.
Tip: The first partial match (from left) with the column's name will be used, so to match the column "Modified" you could use either "m", "Mod", or "modified", for example.
order Defines the order:
[empty]: [Default] Uses the default order for that column.
a: Ascending.
d: Descending.
clk: This is the same behavior as when you click on a column: reverses the order if the sort was already made on that column, otherwise uses the default order.
secondary_sort
0: primary sort
1: secondary sort

Usage

Simply define which column, and optionally which order to use, call the command and the List gets sorted..

Examples

Sort by Name using default order (ascending):

sortby; or sortby n; or sortby name; or sortby Name; or sortby Name, a; or sortby "Name", "a";

Sort by Name descending:

sortby n, d;

Sort by Modified in descending order.

sortby m, d;

Secondary sort by size descending:

sortby "size", "d", 1;

sound

Plays a sound.

Syntax

sound [sound], [loop], [event]

sound file or label; leave empty to stop any sound
loop 0 = don't loop
1 = loop
event 0 = sound is a *.wav file
1 = sound is an event label

Examples

sound "F:\Fun\sounds\ted_stranglehold.wav";

sound <curitem>, 1; //loop the current WAV file

sound; // stop any playing sound

sound "SystemHand", , 1; //system error sound

Notes

Event labels can be found in your registry here:

HKEY_CURRENT_USER\AppEvents\EventLabels\<EVENTLABEL>

status

Show a message in the status bar.

Syntax

status text, [color RRGGBB], [icon=ready|progress|alert|stop]

text: message text.

color: [optional] message color; default = marked text color #1.

icon: [optional] choose among four icons; default = "ready".

Usage

The message may contain any sort of variables.

Examples

status "Done!";

Shows message "Done!" in the status bar.

status "It's <date hh:nn:ss>.";

Shows message "It's 11:19:40." in the status bar (if that's the time).

status "Whoops!", "FF0000", "alert";

Shows message "Whoops!" in red color with alert icon.

step

Enables "Step Mode" for the current execution of scripts.

Syntax

step

Usage

Use the script command step to activate the Step Mode. In Step Mode, you will have the command and its parameters shown, any variables being resolved, and you are prompted whether to continue or cancel. This is highly recommended for debugging scripts.

Use the command unstep to disable Step Mode.

Remarks

(1) You can manually enable Step Mode, available on CKS under the "Miscellaneous" category or as a Toolbar button. When manually enabled, you will be prompted before each command is executed, and commands step and unstep will be ignored.
(2) Note that commands step and unstep only apply to the current script, while option "Step Mode" has a global scope and will apply to all scripts, even scripts called within other scripts.
(3) You can enable prompting on a per-command basis in a much simpler way, by using prefix ? before the command's name. When you want to be asked before one single command gets executed, this syntax is much simpler to use than to use both step and unstep before and after the given command. For example, in the following script you will only be prompted whether or not to execute "command3":
command1; command2; ?command3; command4;

Example

goto "Desktop"; sortby "created", d; sel 1; focus "list"; step; #200;

Goes to the Desktop folder, sorts the list by created date descending, selects the first item, sets focus to list, turns on Step Mode, executes command #200. What is #200? Step mode will tell you before it is executed! (Solution: it's menu Edit | Cut.)

strlen()

Return the length of a string.

Syntax

strlen(string)

Examples

echo strlen("abcdef"); // 6

echo strlen("<curitem>"); // length of current item

strpos()

Return position of first occurrence of a string.

Syntax

strpos(haystack, needle, [start], [matchcase])

haystack [Required] String to search in.
needle [Required] String to search for.
start [Defaults to 0] Allows you to specify which position in haystack to start searching. The position returned is still relative to the beginning of haystack.
Negative start positions are supported to begin searching from the start position leftwards.
matchcase [Defaults to 0] Compare method.
0: A=a
1: A<>a
return Position.

Examples

echo strpos("abcabc", "a"); // 0

echo strpos("abcabc", "d"); // -1 (not found)

echo strpos("abcAbc", "A"); // 0

echo strpos("abcAbc", "A", , 1); // 3

echo strpos("abcAbc", "a", 1); // 3

echo strpos("abcAbc", "a", 10); // -1 (not found)

echo strpos("abcAbc", ""); // -1 (not found)

echo strpos("", "a"); // -1 (not found)

echo strpos("", ""); // -1 (not found)

echo strpos("abcab", "b", 0); // 1

echo strpos("abcab", "b", -1); // 4

echo strpos("abcab", "b", -2); // 1

echo strpos("abcab", "b", -3); // 1

echo strpos("abcab", "b", -4); // 1

echo strpos("abcab", "b", -5); // -1 (not found)

strrepeat()

Repeats a string.

Syntax

strrepeat(string, [count=0])

string string to be repeated
[count] number of repetitions; defaults to 0
return repeated string

Example

echo strrepeat("abc", 2); //abcabc

sub

This command allows you to execute another script (subroutine) within the current script resource (file or script).

Syntax

sub label

label

[Required] The label of the script to execute.

Usage

While you can always execute any script within any file by using the command load with a label, the command sub allows you to execute scripts from within the same file in an easier way, as you don't need to specify the file name again.

Simply put the label of the script to execute. Once its execution is over, the current script will continue.

If a script, called using load or sub, has its execution aborted (user cancellation, error, etc) then any calling scripts will have their execution aborted as well.

Example

The following is inside a script file "date.xys" (located in app data path).

"Show date : date"
msg "<date yyyy-mm-dd>";
"Show time : time"
msg "<date hh:nn:ss>";
"Show Date && Time : datetime"
sub "date";
sub "time";

If you now execute the script load "date.xys", "datetime" then you will first see a message box showing the date, and then a message box showing the time.

substr()

Return part of a string.

Syntax

substr(string, [start], [length])

string [Required] Input string.
start Start of returned part; defaults to 0, first position is 0. If start is negative, the returned string will start at the start'th character from the end of string.
length Length of returned part (number of characters). If missing then the whole string is returned (beginning from start). If length is negative, then that many characters will be omitted from the end of string (after the start position has been calculated when start is negative). If start denotes a position beyond this truncation, an empty string will be returned.
return Part of the string.

Examples

echo substr("abcdef", 0, 3); // "abc"

echo substr("abcdef", 1); // "bcdef"

echo substr("abcdef", 1, 1); // "b"

echo substr("abcdef", -1); // "f"

echo substr("abcdef", -2); // "ef"

echo substr("abcdef", -3, 1); // "d"

echo substr("abcdef", 0, -1); // "abcde"

echo substr("abcdef", 2, -1); // "cde"

echo substr("abcdef", 4, -4); // ""

echo substr("abcdef", -3, -1); // "de"

swapnames

Swaps the names of the two selected List items.

Syntax

swapnames

Usage

Simply call it and it swaps the names of the two selected List items.

In order to work, there must be exactly two items selected on List, no more, no less, otherwise an error message will be displayed.

Note that the identical command is available on menu File | Swap Names.

sync()

Modify the selection in one pane based on items in the other pane.

Syntax

sync([command], [justcalc], [ignoreextensions], [mode], [inactivepane])

command The sync command to be executed; there are currently five available commands (case-insensitive, A=a):
SelectMatches: [Default] Select all items that are also listed in the other pane.
SelectUniques: Select all items that are only listed in this pane.
SelectNewer: Select all matches with a more recent modified date.
SelectUniquesAndNewer: Select all items that are unique or newer.
SelectSelected: Select all items that are selected in the other pane.

justcalc
0: [Default] Select the items in the active pane.
1: Do not select anything but only return what would have been selected.

ignoreextensions
0: [Default] Mind extensions when matching the names.
1: Ignore extensions.

mode
n: [Default] New selection (drop current selections).
a: Add the matches to any current selections.
r: Remove the matches from any current selections.

inactivepane
0: [Default] Select items on active pane based on items on inactive pane.
1: Select items on inactive pane based on items on active pane.

return Pipe(|)-separated list of selected item names.

Remark

This command corresponds to the Select Items dialog in menu Panes. It uses the identical routines. With SC sync you gain access to these routines via User-Defined Commands and Custom Toolbar Buttons.

FYI, this command is called "sync" because in a future version, actual synchronizing commands will be added.

Examples

sync(); //select matches on the active pane

sync( , , , , 1); //select matches on the inactive pane

sync("SelectNewer"); //select newer matches on the active pane

text sync("selectuniques", 1); //show uniques in text box

tab()

Retrieve tab information, modify a tab, or open a new tab.

Syntax

tab([operation], [data], [index])

operation operation, identified by name

"close" = close tab

data:

0 = [default] no prompts

1 = prompt if the tab is a default, locked, or home zone tab

index: index of the tab to close (leftmost tab = 1); defaults to the current tab

return: index of the new current tab

"closeothers" = close all other tabs

data:

0 = [default] no prompts

1 = prompt if there are default, locked, or home zone tabs

index: unused

return: index of the current tab before the others were closed

"get" = [default] return a value depending on data (first tab = 1)

data:

[empty or missing] the index of the current tab (first tab = 1).

"c", "count": tab count.

"caption": caption of a tab (as displayed)
"name": name of a tab (as set by rename)
"data": (unresolved) data, e.g. %temp%
"path": (resolved) path of a tab
"term": the path including any Visual Filter or Name Search (same as menu View | Tab | Copy Location Term).
"flags": returns various tab properties in a bit field (values combined by OR, which here is equivalent to being added).
1 = Locked Location
2 = Locked Home Zone
4 = Iconized

index: unused

return: value depending on data

"filter" = apply a Visual Filter to a tab

data: the filter pattern (if empty then any filter is removed)

index: tab to filter from (if missing then current tab)

return: index of the affected tab

"new" = create new foreground tab

data: location (if empty then current tab is cloned); also Name Searches and Visual Filters are supported, e.g.:
Tab("new", "%computer%?tags:*");
Tab("new", "%desktop%|x*");

index: tab to clone from (if missing then current tab)

return: index of the newly created tab

"newb" = new background tab

data: location (if empty then current tab is cloned)

index: tab to clone from (if missing then current tab)

return: index of the newly created tab

"relocate" = relocate a tab (make it point to a new location)

data: new location

index: tab to relocate (if missing then current tab)

return: index of the affected tab

"rename" = rename a tab

data: new name (if empty then any name is removed)

index: tab to rename (if missing then current tab)

return: index of the affected tab

"sethome" = sets a Home path to a tab

data: path to set

index: tab to set home to (if missing then current tab)

Note: If you set the home of a non-current tab then all relevant list settings of the *current* tab are used for the home definition of that other tab.

return: index of the affected tab

"iconize" = iconize a tab

data:

[missing] = toggle iconize

0 = de-iconize

1 = iconize

index: tab to iconize (if missing then current tab)

return: index of the affected tab

"lock" = lock a tab

data:

[missing] = toggle lock

0 = unlock

1 = lock

index: tab to lock (if missing then current tab)

return: index of the affected tab

"lockhomezone" = lock the home zone of a tab

data:

[missing] = toggle lock

0 = unlock

1 = lock

index: tab to lock (if missing then current tab)

return: index of the affected tab

Note: If a tab has no home you get an error message.

Notes

If index is negative then position is calculated from the right end (-1 points to the right-most tab). If index is invalid then the current tab's index is used. The function only affects tabs on the active pane.

Examples

text tab(); //ret index of current tab (first tab = 1)

text tab(, "c"); //ret tab count

text tab("get", "caption"); //caption of a tab (as displayed)

text tab("get", "name"); //name of a tab (as set by rename)

text tab("get", "path"); //(resolved) path of a tab

text tab("get", "data"); //(unresolved) data, e.g. %temp%

tab("close"); //close current tab (no prompts)

tab("close", 1); //close current tab (prompts)

tab("close", , 2); //close second tab (no prompts)

tab("close", 1, 2); //close second tab (prompts)

tab("filter", "*.txt"); //apply filter "*.txt" to current tab

tab("filter"); //remove any filter from current tab

text tab("new"); //clones the current tab; ret index of new tab

tab("new", "C:\"); //new foreground tab at "C:\"; as above

tab("newb", "D:\"); //new background tab at "D:\"; as above

tab("rename", "Godzilla"); //name the current tab "Godzilla"

tab("rename"); //remove any name from the current tab

tab("iconize", 1); //iconizes the current tab

tab("iconize"); //de-iconizes the current tab

tab("iconize", 1, 1); //iconizes the first tab

tab("iconize", 1, -1); //iconizes the last tab

tab("lock"); //lock toggle current tab

tab("lock", , 0); //lock toggle current tab

tab("lock", , 1); //lock toggle first tab

tab("lock", , -1); //lock toggle last tab

tab("sethome", '%temp%'); //set home %temp% to current tab

tab("sethome"); //remove any home from current tab

tab("sethome", '%temp%', 6); //set home %temp% to tab 6

tab("relocate", '%tmp%');// relocate current tab to %tmp%

tabset()

Opens, saves, or renames a tabset.

Syntax

tabset([operation=open], [name], [pane=a])

operation Operation, identified by name.
"browse" Open/Load a stored tabset by browsing the file system.

name: Folder to start browsing in (defaults to <xydata>\Panes).

"new" Start a virgin tabset.
"open" [default] Open/Load a stored tabset from the complete list of available tabsets.
name: Folder to look in (defaults to <xydata>\Panes).
"load" Open/Load a stored tabset by name.
name: Name or full path of the tabset to load.
If name is missing the default tabset is opened.
"rename" Rename the current tabset.
If name is missing the name is prompted for.
"revert" Revert the current tabset to its saved state.
"save" Save the current tabset.
"saveas" Save the current tabset under a new name.
name: New name or full path.
"savecopyas" Save a copy of the current tabset under a new name.
name: New name or full path.
name (if not otherwise noted above)
Name of the tabset (folder relative to <xydata>\Panes) or full path.
If name is missing it is prompted for.
pane The affected pane; defaults to the current pane.
a active [default]
i inactive
1 1st pane
2 2nd pane
return The full path to the current tabset.

Examples

Open tabsets listing in order to select one:

tabset();

Load the active pane's default tabset:

tabset("load");

Load "Bat" into the active pane:

tabset("load", "Bat");

Start a new tabset named "Sue":

tabset("new", "Sue");

Rename back pane tabset to "Jack":

tabset("rename", "Jack", "i");

Load tabset via absolute network path:

tabset("load", "\\Cooper\Shared\blah\");

Cloning Tabsets

The operations browse, load, and open support cloning, i.e. opening a tabset under a new name. This is achieved by using the "as:"-syntax: Original source name and clone name are separated by " as: ", e.g. "work_1 as: clone1" to open tabset "work1" under the name "clone1". Working with clones instead of originals protects your sources and offers you a "revert to saved" functionality simply by repeating the command that loaded the clone before. The main window offers the same functionality in menu Tabsets | Open As...

Examples for "load":

Open tabset "work_1" as "clone1":

tabset("load", "work_1 as: clone1");

Open current tabset as "clone1":

tabset("load", " as: clone1");

Open tabset "work_1" as clone (prompt for name of clone):

tabset("load", "work_1 as: ");

Open current tabset as clone (prompt for name of clone):

tabset("load", " as: ");

Examples for "open":

Select a tabset in E:\Tabsets and open as "clone1":

tabset("open", "E:\Tabsets as: clone1");

Select a tabset from the default tabsets folder and open as "clone1":

tabset("open", " as: clone1");

Select a tabset from the default tabsets folder and open as clone (prompt for name of clone):

tabset("open", " as: ");

tag

Tag item(s).

Syntax

tag [value], [itemlist], [type=0], [tagsmode=0]

value Tag value, which (depending on type) can be label name or ID, tag(s), or comment, or Extra Tag.
If missing or 0: remove any tag of that type.
itemlist |-separated list of items (full path) to tag;
if empty then current list selections are tagged
type 0=Label [Default]
1=Tags
2=Comment
3, ex1 = Extra 1
4, ex1 = Extra 2
5, ex1 = Extra 3
6, ex1 = Extra 4
7, ex1 = Extra 5
tagsmode [only applicable if type=1 (Tags)]
0=Add [Default]
1=Set (Replace any existing tags with the new tags)
2=Remove

Examples

tag "Green"; //set label "Green" to all selected items

tag 3; //set label #3 to all selected items

tag 3, <curitem>; //set label #3 to current item

tag 0, <curitem>; //remove any label from current item

tag 3, "C:\foo.txt|D:\bar.txt"; //set label #3 to these items

tag; //remove all labels from all selected items

tag "cats,dogs", , 1; //add tags "cats" and "dogs" to all selected items

tag "cats,dogs", , 1, 1; //set tags "cats" and "dogs" to all selected items

tag "cats,dogs", , 1, 2; //remove tags "cats" and "dogs" from all selected items

tag , , 1, 2; //remove all tags from all selected items

tag "wow", , 2; //set comment "wow" to all selected items

tag , , 2; //remove all comments from all selected items

tag "wow", , ex3; // set "wow" to Extra Tag 3 of all selected items

Multi-line comments

You can as well define multi-line comments. The CRLF (carriage return line feed) sequence is internally stored as pilcrow character (¶). Also in the file list's Comment column, which has only a single line per item, pilcrows are used for CRLFs.

These script lines create identical 2-line comments:

tag "multi-line<crlf>comment.", , 2;

tag "multi-line¶comment.", , 2;

taglist()

Sets a new tag list, or modifies the current one.

Syntax

taglist([tags], [flags=0])

tags Comma-separated list of tags.
Empty: keep current.
flags 0: Replace current tag list.
1: Add to current tag list.
2: Remove from current tag list.
return The current (old) tag list.

Examples

text taglist(); // displays the current tag list

taglist("may,june,july"); // defines a new tag list

taglist("may,june,july", 1); // adds to current tag list

taglist("may,june,july", 2); // removes from current tag list

Usage

Using taglist() you can easily switch tag lists and make tagging new files a snap.

Remarks

The "Tag List" is your tag cloud. It is there to let you select tags rather than type them again and again.

In the Edit Tags dialog there is a checkbox "Add new tag(s) to tag list" which auto-maintains your tag cloud. New tags are always added to the top of the list.

You can also manually manage the Tag List in List Management. This way you can easily load a new cloud to have a different set of tags ready for selection.

Note that editing the Tag List does not change or remove any tags from your files or folders! The Tag List is only your interface to selecting/attaching tags.

text

Shows a multi-line textbox, allowing to select and copy text to the clipboard.

Syntax

text text, [width=600], [height=400], [caption], [wrap], [linebreaker="<br>"]

text The text to be shown in the window.
width Width of window in pixels (minimum: 250; maximum: screen width; default: 600).
height Height of window in pixels (minimum: 150; maximum: screen height; default: 400).
caption Caption on window's title bar.
wrap [optional]
w wordwrap (show text wrapped)
linebreaker [optional] Any character sequence to be replaced by a line break. Defaults to "<br>". Pass "" to prevent any replacing.

Usage

Simply call the command with whatever text you want to show. You can of course use any variables in your text, as well as put your text over multiple lines, using the line breaker <br> which will be converted to a CRLF (0D0A).

You can change the line breaker (<br>) by using command br first.

Example

text "XYplorer is running from <xypath><br>The application data are stored in <xydata>", 550, 150, "XYplorer Locations";

Shows a small text-window with the application's folder (path to running XYplorer.exe) and the application's data folder (where all settings are stored).

timestamp

Change any of the three file dates.

Syntax

timestamp [type], [date], [itemlist]

type [optional] c|m|a or any combinations in any order (cm, am, cma, ac...); defaults to cma
date [optional] must be in a format that the local system can understand;
missing: defaults to Now;
empty (""): do not change date at all.

Note that you pass a date variable in single quotes. It will be resolved per file. See examples below.

itemlist [optional] |-separated list of items (full path) to timestamp; if empty then the current list selections are timestamped

Examples

timestamp

Set all 3 dates of all selected List items to Now.

timestamp , "2008-12-31"

Set all 3 dates of all selected List items to 2008-12-31 00:00:00.

timestamp m, "<date yyyy-mm-dd> 12:00:00"

Set modified date of all selected List items to today, 12:00:00.

timestamp mc, "<date yyyy-mm-dd> 12:00:00", "C:\Test.txt|C:\Test2.txt"

Set modified and created date of C:\Test.txt and C:\Test2.txt to today, 12:00:00.

Passing a date variable in single quotes

When you pass a date variable in single quotes (so that it is not evaluated before it is passed to the timestamp function) the variable is evaluated per-file. See the difference:

Set modified and created date of all selected files to the EXIF date of the current file:

timestamp mc, "<dateexif>";

Set modified and created date of all selected files to the EXIF date of each of those files:

timestamp mc, '<dateexif>';

UTC Support (Universal Time Stamp)

By appending "Z" (or "z") you can mark the time expression as UTC (Coordinated Universal Time). This way you can modify the UTC date of a file directly (as it is internally used by NTFS). For example, this will set the modified date to UTC 12:00 today (displayed as 14:00 in Germany with Daylight Saving Time in effect):

timestamp "m", "<date yyyy-mm-dd> 12:00Z";

That way you can guarantee the same universal timestamp regardless of any DST (Daylight Saving Time) offset in effect. Very nice for software developers with a global market.

The ISO 8601 formats for UTC and time offsets from UTC are supported. The following time expressions all refer to the same point in time:

2013-05-14 10:00:00+02:00

2013-05-14 08:00:00+00:00

2013-05-14 08:00:00Z

2013-05-14 03:00:00-05

2013-05-13 23:00:00-0900

2013-05-13 20:00:00-12:00

toolbar()

Customizes the toolbar.

Syntax

toolbar([buttons], [large])

buttons [optional] comma-separated list of button keys.
missing: keep current toolbar
empty (""): reset toolbar to factory default buttons
large [optional]
0: small
1: large
missing: keep current setting
return the current (old) toolbar

Examples

Displays the current toolbar button keys:

text toolbar();

Defines a mini toolbar:

toolbar("back,fore,up,refresh,-,exitnosave");

Resets toolbar to factory default, and makes it small:

toolbar("", 0);

Remarks

With a little simple scripting you can now write your own Toolbar Manager and have as many different custom toolbars as you like, selectable e.g. from a popup menu.

trim()

Strips spaces (or other characters) from the beginning and/or end of a string.

Syntax

trim(string, [charlist=" "], [mode="LR"])

string String to trim.
charlist One or more characters to be stripped:
single, e.g. "X"
groups, e.g. "xyab"
ranges, e.g. "a-m", "3-6"
wildcards, e.g. "#" (digits)
The default is " " (space).
mode Where to trim:
L: left
R: right
LR: both (default)
(not case-sensitive, "l" and "r" work as well)
return Trimmed string.

Note

It is not possible to combine the closing bracket "]" with other characters in a group or range. As a single character it works.

Examples

text trim(" d "); //"d"

text trim(" d ", , "L"); //"d "

text trim(" d ", , "R"); //" d"

text trim(" d ", , "rl"); //"d"

text trim("aadaa", "a"); //"d"

text trim("abdab", "cba"); //"d"

text trim("123ab2ac654", "#"); //ab2ac

text trim("123ab2ac654", "3-5"); //123ab2ac6

text trim("]]123654]]", "]"); //123654

unset

Unsets an existing variable.

Syntax

unset variable(s)

variable The name of the variable(s) to unset.

Usage

Simply put the name of the variable you want to unset, and it will be unset, or destroyed. This is not the same as setting its value to nothing. For example:

$a = "A"; msg "a=$a"; //a=A

$a = ""; msg "a=$a" //a=

unset $a; msg "a=$a" //a=$a

Supports up to 11 variables in one statement, separated by commas:

unset $a, $b, $c, $d, $e, $f, $g, $h, $i, $j, $k;

unstep

Disables Step Mode for the current execution of scripts.

Syntax

unstep

Usage

See step.

urldecode()

Decodes URL-encoded string.

Syntax

urldecode(string, raw=0)

string String to decode (max length is 2083 characters).

raw

0: URL-decode according to RFC 3986;
will convert "+" to " " (space)
1: URL-decode according to RFC 1738;
will NOT convert "+" to " " (space)

Note that "%20" is always converted to " " (space) with either setting.

Examples

echo urldecode("%E4%20%F6%20%FC"); //ä ö ü

echo urldecode("%E4%20%F6%20%FC, 1"); //ä ö ü !

echo urldecode("%E4+%F6+%FC"); //ä ö ü

echo urldecode("%E4+%F6+%FC", 1); //ä+ö+ü !!!

urlencode()

URL-encodes string.

Syntax

urlencode(string, raw=0)

string String to encode (max length is 2083 characters).

raw

0: URL-encode according to RFC 3986;
will convert " " (space) to "+"
1: URL-encode according to RFC 1738;
will NOT convert " " (space) to "+" (but to "%20")

Remarks

It also encodes the percent character (% = %25).

Examples

echo urlencode("ä ö ü"); //%E4+%F6+%FC

echo urlencode("ä ö ü", 1); //%E4%20%F6%20%FC

utf8decode()

Decodes UTF-8 encoded string.

Syntax

utf8decode(string)

Example

echo(utf8decode("KÃ¶ln")); //Köln

utf8encode()

Encodes a string to UTF-8.

Syntax

utf8encode(string)

Example

echo(utf8encode("Köln")); //KÃ¶ln

wipe

Wipes the specified items.

Syntax

wipe [itemlist]

itemlist |-separated list of items (full path) to delete. The | (pipe) respectively the items may be surrounded by any number of blanks.
Defaults to the selected items in list.

Notes

· The Wipe operation is identical to the one in menu File | File Special | Wipe. The main advantage with SC wipe is that you can pass the items to wipe as an argument.
· For safety reasons there is no way to turn off the warning prompt before the operation starts.
· Just as a reminder: You can also wipe whole folders. All files found within are individually wiped. Then the folders are removed.

Examples

wipe; // wipe all selected items in the file list

wipe "E:\Test\1.txt|E:\Test\2.txt"; // wipe two particular files

writefile()

Writes data to a file.

Syntax

writefile(filename, data, [on_exist], [mode])

filename Full path/name, or relative to the current path. Will be created if does not exist yet. Also the path of the file to be written is auto-created if necessary.
data String data to write.

on_exist
o: [default] create new file/if existing: overwrite
a: create new file/if existing: append
n: create new file/if existing: do nothing
r: create new file/if existing: rename by appending the default suffix as defined in Configuration | Templates | Incremental Affix.

mode
t: [default] text; auto-detects whether text can be written as ASCII or needs to be written as UNICODE
ta: text ASCII (1 byte per char); wide chars (upper Unicode) are represented by "?"
tu: text UNICODE (2 bytes per char); with LE BOM at file beginning LE BOM = Little Endian Byte Order Mark: 0xFFFE
b: binary: raw bytes; each byte is internally stored as double-byte character with a zero big byte; corresponds to mode "b" in ReadFile()

return The following values or OR-ed bitwise:
0 = failed
1 = data written
2 = file existed
4|filename = file was renamed | new filename (only if on_exist is r)

Success codes depending on "on_exist" argument:
"n" AND file existed > 2
"a"/"o" AND file existed > 3
"a"/"o"/"n" AND file created > 1

Usage

WriteFile() is implemented as a function (instead of a statement) because the return value can be useful. You may, however, call functions without using a dummy variable. See examples below.

Examples

writefile("test_A.txt", "text");

Creates a 4 byte file in current folder.

writefile("test_U.txt", "text ".chr(20000));

Creates a 14 byte file (2 bytes BOM + 2 * 6) in current folder.

writefile("test_TA.txt", "text ".chr(20000), , "ta");

Creates a 6 byte file in current folder.

writefile("test-TU.txt", "text ".chr(20000), , "tu");

Creates a 14 byte file (2 bytes BOM + 2 * 6) in current folder.

writefile("test-B.txt", "text ".chr(20000), , "b");

Creates a 6 byte file in current folder.

Example with on_exist = "r"

For example, if "a.txt" exists in the current folder, a new file "a-01.txt" is created if the Incremental Affix is "-01":

text writefile("a.txt", "ab", "r");

The text window will shown a return like this including the full filename. The "5" (1 OR 4) means "data written" and "file was renamed": 5|E:\Test\a\K\a-01.txt

writepv

Writes all permanent variables (PVs) to a file.

Syntax

writepv [file]

file The file to write to. Can be relative to the current path.
If empty it defaults to "<xydata>\pv.dat".

Examples

writepv; //write to "<xydata>\pv.dat"

Remarks

See readpv for reading files written with writepv.

zip_add()

Adds items to a Zip archive.

Syntax

zip_add(zipfile, itemlist, [separator="|"])

zipfile Path/name of Zip archive.
Can be relative to current path.
If empty the name is prompted.
itemlist List of items to add.
If empty defaults to the selected items.
separator Separator of items in itemlist.
return Full path/name of Zip archive.

Examples

Add selected items to zip (name is prompted):

text zip_add();

Add selected items to "test.zip" (in current path):

text zip_add("test.zip");

Add selected items to "E:\test.zip":

text zip_add("E:\test.zip");

Add "E:\a.png" and "E:\b.png" to "E:\test.zip":

text zip_add("E:\test.zip", "E:\a.png|E:\b.png");

zip_extract()

Extracts items from a Zip archive.

Syntax

zip_extract(zipfile, path, [itemlist], [separator="|"])

zipfile Path/name of Zip archive.
Can be relative to current path.
If empty the current file is used.
path Target path.
If empty the path is auto-named from the first selected item.
If missing the current path is used (= Extract to Here).
itemlist List of items to extract.
Paths are to be given relative to the Zip.
If empty all items are extracted.
separator Separator of items in itemlist.
return Target path.

Examples

Extract the selected Zip archive to an auto-named folder in the current path:

text zip_extract();

Extract to "test\" (in current path):

text zip_extract("test.zip")

Extract to "new\" (in current path):

text zip_extract("test.zip", "new");

Extract to "E:\new\":

text zip_extract("test.zip", "E:\new\");

Extract "test.zip" (current path) to here:

text zip_extract("test.zip", "");

Extract "E:\test.zip" to here:

text zip_extract("E:\test.zip", "");

Examples for extracting particular items from an archive

Note that XP behaves differently from Vista and followers when items in subfolders are copied:

· XP: Source subfolders are auto-created in the target folder before items are copied (like XY's "Rich Copy").
· Vista and later: Items are all copied flat to the target path (with possible collisions).

Extract "XYplorer.exe" from "E:\Test\ZipTest\xyplorer_12.50_beta_noinstall.zip" to "D:\XY\":

text zip_extract("E:\Test\ZipTest\xyplorer_12.50_beta_noinstall.zip", "D:\XY\", "XYplorer.exe");

Extract Test\a\b.png from deep.zip in the current path. XP: target folder "Test\a\" will be created if necessary:

text zip_extract("deep.zip", "", "Test\a\b.png");

Extract two same-named files from one archive. No problem under XP; under Vista you get a collision prompt:

text zip_extract("deep.zip", "", "test\a\a.png|test\b\a.png");

Offer to extract items from the currently selected zip file:

zip_extract (, "", inputselect("Check Items to extract to current folder", replace(zip_list(, "|", 0), "<tab>", ""), "|", 11,,,, "<curitem>"), "|");

zip_list()

Lists the items in a Zip archive.

Syntax

zip_list(zipfile, [separator="|"], flags)

zipfile Path/name of Zip archive.
Can be relative to current path.
If empty the current file is used.
separator Separator of items returned.
flags 0 = List names only.
1 = List basic properties as well (size and modified date).
return Items in Zip.

Notes

The items are listed sorted by path/name.

Items in a subfolder are listed with the relative path.

The column order is: path, name, size, modified.

Examples

List items in the selected archive:

text zip_list(, <crlf>);

List items in "E:\test.zip, with properties.":

text zip_list("E:\test.zip", <crlf>, 1);


Variables

XYplorer Native Variables

Here's a list of the built-in variables that can be used in User-Defined Commands and Scripting. Note that all of these variables are read-only, i.e. you cannot deliberately alter their values.

<curpath> real current path (unslashed)

e.g. C:\Dokumente und Einstellungen\Donald\Desktop

C:\Dokumente und Einstellungen\Donald\Desktop\New Stuff

C:

<curpath_s> special current path (if applicable, else = <curpath>)

e.g. Desktop

Desktop\New Stuff

C:

<curpath_dos> current path in DOS format (8.3)

<curtab> location term of the current tab, e.g. %USERPROFILE%

<curfolder> name of the current folder (without path)

<curitem> current (selected & focused) list item (full path)

<curitemprev> previous current (selected & focused) list item (full path)

<curitem_dos> current item in DOS format (8.3)

<curitempath> current (selected & focused) list item's full path

<curbase> base-name of the current list item

<curext> extension of the current list item

<curname> name (base.ext) of the current list item

<cursize> file size in bytes of the current list item

<curver> version of the current list item

<curlen> length in characters of the current list item

<focitem> focused item in tree (if tree has focus) or list (else);

note that, contrary to <curitem>, <focitem> will also

return the focused item if it is not selected

<selitems> space-separated list of the currently selected list items in quotes

<datem yyyymmdd_hhnnss> modified date/time of the current list item

<date yyyymmdd_hhnnss> date/time now

... see below for more on date variables!

<xy> XYplorer executable path and name

<xyexe> XYplorer executable name

<xypath> XYplorer application path

<xydata> XYplorer data path

<xycatalogs> XYplorer catalogs path

<xythumbs> XYplorer thumbnails cache path

<xyicons> XYplorer icons path

<xypane> XYplorer active pane data path

<xypane1> Pane 1 data path

<xypane2> Pane 2 data path

<xytagdat> XYplorer tags database path/file

<xynewitems> XYplorer new items path

<xyscripts> XYplorer scripts path

<xyini> current XYplorer INI file (without path)

<xydrive> XYplorer drive (unslashed), e.g. C: or \\Server\Share

<xyver> XYplorer version

Scripting only

<clipboard> current clipboard contents

<drop> a synonym for <get drop>

<taggeditem> resolves to the item (full path) that is being tagged via clicking a column cell

<taggedcolumn> resolves to the column caption that is being tagged via clicking a column cell

<hwnd> the handle of the main application window

Scripting with Portable File Associations only

<pfaitem> the item (full path) the opening application or script in a Portable File

Association is associated with

Constants

<crlf> Carriage Return Line Feed (0x0D0A)

<tab> Tab character (0x09)

Note that both <crlf> and <tab> take an optional count parameter for repetition. Example:

::echo "Catch<crlf 22>22";

UDC Open With only

<items> space-separated list of the currently selected list items in quotes

<item1> <item2> the first two of all selected items

<base> base (= base name only, no path and no extension) of currently processed item

(only meaningful when calling multiple instances)

You can use it like this:

"winzip32" -e <items> "<base>"

This will extract all currently selected archives, each into a

folder auto-named to the base-name of the respective archive.

<title> title (= base and extension) of currently processed item

(only meaningful when calling multiple instances)

You can use it like this:

"winzip32" -a "<title>.zip" <items>

This will add all currently selected items, each to an archive

auto-named to the title of the respective item.

Date Variables

Without any format argument, the format used will be the general system date format:

<date> current date

<datem> modified date of the current list item

<datec> created date of the current list item

<datea> accessed date of the current list item

<dateexif> EXIF date of the current list item

Use a format argument to specify a user-defined format:

<date yyyy>

<datem yyyy-mm-dd>

<datec yyyy-mm-dd hh:nn:ss>

<datea yymmdd_hh_nn_ss>

Use argument "List" to apply the current file list date format:

<date List>, <datem List> ...

Date shifting: Pass an optional extra argument to shift the date to the past or the future by a certain number of time units. Supported units are y = years, m = months, w = weeks, d = days, h = hours, n = minutes, s = seconds:

<datem +8h yyyymmdd_hhnnss>

<datec -8d yyyymmdd>

Special arguments:

<date Zodiac> will resolve to "Gemini".

<date ISOWeek> will resolve to "2008-W25-5".

Variable <curver>

You can add a textual context to <curver> that only will be returned when an actual file version is present. This allows for better formatting control. The general syntax is <curver|text*text>, where * is the place holder for the actual version number. If you omit * then text is by default prefixed to the version info proper.

Examples, each resolved for two items, one with version info, and one without version info:

(1) <curname><curver|, v*>

XYplorer.exe, v7.20.0009

History.txt

(2) <curname><curver| [ver ]>

XYplorer.exe [ver 7.20.0009]

History.txt

(3) <curname><curver>

XYplorer.exe7.20.0009

History.txt

Variable <get ...>

The native variable <get ...> corresponds to the scripting function get().

Syntax:

<get info [param1]>

Example:

::text "<get specialfolder 9>"; //returns sendto folder

Quoted Parameters:

Note that <get ...> supports quoted parameters in some contexts. It allows you to pass parameters containing spaces (because the space characters also serves to separate the parameters in this context). The parameters themselves are unquoted after parsing. For example, this returns "Dual Pane" when Dual Pane is enabled, and "Single Pane" when it's not:

::text <get #800 "Dual Pane" "Single Pane">;

You can even pass embedded quotes by doubling them:

::text <get #800 """Dual Pane""" "Single Pane">;

Variable <prop ...>

The native variable <prop ...> corresponds to the scripting function property(). It returns any available Shell Property value of the current item. See property() for details and caveats.

Syntax:

<prop property_index_or_name>

Examples from scripting:

Retrieve Size, Type, and Version of the current item (under XP):

::msg "<prop #1>, <prop #2>, <prop fileversion>";

Suffix " n" to the property index return the (locale aware) name of the property:

::msg "<prop #1 n>, <prop #2 n>, <prop fileversion>";

Append the file version to the name:

::rename b, '*-<prop fileversion>', p;

Append width and height to the name (images only; some videos work as well):

::rename b, '*-<prop ImageX>x<prop ImageY>', p;

Append camera model to the name (photos only, of course):

::rename b, '*-<prop CameraModel>', p;

To have the CameraModel of the current file on the status bar, use this tweak:

::StatusBar3OnFile="<curname>, Camera: <prop CameraModel>"

Tip1: Note that this variable is also supported by Rename Special (regular UI, not only via scripting).

Tip 2: Also supported are XYplorer-specific named properties like #JunctionTarget, #Tags, or #Comment. See property() for details.

Environment Variables

These are the valid environment variables in XYplorer:

Common Windows Environment Variables

(1) Referring to paths:

%allusersprofile%

%appdata%

%commonprogramfiles%

%programfiles%

%systemdrive%

%systemroot%

%temp%

%tmp%

%userprofile%

%windir%

(2) Other:

%CLIENTNAME%

%COMPUTERNAME%

%FP_NO_HOST_CHECK%

%HOMEPATH%

%NUMBER_OF_PROCESSORS%

%OS%

%PATHEXT%

%PROCESSOR_ARCHITECTURE%

%PROCESSOR_IDENTIFIER%

%PROCESSOR_LEVEL%

%PROCESSOR_REVISION%

%SESSIONNAME%

%USERDOMAIN%

%USERNAME%

XYplorer only:

%computer% "Computer" special folder (= drives listing)
%desktop% "Desktop" special folder
%net% "My Network Places" special folder
%recycler% "Recycle Bin" special folder
%personal% "My Documents" special folder
%desktopreal% "Desktop" real path (this user)
%personalreal% "My Documents" real path
%winsysdir% Windows system directory
%winsysnative% "System32" path on 32-bit Windows, "SysNative" path on 64-bit Windows
%commonappdata% All Users application data folder
%commondesktop% All Users desktop folder
%winver% Current Windows version number (e.g. 5.1)
%osbitness% OS bitness (e.g. 64 on a 64-bit Windows)

Note that case is ignored: %desktop% = %DESKTOP%.

Note that all paths are returned without backslash.


Tweaks

What's a Tweak?

A "tweak" is a manual change in XYplorer's INI file (usually XYplorer.ini). It's easy to do once you have a text editor and an idea how to do it.

To do it right, you have to know that XYplorer reads the INI at startup and writes it at Exit (unless you unticked "Save Settings on Exit"). So, if you open the INI from a running XYplorer, do your manual editing, save and close the INI, and then close and restart XYplorer in order to read the tweaked INI, it might not work because when you closed XYplorer it has probably overwritten the INI with the old values stored in memory! So the trick is to avoid this. Here's how you can it:

Tweaking the INI file from running XYplorer

(1) Menu File | Save Settings (unless you don't care about the current state)

(2) Menu Tools | Open Configuration File... (will open the INI in your default editor)

(3) In the editor: Do your editing (look up the tweak key and edit its value), save the tweaked INI

(4) Menu File | Restart without Saving (this is the important part)

Done. Now XYplorer should have read the tweaked values.

Why tweak the INI?

Because a couple of XYplorer settings don't have a GUI (they are not featured in the Configuration dialog or elsewhere in the interface). Those settings are called "Tweaks". For example:

; Tweak: 'Now' in file dates

TermThisHour=Now

; Tweak: 'Today' in file dates

TermToday=Today

; Tweak: 'Yesterday' in file dates

TermYesterday=Yesterday


How to purchase a license

Registration: Purchasing A License

XYplorer Is Not Freeware

XYplorer is not freeware.* You may evaluate XYplorer for free for a maximum period of 30 days. If you wish to continue using it after 30 days, you have to register and purchase a license.

*A lite version of XYplorer is offered as freeware under the name "XYplorerFree".

The XYplorer License

LICENSE GRANT. As an individual person, you need one license to use XYplorer. This license grants you a non-exclusive and non-transferable right to use XYplorer on any number and kind of devices. As an employer, you need a license for each employee using XYplorer. Floating or concurrent license usage is expressly prohibited.

There are three types of licenses: (1) The "Lifetime License" is valid for all future versions of the Software: You will get all future upgrades for free. (2) The "Standard License" is valid for one full major version cycle of the Software (e.g. v8.30 up to but excluding v9.30). (3) The "Fixed License" is valid only for the specific version it came with; no upgrading is possible.

Volume Discount Prices

There are volume discount prices, site licenses, and corporate licenses. See http://www.xyplorer.com for further details and prices.


Contact

Contact and Web Site

Support contact

Address

Donald Lessau
Seyengasse 1a
D-50678 Köln/Cologne, Deutschland/Germany

Email (click this link to open your email client):

support@xyplorer.com

Homepage

Find the latest version and information here. The site is updated frequently.

http://www.xyplorer.com/

User Forum

Feel free to join the XYplorer User Forum:

http://www.xyplorer.com/xyfc/

Check for upgrades once in a while...

Due to lots of user feedback, XYplorer is developing at a rapid step. If you are a registered user, you might check in once in a while to get your free upgrade (depending on your license).


Disclaimer

DISCLAIMER OF WARRANTY

This program is distributed as is. The author (Donald Lessau) makes no warranty of any kind, expressed or implied, including but not limited to warranties of merchant ability or fitness for a particular purpose, with respect to this software and documentation. In no event shall the author be liable for any damages, including lost profits, lost savings, or any other incidental or consequential damages arising out of the use of or the inability to use this program.

By using the above mentioned program you acknowledge that you have read this disclaimer of warranty, understand it, and agree to be bound by its terms and conditions. You also agree that the limited warranty is the complete and exclusive statement of agreement between the parties and supersede all proposals or prior agreements, oral or written, and any other communications between the parties relating to the subject matter of the limited warranty.

Donald Lessau, Cologne 2014


Copyright

XYplorer

Copyright © 1997-2014 Donald Lessau. All Rights Reserved.

Trademark Information

Products

FlexyFiles™ is trademarked 2010 by Donald Lessau.

XYplorer™ is trademarked 2005 by Donald Lessau.

TrackerV3™ is trademarked 1997 by Donald Lessau.

Windows® is a registered trademark of Microsoft Corporation.

Features

Droppable User Buttons™ is trademarked 2011 by Donald Lessau.

Mini Tree™ and MiniTree™ are trademarked 2008 by Donald Lessau.

Portable Openwith Menu™ is trademarked 2008 by Donald Lessau.

Portable File Associations™ is trademarked 2006 by Donald Lessau.

Details with Thumbnails™ is trademarked 2006 by Donald Lessau.

Mouse Down Blow Up™ is trademarked 2004 by Donald Lessau.

Rich File Operations™, Rich Copy™, and Rich Move™ are trademarked 2000 by Donald Lessau.

All other trademarks mentioned in this help file are the property of their respective owners.


.topic 1001
Extended File Info, example:
Name: XYplorer.exe
DOS name: XYPLORER.EXE
Type: Anwendung
Location: E:\XY\XYplorer\
Size: 1,47 MB (1.536.512 bytes)
Space used: 1,47 MB (1.540.096 bytes), 376 clusters
Created: 26.11.2005 19:17:30
Modified: 18.01.2006 23:10:31
Accessed: 19.01.2006 13:28:14
Attributes: Archive

File version: 4.40.0054
Description: Advanced File System Explorer
Copyright: Copyright © 2000-06 by Donald Lessau
Character Set: Unicode
Comments: Tabbed browsing, extended file find, file system reports, multimedia preview, font preview, file view.
Company Name: www.xyplorer.com
Internal Name: XYplorer
Language: Deutsch (Deutschland)
Original Filename: XYplorer.exe
Product Name: XYplorer
Product Version: 4.40.0054

Type: Application
File version: 4.40.00.54
Prod. version: 4.40.00.54
File flags: (none)
Target OS: 32-bit Windows

.topic 1002
List
That's the right part of the main window where all the files are listed when you browse thru your folders (Browse Mode). It is also where the results of a file find are listed (Find Mode).
.topic 1003
Computer Icon
That's the top node of the Tree.
.topic 1004
Info Panel
That's the lower part of the main window with all those tabs (if you don't see it press F12).
.topic 1005
Folder Contents Report, example:
========================================================================
C:\Programs\XYplorer\
------------------------------------------------------------------------
CatalogDefault.dat                            2.887  30.01.2012 12:00:00
LicenseXY.txt                                 4.033  30.01.2012 12:00:00
ReadmeXY.txt                                  6.304  30.01.2012 12:00:00
Startup.ini                                      34  30.01.2012 12:00:00
TipOfTheDay.htm                              19.063  30.01.2012 12:00:00
Uninstall.exe                                70.874  30.01.2012 11:41:04
XYcopy.exe                                  348.160  30.01.2012 12:00:00
XYplorer Homepage.url                            50  30.01.2012 11:41:04
XYplorer.chm                                640.222  30.01.2012 12:00:00
XYplorer.exe                              4.886.528  30.01.2012 12:00:00
------------------------------------------------------------------------
10 file(s), 0 folder(s)                   5.978.155 bytes
========================================================================

.topic 1006
Folder Contents Report to CSV file, example:
The first line has the column headers. The lines are quite long naturally, for display reasons they are shown wrapped below. Remember that this stuff is made to be read by machines.
Name;DOS Name;Type;Location;Size;Space Used;Clusters;Created;Modified;Accessed;Attributes;File Version;Description;Copyright;Character Set;Comments;Company Name;Internal Name;Language;Legal Trademarks;OLESelfRegister;Original Filename;Product Name;Product Version;Extra Info;Fixed Type;Fixed File Version;Fixed Product Version;Fixed File Flags;Fixed Target OS
License.txt;LICENSE.TXT;Textdatei;C:\Programs\XYplorer\;3423;4096;1;29.11.2005 20:47:52;29.11.2005 20:47:52;19.01.2006 14:03:32;----A---;;;;;;;;;;;;;;;;;;;
Readme.txt;README.TXT;Textdatei;C:\Programs\XYplorer\;5077;8192;2;11.01.2006 21:55:03;11.01.2006 21:55:03;19.01.2006 14:03:37;----A---;;;;;;;;;;;;;;;;;;;
Uninstall.exe;UNINST~1.EXE;Anwendung;C:\Programs\XYplorer\;63125;65536;16;30.11.2005 17:48:58;18.01.2006 23:11:52;19.01.2006 14:03:32;----A---;;;;;;;;;;;;;;;;;;;
XYplorer.cnt;XYPLORER.CNT;Help Contents File;C:\Programs\XYplorer\;437;4096;1;11.01.2006 17:17:36;11.01.2006 17:17:36;19.01.2006 14:03:32;----A---;;;;;;;;;;;;;;;;;;;
XYplorer.exe;XYPLORER.EXE;Anwendung;C:\Programs\XYplorer\;1536512;1540096;376;18.01.2006 23:10:31;18.01.2006 23:10:31;19.01.2006 14:03:37;----A---;4.40.0054;Advanced File System Explorer;Copyright © 2000-06 by Donald Lessau;Unicode;Tabbed browsing, extended file find, file system reports, multimedia preview, font preview, file view.;www.xyplorer.com;XYplorer;Deutsch (Deutschland);;;XYplorer.exe;XYplorer;4.40.0054;;Application;4.40.00.54;4.40.00.54;(none);32-bit Windows
XYplorer.GID;XYPLORER.GID;GID-Datei;C:\Programs\XYplorer\;23131;24576;6;11.01.2006 21:51:23;11.01.2006 21:51:51;11.01.2006 21:51:51;-H--A---;;;;;;;;;;;;;;;;;;;
XYplorer.hlp;XYPLORER.HLP;Hilfedatei;C:\Programs\XYplorer\;113962;114688;28;17.01.2006 10:51:45;17.01.2006 10:51:45;19.01.2006 14:03:33;----A---;;;;;;;;;;;;;;;;;;;
XYplorer.ini;XYPLORER.INI;Konfigurationseinstellungen;C:\Programs\XYplorer\;5213;8192;2;05.01.2006 15:29:43;18.01.2006 23:12:26;18.01.2006 23:12:26;----A---;;;;;;;;;;;;;;;;;;;
XYplorer.url;XYPLORER.URL;Internetverknüpfung;C:\Programs\XYplorer\;49;4096;1;30.11.2005 17:48:58;18.01.2006 23:11:52;19.01.2006 13:48:31;----A---;;;;;;;;;;;;;;;;;;;
XYplorer-clean.ini;XYPLOR~1.INI;Konfigurationseinstellungen;C:\Programs\XYplorer\;5075;8192;2;17.12.2005 11:40:12;17.12.2005 11:41:41;19.01.2006 14:03:33;----A---;;;;;;;;;;;;;;;;;;;

.topic 1007
Folder Contents Report (Tree Structure), example:
E:\XY\XYplorer
··· FindTemplates
··· NewItems
    ··· web project folder structure

.topic 1008
Report List, example:
Path: C:\Programs\XYplorer\

FindTemplates                       Dateiordner                    2006-01-05 15:29:29    2006-01-05 15:29:29
NewItems                            Dateiordner                    2006-01-05 15:29:29    2006-01-05 15:29:29
License.txt         txt       4 KB  Textdatei                      2005-11-29 20:47:52    2005-11-29 20:47:52
Readme.txt          txt       5 KB  Textdatei                      2006-01-11 21:55:03    2006-01-11 21:55:03
Uninstall.exe       exe      62 KB  Anwendung                      2006-01-18 23:11:52    2005-11-30 17:48:58
XYplorer.cnt        cnt       1 KB  Help Contents File             2006-01-11 17:17:36    2006-01-11 17:17:36
XYplorer.exe        exe   1.501 KB  Anwendung                      2006-01-18 23:10:31    2006-01-18 23:10:31
XYplorer.hlp        hlp     112 KB  Hilfedatei                     2006-01-17 10:51:45    2006-01-17 10:51:45
XYplorer.ini        ini       6 KB  Konfigurationseinstellungen    2006-01-18 23:12:26    2006-01-05 15:29:43
XYplorer.url        url       1 KB  Internetverknüpfung            2006-01-18 23:11:52    2005-11-30 17:48:58
XYplorer-clean.ini  ini       5 KB  Konfigurationseinstellungen    2005-12-17 11:41:41    2005-12-17 11:40:12

.topic 1009
Tree
That's the left part of the main window where all the folders are listed.


Bug Reports

 Top

It might be fixed already

If your version of the program is more than a week old, chances are that you're not the first who spotted the bug. Since we usually fix bugs immediately and upload the fixed version to the upgrade section of XYplorer's homepage within a few days, you might check there first. On this homepage you also find a detailed history of changes, additions, and bug fixes.

XYplorer in trouble

If you get a bug, an error message, a crash, or some other suspicious event ... please let us know! To help us locating the problem, give us any information on the problem's context that you think might be relevant, especially:

What's the problem?

What did you do when the problem happened?

Can you reproduce the problem (if you dare)?

Can you reproduce the problem with a copy of XYplorer.exe in a temporary folder?

If you got an error message, what was it saying?

If you run this through the Address Bar <xydata>|xyerrorlog-*.txt, are there any recent error log files? If yes, what is their content?

What exact version of XYplorer are you using?

What operating system are you running?

What's the language of your system?

Is your computer part of a network neighborhood?

Send bug reports by email

support@xyplorer.com


Glossary

 Top

Glossary

Abbreviations

AB Address Bar
AC Access Control
ADP Application Data Path
AL Action Log
BV Branch View
CEA Custom Event Actions (planned)
CKS Custom Keyboard Shortcuts
CTB Custom Toolbar Buttons
DP Dual Pane
DUB Droppable User Buttons
FVS Folder View Settings
IP Info Panel
KS Keyboard Shortcut
MBV Multi Branch View
MDBU Mouse Down Blow Up
MFS Multi Field Search
MT Mini Tree
PFA Portable File Associations
POM Portable Openwith Menu
QS Quick Search
RB Recycle Bin
RFO Rich File Operation
SB Status Bar
SC Scripting Command
SRC Search Results Caching
TB Toolbar
UB User Button
UDC User-Defined Commands
VF Visual Filters
VFO Virtual Folder (planned)

Special Terms

Location term: Every term that is accepted by the Address Bar, e.g. a path, a file, a quick search, a visual filter, a quick script, a dos command, an alias, a spot and jump pattern.

Location port: Any interface that accepts a location term, e.g. Address Bar, Catalog, Favorites, Go To dialog, Scripts.


Further Notes on Installation

 Top

Integrating XYplorer with the Shell

To integrate XYplorer with the Windows shell check the XYplorer in shell context menu (Configuration | Shell Integration) checkbox while XYplorer is running. The new item "XYplorer" will then appear in Explorer's context menu for drives and folders.

To accomplish this, the following keys are added to the Windows registry:

HKEY_CLASSES_ROOT\Folder\Shell\XYplorer

HKEY_CLASSES_ROOT\Folder\Shell\XYplorer\Command

To remove XYplorer from the shell context menu and these keys from the registry simply uncheck the XYplorer in shell context menu checkbox.


Info Panel: Version

 Top

Version Tab

Displays any version information contained in the selected file.

Pretty self-explaining: you know this stuff from the Explorer Properties dialog.

Tip You can copy virtually any information on this tab by double-clicking it. Double-clicking the key copies key and value, double-clicking the value copies just the value.
Note If the version tab is empty, the selected file has no version info. Version information is typically contained in EXE, DLL, DRV, OCX etc. files.

Fixed File Version

Here's some advanced version information that is not revealed to you by Explorer. Explorer only shows you the String File Version info of files. Usually files that contain any version information have each.


Edit Menu

 Top

Edit Menu Commands

Undo

Undo the previous action (if possible). See Undo...

Shortcut: Ctrl+Z

Redo

Redo the previously undone action. See Undo...

Shortcut: Ctrl+Shift+Z

Action Log...

Show the Action Log dialog. See Action Log...

Shortcut: Ctrl+Alt+Z

Recent File Operations...

Pops a menu by which you can apply recent file operations (Copy and Move) to the currently selected files, using the same operation and target path as recently. The menu draws its data from the Action Log and is organized in two sections:

· Section 1: Recent file operations from here, chronologically ordered from youngest to oldest (up to 10).
· Section 2: recent file operations from elsewhere, chronologically ordered from youngest to oldest (up to 10).

Copy and Move operations are mixed, Move is indented for clearer distinction.

Tip: Hold CTRL to go to the selected target path (instead of repeating the file operation).

Note: There is a toolbar button available with the same name and functionality.

Shortcut: Alt+F7

Cut

Cut selected items to clipboard.

Shortcut: Ctrl+X

Copy

Copy selected items to clipboard.

Shortcut: Ctrl+C

Paste

Paste selected items from clipboard.

Shortcut: Ctrl+V

Paste Special (Submenu)

Paste Here to New Subfolder...: Lets you paste any files currently found in the clipboard to a newly created subfolder of the current folder (the one that's displayed in the main title bar).

You are presented an array of 4 possible default names for the new subfolder about to be created. The first three are (can be) defined in the [NewTemplates] INI section. Here's an example:

  [NewTemplates]

  Folder0=\N\e\w \F\o\l\d\e\r   'date/time sensitive, shortcut Ctrl+N

  Folder1=yyyymmdd              'date/time sensitive

  Folder2=yyyy-mm-dd            'date/time sensitive

The fourth is made from the first item to be moved [copied, pasted] into the new subfolder, i.e. the item that was focused in the moment of cutting, copying, dragging. The index of the last selection is remembered between sessions.

Shortcut: Ctrl+Shift+V

Paste Here with Path...: A copy command that offers you smart choices regarding the target location. Makes it very easy to mirror copy individual items from/to deeply nested locations. Same functionality as "Copy/Move Here with Path..." in the Custom Drag and Drop Context Menu.

Paste Here As...: Lets you to paste item(s) in the clipboard under a new name. The functionality, interface, and syntax are analogue to File | Duplicate | Copy Here As... (including advanced syntax with wildcards and variables), only that the source(s) are in the clipboard.

Paste (Move) and Paste (Copy): Paste moving/copying the items currently found in clipboard, independent of the way the files have been send to the clipboard before (cut or copied).

Paste (Backup): Trigger the Backup operation for items on the clipboard with the current folder as target.

Paste As Shortcut(s): Use it to create shortcuts to the file items on clipboard, in the current location. It also works for more than one file at a time.

Paste As Hard Link(s): Creates a new file hard linked to the file currently on the clipboard, in the current location. It also works for more than one file at a time. Notes:

· Hard links can only be created for files, not for folders.
· All hard links to a file must be on the same volume (same drive letter or network share).
· Hard links can only be created on NTFS volumes.
· The maximum number of hard links that can be created is 1023 per file.

Paste As Symbolic Link(s): Creates a symbolic link (aka symlink or soft link) to the item currently on the clipboard, in the current location. It also works for more than one item at a time. Notes:

· This command needs Vista or later!
· You may need administrator rights to create symbolic links.
· Contrary to Paste As Junction(s) this command can be applied also to files (not just folders).
· Symbolic links can point to non existent targets because the operating system does not check to see if the target exists.
· Currently no relative symbolic links are supported. It might come later...
· The targets of Symbolic Links are shown as "Junction Target" in the interface (File Info Tips, List context menu) just like the targets of Junctions proper, in order to keep things a bit tighter.
· Also the Color Filters make no difference between Symbolic Links and Junctions, since all share the FILE_ATTRIBUTE_REPARSE_POINT file attribute.
· And, consequently, when you uncheck "Show Junctions" in Configuration | Tree and List, then also any Symbolic Links are hidden.

Paste As Junction(s): Creates a junction (aka NTFS junction point or directory junction) to the folder currently on the clipboard, in the current location. It also works for more than one folder at a time. Notes:

· The command works only on folders, not on files.
· Windows does not support junctions to directories on remote shares.

Paste Extracted: Lets you extract the Zip on the clipboard to the current folder. Only enabled if exactly one Zip archive is on the clipboard.

Paste Zipped: Lets you paste the items in the clipboard to a newly created zip file. To make it maximally streamlined you are NOT prompted for a name. The zip name defaults to the first item found in the clipboard (auto-suffixed on collision). After completion the new zip file is auto-selected.

Note: This command will never remove the source items, even if they were *cut* to the clipboard. So, "cut" and "copy" make no difference here.

Paste Folder Structure: Use it to paste the folder structure (without any contained files) from folder(s) on clipboard into the current list path. Functionally equivalent to "Create Branch(es) Here" in the drag and drop context menu.

Paste Text Into New File: Creates a new text file filled with the current clipboard contents. The pasted text depends on the actual data format on the clipboard; it is identical to what variable <clipboard> would

return:

Clipboard contents Text

------------------ ----

Text The text

File items One item per line, CRLF ends a line

Else (e.g. images) Nothing

The new file is called something like "Clipboard- 20080302.txt". The "-20080302" part is the date now (format defined in Configuration | Templates under Filename affixes. The file is appended to the

current file list (aka "lazy sort"), and after creation of the file, rename-mode is invoked.

Shortcut: Ctrl+Alt+V

Paste Image Into New [EXT] File: Creates a new image file filled with the image (if any) currently on the clipboard. The standard image format is PNG. But you can change this to JPG, GIF, BMP or TIF using a new INI Tweak:

[General]

ImageFromClipFormat=jpg

Allowed values are: png (default), jpg, gif, bmp, and tif. In the case of JPG you can control the quality by appending a number from 1 (worst) to 100 (best) inclusively, for example:

ImageFromClipFormat=jpg100

or:

ImageFromClipFormat=jpg50

The default value is 85.

Note that the GIF quality is very bad (dithered) and practially unusable. The other formats, however, are of high quality.

This feature requires GDI+.

Shortcut: Ctrl+Shift+Alt+V

Mark Files in Clipboard as 'Cut'/’Copied’: here you can set/change the "drop effect" of the items currently in the clipboard. On paste, "cut" items will be moved, and "copied" items will be copied. Also the current "drop effect" is signaled by a checkmark.

Edit Files in Clipboard...: Allows you to view what's currently sitting in the clipboard and to manually edit it.

Clear Clipboard: Allows you to remove any files (and, en passant, everything else) from the clipboard. Of course, the actual files are not touched by this operation, even if they have been "Cut" to the clipboard.

Move To..., Copy To..., Backup To... (Dialogs)

Finally fast, easy, non-menu keyboard access to these important file operations! While the lists are shared between Move/Copy/Backup, the previous selection is stored per-operation between sessions. In the destination folder list you can Move (Ctrl+Up/Down) and Delete (Del) items. These changes have no effect though when you cancel the dialog.

Move To Shortcut: Shift+F7

Copy To Shortcut: Ctrl+F7

Backup To Shortcut: Ctrl+Shift+F7

Special Tips

Relative paths are allowed

You may state paths relative to the current path. So e.g. you can state a target like "..\sister" to move a file to a folder called "sister" under the same parent as the moved items. And better: if this folder does not exist yet it is created!

Destination paths may contain Date Variables

The destination path is allowed to contain date variables that will be resolved into the date now! The syntax is identical to the one used in Batch Rename, namely "<date [date spec]>". Examples:

<date yyyy> = 2006

<date yyyymmdd> = 20061004

<date yyyy-mm-dd_hh-nn-ss> = 2006-10-04_09-08-04

Together with the feature described in the next paragraph (non-existing paths are created for you), this is an extremely valuable addition! For example, you now can easily make regular

dated backups by using a destination like this:

"D:\My Regular Backups\<date yyyy-mm-dd_hh-nn-ss>"

When you now Copy (or Backup; it's the same in this case, since

the destination is new) anything to that destination

1. The folder "D:\My Regular Backups\2006-10-04_09-08-04" is created.

2. The selcted stuff is copied there.

Note, that you even can have more than one date variable in the string. So you also can do something like:

"D:\My Regular Backups\<date yyyy-mm-dd>\<date hh-nn-ss>"

A folder for the day, a subfolder for the time. Wow.

Non-existing paths are created on the fly

You may enter non-existing paths, and you will be prompted whether you wish to create them on the fly before continuing with the file operation. Note that all parts can be new, not just the last subfolder. So "D:\new\new too\also new" will work just fine.

Catalog Categories can be backed up as well

The Catalog (Items and Categories) is supported as source for backup operations. To cope with distributed source items, the paths of the items are *fully* recreated in the target folder, including the drive letter (respectively server name). For example, if the selected Catalog Category

contains these items...

- C:\project\code\

- D:\www\project\code\

- \\cary\grant\hat\black.ico

- \\cary\grant\suit\black.ico

... and you backup them today (2007-10-26) to E:\Backup\<date yyyy-mm-dd>, then the

resulting copies will be:

- E:\Backup\2007-10-26\C\project\code\

- E:\Backup\2007-10-26\D\www\project\code\

- E:\Backup\2007-10-26\cary\grant\hat\black.ico

- E:\Backup\2007-10-26\cary\grant\suit\black.ico

This is the only way to guarantee that no merging/overwriting of homonymous items happens. And by the way, it's also a nice way to tell you quickly and exactly where a backup came from. Of course, you have to take care with huge path names, else you will hit the 260 char limit sooner than you think. The Backup Report will state as source: "[multiple source

locations, fully recreated in target]".

The capability to backup whole Catalog Categories provides nothing less than a one-click backup of distributed sources.

Compare (Submenu)

Compare Current File with Previous File

Allows you to determine whether the currently selected file is same or different from the previously selected file. The files need not be in same folder. A file is "selected" once it is displayed on Info Panel and Status Bar.

Logic & Remarks: See next paragraph.

Shortcut: Ctrl+K

Compare Current File with File in Clipboard

Sort of a "Quick Compare" that allows you to check whether the currently selected file is same or different from the file currently on clipboard.

Steps

(1) Copy one file to the clipboard. Normal file copy (Ctrl+C), or copy of file name (Ctrl+P), both works. Copying of the file's contents will not work.
(2) Select another file in the file list.
(3) Now these two files can be compared using the Compare ... command.

Logic

First the file sizes are compared. If they are identical, the contents themselves are compared. The result is simply a "same" or "different" without any further information. If you need more details use a specialized comparison application (which can easily be automated from XY using UDCs or Scripting).

Remarks

For comparisons of files larger 1 MB you get a progress indication and a break chance by ESC.

Shortcut: Ctrl+Shift+K

Compare Current File on Both Panes

Checks whether the currently focused file is same or different from the file currently focused on the other pane.

Logic & Remarks: see previous paragraph.

Shortcut: Ctrl+Alt+K

New (submenu)

New Folder, New Text File

Create new folder or new text file in current folder. Choose the date-named variants of the commands to auto-name the created folder or text file to the current date, eg:

2000-03-05.txt

New Shortcut...

Displays the Create New Shortcut dialog. Completing the dialog creates a shortcut at the current location.

New Path...

Here you can create a multi-part path in one go. Any slashes "/" are auto-converted into

backslashes "\". After creation you will be transported to the newly created location.

Shortcut: Ctrl+Alt+N (= AltGr+N)

New Folders...

Here you can enter a list of new folders or whole new paths that will be created in one go.

· The folder paths can be absolute or relative (to current).
· They can be slashed or unslashed.
· They can be whole new paths, or just new subfolders to existing paths.
· They can be stated in any order.
· Any slashes "/" are auto-converted into backslashes "\".
· XYplorer native variables and environment variables are supported.
· The last list is remembered within the session.

Example for a list:

backup

code

docs

materials\%username%

materials\pics

materials\audio

materials\video

New <date yyyymmdd>

New Files...

Here you can enter a list of new files (one per line) that will be created in one go.

· Paths can be absolute or relative (to current path).
· Non-existing path are created on the fly.
· They can be stated in any order.
· XYplorer native variables and environment variables are supported.
· Files that already exist are silently ignored (and not overwritten).
· The last list is remembered within the session.

Example for a list:

newtextfilehere.txt

MoonLanding\TopSecret\new.txt

\MarsLanding\TopSecret\new.txt

D:\Testpath\new.txt

%username%.txt

New <date yyyymmdd>.txt

New Items (submenu)

The New Items submenu is a fully and easily configurable "New"-menu that vastly surpasses the possibilities of Explorer's "New" menu.

You can freely place any files or folders (with subfolders and contents if you like) of your own choice and making in an application folder called "NewItems" (typically C:\Program Files\XYplorer\NewItems). On startup, XYplorer scans this folder and fills the submenu Edit/New Items with all items found in this folder.

Using the menu works as expected: You select one of the menu items, and the respective file or folder (incl. contents!) item is created in (copied to) the current folder, and the rename mode is immediately invoked. Which makes for instance the repeated creation of a project's complex folder structure a one-click-affair!

Tags: Any tags in the source item are copied to the new target item. This works silently and independently of the setting of "Copy tags on copy operations".

The number of items is not limited.

Date variables are supported in the item names. For example: (1) Create a file named "Log {yyyy-mm-dd}.txt" in the NewItems folder in app path. (2) A file called "Log 2010-09-17.txt" will be created when you select this file in the NewItems menu! (If today is 2010-09-17.) Note that date variables are not resolved in any subitems of a folder in NewItems.

Also comments are supported in the item names. The comment is added as part of the source item name and is separated from the target item name by the sequence space-space-singlequote (singlequote = ASCII 39). When a new item is copied the comment is dropped and only the part left of the comment separator is used in the target. For example, and item named "targetname 'comment" in the New Items folder will be copied to the new item "targetname". The comments are visible in the New Item menu.

With folders the comment is simply appended to the name. With files the comment has to be placed left of the extension, for example:

Source: <newitemspath>\targetname 'comment.txt

Target: <targetpath>\targetname.txt

Go to New Items Folder: Brings you to the folder where you can add or edit the items that will be shown in the New Items menu.

Select (submenu)

Select All

Selects all items currently listed.

Shortcut: Ctrl+A

Deselect All

Deselects all items currently listed.

Shortcut: Ctrl+Shift+A

Invert Selection

Selects all unselected files, unselects all selected files.

Shortcut: Ctrl+Shift+I

Restore Selection

Use Restore Selection to restore the last selection when you inadvertently lost it. The "last selection" is any selection right before the last time all items in the list have been unselected, or when a multi-selection has been directly replaced by a single or multi-selection.

Notes:

· A plain change of selection from one item to another (e.g. by single click on another item) does NOT store the previously selected item and thus will not affect the currently stored selection.
This means: You can have a complex selection, then single-select some items (e.g. to preview them), and then restore the complex selection. Nice!
· When you do "Restore Selection" while there is another selection then doing "Restore Selection" again will restore that other selection. In other words, you can toggle between two selection patterns.
· When in Find mode (Search Results tab), then the full paths of the last selected items are (re)stored.
· The command does not restore the previous focus.
· Each pane remembers its own last selection (but not each tab).
· To save resources selections are only retained in lists of no more than 32,767 items, and only selections of no more than 4,096 selected items can be restored.
· The last selection is not stored between sessions.

Selection Filter...

Select a subset of the currently listed items via pattern matching or Regular Expressions (prefix term with >).

You can enter more than one wildcard patterns (separated by ;) to select all matching items.

For example: '*.jpg;*.gif;*.png'.

Shortcut: Ctrl+M

Column-wise Selection Filter: You can as well select items by comparing your pattern with *any* column (not just the Name column). The comparison that results in selections on a match is a case-insensitive string comparison (not a number or date comparison). To select by columns other than the name column, simply prefix the pattern with '[column name]:' Note: the column identification is case-insensitive (e.g. 'type' works for the Type column), and there's no space after ":".

Examples (results partly depend on the column display format):

size:? KB                -> selects all items < 10 KB

modified:*2006* -> selects all items modified in year 2006

type:vis* -> selects all items of type starting with "vis"

len:2?? -> selects all items with a filename >= 200 characters

The name column is the default, so "name:" can be omitted. If you type an invalid column name, the name column will be used.

Limiting the selections to files or folders: You can restrict the selections to files or folders by attaching one of the following prefixes to the pattern:

*: => select files only

\: => select folders only

Examples:

new* Select all items starting with "new"

*:>new* Select all files starting with "new"

\:>new* Select all folders starting with "new"

Also works with RegExp:

>^new Select all items starting with "new" (RegExp)

*:>^new Select all files starting with "new" (RegExp)

\:>^new Select all folders starting with "new" (RegExp)

The prefix must precede any other prefix:

*:!>^new Select all files NOT starting with "new" (RegExp)

*:!type:doc Select all files where the Type does NOT have "doc"

Adding to / removing from the current selections: You can add to or remove from the current selections very easily:

- Hold CTRL while clicking OK in the Selection Filter dialog = Add matches to the current selections.
- Hold SHIFT while clicking OK in the Selection Filter dialog = Remove matches from the current selections.

Select By Selected Type(s)

Selects all list items with the same type(s) as the currently selected item(s). Also useful when you want count the items of a certain type.

Shortcut: Ctrl+Alt+M

Select All Files

Selects all files in the List, not the folders.

Shortcut: Ctrl+Shift+Alt+M

Select Items...

Here you can select items in the current list by way of a list of item names. These are the rules for such a list:

- One item name per line.
- Empty lines are allowed and ignored.
- Full paths are allowed in the list and will be ignored at the matching. However, when you pass items with paths and the list is in Find mode, then the matching takes the full path into account.
- Encoded URLs will be decoded (%20 is decoded to space, etc.).
- URL queries are allowed and ignored at the matching.
- The sequence of the item names does not matter.
- Leading and trailing spaces around each name are allowed and ignored.
- Matching is case-insensitive (A=a), so you can state the names with wrong capitalization and still have them selected.
- XY native and environment variables are allowed (though rarely useful here, I think).

As an example for the parsing, the following item names would all select the file "Arial Unicode MS.php" in the current list:

Arial Unicode MS.php

c:\files\A\Arial Unicode MS.php

\\192.168.0.2\Fonts\Arial Unicode MS.php

file:///c:/files/A/Arial Unicode MS.php

http://www.sofontes.com.br/files/A/Arial Unicode MS.php

http://www.sofontes.com.br/files/A/Arial%20Unicode%20MS.php

Arial Unicode MS.php?f=3&t=5502&p=51346

Some further options and properties:

- Ignore extensions: If checked then matching is done only against the base of the given item names, and one item name can potentially generate any number of selections in the List.
The state of the checkbox is remembered within the session.
- The first selected item from top is focused and moved into view.
- The last used list is remembered within the session.

Example: A small list of item names could look like this (and would select these three files in the current List if they are present):

install.log

Readme.txt

License.txt

More Interesting Use Case: This command enables you to perform a potentially large, complex, and not-rule-based selection in a very easy and convenient way. There is no other way to do what Select Items... can do for you. Here's an example: Say you are going to overwrite 250 files in a folder of 5,000 files with newer versions. But you'd like to backup the original versions first. How will you grab those 250 out of the 5,000 without spending a tedious time with manual selection? Using Select Items... this is a snap: Go to the folder with the 250 new items and copy their names the clipboard (Ctrl+Shift+P); then go to the folder with the 5,000 items, click Select Items..., paste the 250 names into the text box, and click OK; all original items about to be overwritten are selected and ready for backup! This will take you less than 10 seconds.

Shortcut: Ctrl+Shift+M

Selection Stats

Displays statistical information on the currently selected list items (recurring any folders).

When the Tree has the focus, the stats on the current tree folder are returned.

Find Files

Open the Find Files tab on the Info Panel, and place the cursor into the Name field. If that is already the case then the command hides the Info Panel.

Shortcut: Ctrl+F

Find Now

Starts File Find with the current parameter setting, starting in the current folder.

Shortcut: Ctrl+Alt+F

Repeat Last Search

Runs File Find at the last searched location using the current find settings.

Search Templates...

Opens the Search Templates.

Quick Name Search...

Opens the Quick Name Search dialog.

Shortcut: F3

Toggle Quick Name Search

Toggles between no Quick Name Search and the last one (if any) in the current location.

Shortcut: Ctrl+Shift+F3

Repeat Last Quick Name Search

Repeats the last Quick Name Search (if any) in the current location.

Shortcut: Shift+F3

Show All Items In Branch

Recursively browses the current folder (including subfolders) and lists everything in it independent of the current Find Files settings.

Note that the more recent feature Branch View offers a superior way to achieve this.

Shortcut: Ctrl+F3


Favorites Menu

 Top

Favorites Menu Commands

Favorite Folders

All locations you have previously defined as favorites (by pressing Ctrl+B).

Using menu Tools | List Management | Favorite Folders you can optionally define custom menu captions for the items. Simply prefix the caption in quotes (optionally followed by any number of blanks). These will work identically:

"caption" location

"caption"location

"caption" location

This allows you to attach catchy aliases to long and hard-to-read paths! For example:

"Transparent PNGs" E:\VB-Don\TestFiles\Media\image-formats\trans\png\ARGB 32bit\

As a 2nd example, here is a custom favorite folder where the "location" is a quick script (prefixed by ::):

"Script to append modified date" ::rename , '*-<datem yyyymmdd>'

Will show "Script to append modified date" (without quotes) in the menu; when you click it, the script is executed. So you now have another, very comfortable way to place some heavy-rotation scripts right under your mouse button!

Tip: You can manage your Favorite Folders in Tools | List Management | Favorite Folders. Here you can also reorder the list and add menu separators by inserting items with a single hyphen (minus sign) as caption.

Fuzzy Favorites

Favorite Folders and Favorite Files support the wildcards * (stands for "any number of characters including none"). With a Fuzzy Favorite the first match will be used. This can be useful when you need to reference Favorites with variable names.

Some examples from an XP system:

Fuzzy Favorite Resolved to

C:\*.log -> C:\RobotError.log

C:\REC*\ -> C:\RECYCLER\

You can manually define Fuzzy Favorites via Tools | List Management | Favorite Folders.

Favorite Files

All files you have previously defined as favorite files. You can directly jump to any file by a single click.

Toggle Favorite File: (un)marks a file as favorite. Applies to the currently focused file.

Special System Folders

Browse to various special system folders.

Toggle Favorite Folder: (un)marks a folder as favorite (either by bold face, or by an overlay icon: configure this in menu Tools | Customize Tree). Favorite Folders are added to the Favorites Listing within this menu. When you rename a favorite folder the favorites are automatically updated so that the link is kept alive.

Shortcut: Ctrl+B

Toggle Highlighted Folder: throws a highlight (color configurable) on the current folder. It's 8 pixels wider than the selection rectangle to keep it visible when the folder is selected.

Shortcut: Ctrl+Shift+B

Toggle Boxed Branch: draws a colored rectangle on the background of the whole branch.

Shortcut: Ctrl+Alt+B

Set Highlight Color: define the highlight color for the current tree folder. Enables Highlighted Folder for this folder if not yet enabled anyway.

Set Box Color: define the box color for the current tree folder. Enables Boxed Branch for this folder if not yet enabled anyway.

Note The Favorite Folders submenu pops up when you right-click anywhere in the free area (not on a folder) of the Tree.

Labels (Submenu)

Here you can assign any out of the currently defined labels to all currently selected items, or remove them by selecting "None".

Apply Last Label

Apply the last used label to all currently selected items.

Add Tags...

Add more tags to the tags of all selected items.

Add Tags by List...

Add more tags to the tags of all selected items (select from the Tag List).

Add Last Tags

Add the last added tag(s) to the tags of all selected items.

Edit Tags...

Edit the tags of all selected items (based on the tags of the current item).

Edit Tags by List...

Edit the tags of all selected items via a checkbox tag list. The checkboxes are pre-ticked based on the tags of the current item.

Remove Tags by List...

Remove particular tags from all selected items (select from the Tag List).

Remove All Tags

Remove all tags from all selected items.

Comment...

Here you can assign a comment to all currently selected items, or remove any comments by entering nothing.

Reload Tags Database

Reload the tags database from disk, aka revert to saved. Especially useful when XYplorer is run in a company where many users share read-only access to a common tags database which can be altered only by the administrator (see Admin Settings).


File Menu

 Top

To Clipboard (Submenu)

Copy various file information to the clipboard.

Section 1:

The following commands are applied to all selected items (files or folders). If more than one item is selected, each item in the copy string is terminated by a line feed (thus generating a vertical list). If only one item is selected, no line feed is appended to it.

Item Path/Name(s)

Copy the selected item name(s) with path, eg:

C:\Programs\XYplorer\XYplorer.exe

Shortcut: Ctrl+P

Item Name(s)

Copy the selected item name(s) (no path), eg:

XYplorer.exe

Shortcut: Ctrl+Shift+P

Item Path(s)

Copy the selected item path(s) (no name), eg:

C:\Programs\XYplorer\

Shortcut: Ctrl+Shift+Alt+P

Item Base(s)

Copy the selected item base(s) (no path, no extension), eg:

XYplorer

Item Short Path/Name(s)

Copy the selected item short (DOS 8.3 format) name(s) with path, eg:

C:\DOKUME~1\ALLUSE~1\STARTM~1\PROGRA~1.LNK

Item UNC Path/Name(s)

Copies the full path/name of all selected Tree or List items, using the UNC path for items located on a mapped drive. Other items are copied without change.

Name(s), Bytes, Modified[, Version]

Copy item name (no path) and basic info, eg:

XYplorer.exe, 6.029.312 bytes, 2014-01-02 09:35:12, ver 13.50.0019

Name(s), Bytes, Modified[, Version], Path

Copy item name and basic info including path, eg:

XYplorer.exe, 6.029.312 bytes, 2014-01-02 09:35:12, ver 13.50.0019, E:\XY\XYplorer\

Name(s), Bytes, Modified[, Version], Path, MD5

Copy item name and basic info including path and MD5 hash, eg:

XYplorer.exe, 6.029.312 bytes, 2014-01-02 09:35:12, ver 13.50.0019, E:\XY\XYplorer\, 5ecc1e347db8e789fd97d5f59f9aa491

Section 2:

The following commands are applied to only the focused item (the file or folder marked by the dotted focus line).

Compact File Info

Eg: XYplorer.exe, 1.539.072 bytes, 16.01.2006 09:56:06, ver 4.40.0047

This is equivalent to Name, bytes, modified[, version] (see above)

Extended File Info

Example

Large Icon

Copy bitmap of the large icon (32x32) of the focused item. Transparent areas are set to window background color (typically white).

Small Icon

Copy bitmap of the small icon (16x16) of the focused item. Transparent areas are set to window background color (typically white).

Section 3:

Image

If the current file is an image file this command will copy the image directly to the clipboard.

Section 4:

Selected List Rows

Copy all selected rows of the List as currently shown in the list

All List Rows

Copy all rows of the List as currently shown in the list

Rename Special (Submenu)

The following rename routines apply to all currently selected files. It is recommended that you use the built-in Preview function before actually applying the rename.

Batch Rename...

Provides a simple way to rename a bunch of files using a common template consisting of a fixed part and an auto-incremented counter. You can define the starting value and the number of leading zeroes. Examples:

File<#1>.ext = File1.ext, File2.ext, ... File74.ext ...

File<#00>.ext = File00.ext, File01.ext, ... File235.ext ...

File<#055>.ext = File055.ext, File056.ext, ... File9574.ext ...

You can as well add strings to the beginning and/or the end of the original name (extension excluded). In the template the original name is referred to by "*" (asterisk) -- the self-referential wildcard (see also below). For example, the template "2006-*-(backup)" will trigger the following renames:

Convdsn.exe -> 2006-Convdsn-(backup).exe

Drvspace.vxd -> 2006-Drvspace-(backup).vxd

Comdlg32.ocx -> 2006-Comdlg32-(backup).ocx

You can as well datestamp the selected files. <date will used the current date, <datem/c/a will use each item's modified/created/accessed date:

*_<date yyyy-mm-dd_hh-nn-ss> -> OldName_2006-08-16_15-49-03.txt

<date yyyy>_* -> 2006_OldName.txt

<datem yyyy>_* -> 2004_OldName.txt (OldName.txt was last modified 2004)

<datec yyyy>_* -> 2002_OldName.txt (OldName.txt was created 2002)

<datea yyyy>_* -> 2006_OldName.txt (OldName.txt was last accessed 2006)

Note that fractions of a second (up to 7 decimal digits) are supported. The placeholder is "f". The following example will use the milliseconds of the current time for the new filename:

<date yyyymmdd_hhnnss.fff>_* -> 20130610_103214.106_test.txt

The files are renamed one after the other in their current order. In case of a name collision you get a message with the option to continue or abort the batch job. If only one list item is selected you can force the Batch Rename interface by pressing Shift+F2.

Self-referential wildcards

The wildcard (*) is replaced by the original file base (file title excluding extension). Additionally, there's a 2nd self-referential wildcard (?) that stands for the original file extension. Examples:

Old Pattern New

a.jpg ? jpg.jpg

a.jpg *.?.bak /e a.jpg.bak

a.jpg ?-<#001> jpg-001.jpg

a.jpg ?-<#aa> jpg-aa.jpg

a.jpg *.?.<date yymmdd> a.jpg.081023.jpg

a.jpg *.?.<date yymmdd> /e a.jpg.081023

Batch Rename Switches

e/ for Extensions: Note that the original file extensions remain unchanged. However there's an easy way to actually change the extensions: append /e to the pattern! The /e switch simply means: drop the original extension. Then it depends on the pattern whether a new extension is supplied or not. Examples:

Original name: test.txt

*-<datem yyyymmdd> test-20070607.txt

*-<datem yyyymmdd>.htm test-20070607.htm.txt

*-<datem yyyymmdd>/e test-20070607

*-<datem yyyymmdd>.htm/e test-20070607.htm

New<#01> New01.txt, New02.txt, New03.txt ...

New-<#aa> New-aa.txt, New-ab.txt, New-ac.txt ...

New<#04>/e New04, New05, New06 ...

New<#01>.csv New01.csv.txt, New02.csv.txt, New03.csv.txt ...

New<#01>.csv/e New01.csv, New02.csv, New03.csv ...

ping.png/e ping.png

s/ for skip: If you want to smartly avoid any collision that might arise from using auto-increments: append /s to the pattern! Examples:

Old Pattern New If b-3.jpg exists

a.jpg b-<#3> b-3.jpg collision!

a.jpg b-<#3> /s b-4.jpg collision auto-avoided

a.jpg b-<#3>.png /s b-3.png.jpg no collision anyway

a.jpg b-<#3>.jpg /e b-3.jpg collision!

a.jpg b-<#3>.png /es b-3.png no collision anyway

a.jpg b-<#3>.png /se b-3.png no collision anyway

The last two examples merely illustrate that the order of switches is irrelevant.

i/ for "Increment On Collision": If you want to automatically avoid collisions with existing files, append a "/i" to your pattern.

For example, you have these files, both modified on 2008-07-29:

hilite.png

hilite-20080729.png

If you now apply the pattern *-<datem yyyymmdd> to hilite.png, renaming is not possible because of collision with the already existing hilite-20080729.png. However, if you use the pattern *-<datem yyyymmdd>/i the file will be renamed to hilite-20080729-01.png (or hilite-20080729-02.png if hilite-20080729-01.png exists, etc). The format of the incremental suffix is determined by the setting of Incremental suffix in Configuration | Templates.

Note that some patterns avoid collisions anyway by default, so appending the switch is not necessary here (but harmless):

- patterns with explicit increment, e.g. "New-<#01>"

- simple patterns, e.g. "New"

Note that pattern switches can be combined in any order: If you need to change the extension (/e) AND want to increment on collision (/i) then simply append /ei or /ie.

RegExp Rename...

Allows you to rename selected filename(s) using Regular Expressions. Format:

RegExpPattern > ReplaceWith

Mind the quotes around the separator ( > ).

The default operation is case-insensitive (a=A). To search case-sensitively add a back-slash to the end of ReplaceWith:

Examples:

.html$ > .htm = change extensions .html to .htm

.html$ > .htm\ = change extensions .html (but not eg .HTML) to .htm

Note Renaming includes file extensions.

Search and Replace...

Here you can enter a list of characters to be removed or replaced from selected filename(s). You can

(1) define no replace entity, in which case all characters in the list will be removed, or
(2) define a common replace string (can be longer than one character) at the end of the list after '>', or
(3) define a replace list at the end of the list after '>>' (remove-list and replace-list must have same length), or
(4) define lists with units larger than one character before and after '>>', or
(5) define a string to be replaced by another string, both strings separated by '/'. Is by default case-insensitive (a=A), but can be made case-sensitive by appending a backslash (\).

Examples:

[]{};,! = Remove all these characters
[]{};,!>_ = Replace each of these characters with _
[]{};,!>off = Replace each of these characters with 'off'
äöü>>aou = Replace all ä with a, ö with o, ü with u

Ä|Ö|Ü|ä|ö|ü>>Ae|Oe|Ue|ae|oe|ue = Replace all Ä with Ae, Ö with Oe, etc.

before/now = Replace all 'before' (or 'beFOrE') with 'now' (case-insensitive: a=A)
before/now\ = Replace all 'before' with 'now' (case-sensitive)
before/ = Remove all 'before'
Note The original file extensions are preserved.

Keep Particular Characters...

Here you can enter a list of characters to be kept in selected filename(s). The default list is:

abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 _-.()

You can

(1) define no replace entity, in which case all other characters will be removed, or
(2) define a common replace string (can be longer than one character) at the end of the list after '>'.

Examples:

abc = Remove all characters that are not a, b, or c

abc>_ = Replace all characters that are not a, b, or c, with '_'

Note The original file extensions are preserved.

Set Extension...

Sets a new extension to all selected files (replacing the old one, or adding a new one if there was none before). Enter nothing to remove any extensions.

Folder names are skipped.

Edit Item Names...

Here you can edit the names of the selected List items in a multiline text box. Depending on your rename tasks this offers an elegant way to handle them.

You might even copy the names to a full blown editor, do some fancy things with them, and then paste them back to the dialog and perform the rename.

Notes:

- Empty lines or missing lines at the end of the list will be taken as "don't rename this item"; excessive lines at the end of the list will be ignored.
- The Rename Preview is unconditionally invoked before the actual rename is performed.

Capitalization

A* A*.aaa Capitalizes each word in the filename(s), but leaves any upper case letters within the words untouched. The extension is put to lower case.

Aaa Aa.aaa Capitalizes each word in the filename(s), sets all non-first letters to lower case. The extension is put to lower case.

aaa aa.aaa All lower case.

AAA AA.AAA All upper case.

Note This is not a real file rename since Windows treats filenames case-insensitive – it just concerns name display.
Note Windows 9x displays filenames which are set to all caps (AAAA.AAA) invariably in "proper case" (i.e. Aaaa.aaa) if they conform to the DOS 8.3 name standard (8 chars-dot-3 chars), i.e. if they are short filenames.

*.aaa Set extension to lower case.

*.AAA Set extension to upper case.

Examples:

XYplorer_work.ini ->

A* A*.aaa: XYplorer_Work.ini

Aaa Aa.aaa: Xyplorer_Work.ini

aaa aa.aaa: xyplorer_work.ini

AAA AA.AAA: XYPLORER_WORK.INI

*.aaa: XYplorer_Work.ini

*.AAA: XYplorer_Work.INI

Spaces to _ and _ to Spaces: Replaces spaces in long filenames by underscore (and vice versa).

Remove Diacritics: Strips any diacritical marks from the letters in the selected item names.

Convert to ASCII: Converts the filename to 7-bit ASCII using a various smart and language-specific conversions. In German e.g. it converts ä to ae, Ö to Oe, ß to ss, etc. Cyrillic characters are romanized. Non-convertible characters are replaced by "_" or whatever is defined in Configuration | Templates | Character to replace invalid characters in dropped messages.

UrlEscape: Converts " " to "%20" etc."%20" is often found in the names of downloaded files, it is the escape sequence for a space used in URLs. Apart from this there are other escapes for unsafe characters in URLs, eg "%FC" for "ü". Unsafe characters are those characters that may be altered during transport across the internet.

UrlUnescape: Converts "%20" to " " etc. (reversal of UrlEscape).

Unicode to UTF-8: Converts non-latin characters to ANSI characters using the UTF-8 encoding scheme.

UTF-8 to Unicode: The same backwards.

Mp3 Special (Submenu): Here you find some convenient renaming schemes for MP3 files ("ID3 Tag to Filename") and also schemes to alter the ID3 tag from the file name ("Filename To ID3 Tag"). The placeholders Artist, Year, Album, Track, and Title are supported. The factory default presets can be altered by editing the INI file.

Preview All: Check to show a preview for each of the Rename Special operations, including detection of possible conflicts.

Move/Copy/Backup To (Submenu)

Move To / Copy To / Backup To

Favorite Folders: Move/Copy/Backup currently selected files to a predefined favorite folder.

Tabs: Move/Copy/Backup currently selected files to any of the currently existing tabs (if they are suitable as destinations).

Move To / Copy To / Backup To...: Open the internal Move/Copy/Backup To dialog to each of the submenus. Duplicates the commands in menu Edit for the sake of usability.

Browse for Move Destination...: You can target folders not listed by selecting the Browse... command; they'll be added to the top of the list. Move To/Copy To/Backup To all share the same list.

Tip: Dbl-clicking a destination in the destination list triggers the default action (Move, Copy, or Backup) with that destination.

Open Selected Item(s)

Open all currently selected files at once.

Shortcut: Enter

Open with...

Pops up a menu showing all applications associated (Portable File Associations - PFA) with the current (focused+selected)* List item. Select one of them to open all selected List item(s) with it.

* If none of the selected items is focused, then the first selected item (from top) is used to match the PFA patterns against.

See also Portable Openwith Menu (POM).

Shortcut: Ctrl+Alt+Enter

Open with Arguments...

Open the selected list item(s) with command line arguments of your choice. The last used arguments are saved between sessions.

Open Focused Item

Open the currently focused file.

Shortcut: Ctrl+Enter

Open...

Here you can enter, paste, or select an item (file, folder, drive) to open, without the need to go there first. Recently opened items are stored in a MRU list that is saved between sessions. The dialog is preset to the last opened item.

In the input dialog you can choose between "Open" which will open the item using the default application (taking XY's portable associations into account), and "Open with..." (Ctrl+Enter) which will pop the Portable Openwith Menu (POM) for the item you have entered (POM is Pro Edition only).

The POM features the extra commands "Go to Item" and "Copy Item". Note that both commands (like all other commands in the menu) work on the current contents of the edit field. So you can type or paste any existing item name, and go to it or copy it (the item, not just the name) to the clipboard. Nice!

What is added to the MRU: Single files (not folders) opened thru the List by Enter/Dbl-Click or via the POM are automatically added to the MRU (and thus made available in the new Open dialog. Files opened via scripts, or UDC, or Catalog, or shell context menu, or within a group of files (i.e. non-single), or other means are not auto-added.

You can edit the MRU in Tools | List Management | Recently Opened Files.

Shortcut: Ctrl+O

Duplicate (submenu)

Copy Here

Makes a copies of the selected items. On collision items are renamed in the Windows standard way ("Copy of...").

Copy Here with Increment

Creates auto-serial-numbered/lettered (template defined in Configuration | Templates) duplicates of the selected items. Examples:

My.txt => My-01.txt

My.txt => My-02.txt (if My-01.txt already exists in the target folder)

My.txt => My-03.txt (if My-01.txt and My-02.txt already exist in the target folder)

etc.

Shortcut for Copy Here With Increment: Ctrl+D (think "Duplicate")

Copy Here with Current/Last Modified Date

Makes a copies of the selected items and automatically appends the last modified date [respectively current date] of the copied item in a format defined by a template. Date-stamped copies are very, v-e-r-y, useful when working with versions. If an item by the new name already exists, auto-incremented numbers are suffixed.

Shortcuts (think "Duplicate Dated"):

Ctrl+Shift+D: Last Modified Date

Ctrl+Shift+Alt+D: Current Date

Copy Here As...

Allows you to create renamed copies of the selected items in the same path. The newly generated names are distinguished by suffix numbers in the current order of listing, for example:

Copy

china.jpg

japan.jpg

Here As "asia" will generate the following copies (assuming your incremental suffix template is "-01"):

asia-01.jpg (copy of china.jpg)

asia-02.jpg (copy of japan.jpg)

However, if only one file is selected (and this will be the typical case with this command) then no suffix number is appended:

Copy

china.jpg

Here As "asia" will generate the following copy:

asia.jpg

Wildcards in Copy/Move Here As...

You can as well state a wildcard pattern and variables to define the target names of the operation.

Wildcard * stands for the file base.

Wildcard ? stands for the file extension (without dot).

For example, the pattern (the date variable refers to the current date)

*_backup_<date yyyymmdd>.?

applied to files

motherearth.txt

funlicker.jpg

would create copies named

motherearth_backup_20100117.txt

funlicker_backup_20100117.jpg

in the same folder. If you'd do the same thing again on the same day the following copies would be created:

motherearth_backup_20100117-01.txt

funlicker_backup_20100117-01.jpg

FYI, the format of the incremental suffix is defined in Configuration | Templates.

Also supported are date variables that refer to the selected items individually. For example, to append the modified date of each file to the copy:

Pattern: *_<datem yyyymmdd>.?

Sources: Che.txt, Fidel.txt

Targets: Che_20100918.txt, Fidel_20101111.txt

Shortcut for Copy Here As: Ctrl+S (think "Save As...")

Copy Here to New Subfolder...

Copy the selected list item(s) to a new subfolder of the current folder. An input dialog opens to enter the desired new folder name.

Note that this command only works on the selected list item(s), and is disabled if the file list is not focused.

Shortcut: Ctrl+Shift+C

Move Here to New Subfolder...

Move the selected list item(s) to a new subfolder of the current folder. An input dialog opens to enter the desired new folder name.

Note that this command only works on the selected list item(s), and is disabled if the file list is not focused.

Shortcut: Ctrl+Shift+X

Delete

Delete all currently selected files.

Shortcut: Del

Rename

Renames the currently selected items. If only one item is selected and focused, inline rename is invoked. Otherwise Batch Rename is invoked.

Serial Rename: When in single item rename mode, pressing the Tab key will apply the changes and immediately open the rename box for the next item in List. Shift+Tab will do the same for the previous item in the List. The function wraps around the upper and lower ends of the list.

Note that on Serial Rename the list will not be auto-resorted after each rename operation even if you checked "Resort list immediately after rename" in Configuration | Sort and Rename.

Shortcut: F2

File Special (submenu)

Create Shortcut(s)

Creates a shortcut (*.lnk) to each selected tree or list item(s) in the current folder. After creation the shortcuts are auto-selected.

Delete (No Recycle Bin)

Delete all currently selected files, skip the Recycle Bin.

Shortcut: Shift+Del

Delete (Skip Locked)

Normally, when deleting multiple files and a locked file (a file currently used by any application) is met, the OS sits about 2 seconds doing nothing, and then you get a message that a file can't be deleted because it is in use, and finally the deleting stops at this point. All other files that are not in use aren't deleted. Very annoying, and you have surely experienced this when you wanted to clean up in your temp folder last time. "Delete (Skip Locked)" comes in handy here. It simply deletes everything that's not locked and does not contain anything locked.

It takes the following two-step approach:

(1) Look for any locked files within the current selection (recurring any selected folders). Then delete all other (unlocked) files (if any).

(2) Look for any empty folders (where empty means: no *files* contained in the whole branch) within the current selection. Then delete those folders (if any).

In step (1), if any locked files are detected, you'll get a confirmation dialog where you can decide how to proceed.

In step (2), if any empty folders are detected, you'll get a confirmation dialog where you can decide how to proceed.

Shortcut: Ctrl+Del

Shortcut: Ctrl+Shift+Del (No Recycle Bin)

Delete Long

Use this command to delete the selected Tree or List item(s) even when they have overlong paths (> 260 characters). The deletion is permanent since the Recycle Bin does not support items that long. The action is listed in the Action Log but cannot be undone.

Note: This command is only available if Configuration | Controls and More | Support overlong filenames is ticked.

See also Overlong Filenames.

Wipe

Wipe is a method to securely delete files beyond recovery (at least by conventional software-based forensic tools). This sort of deletion is also known as Shred, Erase, Secure Delete, Nuke, etc. XYplorer's Wipe doesn't perform paranoid stuff like multiple passes or random patterns, because instead of increasing security this is just stressing your hardware. The following steps suffice to destroy a file permanently:

1. Reset file attributes.

2. Overwrite file with zeros (single pass).

3. Set file size to zero.

4. Rename file.

5. Reset the three file dates to random dates.

6. Delete file.

You can trigger Wipe in four ways:

· First, there is a normal menu command: File | File Special | Wipe.
· Second, there is the Wipe toolbar button.
· Third, there is the Nuke toolbar button which has configurable properties in its right-click menu. Tick "Wiping Beyond Recovery" to make the Nuke button a very dangerous tool.
· Fourth, there is a Miscellaneous command Nuke (#1054) which can be assigned a keyboard shortcut and acts the same as if the Nuke toolbar button is pressed.

Notes:

· You will always get a confirmation prompt before a Wipe operation starts.
· Wipe supports overlong filenames (> 260 chars).
· Wipe does support files > 2GB.
· Wiping huge files takes a while (the "Overwrite file with zeros" part, of course). You will see a little progress indicator in the status bar, and a chance to ESC the operation.
· You can also wipe whole folders. All files found within are individually wiped. Then the folders are removed.
· Toolbar | Nuke: When "Wiping Beyond Recovery" is ON, then "To Recycler" is automatically disabled. Obviously the two cannot coexist.
· Note that wiping (specifically overwriting a file with zeros) should only be performed on HDs (hard disks), but not on SSDs (solid state drives, e.g. flash drives) where the success of overwriting the bytes with zeros cannot be assured due to the logic of those devices, and where it in fact would only increase wear.
· Take care: There is no undo for wipe. :)

Swap Names

Swaps the names of two selected List items. You have to select exactly two items.

Shortcut: Ctrl+Shift+F2

Set Modified Date to Current

Sets the Modified Date of all selected List items to the current date/time. Also known as timestamp.

Set Modified Date to Exif

Sets the Modified date of each selected image file (JPEG, TIFF) to its Exif date.

Set Created Date to Exif

Sets the Created date of each selected image file (JPEG, TIFF) to its Exif date.

Display Hash Values

Generates and displays the most common hash values for the current file: CRC-32, MD5, SHA-1, SHA-256, SHA-512.

Extract Here

Extracts the selected archive here.

Add to Zip...

Adds the selected items to a Zip archive. You are prompted for a name for the archive.

Properties

Display the shell properties dialog for the the current item (Tree, List, Catalog, Address Bar). Works on the focused list item when there are no selections, else it works on any selected list items.

Shortcut: Alt+Enter

Metadata

Show all available metadata of the current item (Tree, List, Catalog, Address Bar) in a popup text box. Also works on the focused list item when it is not selected. Note that also a toolbar button exists for this function.

The window shares size and position with the Quick File View, and remembers both between sessions.

Tip: Tick Configuration | Preview | Quick file view | Modeless dialog to have the dialog modeless: You can leave it open and select files in the file list to view their metadata.

Shortcut: Shift+Enter

Preview

Opens the Preview tab (and, if necessary, the Info Panel) for the focused file. If the Preview tab is currently selected then Ctrl+Q will close the Info Panel.

Shortcut: Ctrl+Q

Quick File View

Opens a Quick File View window for the currently focused file (even if it is not selected).

(1) There's no editing, just viewing. But you can select and copy.
(2) Of larger files only the first 256 KB are shown. If you need more, used Raw View on Info Panel.
(3) Non-binary file are displayed in the usual text mode. All sorts of line feeds (DOS, Mac...) are recognized correctly.
(4) Binary files are displayed in the usual hex editor mode. For performance reasons only the first 32 KB are shown of them.
(5) Of course, this function does not work for folders.

Tip: Tick Configuration | Preview | Quick file view | Modeless dialog to have the dialog modeless: You can leave it open and select files in the file list to have them quick-viewed.

Shortcut: Ctrl+Shift+Q

Note that the Floating Preview (F11) and Full Screen Preview (Shift+F11) will automatically open the Quick File View if the previewed file is not supported by them.

Note also that the same keyboard shortcut that opens the Quick File View window can also be used to close it.

Floating Preview

Toggles the Floating Preview.

Note that the Quick File View is auto-opened on a file that's not supported by the Floating Preview.

There is a toolbar button to toggle the Floating Preview.

Shortcut: F11

Save Settings

Save the current configuration to the current INI file. This command also saves the keyboard shortcuts (ks.dat), the User-Defined Commands (udc.dat), the Folder View Settings (fvs.dat), the Tags (tag.dat), the Catalog (catalog.dat), and (if enabled) the cached servers (servers.dat).

The command also writes the current Action Log from memory to disk (action.dat) if "Remember the logged actions between sessions" is enabled.

Settings Special (submenu)

An asterisk (*) is prefixed to all dirty configurations (that have been changed since startup).

Load Configuration

Loads a previously saved (see below Save Configuration As...) configuration (*.ini). Tip: in the title bar of the main window as well as of the configuration window (F9) you can see the currently active INI file.

Note: You can load a configuration file from anywhere (not just from application path). However, to keep things in one place, a copy of that file will be auto-created in the application path (no overwriting will happen), and that copy will be used as the new configuration file.

Save Configuration

Save the current configuration to the current INI file.

Save Configuration As...

The current configuration will be saved to a new INI file located in the app's path. This new INI will become the currently active one.

Save Copy of Configuration As...

Backups the current configuration under a new name (defaults to the present date suffixed to the INI base name) without making it the active INI file.

Create Shortcut to this Configuration...

Creates a shortcut file to XYplorer containing a switch to the current INI-file on your Desktop. All you have to do is to give the shortcut a name.

Save Catalog

Save the catalog database (catalog.dat).

Save User-Defined Commands

Save the User-Defined Commands database (udc.dat).

Save Keyboard Shortcuts

Save the keyboard shortcuts database (ks.dat).

Save Folder View Settings

Save the Folder View Settings database (fvs.dat).

Save Tags

Save Tags, Labels, and Comments to the database (tag.dat).

Save Servers

Save (if Cache Network Servers is enabled) the cached servers database (servers.dat).

Backup Application Data Folder...

Backups all contents of the Application Data Folder to a folder of your choice. The hard-coded operation type is "Backup" with "Overwrite only older files" and "Preserve item dates".

The last used target path is remembered and preselected when you use the command the next time.

Restart without Saving

Restart program without saving settings.

Exit without Saving

Exit program without saving settings.

Keyboard trick: hold CTRL while closing the app via Window X-button to force exit without saving.

Shortcut: Ctrl+Alt+F4

Exit

Exit program. If Configuration | Startup & Exit | Save Settings on Exit is ticked then all settings are saved before exiting.

Shortcut: Alt+F4


Go Menu

 Top

Go Menu Commands

Go to Previous Location

Jump to the previous tab/mode/location (useful to zap back and fore between two locations). If the previous location has been on another tab, this tab is opened (if it still exists). If the previous tab does not exist anymore, the location is opened in a new tab.

Shortcut: F7

Go to Previous Item in List

Jump to the previously focused and selected item in the current file list.

Shortcut: Shift+Alt+F7

Go to Last Target

Beams you to the most recent target of a move/copy file operation that was performed inside the current XYplorer instance and session. That's good news for the paranoid: a quick [Ctrl+Alt+F7] (or right-handed [AltGr+F7]) will carry you to the place you've just moved/copied some files to, to check personally whether the files arrived in a good condition. Dual pane without the space-waste... ;)

As a special service the copied or moved items found in that target location are auto-selected when you go there using this command. Every new copy/move will overwrite the previous last target data. And, just like the target folder itself, these selections are not remembered between sessions.

Shortcut: Ctrl+Alt+F7

Top

Jump to the top folder (Drive, \\Server, Desktop, MyDocuments) of the current folder.

Shortcut: Ctrl+Home @Tree (=only if the Tree is focused).

Up

Jump to parent folder of the current location.

Shortcut: Backspace

Down

Takes you down to the most recently used subfolder of the current folder (if any).

Shortcut: Shift+Backspace

Breadcrumb...

You could also call it "Up-Down-History", "Popup Breadcrumb", "Vertical Breadcrumb", or "Relative History".

You'll immediately grab the idea: when you click this command (or click the arrow besides the "Up" toolbar button, or right-click this button) a menu is popped up presenting you a selection of destinations directly related to your current location. The Up-part is simply generated by parsing the current path. The Down-part is drawn from the recent history.

· It's a breadcrumb that takes no screenspace at all if you don't want it to. It works without toolbar, address bar, whatever bar. Simply press [Ctrl+Backspace] to have it pop up.
· It's a breadcrumb that's manageable by keyboard-only. Even one-handedly when using the right Ctrl-key.
· It's a breadcrumb that goes not only back up but also back down.

Tip: Right-clicking the icon of a tab pops a breadcrumb menu for the tab's path.

Shortcut: Ctrl+Backspace

and: Ctrl+Alt+Backspace; AltGr+Backspace (to avoid the ding sound)

Drives...

Pops up a menu featuring all currently available drives. Empty removable and unaccessible network drives are skipped.

Back

Step back in history.

Shortcut: Alt+Left

Forward

Step forward in history.

Shortcut: Alt+Right

History...

Pops up a list with your recent browse history. The first/oldest entry is at the bottom, the last/newest at the top. The history holds up to 256 entries and remembers them between sessions.

Recent Locations...

Shows the MRU list of locations from most recent (at the top, with number 1) to most ancient. Dbl-click an item to jump to it. The MRU holds maximally 64 items.

Note that there's a toolbar button of the same name that pops a menu of the most recent locations.

Hotlist...

The Hotlist is a brand-new interface to your history, with the intention to present the history in a way that makes it as easy as possible to quickly go back to one of the places you have recently been -- as opposed to the traditional presentation of the history which makes it easy to go back and forth on your recent track.

The Hotlist is made like this:

(1) All its items are taken from the history.

(2) Computer and Network Places are removed (to keep it tight).

(3) It's ordered alphabetically.

(4) It's fresh: only existing paths are shown (the history can be outdated in this aspect).

(5) It's compressed: only the *leaves* of the branches are displayed. If your history contains

C:\

C:\Programs

C:\Programs\XYplorer

then only the latter is shown in the Hotlist. It is assumed that the skipped parent items have just been transit stations on the way to the final "leaf" item, C:\Programs\XYplorer, and hence aren't interesting (or "hot") targets.

(6) It's grouped by separators, one section per drive.

Shortcut: Ctrl+H

Tablist...

Pop up a menu containing all currently existing tabs.

Shortcut: Ctrl+Shift+T

Aliases...

Here you can select an alias from a list of all aliases you have defined. If you don't remember what an alias stands for, you can check in Tools | List Management | Aliases, and maybe find a better name for it.

Go to...

Enter/paste a location (a path) to jump to. You can as well enter a path/file name to jump directly to a specific file in that path.

Shortcut: Ctrl+G

Go to from Here...

Same as Go to… (see above), but preset to current path.

Note that Go to from Here... supports relative paths. They are resolved relative to the current path (whereas in the normal "Go to" and Address Bar they are resolved relative to app path).

Shortcut: Ctrl+Shift+G

Go to Line...

Enter/paste a line number to jump to.

Shortcut: Ctrl+Shift+L

Go to Application Folder

Well, brings you to the application folder.

Shortcut: Ctrl+Shift+Alt+G

Go to Application Data Folder

It will beam you to the application data path.

Using Startup.ini

Here is a way to control the Application Data Path (ADP) used by XYplorer and thus avoid any issues with UAC (User Account Control) under Vista and later. You can set ADP to any location you like by manually creating and editing a file called "Startup.ini" in the application path.

Note: From version 8.80.0100 onwards the above is done automatically on first installation!

The format of Startup.ini is that of INI files, and it has only one section and one key. Here's an example with a hard-coded app data path on drive E:

[Appdata]

Path=E:\XYplorer\appdata

Here's an example with a soft-coded app data path using an environment variable. It is resolved depending on the current user account:

[Appdata]

Path=%appdata%\XYplorer

You may as well state a path relative to the application path (where XYplorer.exe is located), for example:

[Appdata]

Path=appdata

The following files and folders are written to and read from ADP:

Catalogs <DIR>

catalog.dat

FindTemplates <DIR>

NewItems <DIR>

Panes <DIR>

Scripts <DIR>

Thumbnails <DIR> (configurable)

action.dat

fvs.dat

ks.dat

lastini.dat

servers.dat

tag.dat

udc.dat

tipoftheday_user.htm

XYplorer.ini (and other, alternative INIs)

Naturally, if you change the ADP you will have to move your current application data to the new path if you want to continue working in the same state as you left the application before changing the ADP.

Tip: If you still get an UAC prompt at startup then look on the "Compatibility" tab of the properties for the xyplorer.exe file and/or the shortcut you're using to start XY. If the "Run this program as an administrator" box is checked, then uncheck it to avoid the UAC prompt.

Tip: Since version 7.50 you can set the ADP also using a command line switch! See Command Line Switches.


Help Menu

 Top

Help Menu Commands

Contents and Index

Displays this help file.

Shortcut: F1

Help on Keyboard Shortcuts

Displays all keyboard shortcuts and mouse tricks.

Help on Scripting Commands

Displays the Scripting Commands Reference section of this help file.

Keyboard Shortcuts on Menu

Here you can toggle whether hints for keyboard shortcuts are displayed in the main menu (factory default), or not.

List All Commands...

Shows a list of all commands with their IDs (which can be used in scripts to refer to the commands) and keyboard shortcuts (if they have any). In the list you can select a command and click OK to call it directly from there. If the list shows only one item OK will trigger it even if it is not selected.

Tip: The list's right-click menu provides the option to copy the list to the clipboard.

Online Support (submenu)

Links to various XYplorer-related websites.

Check for Updates: Retrieves the latest official release version online (if you are connected), compares it with the currently running version, and shows the result in a message box. Takes a couple of seconds on first check.

Trial Version Info...

Tells you what you need to know when running then 30-day trial version.

Unlock Trial Version... (if registered: Update Registration Details...)

Opens a dialog where you can enter your name and license key to unlock the trial version.

Environment Variables

Shows the current state of the Environment Variables.

Various Information

Pops up some contextual data.

Tip: Hold CTRL to get some speed related information about your current settings.

Select Language...

Downloads a language file from the server and loads it into the interface in one go. No restart required.

The downloaded language files are saved in the application data path.

Once a file is downloaded you can use CTRL+Select Language... to load the language (e.g. "French.lng") into the running application. If you have downloaded different language files you can switch languages on the fly. No restart required.

Back to English

To quickly go back to English simply tick Back to English (this command will always stay in English). Untick Back to English to go back to the loaded language. Again, no restart required.

Interface Translation Tool

The Interface Translation Tool (ITT) lets you edit a translation or create a new one yourself. See here for details.

About XYplorer

Opens About window.


Scripting Menu

 Top

Scripting Menu Commands

Run Script...

Enter and execute a script directly. The script can be multi-line, and you can enter more than one script (in which case a menu will pop up).

The last entered script is remembered between sessions. Note that the dialog has context sensitive help: F1 will open the Scripting Commands Reference.

Run Script Again

Runs the script previously entered in Run Script... or Try Script... again.

Step Mode

Toggle Step Mode. Stepping through scripts is recommended for debugging scripts, and for carefully testing scripts that you have received from other authors.

Try Script...

Like Run Script... above, but: Step Mode is always enabled for the script you run from the Try Script window. The previous state of Step Mode is restored when done.

Shortcut: Ctrl+Alt+S

Permanent Variables

Pops a list of all Permanent Variables that are currently in memory. Tip: The list has a right-click menu. You can double-click a variable in the listing to show its value. Here you can as well unset these variables individually directly from the right-click menu in the variable list (command Unset).

Load Selected Script File

Allows you to directly load a script resource from the file list. It's your responsibility to ensure that the selected file is a valid script file.

Load Script File...

Here you can load a script file (*.xys) from application data path. If it contains exactly one script it will immediately executed, else a menu is popped up.

Go to Scripts Folder

Brings you to the "Scripts" folder, a subfolder of the application data path.


Tools Menu

 Top

Tools Menu Commands

Configuration...

Open the Configuration window.

Shortcut: F9

Open Configuration File...

Opens the current INI file in whatever application is associated with *.ini files. Of course, any changes you do will be applied only after a restart without saving.

Customize Keyboard Shortcuts...

Open the keyboard shortcuts configuration interface.

Shortcut: Shift+F9

Customize Toolbar...

Open the toolbar configuration interface.

Shortcut: Ctrl+Shift+F9

Trick: Dbl-Click an item to shift it to the other side.

Remove all buttons to restore the default configuration.

Customize File Associations...

Open the interface to customize portable private file associations. See file associations.

Customize File Icons...

Open the interface to customize the file icons. See Custom File Icons.

Shortcut: Ctrl+I

Customize Tree (Submenu)

Adjust the folder tree to your preferences: Show Icons, Show PlusMinus, Show Lines, Mark Favorites (Icon), Mark Favorites (Bold), Narrow Tree, Rename On Slow Double-Click, Apply Highlighting, Full Row Select.

Narrow Tree: Reduces the tree level indent from 19 to 10 pixels. Saves a lot of horizontal space if you work in deeply nested folders.

Rename On Slow Double-Click: Tip: With Configuration | Tree and List | Expand tree nodes on single-click ON and Rename on slow double-click OFF, you can also collapse the current tree node by a single click on the name. Could save you many clicks.

Apply Highlighting: Turn it on to apply Highlights and Box Colors.

Full Row Select: Note that you can still trigger right-click on empty when you hit the area left of the nodes.

Tree Path Tracing: Turn it on to highlight the current path in the Tree, i.e. each component of the current path. It's a visual aid to always know your place in the folder tree, without even consciously looking at the tree. The color can be customized in Configuration | Styles | Tree Path Tracing. Note that there is a toolbar button "Tree Path Tracing" to quickly toggle it on and off. The button's right-click menu offers all tree styles.

Customize List (Submenu)

Adjust the file list to your preferences: Show Icons, Column Drag, Multiple Select, Full Row Select, Highlight Sorted Column, Show Line Numbers, Autosize Columns, Show Grid, Highlight Focused Row, Highlight Selected Rows, Rename On Slow Double-Click, Hide Extensions, Sticky Selection, Manual Sorting.

Note that, by factory default, the list styles are applied globally to all tabs in all panes. This setting is configurable in Configuration | Styles under "Apply list styles globally".

Some notes on particular options:

Show Grid: The colors for the grid are defined in Configuration | Colors | List | Grid. In Configuration | Styles you can as well choose a Grid Style.

Rename On Slow Double-Click: When this setting is enabled, you can do a slow double-click (two consecutive clicks, but slower than a double-click) on a file list item to invoke the single-rename interface. Note that, contrary to Explorer, this will only happen when no other than the clicked item is selected, else other selected items are unselected first.

Sticky Selection: This is a selection style known from many apps with multiple selection lists. The effect is pretty much identical to holding the CTRL key while you click on an item or hit the space key on the focused item: The previous selections are not touched and the current item's selection state toggles. Also clicking on the white space will not unselect the selected items.

Sticky Selection is obviously very practical when you work on long lists and want to pick out particular items manually: You won't easily lose your work by the slip of a finger.

Tip: To unselect all items using the mouse start a drag-select (hold mouse button down and drag a bit), or use Deselect All (Ctrl+Shift+A).

Note that you won't have the "Rename On Slow Double-Click" functionality when "Sticky Selection" is active. Note also that obviously "Sticky Selection" will only come to effect when "Multiple Select" is on (which no known user ever turned off).

Manual Sorting: In Manual Sorting mode you can directly manipulate the displayed order of items by dragging them to a new position. You can drag single as well as multiple items -- the latter even when the selections are non-contiguous in which case they are inserted as a contiguous group to the new position.

Remarks:

· Manual Sorting just concerns display. The files are not touched at all.
· When Manual Sorting is enabled you cannot drag items from the list to any other controls using the left mouse button. Right button drag however works as usual.
· The manual sort order is temporary and not remembered in a tab or between sessions. Also on a List Refresh it's gone. Therefore Auto-Refresh is suspended while a manual sort order is in effect to protect it from an unwanted List Refresh.
· Manual Sorting also works with Find Results and other list modes (not necessarily extremely useful though with any mode).

Checkbox Selection: A checkbox is shown at each list item. Now you can individually select/unselect multiple list items simply by ticking/unticking checkboxes with the left mouse button.

Remarks:

· Checkbox Selection works in all list views and list modes.
· Selecting an item via checkbox does not move the focus to this item.
· Right-clicking any checkbox pops the Select submenu from menu Edit.
· The checkbox has an invisible 2-pixel safety margin that protects shaky clickers from missing the target too easily. In other words, you can miss it by 2 pixels and still make a hit.

Size Column Format (Submenu)

Set file size display format for the size column in List.

Show Folder Sizes

When checked, folder sizes are calculated and shown in the file list. The functionality is identical to the setting "Show Folder Sizes in List" in Configuration | Tree and List. Note that the option is also available via the Size column header's context menu.

Show Space Used

When checked, all file sizes in the list are showing the disk space wasted by each file. The column heading will be changed from "Size" to "Space".

Of course, this item is also available in the context menu of the size column header.

Raw Bytes Count Pure byte count, no suffix, no thousand separators. This format is useful when you create reports that shall be further processed by software that cannot deal with thousand separators.

Bytes Exact bytes, no suffix (would just take away space)

KB (Rounded Up) KBs are rounded up (as in Explorer)

KB, MB, GB, TB, PB Size with 2-digit accuracy

Flexible Byte counts are given in the most easy-to-read unit (i.e. "bytes", "KB", "MB", "GB", "TB", "PB" depend on the actual number):

Flexible (Rounded Up), like Flexible but with all values rounded up

Clusters Number of clusters actually used by a file on this drive

Date Column Format (Submenu)

Adjust date and time display format in List to your preferences.

Tip: These commands are also available in the right-click menu of any of the Date columns in the file list.

Show Age: Show/hide the age of files in days, hours, or minutes.

Shortcut: Ctrl+Shift+E

Show Weekday: If enabled the day part of the date is shown as the weekday name ("Monday, Tuesday ...") if the day lies within the last week. If it's today (yesterday) it is shown as "Today" ("Yesterday"). If the file date is within the last hour, you get "Now" instead of "Today".

Remarks

(1) The option applies to all date formats except, of course, "ISO Week" and "Zodiac".
(2) Like with all date formats, the setting is per List mode: you can e.g. show the weekdays in Search Results while having the normal Date format in Browse mode.
(3) If Show Age is enabled then Show Weekday is ignored.

Tweaks

There are three INI Tweaks that allow you to customize the terms for Now, Today, and Yesterday in file dates:

[General]

; Tweak: 'Now' in file dates

TermThisHour=Now

; Tweak: 'Today' in file dates

TermToday=Today

; Tweak: 'Yesterday' in file dates

TermYesterday=Yesterday

So, if you are using a Spanish Windows you might set it to:

TermThisHour=Ahora

TermToday=Hoy

TermYesterday=Ayer

Show Milliseconds: Tick it to show all file times with milliseconds precision.

Show Times in UTC: Tick it to show all file times as UTC, i.e. time zone-independent as they are internally stored under NTFS. Untick it to show file times auto-converted to the local time zone (as defined in Windows settings), which is the factory default and the usual way file times are shown in file managers and similar applications.

UTC file times are easily recognizable by the suffixed "Z", which is the official way to mark UTC times according to ISO 8601. Note that not only the file list, but also the Properties tab and all sorts of Reports support showing UTC times and hence are affected by this setting.

List Management (submenu)

Here you can manage various lists like History, Favorites, Address Bar, Name, Location, etc.

Tip: All lists (e.g. also in Customize Toolbar Dialog) support a simple Type Ahead Find where you jump to the next item beginning with the letter you typed.

Live Filter Box: The various lists in List Management (and some other dialogs featuring a list) are provided with a live filter box.

· Matching is case-insensitive (A=a).
· Partial matching is supported. E.g. a filter pattern "o" will match "dog". However, if the pattern has wildcards * or ? then the pattern is taken as is, so "o*" will not match "dog".
· In List Management | Editor Mode no filtering is applied.
· Patterns are not retained between calls.
· Patterns don't support Boolean logic.
· Line numbers in filtered lists still refer to the position in the unfiltered list. Cool!
· Sorting is supported in filtered lists.
· Click the icon to toggle between "no filter" (stores the current filter as "last filter") and "last filter". The last filter is shared across all lists, and retained across sessions.

Sticky Section: Various most-recently-used (MRU) lists can have an optional Sticky Section. Items in the Sticky Section are permanent members of this list and will never be pushed out when new items are added. You can use this section for your all-time favorite items and carefully crafted patterns. The Sticky Section can be added via List Management, simply add this dummy item as section separator:

-----> mru

Everything above this line is in the Sticky Section. Everything below this line is in the MRU Section. So the Sticky Section is always displayed on top of the whole list.

The following MRU lists support a Sticky Section: Address Bar & Go to, Find Files Name, Find Files Location, Rename Special patterns, Visual Filter patterns, Selection Filter patterns, Move/Copy/Backup To, Recently Opened Files, Recent Catalogs, Recently Included Catalogs

Notes on Sticky Section

· In dropdown lists the Sticky Section is distinguished from the MRU section by a special text and back color. The colors are currently hard-coded, later this might be made configurable. (In List Management there is no special coloring.)
· No shifting or sorting: When you pick an item from the Sticky Section it will not be shifted to the top but stays in its position.
· When a "Match List" (an alphabetically ordered subset of items that match what is currently typed into the edit field) is dropped the items pertaining to the Sticky Section are not marked in any way but mix with the "normal" items. Reasons: There would be clashes between coloring rules; it would be visually disturbing; and it simply does not make a lot of sense in a Match List.
· The size of the Sticky Section is not limited and adds to the max size of the MRU section (e.g. 64 for Rename Special patterns).
· The section separator makes managing the lists quite easy and intuitive. In List Management you simply drag items to above the separator to add them to the Sticky Section. The separator is visible only in List Management. In the GUI, in a dropdown list it is hidden from the user's eye, in a menu (e.g. Visual Filters in right-click menu of the toolbar button) it is replaced by a menu separator.

Tools Special (submenu)

Control Panel...

Opens the Control Panel.

Open Recycle Bin...

Opens the Recycle Bin.

Empty Recycle Bin...

Empties the Recycle Bin.

Recycle Bin Stats...

It's just a little message box that tells you relatively quick the total number and size of items currently in the recycle bin. Just in case you wanted to know...

Map Network Drive...

Opens the Map Network Drive wizard. Note that there's also a Toolbar button for this function.

Disconnect Mapped Network Drive...

Opens the Disconnect Network Drive wizard. Note that there's also a Toolbar button for this function.

Reconnect All Mapped Network Drives

After a fresh system boot this will (if necessary) revive all your mapped drives in one go. To revive the drives manually and one-by-one: select a sleeping drive in the tree and press Shift+F4 (Refresh Current Folder).

Note: Reconnecting Mapped Network Drives may need a live network connection depending on your system setup.

Browse for Network Server...

Allows you to browse the network and select an accessible computer via the Shell interface.


View Menu

 Top

View Menu Commands

Views (Submenu)

Here you can choose between a number of display styles:

Details: show detailed file information column-wise.

Details with Thumbnails: Details plus a Thumbs column. The thumbnails' size is defined by the settings in Configuration/Thumbnails. Default size is 72 x 54.

List. List is a wrapped column of icons plus names, as opposed to "Small Icons" which is a wrapped row of icons plus names.

Small Icons: Just icons (16x16) and names. The column width matches the current Name column width.

Large Icons: Just icons (32x32 or 48x48 depending on the Windows version) and names.

Small Tiles: Extra large icons or thumbnails (48x48), 3 info lines: Name, Type, Size/Modified Date. Hard column width 250 pixels.

Large Tiles: Extra large icons (48x48) or thumbnails (64x64), 4 info lines: Name, Type, Size/Modified Date, Extra Info (depending on file type, see below). Hard column width 270 pixels.

Extra Info:
Images: Dimensions and Aspect Ratio
Media: Length
Executables and other binaries: File Version

Tip: To enable thumbnails in Tiles views tick Configuration | Thumbnails | Show thumbnails in tiles views.

Thumbnails #1/#2/#3 (Width x Height): thumbnails plus names. The thumbnails' size can be defined by the settings in Configuration/Thumbnails.

Configure Thumbnails...: open the Configuration dialog for thumbnails.

Note: Views are stored tab-wise and retained between sessions.

Tip: hold Shift while selecting a view to apply the view to all tabs.

Sort By (Submenu)

[Column Name]: Set currently sorted column in file list.

Unsorted: Show order as is in the FAT (file allocation table), which is usually alphabetically ascending by name, files and folders mixed.

In a recursive search results listing, the order is in each folder: files first, then folders. The result is a tree-like sort order.

Random Order: Shuffle the file list. Press it repeatedly to keep on shuffling!

Shortcut: Ctrl+Alt+R

Sort Again: Refresh current sort.

Previous Order: Resort the list using the previous sort order. Quite useful to toggle between the two recent sort orders.

Reverse Order: Reverse the current sort order. Handy to reverse the current sort order by keyboard, and the only way to reverse a custom sort order.

Sort Folders Apart: Check this to make XYplorer behave like Explorer in sorting folders apart from files. Uncheck it if you want everything in one alphabet. (Mirrors the same setting in Configuration | Sort and Rename | Sort.)

Show Sort Headers In All Views: Mirrors the same-named setting in "Configuration | Sort and Rename | Sort" and makes it accessible by keyboard and scripting.

Columns (Submenu)

Line Numbers: Show line numbers in the left-most column. Its width auto-adjusts to the number of items in the list, and it got its own fully configurable color in Configuration | Colors. The right border color of the line numbers area is derived from its backcolor by darkening.

[Column Name]: Show/hide this column in List.

Show Columns...: Pops a checkbox list of all available columns in the current list mode, and this offers an alternative way to control column visibility.

Show All Columns: Show all columns.

Autosize Columns Now: This command allows you to adjust the width of all columns. Columns are auto-sized to a max width of 600 pixels.

Tips: You can adjust each file list column's width by dbl-clicking the little gap right of the column header. You can adjust the width of all columns by one dbl-click on the dead-zone right of all column headers, or by dbl-click on the Line Number column header. To automatically adjust the width of all columns when listing the contents of a new location, check Tools | Customize List | Autosize Columns.

Shortcut: Ctrl+Numpad Add

Grow Name Column: Grows the name column by 4 pixels (in all views apart from thumbnails).

Shortcut: Ctrl+Shift+Numpad Add

Shrink Name Column: Shrinks the name column by 4 pixels (in all views apart from thumbnails).

Shortcut: Ctrl+Shift+Numpad Subtract

Save Column Layout and Load Saved Column Layout: For each list mode (Browse, Find, Drives, Network, Recycler) you can store (and later load) a preferred layout for column widths, sequence, and visibility, which is remembered between sessions. Note that sort order is not concerned here.

Set Line Number Column Width: Set the minimum width of the line numbers column measured in digits. The column will enlarge as necessary but never shrink below the user- defined minimum size.

Tab (Submenu)

New Tab: Create a new tab. The new tab will be a clone of the current tab (but without a home).

Shortcut: Ctrl+T

Default Tab: Make this tab the default tab. Any passively (implicitly) opened new tab will open in this tab instead. There's a visual indicator (a green icon overlay) to show which tab is the default tab (if any). There can be only one default tab.

Iconize: Tabs can be iconized, i.e. shrunk to the size of an icon.

Rename Tab...: You can give the tabs any name of your choice. Once a tab is named that name will stay fixed when you change the current directory inside the tab. A tab name can have any characters, even those that are illegal for filenames. To un-name a tab rename it to nothing.

Tip: You can specify the same variables as in Configuration | Tabs | Tab captions | Custom, so you can have per-tab custom captions like e.g.: <drive>: <folder>.

Tip: You can as well specify icons of your free choice for each tab. This is described here.

Copy Location Term: Puts the tab's location, including any Visual Filters, up to the clipboard. If the tab is renamed, the command will still copy the location, not the caption.

Relocate Tab...: Here you can enter a new location for the current or any non-current tab (when opening the menu via right-click on a tab header). If you do it for the current tab, it will browse to the new location.

Of course, the location of an unlocked tab is usually set to the new path simply by going to a new location via Tree or Address Bar or whatever; however, this path is always a hard-coded one. Now Relocate Tab allows you to enter a soft path (aka Portable Path), like %TEMP%, or %USERPROFILE%, or <xydata>. So for example, if you have a tab pointing to %USERPROFILE%, it will always be resolved to the current user profile folder, no matter where it is located in the system you are currently working on! This revolutionary concept is called Portable Tabs.

Tab History...: Pop up a list containing all history items pertaining to the current tab.

Set Home...: each tab can have its own "Home", defined by a browse/find location and mode, and the usual list settings. To set (or update) the current tab's home click "Set Home".

Go Home: to go to the current tab's home click "Go Home".

Shortcut: Alt+Home

Lock Home Zone: First you have to define a home, then you may lock your tab to the Home Zone, which includes the home path and all its subfolders (in other words, the home branch). You can freely move inside the home zone and stay inside the tab, but if you browse to a destination outside the home zone, the tab stays where it is and a new tab will be automatically opened. Home-zoned tabs are recognizable by a dotted underline. Note: a tab that's home-zoned and tight-locked (Ctrl+L; locked to a specific path) is treated as tight-locked.

Lock Location: Lock the current tab. A locked tab will never leave its current location but instead open new tab automatically.

Shortcut: Ctrl+L

Set Visual Filter

Set a Visual Filter to the current file list. See Visual Filters for syntax.

Shortcut: Ctrl+J

Toggle Visual Filter

Toggle between no Visual Filter and the last used Visual Filter or Power Filter.

Shortcut: Ctrl+Shift+J

Filter Selected Item(s)

The command makes the list show only those items that are selected in the moment you apply the command. The filter is hard-coded to the caption "sel". A nice thing about it is that the "Toggle Visual Filter" command will restore the filtered view even when the items are not selected anymore. Even across sessions. Even in other tabs or folders if their contents share the same filenames.

Shortcut: Shift+Alt+J

Filter By Selected Extension(s)

Will show only items with the same extension(s) as the currently selected item(s).

Shortcut: Ctrl+Alt+J

Filter Out Selected Extension(s)

Sets a Visual Filter to *not* show items with the same extension(s) as the List's selected item(s). In other words: hide the items of the currently selected type(s).

Shortcut: Ctrl+Shift+Alt+J

Type Stats and Filter...

Pops a menu of all file types contained in the current file list (no folders), ordered by count (most frequent on top) or by extension (ascending). Click any of the types to filter (Visual Filter) the list by this type. Works also on Branch View and Search Results.

Note: There is a toolbar button available with the same name and functionality. You can modify the sort order of the popup menu via right-clicking the button. There are two options, Sort by Count and Sort by Extension.

Tip: You can use the menu to (un)select files by type.

· Hold CTRL: Add all files of this type to the selection.
· Hold SHIFT: Remove all files of this type from the selection.

Restore Last Closed Tab: Restores the tab that was last closed in the current session (not remembered across sessions). The restored tab is automatically selected.

Close All Other Unlocked Tabs: Close all unlocked tabs apart from the current tab.

Shortcut: Ctrl+Shift+W

Close All Other Tabs...: Close all tabs apart from the current tab.

Close Tab: Close the current tab.

Shortcut: Ctrl+W, Ctrl+F4

Mini Tree (Submenu)

See also Mini Tree.

Mini Tree. Toggles between Maxi Tree and the last used Mini Tree. A Mini Tree will show only the tree paths that have been actually used.

When toggling from Maxi to (last) Mini Tree, the current path is kept even if it is not part of the last Mini Tree. So, no change of location will happen using this command.

Minimize Tree. Reduces the Mini Tree to show just the paths of all tabs in both panes. Turns Mini Tree mode on if off.

Load Last Mini Tree. Loads the last Mini Tree before the Tree was converted to Maxi. Useful when you quickly turn on Maxi Tree for a task and then want to go back to the previous Mini state. If the current session did not have a Mini Tree yet, the last INI-stored Mini Tree is loaded.

Mini Tree From History. Loads a Mini Tree made from the recent history. The history is scanned backwards until the 4 deepest paths are collected that are not in a mutual parent-child relation.

Set As Favorite Mini Tree... Stores the current Mini Tree as Favorite Mini Tree. Overwrites any previously stored Favorite Mini Tree (after OK-ing a prompt). Only available/applicable in Mini Tree mode.

Load Favorite Mini Tree. Loads any previously stored Favorite Mini Tree. Turns on Mini Tree mode if necessary.

Hide Current Folder. Hides the current folder from the Mini Tree (not from your hard disk). Since there must be a selection the parent folder is auto-selected.

Folder View Settings (Submenu)

See also Folder View Settings.

Enable Folder View Settings: Check to enable the Folder View Settings feature, i.e. make the commands available and auto-restore folder-specific view settings.

Save Folder View: Save and remember the current folder view settings. If a folder view is currently active it will be updated to the current view settings.

Restore Folder View: Reverts the current folder view to the saved settings.

Edit...: Edit the active folder view.

Remove: Remove the active folder view.

Apply this Folder View Also To...: Apply the current folder view settings also to another folder name/pattern.

Define this Folder View as Default: Save the current folder view settings as default folder view (used for any folder with no specific folder view).

Manage Folder Views: Opens a list of all stored Folder Views. You can directly jump to the "Edit Folder View" dialog from the list: Select a Folder View and click OK, or double-click a Folder View. You also can delete Folder Views from here: Select a Folder View and press DEL (or use the item's context menu). Note that deletions are only performed when you OK the dialog.

Refresh

Refreshes Tree and List.

Note that the List is not reset (i.e. any selections and the scroll position are kept). To reset the file list use "Reset List" (Ctrl+Shift+F5). The Tree is only refreshed when it is visible.

Shortcut: F5

Auto-Refresh

See "Auto-refresh" in Configuration/Advanced.

Shortcut: Ctrl+Shift+R

Suspend Auto-Refresh

Will immediately and temporarily stop (respectively reactivate) any auto-refreshing for the current location, without changing the general Auto-Refresh setting. Auto-Refresh is automatically reactivated (only if Auto-Refresh is ON, of course) when the current location is changed.

Shortcut: Ctrl+R

Lock Tree

Ever since, the Tree shows basically the same path as the Window Title, the Address Bar and the List: If you change the current path by any of the numerous ways available in XYplorer, the Tree is automatically adjusted to the new location. Even, if you don't really need that service... "Lock Tree" allows you to turn off that automatic syncing of the Tree.

With Lock Tree on, "Refresh Tree" (F4) will re-sync the Tree without changing the mode. Also turning Lock Tree off again, will instantly re-sync the Tree. The setting is remembered between sessions. When you startup with Lock Tree on, the tree will be initialized to a default state with only the top nodes shown.

Here are some possible reasons for turning Lock Tree on once in a while:

(1) It offers a uniform maximum browsing speed that's totally independent of the nesting depth of the target locations. For example, if you quickly need to check size and version of a particular system file, it is totally pointless to expand the tree down to system32, because all you need is a quick glance at that file in the file list. Or, if you have a script that needs to visit some location -- why should the tree get busy here?
(2) It keeps the Tree in a stable state and position while browsing. For example, this can be valuable when collecting stuff from various locations via drag+drop into a couple of target folders -- no need to scroll the tree anymore: the Tree just sits there and waits.
(3) It makes consequent use of XYplorer's many ways of going to a new place: Address Bar, Tabs, Catalog, Favorites, History, Hotlist, Breadcrumb, GoTo, UDCs, Scripts, etc. ... they all work flawlessly without the Tree, and if you just need to go somewhere to work with certain items, you may well be completely uninterested in their position in the file system -- no need for a Tree to show you.

While the Tree is an ingenious interface element one must admit that it almost always shows much more information that you need to have at any given time. So, for the sake of informational economy, you now get a "stand-by" button with it.

Refresh Tree

Updates the whole Tree.

Shortcut: F4

Refresh Current Folder

Updates just the current folder and its child folders (i.e. the current branch) in the Tree.

Shortcut: Shift+F4

Reset Tree

Completely rebuilds a fresh Tree.

The expansion state of the whole tree is preserved when it is a locked Maxi Tree and Configuration | Tree and List | Remember state of tree is enabled.

Shortcut: Ctrl+Shift+F4

Refresh List

Updates the current list data, but keeps any selections and scroll position. Also refreshes the tab icon.

Shortcut: Ctrl+F5

Reset List

Updates the data, scrolls back to top, sets focus to the first item (if any), and unselects any selections. Also refreshes the tab icon.

Shortcut: Ctrl+Shift+F5

Calculate Folder Sizes

Calculates the folder sizes of all folders currently listed. Further, if any folders in the list are selected, then only the sizes of selected folders are calculated.

Empty folders will display a "[Empty]" in the file list and are thus distinguished from non-empty folders with zero bytes content, which display a "0" ("zero" char). Empty folders will sort before 0-bytes folders.

Shortcut: Shift+F5

Show Items (Submenu)

Contains all major show/hide toggles from Configuration | Tree and List.

Caches (Submenu)

Refresh Thumbnails

Recreates the thumbs cache of the current folder (when thumbs caching is enabled and thumbs mode is active).

Refresh Selected Thumbnails

Recreates the thumbs cache for all selected thumbnails.

Refresh Icons

Refreshes all displayed file and folder icons.

Refresh Environment Variables

XYplorer caches environment variables (e.g. %TEMP%) on first usage for performance reasons. Use this command to update the cache in case your environment variables changed.

Update New Items Menu

Rescan the "NewItems" folder.


Window Menu

 Top

Window Menu Commands

Show Address Bar

Show/hide the Address Bar.

Shortcut: Ctrl+Shift+F12

Show Toolbar

Show/hide the Toolbar.

Shortcut: Ctrl+F12

Show Tab Bar

Show/hide the headers of the Tabs on each pane.

NOTE: If you hide the tab bar(s) then opening locations in new background tabs will open them in new "hidden" tabs, hence the results of such an operation may not be immediately visible.

Show Breadcrumb Bar

Show/hide the Breadcrumb Bar on each pane.

Show Status Bar

Show/hide the Status Bar. Note that if the Status Bar is hidden then also the Status Bar Buttons go away.

Show Status Bar Buttons

Show/hide the Status Bar Buttons.

Show Navigation Panel

Show/hide the tree (with catalog).

Shortcut: F8

Show Tree

Show/hide the tree.

Shortcut: Shift+F8

Show Catalog

Show/hide the catalog.

Shortcut: Ctrl+F8

Catalog Above Tree

If checked then the Catalog is shown at the top, and the Tree at the bottom.

Show Info Panel

Show/hide the Info Panel.

Shortcut: F12

Wide Info Panel

Uncheck to let the Tree touch the ground left of the Info Panel.

It should be obvious that unchecking Wide Info Panel

(a) is making a difference only with the info panel on,

(b) is not your choice when you run a 800x600 screen,

(c) is indispensable when working with the Catalog.

Last Size/Minimize Info Panel

Toggle the panel height between minimum height and last user selected height (by dragging the splitter). The same can be achieved by right-clicking the status bar.

Shortcut: Alt+F12

Maximize/Minimize Info Panel

Toggle the panel height between maximum and minimum.

Shortcut: Shift+F12

Layout (Submenu)

Here you can choose between four layouts of the top bars:

[Address Bar & Toolbar] (one row)

[Toolbar & Address Bar] (one row)

[Address Bar] [Toolbar] (two rows)

[Toolbar] [Address Bar] (two rows)

Tabs (Submenu)

Listing of the current tabs on both panes.


Quick Help: Raw View

 Top

Selecting and copying lines

Selecting works line-wise: to (un)select a line simply left-click it. Hold the Shift-key to multi-select larger zones.

While you cannot select individual strings as in an editor, you can select as many different lines as you like, and then copy them to the clipboard in one block.

Copy a single line by dbl-clicking it (no need to select it first).

Extract Text

Scans binary files for text portions. Check International to include French, German, Italian, Portuguese, Scandinavian, and Spanish special characters.


Quick Help: Find Files by Date

 Top

"between"-field

Absolute date, e.g. 17.02.2005 20:26:24 or 17.02.2005

or

[Empty] equivalent to the date/time now.

"and/add"-field

Absolute date, e.g. 17.02.2005 20:26:24 or 17.02.2005

or

[Empty] equivalent to the date/time now.

or

Relative date, e.g.

5 s = "between"-date plus 5 seconds
21 n = "between"-date plus 21 minutes (yes, "n")
4 h = "between"-date plus 4 hours
1 d = "between"-date plus 1 day ("d" is optional)
-15 D = "between"-date minus 15 workdays (big "D")
-9 w = "between"-date minus 9 weeks
-3 m = "between"-date minus 3 months
-10 y = "between"-date minus 10 years


Quick Help: Image Preview

 Top

Mouse down on previewed image

Left Mouse Down Pop up image in original size
Ctrl+Mouse Down Toggle zoom/original size
Right Mouse Click Pop up context menu

Keys for Full Screen Preview

Shift+F11 Open current image file in Full Screen Preview
Shift+F11, Esc Close Full Screen Preview
PageUp/Shift+Space/WheelUp Previous image
PageDown/Space/WheelDown Next image
Up, Down, Left, Right Pan cropped image
Home/End First/Last image
A Fit All
W Fit Width
H Fit Height
O, 1 Original Size
D, 2 Double Size
Numpad Add, Z Toggle Zoom to Fit (Floating Preview only)
Numpad Subtract, B Toggle Black Background
Numpad Multiply, S Toggle Show Filename and Dimensions
Numpad Divide, T Transparency Grid
Q High Quality Image Resampling
F5 Refresh


Quick Help: Progress Bar

 Top

Mouse down on progress bar

Left Mouse Down Go to mouse position
Right Mouse Down Start/Pause playing
Shift+Mouse Down Go to beginning

Keys for audio/video preview

Space bar Start/Pause playing
Left Frame step backward (Video only)
Shift+Left 1 second backward
Right Frame step forward (Video only)
Shift+Right 1 second forward
Shift+Space bar Go to beginning


Removing XYplorer

 Top

If you find that XYplorer does not meet your needs you can easily remove it from your computer.

Use Uninstall

If you installed XYplorer via the Installer Package (e.g. XYplorer_8.90_Install.exe), you'll find an icon "Uninstall" in the program group created during installation. Click this icon to run the uninstall interface.

Delete the Application Folder

Alternatively you can simply delete XYplorer's application folder and its application data folder (if different).

If you go this way then -- before removing the application -- you should take care to clean the registry in case you have enabled any of the settings in Configuration | Shell Integration. In that case simply uncheck all boxes in Configuration | Shell Integration and your registry is clean.


WOW64 Redirection

 Top

WOW64 Redirection (64-bit Windows only)

NOTE: From v13.30 onwards the redirection issue can be handled by ticking a simple checkbox: Configuration | Shell Integration | 64-bit Windows | Show the real System32 directory. The information below is just kept for reference.

WOW64 Redirection helps making 32-bit applications work on 64-bit Windows. Quoting Microsoft:

The %windir%\System32 directory is reserved for 64-bit applications. Most DLL file names were not changed when 64-bit versions of the DLLs were created, so 32-bit versions of the DLLs are stored in a different directory. WOW64 hides this difference using a file system redirector.

In most cases, whenever a 32-bit application attempts to access %windir%\System32, the access is redirected to %windir%\SysWOW64. Access to %windir%\lastgood\system32 is redirected to %windir%\lastgood\SysWOW64. Access to %windir%\regedit.exe is redirected to %windir%\SysWOW64\regedit.exe.

Disabling file system redirection

Disabling file system redirection (which is theoretically possible but not supported by XYplorer) is not recommended because it can result in unexpected behavior, e.g. missing confirmation prompts in file operations!

Bypassing file system redirection

The recommended solution is using the Sysnative alias for System32. Again quoting Microsoft:

32-bit applications can access the native system directory by substituting %windir%\Sysnative for %windir%\System32. WOW64 recognizes Sysnative as a special alias used to indicate that the file system should not redirect the access. This mechanism is flexible and easy to use, therefore, it is the recommended mechanism to bypass file system redirection. Note that 64-bit applications cannot use the Sysnative alias as it is a virtual directory not a real one.

These are the redirections invoked by WOW64 for 32-bit applications on 64-bit Windows:

C:\Windows\System32 ---> WOW64 redirected to ---> C:\Windows\SysWOW64

C:\Windows\Sysnative ---> WOW64 redirected to ---> C:\Windows\System32

So if you need to access C:\Windows\System32 you specify C:\Windows\Sysnative instead.

Note: To enable the Sysnative solution you first have to create an empty new folder C:\Windows\Sysnative. Then you can go to e.g. C:\Windows\Sysnative\drivers to access the 64-bit C:\Windows\System32\drivers.